unit t_monit;

interface
uses
   Classes, Graphics, ExtCtrls,
// KERNEL
   Elements,
   Tools,
// 0TEMP
   F_MonVal;

type

  TAbstractMonitor = class(TTool)
  private
    procedure Sniff; virtual; abstract;
  end;


  TMonitorThread = class(TThread)
  protected
    FMonitor: TAbstractMonitor;
    procedure Execute; override;
  public
    StopThread: boolean;
  end;


  TMonitor = class(TAbstractMonitor)
  private
    FThread: TMonitorThread;
    procedure Sniff; override;
  public
    procedure DoIt; override;
  end;



  TValueMonitor = class(TMonitor)
  private
    FForm: TFValueMonitor;
    procedure Sniff; override;
  public
    constructor Create; override;
    procedure DoIt; override;
  end;

implementation
uses
  Forms, SysUtils,
// KERNEL
  e_Class,
  T_Recurs;

procedure TMonitorThread.Execute;
begin
  if FMonitor = nil then exit;
  repeat
    FMonitor.Sniff
  until StopThread;
end;




procedure TMonitor.Sniff;
begin

end;


procedure TMonitor.DoIt;
begin
  FThread:= TMonitorThread.Create(true);
  FThread.FMonitor:= self;
  FThread.Priority:= tpLowest;
  FThread.Resume
end;



constructor TValueMonitor.Create;
begin
  FForm:= TFValueMonitor.Create(Application);
  FForm.Show;
  inherited Create;
end;


procedure TValueMonitor.Sniff;
begin
  if not (input is TEntity) then exit;
  if input is TRecursor then
     FForm.lbValue.Caption:= IntToStr(TRecursor(Input).Level)
end;


procedure TValueMonitor.DoIt;
begin
  inherited DoIt;
end;



BEGIN
   RegisterOrbisClass(TValueMonitor);
end.
