
(****************************************************************************
*                                                                           *
* Translated from HtmlHelp.h                                                *
*                                                                           *
* Copyright (c) 1996-1997, Microsoft Corp. All rights reserved.             *
*                                                                           *
****************************************************************************)
unit HTMLHelp;
interface
(*
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef __HTMLHELP_H__
#define __HTMLHELP_H__

#ifdef __cplusplus
extern "C" {
#endif  // __cplusplus
*)
// Commands to pass to HtmlHelp()
const

 HH_DISPLAY_TOPIC        = $0000;
 HH_HELP_FINDER          = $0000;  // WinHelp equivalent
 HH_DISPLAY_TOC          = $0001;  // not currently implemented
 HH_DISPLAY_INDEX        = $0002;  // not currently implemented
 HH_DISPLAY_SEARCH       = $0003;  // not currently implemented
 HH_SET_WIN_TYPE         = $0004;
 HH_GET_WIN_TYPE         = $0005;
 HH_GET_WIN_HANDLE       = $0006;
 HH_ENUM_INFO_TYPE       = $0007;  // Get Info type name, call repeatedly to enumerate, -1 at end
 HH_SET_INFO_TYPE        = $0008;  // Add Info type to filter.
 HH_SYNC                 = $0009;
 HH_ADD_NAV_UI           = $000A;  // not currently implemented
 HH_ADD_BUTTON           = $000B;  // not currently implemented
 HH_GETBROWSER_APP       = $000C;  // not currently implemented
 HH_KEYWORD_LOOKUP       = $000D;
 HH_DISPLAY_TEXT_POPUP   = $000E;  // display string resource id or text in a popup window
 HH_HELP_CONTEXT         = $000F;  // display mapped numeric value in dwData
 HH_TP_HELP_CONTEXTMENU  = $0010;  // text popup help, same as WinHelp HELP_CONTEXTMENU
 HH_TP_HELP_WM_HELP      = $0011;  // text popup help, same as WinHelp HELP_WM_HELP
 HH_CLOSE_ALL            = $0012;  // close all windows opened directly or indirectly by the caller
 HH_ALINK_LOOKUP         = $0013;  // ALink version of HH_KEYWORD_LOOKUP
 HH_GET_LAST_ERROR       = $0014;  // not currently implemented // See HHERROR.h
 HH_ENUM_CATEGORY        = $0015;	// Get category name, call repeatedly to enumerate, -1 at end
 HH_ENUM_CATEGORY_IT     = $0016;  // Get category info type members, call repeatedly to enumerate, -1 at end
 HH_RESET_IT_FILTER      = $0017;  // Clear the info type filter of all info types.
 HH_SET_INCLUSIVE_FILTER = $0018;  // set inclusive filtering method for untyped topics to be included in display
 HH_SET_EXCLUSIVE_FILTER = $0019;  // set exclusive filtering method for untyped topics to be excluded from display
 HH_SET_GUID             = $001A;  // For Microsoft Installer -- dwData is a pointer to the GUID string

 HH_INTERNAL             = $00FF;  // Used internally.
(*
 HHWIN_PROP_ONTOP            (1 << 1)    // Top-most window (not currently implemented)
 HHWIN_PROP_NOTITLEBAR       (1 << 2)    // no title bar
 HHWIN_PROP_NODEF_STYLES     (1 << 3)    // no default window styles (only HH_WINTYPE.dwStyles)
 HHWIN_PROP_NODEF_EXSTYLES   (1 << 4)    // no default extended window styles (only HH_WINTYPE.dwExStyles)
 HHWIN_PROP_TRI_PANE         (1 << 5)    // use a tri-pane window
 HHWIN_PROP_NOTB_TEXT        (1 << 6)    // no text on toolbar buttons
 HHWIN_PROP_POST_QUIT        (1 << 7)    // post WM_QUIT message when window closes
 HHWIN_PROP_AUTO_SYNC        (1 << 8)    // automatically ssync contents and index
 HHWIN_PROP_TRACKING         (1 << 9)    // send tracking notification messages
 HHWIN_PROP_TAB_SEARCH       (1 << 10)   // include search tab in navigation pane
 HHWIN_PROP_TAB_HISTORY      (1 << 11)   // include history tab in navigation pane
 HHWIN_PROP_TAB_BOOKMARKS    (1 << 12)   // include bookmark tab in navigation pane
 HHWIN_PROP_CHANGE_TITLE     (1 << 13)   // Put current HTML title in title bar
 HHWIN_PROP_NAV_ONLY_WIN     (1 << 14)   // Only display the navigation window
 HHWIN_PROP_NO_TOOLBAR       (1 << 15)   // Don't display a toolbar
 HHWIN_PROP_MENU             (1 << 16)   // Menu
 HHWIN_PROP_TAB_ADVSEARCH    (1 << 17)   // Advanced FTS UI.
 HHWIN_PROP_USER_POS         (1 << 18)   // After initial creation, user controls window size/position

 HHWIN_PARAM_PROPERTIES      (1 << 1)    // valid fsWinProperties
 HHWIN_PARAM_STYLES          (1 << 2)    // valid dwStyles
 HHWIN_PARAM_EXSTYLES        (1 << 3)    // valid dwExStyles
 HHWIN_PARAM_RECT            (1 << 4)    // valid rcWindowPos
 HHWIN_PARAM_NAV_WIDTH       (1 << 5)    // valid iNavWidth
 HHWIN_PARAM_SHOWSTATE       (1 << 6)    // valid nShowState
 HHWIN_PARAM_INFOTYPES       (1 << 7)    // valid apInfoTypes
 HHWIN_PARAM_TB_FLAGS        (1 << 8)    // valid fsToolBarFlags
 HHWIN_PARAM_EXPANSION       (1 << 9)    // valid fNotExpanded
 HHWIN_PARAM_TABPOS          (1 << 10)   // valid tabpos
 HHWIN_PARAM_TABORDER        (1 << 11)   // valid taborder
 HHWIN_PARAM_HISTORY_COUNT   (1 << 12)   // valid cHistory
 HHWIN_PARAM_CUR_TAB         (1 << 13)   // valid curNavType

 HHWIN_BUTTON_EXPAND         (1 << 1)    // Expand/contract button
 HHWIN_BUTTON_BACK           (1 << 2)    // Back button
 HHWIN_BUTTON_FORWARD        (1 << 3)    // Forward button
 HHWIN_BUTTON_STOP           (1 << 4)    // Stop button
 HHWIN_BUTTON_REFRESH        (1 << 5)    // Refresh button
 HHWIN_BUTTON_HOME           (1 << 6)    // Home button
 HHWIN_BUTTON_BROWSE_FWD     (1 << 7)    // not implemented
 HHWIN_BUTTON_BROWSE_BCK     (1 << 8)    // not implemented
 HHWIN_BUTTON_NOTES          (1 << 9)    // not implemented
 HHWIN_BUTTON_CONTENTS       (1 << 10)   // not implemented
 HHWIN_BUTTON_SYNC           (1 << 11)   // Sync button
 HHWIN_BUTTON_OPTIONS        (1 << 12)   // Options button
 HHWIN_BUTTON_PRINT          (1 << 13)   // Print button
 HHWIN_BUTTON_INDEX          (1 << 14)   // not implemented
 HHWIN_BUTTON_SEARCH         (1 << 15)   // not implemented
 HHWIN_BUTTON_HISTORY        (1 << 16)   // not implemented
 HHWIN_BUTTON_BOOKMARKS      (1 << 17)   // not implemented
 HHWIN_BUTTON_JUMP1          (1 << 18)
 HHWIN_BUTTON_JUMP2          (1 << 19)
 HHWIN_BUTTON_ZOOM           (1 << 20)
 HHWIN_BUTTON_TOC_NEXT       (1 << 21)
 HHWIN_BUTTON_TOC_PREV       (1 << 22)

#define HHWIN_DEF_BUTTONS           \
            (HHWIN_BUTTON_EXPAND |  \
             HHWIN_BUTTON_BACK |    \
             HHWIN_BUTTON_OPTIONS | \
             HHWIN_BUTTON_PRINT)

// Button IDs

 IDTB_EXPAND             200
 IDTB_CONTRACT           201
 IDTB_STOP               202
 IDTB_REFRESH            203
 IDTB_BACK               204
 IDTB_HOME               205
 IDTB_SYNC               206
 IDTB_PRINT              207
 IDTB_OPTIONS            208
 IDTB_FORWARD            209
 IDTB_NOTES              210 // not implemented
 IDTB_BROWSE_FWD         211
 IDTB_BROWSE_BACK        212
 IDTB_CONTENTS           213 // not implemented
 IDTB_INDEX              214 // not implemented
 IDTB_SEARCH             215 // not implemented
 IDTB_HISTORY            216 // not implemented
 IDTB_BOOKMARKS          217 // not implemented
 IDTB_JUMP1              218
 IDTB_JUMP2              219
 IDTB_CUSTOMIZE          221
 IDTB_ZOOM               222
 IDTB_TOC_NEXT           223
 IDTB_TOC_PREV           224

// Notification codes

 HHN_FIRST       (0U-860U)
 HHN_LAST        (0U-879U)

 HHN_NAVCOMPLETE   (HHN_FIRST-0)
 HHN_TRACK         (HHN_FIRST-1)
 HHN_WINDOW_CREATE (HHN_FIRST-2)

typedef struct tagHHN_NOTIFY
{
    NMHDR   hdr;
    PCSTR   pszUrl; // Multi-byte, null-terminated string
} HHN_NOTIFY;

typedef struct tagHH_POPUP
{
    int       cbStruct;      // sizeof this structure
    HINSTANCE hinst;         // instance handle for string resource
    UINT      idString;      // string resource id, or text id if pszFile is specified in HtmlHelp call
    LPCTSTR   pszText;       // used if idString is zero
    POINT     pt;            // top center of popup window
    COLORREF  clrForeground; // use -1 for default
    COLORREF  clrBackground; // use -1 for default
    RECT      rcMargins;     // amount of space between edges of window and text, -1 for each member to ignore
    LPCTSTR   pszFont;       // facename, point size, char set, BOLD ITALIC UNDERLINE
} HH_POPUP;

typedef struct tagHH_AKLINK
{
    int       cbStruct;     // sizeof this structure
    BOOL      fReserved;    // must be FALSE (really!)
    LPCTSTR   pszKeywords;  // semi-colon separated keywords
    LPCTSTR   pszUrl;       // URL to jump to if no keywords found (may be NULL)
    LPCTSTR   pszMsgText;   // Message text to display in MessageBox if pszUrl is NULL and no keyword match
    LPCTSTR   pszMsgTitle;  // Message text to display in MessageBox if pszUrl is NULL and no keyword match
    LPCTSTR   pszWindow;    // Window to display URL in
    BOOL      fIndexOnFail; // Displays index if keyword lookup fails.
} HH_AKLINK;

enum {
    HHWIN_NAVTYPE_TOC,
    HHWIN_NAVTYPE_INDEX,
    HHWIN_NAVTYPE_SEARCH,
    HHWIN_NAVTYPE_BOOKMARKS,
    HHWIN_NAVTYPE_HISTORY,   // not implemented
};

enum {
    IT_INCLUSIVE,
    IT_EXCLUSIVE,
    IT_HIDDEN,
};

typedef struct tagHH_ENUM_IT
{
    int       cbStruct;          // size of this structure
    int       iType;             // the type of the information type ie. Inclusive, Exclusive, or Hidden
    LPCSTR    pszCatName;        // Set to the name of the Category to enumerate the info types in a category; else NULL
    LPCSTR    pszITName;         // volitile pointer to the name of the infotype. Allocated by call. Caller responsible for freeing
    LPCSTR    pszITDescription;  // volitile pointer to the description of the infotype.
} HH_ENUM_IT, *PHH_ENUM_IT;

typedef struct tagHH_ENUM_CAT
{
    int       cbStruct;          // size of this structure
    LPCSTR    pszCatName;        // volitile pointer to the category name
    LPCSTR    pszCatDescription; // volitile pointer to the category description
} HH_ENUM_CAT, *PHH_ENUM_CAT;

typedef struct tagHH_SET_INFOTYPE
{
    int       cbStruct;          // the size of this structure
    LPCSTR    pszCatName;        // the name of the category, if any, the InfoType is a member of.
    LPCSTR    pszInfoTypeName;   // the name of the info type to add to the filter
} HH_SET_INFOTYPE, *PHH_SET_INFOTYPE;

typedef DWORD HH_INFOTYPE;
typedef HH_INFOTYPE* PHH_INFOTYPE;

enum {
    HHWIN_NAVTAB_TOP,
    HHWIN_NAVTAB_LEFT,
    HHWIN_NAVTAB_BOTTOM,
};

#define HH_MAX_TABS 19  // maximum number of tabs

enum {
    HH_TAB_CONTENTS,
    HH_TAB_INDEX,
    HH_TAB_SEARCH,
    HH_TAB_BOOKMARKS,
    HH_TAB_HISTORY,
};

// HH_DISPLAY_SEARCH Command Related Structures and Constants

#define HH_FTS_DEFAULT_PROXIMITY (-1)

typedef struct tagHH_FTS_QUERY
{
    int cbStruct;            // Sizeof structure in bytes.
    BOOL fUniCodeStrings;    // TRUE if all strings are unicode.
    LPCTSTR pszSearchQuery;  // String containing the search query.
    LONG iProximity;         // Word proximity.
    BOOL fStemmedSearch;     // TRUE for StemmedSearch only.
    BOOL fTitleOnly;         // TRUE for Title search only.
    BOOL fExecute;           // TRUE to initiate the search.
    LPCTSTR pszWindow;       // Window to display in
} HH_FTS_QUERY;

// HH_WINTYPE Structure

typedef struct tagHH_WINTYPE {
    int     cbStruct;        // IN: size of this structure including all Information Types
    BOOL    fUniCodeStrings; // IN/OUT: TRUE if all strings are in UNICODE
    LPCTSTR pszType;         // IN/OUT: Name of a type of window
    DWORD   fsValidMembers;  // IN: Bit flag of valid members (HHWIN_PARAM_)
    DWORD   fsWinProperties; // IN/OUT: Properties/attributes of the window (HHWIN_)

    LPCTSTR pszCaption;      // IN/OUT: Window title
    DWORD   dwStyles;        // IN/OUT: Window styles
    DWORD   dwExStyles;      // IN/OUT: Extended Window styles
    RECT    rcWindowPos;     // IN: Starting position, OUT: current position
    int     nShowState;      // IN: show state (e.g., SW_SHOW)

    HWND  hwndHelp;          // OUT: window handle
    HWND  hwndCaller;        // OUT: who called this window

    HH_INFOTYPE* paInfoTypes;  // IN: Pointer to an array of Information Types

    // The following members are only valid if HHWIN_PROP_TRI_PANE is set

    HWND  hwndToolBar;      // OUT: toolbar window in tri-pane window
    HWND  hwndNavigation;   // OUT: navigation window in tri-pane window
    HWND  hwndHTML;         // OUT: window displaying HTML in tri-pane window
    int   iNavWidth;        // IN/OUT: width of navigation window
    RECT  rcHTML;           // OUT: HTML window coordinates

    LPCTSTR pszToc;         // IN: Location of the table of contents file
    LPCTSTR pszIndex;       // IN: Location of the index file
    LPCTSTR pszFile;        // IN: Default location of the html file
    LPCTSTR pszHome;        // IN/OUT: html file to display when Home button is clicked
    DWORD   fsToolBarFlags; // IN: flags controling the appearance of the toolbar
    BOOL    fNotExpanded;   // IN: TRUE/FALSE to contract or expand, OUT: current state
    int     curNavType;     // IN/OUT: UI to display in the navigational pane
    int     tabpos;         // IN/OUT: HHWIN_NAVTAB_TOP, HHWIN_NAVTAB_LEFT, or HHWIN_NAVTAB_BOTTOM
    int     idNotify;       // IN: ID to use for WM_NOTIFY messages
    BYTE    tabOrder[HH_MAX_TABS + 1];    // IN/OUT: tab order: Contents, Index, Search, History, Favorites, Reserved 1-5, Custom tabs
    int     cHistory;       // IN/OUT: number of history items to keep (default is 30)
    LPCTSTR pszJump1;       // Text for HHWIN_BUTTON_JUMP1
    LPCTSTR pszJump2;       // Text for HHWIN_BUTTON_JUMP2
    LPCTSTR pszUrlJump1;    // URL for HHWIN_BUTTON_JUMP1
    LPCTSTR pszUrlJump2;    // URL for HHWIN_BUTTON_JUMP2
    RECT    rcMinSize;      // Minimum size for window (ignored in version 1)
    int     cbInfoTypes;    // size of paInfoTypes;
} HH_WINTYPE, *PHH_WINTYPE;

enum {
    HHACT_TAB_CONTENTS,
    HHACT_TAB_INDEX,
    HHACT_TAB_SEARCH,
    HHACT_TAB_HISTORY,
    HHACT_TAB_FAVORITES,

    HHACT_EXPAND,
    HHACT_CONTRACT,
    HHACT_BACK,
    HHACT_FORWARD,
    HHACT_STOP,
    HHACT_REFRESH,
    HHACT_HOME,
    HHACT_SYNC,
    HHACT_OPTIONS,
    HHACT_PRINT,
    HHACT_HIGHLIGHT,
    HHACT_CUSTOMIZE,
    HHACT_JUMP1,
    HHACT_JUMP2,
    HHACT_ZOOM,
    HHACT_TOC_NEXT,
    HHACT_TOC_PREV,
    HHACT_NOTES,

    HHACT_LAST_ENUM,
};

typedef struct tagHHNTRACK
{
    NMHDR   hdr;
    PCSTR   pszCurUrl;      // Multi-byte, null-terminated string
    int     idAction;       // HHACT_ value
    HH_WINTYPE* phhWinType; // Current window type structure
} HHNTRACK;
*)

HWND
WINAPI
HtmlHelpA(
    HWND hwndCaller,
    LPCSTR pszFile,
    UINT uCommand,
    DWORD dwData
    );

HWND
WINAPI
HtmlHelpW(
    HWND hwndCaller,
    LPCWSTR pszFile,
    UINT uCommand,
    DWORD dwData
    );
{$EXTERNALSYM WinHelpA}
function WinHelpA(hWndMain: HWND; lpszHelp: PAnsiChar; uCommand: UINT; dwData: DWORD): BOOL; stdcall;
{$EXTERNALSYM WinHelpW}
function WinHelpW(hWndMain: HWND; lpszHelp: PWideChar; uCommand: UINT; dwData: DWORD): BOOL; stdcall;
{$EXTERNALSYM WinHelp}
function WinHelp(hWndMain: HWND; lpszHelp: PChar; uCommand: UINT; dwData: DWORD): BOOL; stdcall;


#ifdef UNICODE
#define HtmlHelp  HtmlHelpW
#else
#define HtmlHelp  HtmlHelpA
#endif // !UNICODE

// Use the following for GetProcAddress to load from hhctrl.ocx

#define ATOM_HTMLHELP_API_ANSI    (LPTSTR)((DWORD)((WORD)(14)))
#define ATOM_HTMLHELP_API_UNICODE (LPTSTR)((DWORD)((WORD)(15)))

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // __HTMLHELP_H__
