unit r_ThematicTextLayerEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  r_ThematicLayerEditor, ExtCtrls, StdCtrls,
{$IF RTLVersion < 27}
   Spin,
{$ENDIF}
  e_ThematicMap;

type
  TThematicLayerTextEditor_Frame = class(TThematicLayerEditor_Frame)
    ed_PropName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ed_Size: TEdit;
    Combo: TComboBox;
    procedure ed_PropNameChange(Sender: TObject);
    procedure ed_SizeChange(Sender: TObject);
    procedure ComboChange(Sender: TObject);
  private
    { Private declarations }
  public
     procedure SetLayer(const Value: TThematicLayer); override;
  end;

var
  ThematicLayerTextEditor_Frame: TThematicLayerTextEditor_Frame;

implementation

{$R *.DFM}

procedure TThematicLayerTextEditor_Frame.ed_PropNameChange(
  Sender: TObject);
begin
   inherited;
   Layer.PropertyName := ed_PropName.Text;
end;

procedure TThematicLayerTextEditor_Frame.SetLayer(const Value: TThematicLayer);
begin
   inherited;
   if not (TObject(Value) is TThematicLayer) then exit;
   Combo.Items.CommaText := Value.ItemsString;
   ed_PropName.Text := Value.PropertyName;
   ed_Size.Text := floatToStr(Value.TextSize);
end;

procedure TThematicLayerTextEditor_Frame.ed_SizeChange(Sender: TObject);
begin
  inherited;
  Layer.SetPropertyStringByName('TextSize',ed_Size.Text);
end;

procedure TThematicLayerTextEditor_Frame.ComboChange(Sender: TObject);
begin
   ed_PropName.Text := Combo.Text;
end;

end.
