unit r_CoordMonitor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  r_OrbisFrame, StdCtrls;

type
  TCoordMonitor_Frame = class(TOrbis_Frame)
    Label1: TLabel;
    Label2: TLabel;
    l_X: TLabel;
    l_Y: TLabel;
    procedure Label1Click(Sender: TObject);
    procedure l_XClick(Sender: TObject);
  private
    FWGS84: boolean;
    FMod2: boolean;
    procedure SetWGS84(const Value: boolean);
    procedure SetMod2(const Value: boolean);
    { Private declarations }
  public
     property WGS84: boolean read FWGS84 write SetWGS84;
     property Mod2: boolean read FMod2 write SetMod2;
     procedure SetLabels;
    { Public declarations }
  end;


implementation

{$R *.DFM}

procedure TCoordMonitor_Frame.Label1Click(Sender: TObject);
begin
   WGS84 := not WGS84;
   SetLabels;
end;

procedure TCoordMonitor_Frame.SetMod2(const Value: boolean);
begin
  FMod2 := Value;
end;

procedure TCoordMonitor_Frame.SetWGS84(const Value: boolean);
begin
  FWGS84 := Value;
end;

procedure TCoordMonitor_Frame.l_XClick(Sender: TObject);
begin
   Mod2 := not Mod2;
   SetLabels;
end;

procedure TCoordMonitor_Frame.SetLabels;
begin
   if WGS84 then
   begin
      Label1.Caption := 'N:';
      Label2.Caption := 'E:';
   end
   else
   begin
      if Mod2 then
      begin
         Label1.Caption := 'Y:';
         Label2.Caption := 'X:';
      end
      else
      begin
         Label1.Caption := 'X:';
         Label2.Caption := 'Y:';
      end;
   end;
end;

end.
