unit t_OrbisPageFrame;
interface
uses
   ComCtrls,
   r_ORBISPageFrame,
   t_OrbisFrame,
   t_ControlTool,
   Tools;

type
TOrbisFormPage = class(TControlTool)
private
   function   GetTabSheet: TTabSheet;
protected
    procedure SetName(aName: string); override;
public
   procedure  CreateControl; override;
   property   TabSheet: TTabSheet read GetTabSheet;
end;

TOrbisPageFrame = class(TOrbisFrame)
  private
    function GetPageFrame: TOrbisPage_Frame;
    procedure SetNewPageName(const Value: string);
public
   procedure   CreateFrame; override;

   function    AddTool(aTool: TTool): TTool; override;
   property    PageFrame: TOrbisPage_Frame read GetPageFrame;
published
   property    NewPageName: string write SetNewPageName stored false;
end;


implementation
uses
   Forms,
   SysUtils,
   e_Class;

{ TOrbisPageFrame }

function TOrbisPageFrame.AddTool(aTool: TTool): TTool;
begin
   result := inherited AddTool(aTool);
   if result is TOrbisFormPage then
   begin
      TOrbisFormPage(result).Control.Name := 'Tab'+IntToStr(PageFrame.PageControl.PageCount);
      TOrbisFormPage(result).Owner := PageFrame;
      TOrbisFormPage(result).TabSheet.PageControl := PageFrame.PageControl;
   end;
end;

procedure TOrbisPageFrame.CreateFrame;
begin
   aFrame := TORBISPage_Frame.Create(nil);
   PageFrame.Tool := Self;
end;

function TOrbisPageFrame.GetPageFrame: TOrbisPage_Frame;
begin
   result := TORBISPage_Frame(aFrame);
end;

procedure TOrbisPageFrame.SetNewPageName(const Value: string);
var
   //Tab: TTabSheet;
   P: TOrbisFormPage;
begin
   {
   Tab := TTabSheet.Create(PageForm);
   Tab.Name := 'Tab'+IntToStr(PageForm.PageControl.PageCount);
   Tab.Caption := Value;
   Tab.PageControl := PageForm.PageControl;
   }
   P := TOrbisFormPage.Create;
   P.Name := Value;
   AddTool(P);
end;

{ TOrbisFormPage }

procedure TOrbisFormPage.CreateControl;
var
   Tab: TTabSheet;
begin
   Tab := TTabSheet.Create(Application);
   Control := Tab;
end;

function TOrbisFormPage.GetTabSheet: TTabSheet;
begin
   result := TTabSheet(Control);
end;

procedure TOrbisFormPage.SetName(aName: string);
begin
   inherited;
   if TabSheet = nil then exit;
   TabSheet.Caption := aName;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbisPageFrame);
   RegisterOrbisClass(TOrbisFormPage);
END.


