unit t_ScaleMonitor;

interface
uses
   Elements,
   m_InterA,
   r_ScaleMonitor,
   t_OrbisFrame;

type

TScaleMonitorFrame = class(TOrbisFrame)
private
    function GetScaleFrame: TScaleMonitor_Frame;
public
   procedure CreateFrame; override;
   procedure On_tm_Review(var aMessage: TOrbisMessage; var Handled: boolean); override;
   property  ScaleFrame: TScaleMonitor_Frame read GetScaleFrame;
end;


implementation
uses
   SysUtils,
   e_Class;

{ TScaleMonitorFrame }

procedure TScaleMonitorFrame.CreateFrame;
begin
   aFrame := TScaleMonitor_Frame.Create(nil);
   ScaleFrame.Tool := Self;
end;

function TScaleMonitorFrame.GetScaleFrame: TScaleMonitor_Frame;
begin
   result := TScaleMonitor_Frame(aFrame);
end;

procedure TScaleMonitorFrame.On_tm_Review(var aMessage: TOrbisMessage;
  var Handled: boolean);
begin
   if Device = nil then exit;
   if Device.Projection.Scale < 100 then
      ScaleFrame.ed_Scale.Text := FormatFloat('0.##',Device.Projection.Scale)
   else
      ScaleFrame.ed_Scale.Text := FormatFloat('0',Device.Projection.Scale);
   ScaleFrame.ed_VirtualScale.Text := FormatFloat('0',Device.Projection.VirtualScale);
end;

INITIALIZATION
   RegisterOrbisClass(TScaleMonitorFrame);
END.
