unit t_Orbis01PDialog;
interface
uses
   f_Orbis01PDialog,
   t_OrbisDialog;
type

TOrbis01PDialog = class(TOrbisDialog)
private
    FNewProject: boolean;
    FProjectDirectory: string;
    function GetForm: TOrbis01PDialog_Form;
    procedure SetNewProject(const Value: boolean);
    procedure SetProjectDirectory(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TOrbis01PDialog_Form read GetForm;
   property  NewProject: boolean read FNewProject write SetNewProject;
published
   property  ProjectDirectory: string read FProjectDirectory write SetProjectDirectory;
end;

implementation
uses
   Forms,
   SysUtils,
   e_Class,
   e_LHCProject,
   u_String;

{ TOrbis01PDialog }

procedure TOrbis01PDialog.CreateForm;
begin
   aForm := TOrbis01PDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TOrbis01PDialog.DoIt;
var
   P: TORBISLHCProject;
   S,S1,S3: string;
   PName: string;
   i: integer;
begin
   S := GetAbsolutePath(ProjectDirectory);
   CheckBackSlash(S);
   S1 := 'LHP';
   S3 := '';
   if FileExists(S + S1 + '.OPR') then
   begin
      i := 1;
      S3 := IntToStr(i);
      while FileExists(S + S1 + S3 + '.OPR') do
      begin
         Inc(i);
         S3 := IntToStr(i);
      end;
   end;
   PName := (S1 + S3);
   Inherited;
   case Result of
      1:
      begin
         P := TORBISLHCProject.Create;
         P.Name := PName;
         P.Author := 'ORBIS01';
         if Form.rb_XML.CHecked then
            P.Comment := 'XML'
         else
            P.Comment := 'BLK';
         P.ExternalDataDirectory := Form.ed_Path.Text;
         P.ExternalParcelDirectory := '';
         P.ExportDataDirectory := '';
         P.ExportParcelDirectory := '';
         P.DataDirectory := ProjectDirectory;
         Output := P;
      end;
   end;
end;

function TOrbis01PDialog.GetForm: TOrbis01PDialog_Form;
begin
   result := TOrbis01PDialog_Form(aForm);
end;

procedure TOrbis01PDialog.SetNewProject(const Value: boolean);
begin
  FNewProject := Value;
end;


procedure TOrbis01PDialog.SetProjectDirectory(const Value: string);
begin
  FProjectDirectory := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TOrbis01PDialog);
END.
