unit F_gauge;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  //Gauges,
  ComCtrls;

type
  TF_gaugeForm = class(TForm)
    ProgressBar: TProgressBar;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    FCloseQuery: boolean;
    procedure SetMaxValue(aVal: longInt);
    function  GetMaxValue: longInt;
    procedure SetProgress(aVal: longInt);
    function  GetProgress: longInt;
  public
    { Public declarations }
    destructor Destroy; override;
    function RealyClose(aText: string): boolean;
  published
    property DoCloseQuery: boolean read FCloseQuery write FCloseQuery;
    property MaxValue: longInt read GetMaxValue write SetMaxValue;
    property Progress: longInt read GetProgress write SetProgress;
  end;


implementation

{$R *.DFM}
{
uses
  !PubUnits;
}


destructor TF_gaugeForm.Destroy;
begin
  Close;
  inherited Destroy
end;


procedure TF_gaugeForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  DoCloseQuery:= true;
  CanClose:= true
end;


function TF_gaugeForm.RealyClose(aText: string): boolean;
begin
  result:= MessageDlg(aText, mtConfirmation, mbOKCancel, 0) = mrOK
end;


procedure TF_gaugeForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Screen.Cursor:= crDefault;
  Action:= caFree;	
end;

procedure TF_gaugeForm.FormShow(Sender: TObject);
begin
  Screen.Cursor:= crHourGlass;
end;


procedure TF_gaugeForm.SetMaxValue(aVal: longInt);
begin
//  Gauge.MaxValue:= aVal
  ProgressBar.Max:= aVal
end;

function  TF_gaugeForm.GetMaxValue: longInt;
begin
//  result:= Gauge.MaxValue
  result:= ProgressBar.Max
end;

procedure TF_gaugeForm.SetProgress(aVal: longInt);
begin
//  Gauge.Progress:= aVal;
  if ProgressBar.Max > 0 then
     ProgressBar.Position:= aVal
end;

function  TF_gaugeForm.GetProgress: longInt;
begin
//  result:= Gauge.Progress
  result:= ProgressBar.Position
end;



end.
