unit E_color;

interface
uses
  Graphics,
  e_Pale;

type
  TColorArray = array[0..15] of TColor;
const
  OrigColorTab: TColorArray =
  (clWhite,
   clNavy,  {tmave modra}
   clGreen,
   clTeal,    {tmave modrozelena}
   clMaroon, {tmave cervena}
   clPurple,
   4210816,         {hneda}
   clGray,
   clBlue,         {svetle modra}
   clLime,         {svetle zelena}
   clAqua,         {svetle modro zelena}
   clRed,          {svetle cervena}
   clFuchsia,               {svetle fialova}
   clBlack,
   clYellow,
   clSilver);
  (*
  FColorTab: TColorArray =
  (clWhite,
   clNavy,  {tmave modra}
   clGreen,
   clTeal,    {tmave modrozelena}
   clMaroon, {tmave cervena}
   clPurple,
   4210816,         {hneda}
   clGray,
   clBlue,         {svetle modra}
   clLime,         {svetle zelena}
   clAqua,         {svetle modro zelena}
   clRed,          {svetle cervena}
   clFuchsia,               {svetle fialova}
   clBlack,
   clYellow,
   clSilver);
  *)

  PaletFile: string= '';
  SystemColorPalette: TColorPalette = nil;


function DejBarvicku(aIndex: integer): Integer;
function DejBarvickuTopolW(aIndex: integer): SmallInt;
procedure NastavBarvicky;
procedure NactiBarvickuZeSouboru(aName: string);
procedure InitSystemColorPalette;
function TopolWtoWinColor(aSI: smallInt): longInt;
function WinColorToTopolW(aColor: longInt): smallInt;


implementation
uses
  Controls,
  Forms,
  Windows,
  SysUtils,
  {!T_Main,}
  F_Color;


procedure InitSystemColorPalette;
var
   i: integer;
begin
   if SystemColorPalette = nil then
   begin
      SystemColorPalette := TColorPalette.Create;
   end;
   SystemColorPalette.FreeAll;
   for i := 0 to 15 do
   begin
      SystemColorPalette.NextColor := OrigColorTab[i];
   end;
end;


function TopolWtoWinColor(aSI: smallInt): longInt;
var
  lR, lB, lG: longInt;
begin
  if (aSI and $8000) <> 0 then
  begin
    aSI:= -aSI;
    { filtrace a peveden na 8 bit}
    lR:= (aSI and $7C00) shr 7;
    lG:= (aSI and $03E0) shr 2;
    lB:= (aSI and $001F) shl 3;
    if lR = 248 then lR:= 255;
    if lG = 248 then lG:= 255;
    if lB = 248 then lB:= 255;
    result:= (lB shl 16) + (lG shl 8) + (lR)
  end
  else
    result:= clBlack
end;



function WinColorToTopolW(aColor: longInt): smallInt;
var
  lR, lB, lG, rs: integer;
begin
  lR:= aColor and $F8;
  lG:= (aColor and $F800) shr 8;
  lB:= (aColor and $F80000) shr 16;
  rs:= (lB shr 3) + (lG shl 2) + (lR shl 7);// + $8000;
  result := -smallint(rs);
end;



function DejBarvicku(aIndex: integer): Integer;
begin
   if (aIndex and $8000) = 0 then
   begin
      if aIndex > SystemColorPalette.LastIndex then
         result := 0
      else
         result := SystemColorPalette.Color[aIndex];
   end
   else
      result:= TopolWtoWinColor(aIndex);
  {
  if (B16>=0) and (B16 < 16) then
     result:= FColorTab[B16]
  else
    result:= TopolWtoWinColor(B16)
  }
end;

function DejBarvickuTopolW(aIndex: integer): SmallInt;
var
   aColor: integer;
begin
   if (aIndex and $8000) = 0 then
   begin
      if aIndex > SystemColorPalette.LastIndex then
         aColor := 0
      else
         aColor := SystemColorPalette.Color[aIndex];
      result := WinColorToTopolW(aColor);
   end
   else
      result:= aIndex;
end;


procedure NastavBarvicky;
var
  Form: TFormColor;
  i: integer;
begin
  Form:= TFormColor.Create(Application);
  Form.Palette := SystemColorPalette;
  Form.PaletteFileName := PaletFile;
  case Form.ShowModal of
  mrOK:
     begin
        SystemColorPalette.FreeAll;
        for i := 0 to Form.DG.RowCount - 1 do
        begin
           SystemColorPalette.AddColorName(Form.FColors[i],Form.DG.Cells[2,i]);
        end;
        PaletFile := Form.PaletteFileName;
     end;

  end;
  Form.Free;
end;



procedure NactiBarvickuZeSouboru(aName: string);
var
  F: system.text;
  R, G, B: integer;
  S: string;
  Barva: integer;
begin
  if aName = '' then exit;
  system.assign(F, aName);
  {$I-} system.reset(F) {$I+};
  if ioResult = 0 then
  begin
    SystemColorPalette.FreeAll;
    //for I:= 0 to 15 do
    while not EOF(F) do
    begin
      {$I-} readln(F,R,G,B,S); {$I+}
      if ioResult = 0 then
      begin
        R:= R*4;
        if R>128 then R:= R+3;
        G:= G*4;
        if G>128 then G:= G+3;
        B:= B*4;
        if B>128 then B:= B+3;
        Barva:=  RGB(R, G, B);
        if S = '' then
           S := 'Color '+IntToStr(SystemColorPalette.Count);
        SystemColorPalette.AddColorName(Barva,S);
        //FColorTab[I]:= Barva
      end
    end;
    system.close(F)
  end
  else
     PaletFile := '';
end;


INITIALIZATION
END.
