unit e_RotTxt;

interface

uses
   Classes,
// KERNEL
   Elements,
// GLIB
   g_Elems;


type

TRotTextBlock = class(TTextBlock)
private
   procedure SetSorted(aB: boolean);
   function  GetSorted: boolean;
public
   constructor Create; override;
   destructor  Destroy; override;
published
   property LineHeight: double read GetLineHeight write SetLineHeight;
   property TextHeight: double read GetTextHeight write SetTextHeight;
   property Lines: TStringList read GetLines write SetLines;
   property LinesPlus: TStringList write SetLinesPlus;
   property LinesCount: longInt read GetLinesCount;
   property Delimiter: string read FDelimiter write FDelimiter;
   property Sorted: boolean read GetSorted write SetSorted;
end;


implementation


{ TTextBlock }

constructor TTextBlock.Create;
begin
  inherited create;
   LineHeight := 0.015;
   TextHeight := 0.01;
end;

destructor  TTextBlock.Destroy;
begin
   Lines := nil;
  inherited Destroy
end;

function    TTextBlock.GetLineHeight: double;
begin
   result := FLineHeight;
end;

function    TTextBlock.GetTextHeight: double;
begin
   result := FTextHeight;
end;

function    TTextBlock.GetLines: TStringList;
begin
   result := FLines;
end;

function    TTextBlock.GetLinesCount: longInt;
begin
   result := 0;
   if FLines = nil then exit;
   result := FLines.Count;
end;

procedure   TTextBlock.SetLineHeight(aValue: double);
begin
   FLineHeight := aValue;
end;

procedure   TTextBlock.SetTextHeight(aValue: double);
begin
   FTextHeight := aValue;
end;

procedure   TTextBlock.SetLines(aValue: TStringList);
begin
   if FLines <> nil then
   begin
      FLines.Free;
      FLines := nil;
   end;
   Flines := aValue;
   if FLines <> nil then
      FLines.Sorted:= FSorted
end;


procedure   TTextBlock.SetLinesPlus(aValue: TStringList);
var
  I: longInt;
begin
   if FLines = nil then exit;

   if FLines.Count <> aValue.Count then exit;
   for I:= 0 to FLines.Count-1 do
   begin
     Flines.Strings[I] := FLines.Strings[I] + FDelimiter + aValue.Strings[I];
   end;
end;

procedure TTextBlock.SetSorted(aB: boolean);
begin
  FSorted:= aB;
  if FLines <> nil then
     FLines.Sorted:= aB
end;

function  TTextBlock.GetSorted: boolean;
begin
  if FLines <> nil then
  begin
    result:= FLines.Sorted;
    FSorted:= result
  end
  else
    result:= FSorted
end;


procedure MakeDialog(aB: boolean);
begin

end;


BEGIN
   RegisterOrbisClass(TTextBlock);
END.
