unit _iniFile;

interface

uses
  Classes, IniFiles;


type


TRealIniFile = class(TIniFile)
public
  function  ReadDouble(const Section, Ident: string; const Default: double): double;
  procedure WriteDouble(const Section, Ident: string; const aValue: double);
  procedure WriteSection(aSection: string; aStrings: TStringList);
end;


function GetModulIniFile: string;


implementation

uses
  SysUtils,
  U_String;



function GetModulIniFile: string;
var
   S: string;
begin
   S :=  ChangeFileExt(ExtractFileName(ParamStr(0)), '.INI');
   result := GetAbsolutePath(S);
end;


function TRealIniFile.ReadDouble(const Section, Ident: string; const Default: double): double;
var
  PomStr: string;
  Code: integer;
begin
  PomStr:= readString(Section, Ident, '');
  if PomStr = '' then result:= Default
  else
  begin
    val(PomStr, result, Code);
    if Code <> 0 then
    begin
      if (PomStr[Code] = ',') then
      begin
         PomStr[Code]:= '.';
         val(PomStr, result, Code);
         if Code <> 0 then result:= Default
      end
      else
        result:= Default
    end;
  end;
end;


procedure TRealIniFile.WriteDouble(const Section, Ident: string; const aValue: double);
begin
  writeString(Section, Ident, FloatToStr(aValue));
end;



procedure TRealIniFile.WriteSection(aSection: string; aStrings: TStringList);
var
  I: longInt;
  aName, aValue: string;
begin
   EraseSection(aSection);
   for i := 0 to aStrings.Count -1 do
   begin
     StringAsParameter(aStrings.Strings[i], aName, aValue);
     WriteString(aSection, aName, aValue);
   end;
end;



end.
