unit e_ToolModel;

interface
uses
   // KERNEL
   e_ElementModel,
   Elements;

type

TToolModel = class(TElementModel)
private
   FDynamicTool: boolean;
   FShortCut: string;
   function GetModelTools: TOwnerEntity;
   function GetNoModelTools: boolean;
   procedure SetNewToolName(const Value: string);
   function GetStrTools: string;
   procedure SetDynamicTool(const Value: boolean);
   procedure SetShortCut(const Value: string);
protected
   property strTools: string read GetStrTools;
public
  function GetLastToolModel: TToolModel;
published
   property DynamicTool: boolean read FDynamicTool write SetDynamicTool;
   property ModelTools: TOwnerEntity read GetModelTools stored false;
   property NoModelTools: boolean read GetNoModelTools stored false;
   property NewToolName: string write SetNewToolName stored False;
   property LastTool: TToolModel read GetLastToolModel stored False;
   property ShortCut: string read FShortCut write SetShortCut;
end;

implementation
uses
   e_Class;

{ TToolModel }

function TToolModel.GetLastToolModel: TToolModel;
begin
   result := nil;
   if NoModelTools then exit;
   result := TToolModel(ModelTools.Elements[ModelTools.Count-1])
end;

function TToolModel.GetModelTools: TOwnerEntity;
begin
   result := TOwnerEntity(FindOrCreateElementName(TOwnerEntity,strTools));
end;

function TToolModel.GetNoModelTools: boolean;
var
   E: TOwnerEntity;
begin
   result := true;
   E := TOwnerEntity(FindElementName(strTools));
   if (E = nil) or (E.NoElements) then exit;
   result := false;
end;

function TToolModel.GetStrTools: string;
begin
   result := 'TOOLS';
end;


procedure TToolModel.SetDynamicTool(const Value: boolean);
begin
   FDynamicTool := Value;
end;

procedure TToolModel.SetNewToolName(const Value: string);
var
   TM: TToolModel;
begin
   TM := TToolModel.Create;
   TM.Name := Value;
   ModelTools.AddElement(TM);
end;


procedure TToolModel.SetShortCut(const Value: string);
begin
   FShortCut := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TToolModel);
END.
