unit T_CreateParcelModel_Other;

interface
uses
   e_KatastrModel,
   e_Geometry,
   e_SKMap,
   e_TmpText,
   e_Transformation,
   t_Transformation,
   e_Type,
   Elements,
   Tools;

type

TCreateParcelModelFromDGN = class(TTool)
  private
    FWithOutDialog: boolean;
    FFileName: string;
    FARE_PAR: TEntity;
    FLIN_PAR: TEntity;
    FDGN: TEntity;
    FTextParcelyLevel: string;
    FKatastrLevels: string;
    FParcelyLevels: string;
    FAreas: TEntity;
    FAre_ParcelaColor: integer;
    FLin_ParcelaSymbol: integer;
    FLin_ParcelaColor: integer;
    FLin_KatastrSymbol: integer;
    FLin_ParcelaGroup: integer;
    FLin_KatastrGroup: integer;
    FLin_KatastrColor: integer;
    FTexts: TEntity;
    FKU_KOD: integer;
    FCoordinateSystem: integer;
    FTrafoRequired: boolean;
    FTrafoFinished: boolean;
    FTrafoTable: TTransformationTable;
    FTrafo: TTransformation_Kolinearni2D;
    FGusterberg: TMaps_SK;
    FStepan: TMaps_SK;
    FTextKatastrLevel: string;
    FTextStavebniLevel: string;
    FUserDialog: string;
    FTest: boolean;
    FTXErr: integer;
    FLin_DPMSymbol: integer;
    FLin_BudovaSymbol: integer;
    FLin_BudovaGroup: integer;
    FLin_DPMColor: integer;
    FLin_DPMGroup: integer;
    FLin_BudovaColor: integer;
    FLIN_PARSLU: TEntity;
    function GetParcelModel: Tgis_ParcelModel;
    procedure SetParcelModel(const Value: Tgis_ParcelModel);
    procedure SetFileName(const Value: string);
    procedure SetWithOutDialog(const Value: boolean);
    procedure SetARE_PAR(const Value: TEntity);
    procedure SetLIN_PAR(const Value: TEntity);
    procedure SetDGN(const Value: TEntity);
    procedure SetKatastrLevels(const Value: string);
    procedure SetParcelyLevels(const Value: string);
    procedure SetTextParcelyLevel(const Value: string);
    function GetLevel(aIndex: string): TEntity;
    procedure SetAreas(const Value: TEntity);
    procedure SetAre_ParcelaColor(const Value: integer);
    procedure SetLin_KatastrColor(const Value: integer);
    procedure SetLin_KatastrGroup(const Value: integer);
    procedure SetLin_KatastrSymbol(const Value: integer);
    procedure SetLin_ParcelaColor(const Value: integer);
    procedure SetLin_ParcelaGroup(const Value: integer);
    procedure SetLin_ParcelaSymbol(const Value: integer);
    procedure SetTexts(const Value: TEntity);
    procedure SetKU_KOD(const Value: integer);
    procedure SetCoordinateSystem(const Value: integer);
    procedure SetTrafoFinished(const Value: boolean);
    procedure SetTrafoRequired(const Value: boolean);
    function GetTrafoTable: TTransformationTable;
    function GetTrafo: TTransformation_Kolinearni2D;
    procedure SetGusterberg(const Value: TMaps_SK);
    procedure SetStepan(const Value: TMaps_SK);
    procedure SetTextKatastrLevel(const Value: string);
    procedure SetTextStavebniLevel(const Value: string);
    procedure SetUserDialog(const Value: string);
    procedure SetTest(const Value: boolean);
    procedure SetTXErr(const Value: integer);
    procedure SetLin_BudovaColor(const Value: integer);
    procedure SetLin_BudovaGroup(const Value: integer);
    procedure SetLin_BudovaSymbol(const Value: integer);
    procedure SetLin_DPMColor(const Value: integer);
    procedure SetLin_DPMGroup(const Value: integer);
    procedure SetLin_DPMSymbol(const Value: integer);
    procedure SetLIN_PARSLU(const Value: TEntity);
protected
   procedure PrepareAndCopyLines; virtual;
   procedure CreateAreas; virtual;
   procedure CreateParcely; virtual;
   procedure ProcessTmpText(TmpText: TtmpText; Parcis, Parpod: integer; ARE: TAreaElement); virtual;
public
   procedure DoIt; override;
   procedure Transform;
   procedure CHeckProperties; virtual;
   procedure OpenFile; virtual;
   procedure ReadData; virtual;
   procedure CreateModel; virtual;
   procedure Finish; virtual;
   property  DGN: TEntity read FDGN write SetDGN;
   property  TrafoTable: TTransformationTable read GetTrafoTable;
   property  Trafo: TTransformation_Kolinearni2D read GetTrafo;
   property  Level[aIndex:string]: TEntity read GetLevel;
   property  Areas: TEntity read FAreas write SetAreas;
   property  Texts: TEntity read FTexts write SetTexts;
published
   property ParcelModel: Tgis_ParcelModel read GetParcelModel write SetParcelModel;
   property ARE_PAR: TEntity read FARE_PAR write SetARE_PAR;
   property LIN_PAR: TEntity read FLIN_PAR write SetLIN_PAR;
   property LIN_PARSLU: TEntity read FLIN_PARSLU write SetLIN_PARSLU;
   property ParcelyLevels: string read FParcelyLevels write SetParcelyLevels;
   property KatastrLevels: string read FKatastrLevels write SetKatastrLevels;
   property TextParcelyLevel: string read FTextParcelyLevel write SetTextParcelyLevel;
   property TextStavebniLevel: string read FTextStavebniLevel write SetTextStavebniLevel;
   property TextKatastrLevel: string read FTextKatastrLevel write SetTextKatastrLevel;
   property FileName: string read FFileName write SetFileName;
   property WithOutDialog: boolean read FWithOutDialog write SetWithOutDialog;
   property Lin_ParcelaGroup: integer read FLin_ParcelaGroup write SetLin_ParcelaGroup;
   property Lin_ParcelaColor: integer read FLin_ParcelaColor write SetLin_ParcelaColor;
   property Lin_ParcelaSymbol: integer read FLin_ParcelaSymbol write SetLin_ParcelaSymbol;
   property Lin_BudovaGroup: integer read FLin_BudovaGroup write SetLin_BudovaGroup;
   property Lin_BudovaColor: integer read FLin_BudovaColor write SetLin_BudovaColor;
   property Lin_BudovaSymbol: integer read FLin_BudovaSymbol write SetLin_BudovaSymbol;
   property Lin_DPMGroup: integer read FLin_DPMGroup write SetLin_DPMGroup;
   property Lin_DPMColor: integer read FLin_DPMColor write SetLin_DPMColor;
   property Lin_DPMSymbol: integer read FLin_DPMSymbol write SetLin_DPMSymbol;
   property Lin_KatastrGroup: integer read FLin_KatastrGroup write SetLin_KatastrGroup;
   property Lin_KatastrColor: integer read FLin_KatastrColor write SetLin_KatastrColor;
   property Lin_KatastrSymbol: integer read FLin_KatastrSymbol write SetLin_KatastrSymbol;
   property Are_ParcelaColor: integer read FAre_ParcelaColor write SetAre_ParcelaColor;
   property KU_KOD: integer read FKU_KOD write SetKU_KOD;
   property  CoordinateSystem: integer read FCoordinateSystem write SetCoordinateSystem;
   property  TrafoRequired: boolean read FTrafoRequired write SetTrafoRequired;
   property  TrafoFinished: boolean read FTrafoFinished write SetTrafoFinished;
   property  Gusterberg: TMaps_SK read FGusterberg write SetGusterberg;
   property  Stepan: TMaps_SK read FStepan write SetStepan;
   property  UserDialog: string read FUserDialog write SetUserDialog;
   property  Test: boolean read FTest write SetTest;
   property  TXErr: integer read FTXErr write SetTXErr;
end;

TCreateParcelModelFromDKM =  class(TCreateParcelModelFromDGN)
private
    FLastLevel: integer;
    FLastLineElement: TPolyLineElement;
    FLineReading: boolean;
    FL_K: integer;
    FL_T: integer;
    FY0: double;
    FX0: double;
    FRCoord: boolean;
    FHID: TEntity;
    FKVAL_B: integer;
    FIDReading: boolean;
    FLostPoint: boolean;
    FRealLostPoint: boolean;
    FTestID: integer;
    FFileName1: string;
    FVGI: boolean;
    FLastObject: string;
    FLastTmpText: TtmpText;
    FPARcelaReading: boolean;
    FLastARE: TPolyLineAreaElement;
    FHoleReading: boolean;
    FLastHole: TPolyLineAreaElement;
    procedure SetLastLevel(const Value: integer);
    procedure SetLastLineElement(const Value: TPolyLineElement);
    procedure SetLineReading(const Value: boolean);
    procedure SetL_K(const Value: integer);
    procedure SetL_T(const Value: integer);
    procedure SetX0(const Value: double);
    procedure SetY0(const Value: double);
    procedure SetRCoord(const Value: boolean);
    function GetHID: TEntity;
    procedure SetKVAL_B(const Value: integer);
    procedure SetIDReading(const Value: boolean);
    procedure SetLostPoint(const Value: boolean);
    procedure SetRealLostPoint(const Value: boolean);
    procedure SetTestID(const Value: integer);
    procedure SetFileName1(const Value: string);
    procedure SetVGI(const Value: boolean);
    procedure SetLastObject(const Value: string);
    procedure SetLastTmpText(const Value: TtmpText);
    procedure SetPARcelaReading(const Value: boolean);
    procedure SetLastARE(const Value: TPolyLineAreaElement);
    procedure SetHoleReading(const Value: boolean);
    procedure SetLastHole(const Value: TPolyLineAreaElement);
protected
   procedure PrepareAndCopyLines; override;
   procedure CreateAreas; override;
   procedure CreateParcely; override;
public
   procedure OpenFile; override;
   procedure ReadData; override;
   procedure ProcessAfterRead; virtual;
   procedure ProcessLine(const aLine: string); virtual;
   procedure StartLineElement;
   procedure FinishLineElement(Layer: TEntity; _Druh,_Barva,_Znacka: integer);
   procedure FinishLineTest; virtual;
   procedure AddIDBod(const aX,aY: double; const aB, aCislo: string);
   procedure AddIDBodFinal(const aX,aY: double; const aB, aCislo: string);
   property  HID: TEntity read GetHID;
   property  LastLevel: integer read FLastLevel write SetLastLevel;
   property  LastObject: string read FLastObject write SetLastObject;
   property  LastLineElement: TPolyLineElement read FLastLineElement write SetLastLineElement;
   property  LastTmpText: TtmpText read FLastTmpText write SetLastTmpText;
   property  LastARE: TPolyLineAreaElement read FLastARE write SetLastARE;
   property  LastHole: TPolyLineAreaElement read FLastHole write SetLastHole;
   property  LineReading: boolean read FLineReading write SetLineReading;
   property  IDReading: boolean read FIDReading write SetIDReading;
   property  PARcelaReading: boolean read FPARcelaReading write SetPARcelaReading;
   property  HoleReading: boolean read FHoleReading write SetHoleReading;
   property  L_K: integer read FL_K write SetL_K;
   property  L_T: integer read FL_T write SetL_T;
   property  KVAL_B: integer read FKVAL_B write SetKVAL_B;
   property  X0: double read FX0 write SetX0;
   property  Y0: double read FY0 write SetY0;
   property  LostPoint: boolean read FLostPoint write SetLostPoint;
   property  RealLostPoint: boolean read FRealLostPoint write SetRealLostPoint;
   property  TestID: integer read FTestID write SetTestID;
published
   property  RCoord: boolean read FRCoord write SetRCoord;
   property  FileName1: string read FFileName1 write SetFileName1;
   property  VGI: boolean read FVGI write SetVGI;
end;

THPEntity = class(TOwnerEntity)
private
   FParSpoj: integer;
   procedure SetParSpoj(const Value: integer);
public
   property  ParSpoj: integer read FParSpoj write SetParSpoj;
end;


TCreateParcelModelFromISKN = class(TCreateParcelModelFromDKM)
private
   FPARs: TEntity;               // parcely podle ID
   FIDs: TEntity;                // body podle ID
   FHPs: TEntity;                // Hranice parcel podle ID
   FOBs: TEntity;                // Hranice budov podle ID
   FDPMs: TEntity;               // Hranice dalsich prvku mapy podle ID

   FVLAs: TEntity;               // vlastnictvi podle ID
   FOPSUBs: TEntity;             // vlastnici a majitele
   FTels: TEntity;               // LV podle ID
   FRZOs: TEntity;                // zpusob ochrany pozemku podle ID
   FActualHP: THPEntity;           // aktualni HP pro vlozeni sbp
   FActualOB: THPEntity;           // aktualni OB pro vlozeni sbp
   FActualDPM: THPEntity;          // aktualni DPM pro vlozeni sbp

   FDSOBR: TStringListElement;   // Veta bodu
   FDSBP: TStringListElement;    // Veta linie (spojeni)
   FDPAR: TStringListELement;    // Veta parcely
   FDOBDEBO: TStringListELement; // Veta definicniho boduparcely

   FDVLA: TStringListElement;    // Veta vlastnictvi
   FDTEL: TStringListElement;    // Veta LV
   FDRZO: TStringListElement;    // Veta Zpusobu ochrany
   FDOPSUB: TStringListElement;  // Veta vlastnika
   FDKATUZE: TStringListELement; // Veta Katastru
   FDOP: TStringListElement;     // Veta obrazu parcely
   FErrID: TStringListElement;   // test podezrela ID
    FMajitele: Tgis_Majitele;
    FNoMaj: boolean;
    FNoPar: boolean;
    FIsHP: boolean;
    FErrHP: integer;
    FLostPoint: boolean;
    FRealLostPoint: boolean;
    FTXNopar: integer;
    FLide: Tgis_People;
    FPNT: TEntity;
    FParcelyFromModel: boolean;
    procedure SetMajitele(const Value: Tgis_Majitele);
    procedure SetNoMaj(const Value: boolean);
    procedure SetNoPar(const Value: boolean);
    procedure SetTestFile(const Value: boolean);
    procedure SetTestFile1(const Value: boolean);
    procedure SetTXNopar(const Value: integer);
    procedure SetLide(const Value: Tgis_People);
    procedure SetPNT(const Value: TEntity);
    procedure SetParcelyFromModel(const Value: boolean);
protected
   procedure ProcessTmpText(TmpText: TtmpText; Parcis, Parpod: integer; ARE: TAreaElement); override;
   procedure ProcessTmpTextAsPoint(TmpText: TtmpText);
public
   procedure PrepareData;
   procedure FinishData;
   procedure ReadData; override;
   procedure ProcessAfterRead; override;
   procedure ProcessLine(const aLine: string); override;
   procedure FinishLineTest; override;
   procedure GetHP(HPID: string);
   procedure GetOB(OBID: string);
   procedure GetDPM(DPMID: string);
published
   property Majitele: Tgis_Majitele read FMajitele write SetMajitele;
   property Lide: Tgis_People read FLide write SetLide;
   property NoPar: boolean read FNoPar write SetNoPar;
   property NoMaj: boolean read FNoMaj write SetNoMaj;
   property TestFile: boolean write SetTestFile stored false;
   property TestFile1: boolean write SetTestFile1 stored false;
   property TXNopar: integer read FTXNopar write SetTXNopar;
   property PNT: TEntity read FPNT write SetPNT;
   property ParcelyFromModel: boolean read FParcelyFromModel write SetParcelyFromModel;
end;


implementation
uses
   Classes,
   Dialogs,
   FOrms,
   SysUtils,
   cpConvrt,
   e_Class,
   e_GeometryElement,
   e_QTree,
   e_Sort,
   e_TopolElements,
   m_Proj,
   Mathlib,
   g_Elems,
   t_Select,
   t_Applac,
   t_AreMak,
   t_DGNImp,
   t_QTreeTools,
   t_SelFil,
   t_Sort,
   u_String;



{ TCreateParcelModelFromDGN }

procedure TCreateParcelModelFromDGN.CreateModel;
begin
   PrepareAndCopyLines;
   if Test then exit;
   CreateAreas;
   CreateParcely;
end;

procedure TCreateParcelModelFromDGN.CHeckProperties;
begin
   if (ParcelModel = nil) or not (ParcelModel is Tgis_ParcelModel) then
   begin
      Error := 1;
      ShowMessage('Model parcel chyb nebo nen modelem parcel, operace kon');
      exit;
   end;
   if (ARE_PAR = nil) or (LIN_PAR = nil) then
   begin
      Error := 1;
      ShowMessage('Povinn parametr ARE_PAR nebo LIN_PAR  chyb, operace kon');
      exit;
   end;
   //!!! tady nekde bude kontrola existence, nabidka prepsani nebo pridani dat
   // nebude !
end;

procedure TCreateParcelModelFromDGN.DoIt;
begin
   TXErr := 0;
   Error := 0;
   CHeckProperties;
   if Error > 0 then exit;
   OpenFile;
   if Error > 0 then exit;
   StartProgress('Import Parcel z '+FileName,0,0);
   ProgressText := 'Natn souboru...';
   ReadData;
   if Error > 0 then exit;
   ProgressText := 'Tvorba modelu ...';
   CreateModel;
   if Error > 0 then exit;
   Finish;
end;

procedure TCreateParcelModelFromDGN.Finish;
begin

end;

function TCreateParcelModelFromDGN.GetParcelModel: Tgis_ParcelModel;
begin
   result := Tgis_ParcelModel(Output);
end;

function TCreateParcelModelFromDGN.GetTrafoTable: TTransformationTable;
begin
   if FTrafoTable = nil then
   begin
      FTrafoTable := TTransformationTable.Create;
      FTrafoTable.Name := 'TrafoTable';
      AddElement(FTrafoTable);
   end;
   result := FTrafoTable;
end;


procedure TCreateParcelModelFromDGN.OpenFile;
//var
   //D: TSelectFileDialog;
begin
   Error := 0;
   {
   if not WithOutDialog then
   begin
      D := TSelectFileDialog.Create;
      D.Caption := 'Volba souboru DGN';
      D.Filter := 'Soubory Microstation|*.dgn|Vechny soubory|*.*';
      D.InitialDir := '';
      D.DoIt;
      FileName := D.FileName;
      D.Free;
   end;
   }
   if (FileName = '') or not FileExists(FileName) then
   begin
      ShowMessage('Soubor '+FileName+' neexistuje, operace kon');
      Error := 1;
   end;
end;

procedure TCreateParcelModelFromDGN.ReadData;
var
   DI: TDGNImport;
begin
   DI := TDGNImport.Create;
   try
   DI.FileName := FileName;
   DI.AsTMPText:=True;
   DI.DoIt;
   except
      Error := 1;
      ShowMessage('pi natn souboru nastala neznm katastrofa, operace kon!');
      if DI.Output <> nil then
         DI.Output.Free;
      DI.Free;
   end;
   DGN := TEntity(DI.Output);
   DI.Free;
end;

procedure TCreateParcelModelFromDGN.SetParcelModel(const Value: Tgis_ParcelModel);
begin
   Output := Value;
end;

procedure TCreateParcelModelFromDGN.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TCreateParcelModelFromDGN.SetTrafoFinished(const Value: boolean);
begin
  FTrafoFinished := Value;
end;

procedure TCreateParcelModelFromDGN.SetTrafoRequired(const Value: boolean);
begin
  FTrafoRequired := Value;
end;

function TCreateParcelModelFromDGN.GetTrafo: TTransformation_Kolinearni2D;
begin
   if FTrafo = nil then
   begin
      FTrafo := TTransformation_Kolinearni2D.Create;
      AddElement(FTrafo);
   end;
   result := FTrafo;
end;

procedure TCreateParcelModelFromDGN.Transform;
var
   i,ii: integer;
   GE: TGeometryElement;
   G: TGeometry;
   L: TPolyLineElement;
   e: TElement;
   C: T2DCoordinate;
   aX,aY, tX, tY: extended;
   TmpT: TTmpText;
   Klad: TMaps_SK;
   LastMap: TMap_SK;
   _Map: TMap_SK;

   function TestMap(aMap: TMap_SK): boolean;
   var
     IDB: TIDBod;
   begin
      result := false;
      if aMap = nil then exit;
      result := true;
      if aMap = LastMap then exit;
      TrafoTable.FreeAll;
      //1
      IDB := TIDBod.Create;
      IDB.zX := aMap.MinX_SK;
      IDB.zY := aMap.MaxY_SK;
      IDB.cX := aMap.X1;
      IDB.cY := aMap.Y1;
      TrafoTable.AddElement(IDB);
      //2
      IDB := TIDBod.Create;
      IDB.zX := aMap.MaxX_SK;
      IDB.zY := aMap.MaxY_SK;
      IDB.cX := aMap.X2;
      IDB.cY := aMap.Y2;
      TrafoTable.AddElement(IDB);
      //3
      IDB := TIDBod.Create;
      IDB.zX := aMap.MaxX_SK;
      IDB.zY := aMap.MinY_SK;
      IDB.cX := aMap.X3;
      IDB.cY := aMap.Y3;
      TrafoTable.AddElement(IDB);
      //4
      IDB := TIDBod.Create;
      IDB.zX := aMap.MinX_SK;
      IDB.zY := aMap.MinY_SK;
      IDB.cX := aMap.X4;
      IDB.cY := aMap.Y4;
      TrafoTable.AddElement(IDB);
      Trafo.TransformationTable := TrafoTable;
      if Trafo.Error > 0 then
         result := false;
      LastMap := aMap;
   end;
begin
   if not TrafoRequired then exit;
   Klad := nil;
   LastMap := nil;
   case CoordinateSystem of
      2: Klad := Gusterberg;
      3: Klad := Stepan;
   end;
   if Klad = nil then exit;
   // linie
   for i := 0 to LIN_PAR.LastIndex do
   begin
      e := LIN_PAR.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      G := GE.Geometry;
      if G = nil then continue;
      if not (G is TPolyLineElement) then continue;
      L := TPolyLineElement(G);
      for ii := 0 to L.LastIndex do
      begin
         C := L.GetOrientedCoordElement(ii,true);
         aX := C.X;
         aY := C.Y;
         _Map := Klad.GetMapByXY_SK(aX,aY);
         if not TestMap(_Map) then
            exit;
         Trafo.TransformXY(aX, aY, tX, tY);
         C.X := tX;
         C.Y := tY;
      end;
      L.RecalculateRect;
      L.CalculateLabelProps;
   end;
   // texty
   for i := 0 to Texts.LastIndex do
   begin
      e := Texts.Elements[i];
      if not (e is TtmpText) then continue;
      TmpT := TTmpText(e);
      aX := TmpT.X;
      aY := TmpT.Y;
      _Map := Klad.GetMapByXY_SK(aX,aY);
      if not TestMap(_Map) then
         exit;
      Trafo.TransformXY(aX, aY, tX, tY);
      TmpT.X := tX;
      TmpT.Y := tY;
   end;
   TrafoFinished := true;
end;

procedure TCreateParcelModelFromDGN.SetGusterberg(const Value: TMaps_SK);
begin
  FGusterberg := Value;
end;

procedure TCreateParcelModelFromDGN.SetStepan(const Value: TMaps_SK);
begin
  FStepan := Value;
end;

procedure TCreateParcelModelFromDGN.SetWithOutDialog(const Value: boolean);
begin
  FWithOutDialog := Value;
end;

procedure TCreateParcelModelFromDGN.SetARE_PAR(const Value: TEntity);
begin
  FARE_PAR := Value;
end;

procedure TCreateParcelModelFromDGN.SetLIN_PAR(const Value: TEntity);
begin
  FLIN_PAR := Value;
end;

procedure TCreateParcelModelFromDGN.SetDGN(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FDGN),Value);
end;

procedure TCreateParcelModelFromDGN.SetKatastrLevels(const Value: string);
begin
  FKatastrLevels := Value;
end;

procedure TCreateParcelModelFromDGN.SetParcelyLevels(const Value: string);
begin
  FParcelyLevels := Value;
end;

procedure TCreateParcelModelFromDGN.SetTextParcelyLevel(const Value: string);
begin
  FTextParcelyLevel := Value;
end;

function TCreateParcelModelFromDGN.GetLevel(aIndex: string): TEntity;
begin
   result := nil;
   if DGN = nil then exit;
   result := TEntity(DGN.FindElementName('Level '+aIndex));
end;

procedure TCreateParcelModelFromDGN.SetAreas(const Value: TEntity);
begin
  ExchangeFieldElement(TElement(FAreas), Value);
end;

procedure TCreateParcelModelFromDGN.CreateAreas;
var
   ACL: TAreasFromClearLines;
   //i: integer;
begin
   ProgressText := 'Tvorba ploch z liniov kresby ... '+ParcelyLevels;
   Application.ProcessMessages;
   ACL := TAreasFromClearLines.Create;
   ACL.Input := LIN_PAR;
   ACL.DoIt;
   Areas := TEntity(ACL.Output);
   ACL.Free;
end;

procedure TCreateParcelModelFromDGN.PrepareAndCopyLines;
var
   i,j: integer;
   En: TEntity;
   E: TElement;
   L :TStringList;
   LIN: TTopolLineElement;
   TmpT: TTmpText;
   MaxY: double;
begin
   MaxY := -5000000;
   L := TStringList.Create;
   // Parcely
   ProgressText := 'Pprava lini parcel... vrstvy '+ParcelyLevels;
   Application.ProcessMessages;
   L.CommaText := ParcelyLevels;
   for i := 0 to L.Count - 1 do
   begin
      En := Level[L.Strings[i]];
      if En = nil then continue;
      for j := 0 to En.LastIndex do
      begin
         E := En.Elements[j];
         if not (E is TTopolLineElement) then continue;
         LIN := TTopolLineElement(E);
         LIN.Druh := Lin_ParcelaGroup;
         LIN.Barva := Lin_ParcelaColor;
         LIN.Znacka := Lin_ParcelaSymbol;
         if Lin.MaxY > MaxY then
            MaxY := Lin.MaxY;
         LIN_PAR.AddElement(LIN);
      end;
   end;
   //          Katastry
   L.Clear;
   ProgressText := 'Pprava lini katastru... vrstvy '+KatastrLevels;
   Application.ProcessMessages;
   L.CommaText := KatastrLevels;
   for i := 0 to L.Count - 1 do
   begin
      En := Level[L.Strings[i]];
      if En = nil then continue;
      for j := 0 to En.LastIndex do
      begin
         E := En.Elements[j];
         if not (E is TTopolLineElement) then continue;
         LIN := TTopolLineElement(E);
         LIN.Druh := Lin_KatastrGroup;
         LIN.Barva := Lin_KatastrColor;
         LIN.Znacka := Lin_KatastrSymbol;
         if Lin.MaxY > MaxY then
            MaxY := Lin.MaxY;
         LIN_PAR.AddElement(LIN);
      end;
   end;
   L.Clear;
   // Texty parcel
   Texts := TOwnerEntity.Create;
   L.Free;
   ProgressText := 'Pprava text ... '+TextParcelyLevel;
   Application.ProcessMessages;
   En := Level[TextParcelyLevel];
   if En <> nil then
   for j := 0 to En.LastIndex do
   begin
      E := En.Elements[j];
      if not (E is TTmpText) then continue;
      Texts.AddElement(E);
   end;
   ProgressText := 'Pprava text ... '+TextStavebniLevel;
   Application.ProcessMessages;
   En := Level[TextStavebniLevel];
   if En <> nil then
   for j := 0 to En.LastIndex do
   begin
      E := En.Elements[j];
      if not (E is TTmpText) then continue;
      TmpT := TTmpText(E);
      TmpT.Text := '-'+TmpT.Text;  // zaporne cislo parcely
      Texts.AddElement(E);
   end;
   // Katastr
   En := Level[TextKatastrLevel];
   if (En <> nil) and not En.NoElements then
   begin
      E := En.FindElementClass(TTmpText);
      if E <> nil then
      begin
         TmpT := TTmpText(E);
         KU_KOD := StrToIntDef(TmpT.Text,1);
      end;
   end;
   TrafoRequired := MaxY > 0; // asi Gusterberg nebo Stepan
   if UserDialog <> '' then
   begin
      PostTextMsg(tm_Run,UserDialog,nil);
      Application.ProcessMessages;        // at se koza nazere ...
      Application.ProcessMessages;
   end;
   Transform;
   if LIN_PAR is TRectEntity then
      TRectEntity(LIN_PAR).Update;
end;

procedure TCreateParcelModelFromDGN.SetAre_ParcelaColor(const Value: integer);
begin
  FAre_ParcelaColor := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_KatastrColor(
  const Value: integer);
begin
  FLin_KatastrColor := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_KatastrGroup(
  const Value: integer);
begin
  FLin_KatastrGroup := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_KatastrSymbol(
  const Value: integer);
begin
  FLin_KatastrSymbol := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_ParcelaColor(
  const Value: integer);
begin
  FLin_ParcelaColor := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_ParcelaGroup(
  const Value: integer);
begin
  FLin_ParcelaGroup := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_ParcelaSymbol(
  const Value: integer);
begin
  FLin_ParcelaSymbol := Value;
end;

procedure TCreateParcelModelFromDGN.SetTexts(const Value: TEntity);
begin
   ExchangeFieldElement(TElement(FTexts), Value);
end;

procedure TCreateParcelModelFromDGN.ProcessTmpText(TmpText: TtmpText; Parcis, Parpod: integer; ARE: TAreaElement);
begin
   ParcelModel.CreateParcelaCislo(PARCIS,PARPOD,0);
   ParcelModel.ActualParcela.Barva := Are_ParcelaColor;
   ParcelModel.ActualParcela.Znacka := 1;
   ParcelModel.CreateParCast;
   ParcelModel.ActualParCast.Barva := Are_ParcelaColor;
   ParcelModel.ActualParCast.Znacka := 1;
   ParcelModel.ActualParCast.AddGeometry(ARE);
   if not ParcelModel.ActualParCast.IsMyOwner(ARE_PAR) then
      ARE_PAR.AddElement(ParcelModel.ActualParCast);
end;


procedure TCreateParcelModelFromDGN.CreateParcely;
var
   QTFinder: TFindRectEntityInQTreeByXY;
   TQ: TAddEntityToQTree;
   QT: TRectEntityQTree;
   S,S1,S2: string;
   i: integer;
   e: TElement;
   T: TTmpText;
   PARCIS,PARPOD: integer;
   ARE: TAreaElement;
begin
   S := 'Tvorba parcel z ploch a text ';
   ProgressText := S;
   Application.ProcessMessages;
   QTFinder := TFindRectEntityInQTreeByXY.Create;
   QT :=TRectEntityQTree.Create;
   QT.Name := 'Areas QT';
   ProgressText := S+'... pracovn struktura';
   Application.ProcessMessages;
   TQ := TAddEntityToQTree.Create;
   TQ.Input := Areas;
   TQ.Output := QT;
   TQ.DoIt;
   MaxProgress := Texts.LastIndex;
   Progress := 0;
   ProgressText := S+'... penos atribut z text';
   Application.ProcessMessages;
   QTFinder.Input := QT;
   if KU_KOD = 0 then
      KU_KOD := 1;
   ParcelModel.CreateKatastrCislo(KU_KOD);// sem pijde skuten slo katastru !!!
   ParcelModel.CreateSkupinaParcelCislo(1);
   {
   for i := 0 to Areas.LastIndex do
   begin
      e := Areas.Elements[i];
      e.Name := IntToStr(i);

   end;
   }
   for i := 0 to Texts.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      e := Texts.Elements[i];
      if not (e is TTmpText) then continue;
      T := TTmpText(e);
      //if T.Text='801' then
         //T.X := T.X+0.2;
      QTFinder.X := T.CenterX;
      QTFinder.Y := T.CenterY;
      QTFinder.DoIt;
      e := QTFinder.Output;
      if e = nil then
      begin
         TXErr := TXErr + 1;
         continue;
      end;
      if not (e is TAreaElement) then Continue;
      ARE := TAreaElement(e);
      ARE.AbsRefX := T.CenterX;
      ARE.AbsRefY := T.CenterY;
      S := T.Text;
      if StringAsTwoParams(S,'/',S1,S2) then
         PARPOD := StrToIntDef(S2,0)
      else
         PARPOD := 0;
      PARCIS := StrToIntDef(S1,0);
      ProcessTmpText(T, PARCIS, PARPOD, ARE);
   end;
   if ARE_PAR is TRectEntity then
      TRectEntity(ARE_PAR).Update;
   ParcelModel.UpdateAll := true;
   TQ.Free;
   QT.Free;
   QTFinder.Free;
end;

procedure TCreateParcelModelFromDGN.SetKU_KOD(const Value: integer);
begin
  FKU_KOD := Value;
end;

procedure TCreateParcelModelFromDGN.SetCoordinateSystem(
  const Value: integer);
begin
  FCoordinateSystem := Value;
end;

procedure TCreateParcelModelFromDGN.SetTextKatastrLevel(
  const Value: string);
begin
  FTextKatastrLevel := Value;
end;

procedure TCreateParcelModelFromDGN.SetTextStavebniLevel(
  const Value: string);
begin
  FTextStavebniLevel := Value;
end;

procedure TCreateParcelModelFromDGN.SetUserDialog(const Value: string);
begin
  FUserDialog := Value;
end;

procedure TCreateParcelModelFromDGN.SetTest(const Value: boolean);
begin
  FTest := Value;
end;

procedure TCreateParcelModelFromDGN.SetTXErr(const Value: integer);
begin
  FTXErr := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_BudovaColor(
  const Value: integer);
begin
  FLin_BudovaColor := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_BudovaGroup(
  const Value: integer);
begin
  FLin_BudovaGroup := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_BudovaSymbol(
  const Value: integer);
begin
  FLin_BudovaSymbol := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_DPMColor(const Value: integer);
begin
  FLin_DPMColor := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_DPMGroup(const Value: integer);
begin
  FLin_DPMGroup := Value;
end;

procedure TCreateParcelModelFromDGN.SetLin_DPMSymbol(const Value: integer);
begin
  FLin_DPMSymbol := Value;
end;

procedure TCreateParcelModelFromDGN.SetLIN_PARSLU(const Value: TEntity);
begin
  FLIN_PARSLU := Value;
end;

{ TCreateParcelModelFromDKM }

procedure TCreateParcelModelFromDKM.AddIDBod(const aX, aY: double; const aB,aCislo: string);
var
   E: TElement;
   En: TEntity;
   IDB: TIDBod;
begin
   E := HID.FindOrCreateElementName(TOwnerEntity,aB); // hledame skupinu
   En := TEntity(E);
   E := En.FindElementName(aCislo);
   if E = nil then                                    // cislo zjevne neexistuje
   begin
      IDB := TIDBod.Create;
      IDB.Name := aCislo;
      IDB.zX := aX;
      IDB.zY := aY;
      En.AddElement(IDB);
   end;
end;

procedure TCreateParcelModelFromDKM.AddIDBodFinal(const aX, aY: double; const aB, aCislo: string);
var
   E: TElement;
   En: TEntity;
   IDB: TIDBod;
begin
   E := HID.FindOrCreateElementName(TOwnerEntity,aB); // hledame skupinu
   En := TEntity(E);
   E := En.FindElementName(aCislo);
   if E = nil then Exit;                             // cislo zjevne neexistuje
   if not (E is TIDBod) then exit;
   IDB := TIDBod(E);
   IDB.cX := aX;
   IDB.cY := aY;
   TrafoTable.AddElement(IDB);
end;

procedure TCreateParcelModelFromDKM.CreateAreas;
begin
   if VGI then
   begin
   end
   else
      inherited;
end;

procedure TCreateParcelModelFromDKM.CreateParcely;
var
   i: integer;
   e: TElement;
   PC: TGis_ParcelaCast;
   G: TPolyLineAreaElement;
   MP: TMultiAreaPointPlacer;
begin
   if VGI then
   begin
      if ARE_PAR is TRectEntity then
         TRectEntity(ARE_PAR).Update;
      for i := 0 to ARE_PAR.LastIndex do
      begin
         e := ARE_PAR.Elements[i];
         PC := TGis_ParcelaCast(e);
         G := TPolyLineAreaElement(PC.Geometry);
         if G.Holes <> nil then
            G.Holes.Update;
      end;
      // popisove body
      MP := TMultiAreapointPlacer.Create;
      MP.Input := ARE_PAR;
      MP.DoIt;
      MP.Free;
   end
   else
      inherited;
end;

procedure TCreateParcelModelFromDKM.FinishLineElement(Layer: TEntity; _Druh,_Barva,_Znacka: integer);
var
   L: TPolyLineElement;
   TL: TTopolLineElement;
   aLay: TEntity;
begin
   if not LineReading then
      exit;
   aLay := LIN_PAR;
   L := LastLineElement;
   if L = nil then exit;
   if L.Count < 2 then
   begin
      //L.Free;
      LastLineElement := nil;
      L_T := 0;
      L_K := 219;
      LineReading := false;
      exit;
   end;
   L.RecalculateRect;
   L.CalculateLabelProps;
   if VGI then
   begin
      if HoleReading then
      begin
         if LastHole <> nil then
            LastHole.AddPolyLine(L,True);
      end
      else
      if PARcelaReading then
         if LastARE <> nil then
            LastAre.AddPolyLine(L,True);
   end;
   TL := TTopolLineElement.Create;
   TL.Geometry := L;
   if Layer = nil then
   begin
      if VGI then
         L_K := 219;
      if L_K = 219 then                  // 219 hranice parcely ostatni katastr
      begin
         TL.Druh := Lin_ParcelaGroup;
         if RealLostPoint then
            TL.Barva := 11
         else
            TL.Barva := Lin_ParcelaColor;
         TL.Znacka := Lin_ParcelaSymbol;
      end
      else
      begin                              // i kdyz sou tam i statni a tak
         TL.Druh := Lin_KatastrGroup;
         if RealLostPoint then
            TL.Barva := 11
         else
            TL.Barva := Lin_KatastrColor;
         TL.Znacka := Lin_KatastrSymbol;
      end;
   end
   else
   begin
      aLay := Layer;
      TL.Druh := _Druh;
      TL.Barva := _Barva;
      TL.Znacka := _Znacka;
   end;
   TL.Presnost := L_T;
   aLay.AddElement(TL);
   //if Test then
   //   FinishLineTest;
   LastLineElement := nil;
   L_T := 0;
   L_K := 219;
   LineReading := false;
end;

procedure TCreateParcelModelFromDKM.FinishLineTest;
begin

end;

function TCreateParcelModelFromDKM.GetHID: TEntity;
begin
   if FHID = nil then
   begin
      FHID := TOwnerEntity.Create;
      FHID.Name := 'HID';
      AddElement(FHID);
   end;
   result := FHID;
end;

procedure TCreateParcelModelFromDKM.OpenFile;
begin
   inherited;
   if Error > 0 then exit;
   if not VGI then
      VGI := UpperCase(ExtractFileExt(FileName)) = '.VGI';
   if (FileName1 <> '') and not FileExists(FileName1) then
   begin
      ShowMessage('Soubor '+FileName1+' neexistuje .. KONEC!');
      Error := 1;
   end;
end;

procedure TCreateParcelModelFromDKM.PrepareAndCopyLines;
begin

end;

procedure TCreateParcelModelFromDKM.ProcessAfterRead;
begin

end;

procedure TCreateParcelModelFromDKM.ProcessLine(const aLine: string);
var
   Li: integer;  // last line index
   W: string;    // nactene slovo z radku
   VCh: char;    // oznaceni vety

   function GetNextWord(Firsti: integer; var Lasti: integer): string;
   var
      i: integer;
      l: integer;
   begin
      result := '';
      l := Length(aLine);
      Lasti := l+1;
      i := Firsti;
      while (i <= l) and (aLine[i] in [#0,#09,' ']) do inc(i);
      if i > l then exit;
      while (i <= l) and not (aLine[i] in [#0,#09,' ']) do
      begin
         result := result + aLine[i];
         inc(i);
      end;
      Lasti := i;
   end;

   function ReadFloat: double;
   begin
      result := 0;
      W := GetNextWord(Li,Li);
      if W = '' then exit;
      result := StrToExtended(W);
   end;

   procedure ReadCoord(var aX, aY: double);
   begin
      aX := ReadFloat;
      aY := ReadFloat;
      if RCoord then
      begin
         aX := X0 + aX;
         aY := Y0 + aY;
      end;
      aX := -aX;
      aY := -aY;
   end;

   function ReadParam(var aName,aValue: string): boolean;
   begin
      result := false;
      W := GetNextWord(Li,Li);
      if W = '' then
         exit;
      result := StringAsParameter(W,aName,aValue);
   end;

   procedure ReadHeader;
   begin
      KVAL_B := 3;
      W := GetNextWord(Li,Li);
      if W = '' then
         exit;
      //if W[1] = 'S' then
      //W := copy(W,2,Length(W)-1);
      KU_KOD := StringToInteger(W);
      X0 := ReadFloat;  // redukce se nehazeji do zaporna
      Y0 := ReadFloat;
      W := GetNextWord(Li,Li);
      while W <> '' do
      begin
         if Length(W) > 3 then           // tak to asi bude katastr
            KU_KOD := StrToIntDef(W,0)
         else
            KVAL_B := StrToIntDef(W,3);
         W := GetNextWord(Li,Li);
      end;
      if VGI then
      begin
         ParcelModel.CreateKatastrCislo(KU_KOD);
         ParcelModel.CreateSkupinaParcelCislo(1);
      end;
   end;

   procedure ReadID;
   var
      ParName,ParValue: string;
   begin
      While ReadParam(ParName, ParValue) do
      begin
         if ParName = 'S' then
         begin
            CoordinateSystem := StrToIntDef(ParValue,0);
            if CoordinateSystem in [2,3] then
               TrafoRequired := true;
            break;
         end;
      end;
   end;

   procedure ReadRange;
   begin
      ReadFloat;  // opsany obdelnik nas nezajima
      ReadFloat;
      ReadFloat;
      ReadFloat;
      W := GetNextWord(Li,Li);  // meritkovy faktor  nas taky nezajima
      if W = '' then
         exit;
      W := GetNextWord(Li,Li);  // Redukce nas ovsem zajima
      RCoord := W = 'R';
   end;

   procedure ReadLevel;
   begin
      W := GetNextWord(Li,Li);
      LastLevel := StrToIntDef(W,0);
   end;

   procedure ReadObject;
   begin
      W := GetNextWord(Li,Li);
      LastObject := UpperCase(W);
   end;

   procedure ReadLinePoint;
   var
      aX,aY: double;
      ParName,ParValue: string;
      iValue: integer;
      B: string;
      C: string;
      //TValue: integer;
   begin
      if not LineReading then
         exit;
      if LastLineElement = nil then
         exit;
      ReadCoord(aX, aY);
      LastLineElement.AddXY(aX, aY);
      B := '';
      C := '';
      //TValue := KVAL_B;
      While ReadParam(ParName, ParValue) do
      begin
         if ParName = 'T' then
         begin
            iValue := StrToIntDef(ParValue,0);
            if iValue > L_T then
               L_T := iValue;
            //TValue := iValue;
         end
         else
         if ParName = 'K' then
         begin
            L_K := StrToIntDef(copy(ParValue,1,3),219);
         end
         else
         if ParName = 'B' then
         begin
            B := ParValue;
         end
         else
         if ParName = 'C' then
         begin
            C := ParValue;
         end;
      end;
      {
      if TrafoRequired then // sbirame body na transformaci
      begin
         if TValue > 5 then exit;   // mala presnost
         if B = '' then exit;       // chybi skupinove cislo bodu
         if C = '' then exit;       // a navic nema ani cislo, blbecek
         AddIDBod(aX,aY,B,C)
      end;
      }
   end;

   procedure ReadIDBod;
   var
      B: string;
      C: string;
      iValue: integer;
      aX,aY: double;
   begin
      // ve W je uplne cele cislo bodu
      if Length(W) < 10 then exit;  // ha ha
      B := copy(W,1,8);
      C := copy(W,9,4);
      iValue := StrToIntDef(C,0);
      C := IntToStr(iValue);
      if iValue = 0 then exit; // nema cislo
      aX := -ReadFloat;
      aY := -ReadFloat;
      AddIDBodFinal(aX, aY, B, C);
   end;

   procedure ReadLastTextPoint;
   var
      aX,aY: double;
   begin
      if LastTmpText = nil then
         exit;
      ReadCoord(aX, aY);
      LastTmpText.X := aX;
      LastTmpText.Y := aY;
   end;

   procedure ReadLine;
   begin
      if  VGI then
      begin
         if LastObject = 'TEXT' then
         begin
            W := GetNextWord(Li,Li);
            if not (W = 'P') then exit;
            //ReadLastTextPoint;
            LastObject := '-';
            exit;
         end
         else
         if LastObject <> 'KLADPAR' then exit;
      end
      else
         if LastLevel <> 1 then exit;
      W := GetNextWord(Li,Li);
      if not (W = 'P') then exit;
      StartLineElement;
      ReadLinePoint;
   end;

   procedure ReadText;
   var
      aX,aY: double;
      TmpT: TtmpText;
      Parcela: string;
      ParName,ParValue: string;
      iValue: integer;
   begin
      if  VGI then
      begin
         if LastObject <> 'KLADPAR' then exit;
      end
      else
         if LastLevel <> 2 then exit;
      ReadCoord(aX, aY);
      W := GetNextWord(Li,Li);
      Parcela := copy(W,2,Length(W)-2);
      While ReadParam(ParName, ParValue) do
      begin
         if ParName = 'K' then
         begin
            iValue := StrToIntDef(ParValue,0);
            if iValue = 28  then          // stavebni parcela
               Parcela := '-' + Parcela;
            break;
         end;
      end;
      TmpT := TtmpText.Create;
      TmpT.X := aX;
      TmpT.Y := aY;
      TmpT.Text := Parcela;
      Texts.AddElement(TmpT);
      LastTmpText := TmpT;
      ParcelaReading := false;
      if  VGI then
      begin
         LastObject := 'TEXT';
      end;
   end;

   procedure ReadPARCIS;
   var
      ParName,ParValue: string;
      Parcis,Parpod: integer;
      S1,S2: string;
      Par: TGis_Parcela;
      ARE: TPolyLineAreaElement;
   begin
      if not   ReadParam(ParName, ParValue) then
         exit;
      if ParName <> 'PARCIS' then exit;
      if StringAsTwoParams(ParValue,'.',S1,S2) then
         PARPOD := StrToIntDef(S2,0)
      else
         PARPOD := 0;
      PARCIS := StrToIntDef(S1,0);

      ParcelModel.CreateParcelaCislo(PARCIS,PARPOD,0);
      ParcelModel.ActualParcela.Barva := Are_ParcelaColor;
      ParcelModel.ActualParcela.Znacka := 1;
      ParcelModel.CreateParCast;
      ParcelModel.ActualParCast.Barva := Are_ParcelaColor;
      ParcelModel.ActualParCast.Znacka := 1;
      ARE := TPolyLineAreaElement.Create;
      ParcelModel.ActualParCast.AddGeometry(ARE);
      if not ParcelModel.ActualParCast.IsMyOwner(ARE_PAR) then
         ARE_PAR.AddElement(ParcelModel.ActualParCast);
      ParcelaReading := true;
      LastARE := ARE
   end;

begin
   if aLine = '' then exit;
   Li := 1;                  // zacatek radku
   W := GetNextWord(Li,Li);  // prvni slovo
   if W = '' then exit;      // nic tam nebylo...
   if W[1]='&' then          // pozor - oznaceni vety
   begin
      FinishLineElement(nil,1,13,0);     // pokud byla nejaka linie pocata, je treba ji dokoncit
      IDReading := false;    // a kdyby neco tak ukoncime cteni ID bodu
      if Length(W) < 2 then exit;   // ale, ale?
      VCh := W[2];           // ve Vch je veta
      case Vch of
         'V': ReadHeader;    // Hlavicka
         'D': ReadID;        // Identifikace souboru
         'R': ReadRange;     // Rozsah
         'U': ReadLevel;     // Vrstva
         'L': ReadLine;      // Liniovy prvek
         'T': ReadText;      // text;
         'O': ReadObject;    // objekt pro VGI;
         'A': ReadPARCIS;    // PARCIS pro VGI;
         //'S': IDReading := TrafoRequired; // pokud bude trafo tak cteme ID body
      end;
   end
   else
   if IDReading then
   begin
      //ReadIDBod;
   end
   else
   begin
      if  VGI then
      begin
         if LastObject <> 'KLADPAR' then exit;
      end
      else
         if LastLevel <> 1 then exit; // z ostatniho nas zajima jen vrstva 1 (a to linie)
      if W = 'P' then
      begin
         FinishLineElement(nil,1,13,0);
         StartLineElement;
         ReadLinePoint;
      end
      else
      if W = 'NL' then
      begin
         FinishLineElement(nil,1,13,0);
         HoleReading := not HoleReading;
         StartLineElement;
         ReadLinePoint;
      end
      else
      if W = 'L'  then
         ReadLinePoint;
   end;
end;

procedure TCreateParcelModelFromDKM.ReadData;
var
   FSource: System.Text;
   FSiz: integer;
   FPos,FPosN: integer;
   S: string;
   Procedure ReadFile(aFName: string);
   begin
      system.assign(FSource, aFName);
      system.reset(FSource);
      Fsiz := FileSize(FSource);
      Fpos := 0;
      MaxProgress := FSiz;
      Application.ProcessMessages;
      LastLevel := 0;
      LastObject := '';
      LastLineElement := nil;
      while not Eof(FSource) do
      begin
         ReadLn(FSource,S);
         FPosN := FilePos(FSource);
         if fposn > fpos then
         begin
            fpos := fposn;
            Progress := fpos;
            Application.ProcessMessages;
         end;
         ProcessLine(S);
      end;
      system.close(FSource);
   end;
begin
   Texts := TOwnerEntity.Create;
   Texts.Name := 'TXTs';
   ReadFile(FileName);
   if FileName1 <> '' then
   begin
      EndProgress;
      Application.ProcessMessages;
      StartProgress('Import Parcel z '+FileName1,0,0);
      ProgressText := 'Soubor .2...';
      Application.ProcessMessages;
      ReadFile(FileName1);
   end;
   ProcessAfterRead;
   if UserDialog <> '' then
   begin
      PostTextMsg(tm_Run,UserDialog,nil);
      Application.ProcessMessages;        // at se koza nazere ...
      Application.ProcessMessages;
   end;
   Transform;
   if LIN_PAR is TRectEntity then
      TRectEntity(LIN_PAR).Update;
end;

procedure TCreateParcelModelFromDKM.SetFileName1(const Value: string);
begin
  FFileName1 := Value;
end;

procedure TCreateParcelModelFromDKM.SetHoleReading(const Value: boolean);
var
   aHole: TPolyLineAreaElement;
begin
  FHoleReading := Value;
  if Value then
  begin
     if not PARcelaReading then exit;
     if LastARE = nil then exit;
     aHole := TPolyLineAreaElement.Create;
     LastAre.AddHole(aHole);
     LastHole := aHole;
  end
  else
     LastHole := nil;
end;

procedure TCreateParcelModelFromDKM.SetIDReading(const Value: boolean);
begin
  FIDReading := Value;
end;

procedure TCreateParcelModelFromDKM.SetKVAL_B(const Value: integer);
begin
  FKVAL_B := Value;
end;

procedure TCreateParcelModelFromDKM.SetLastARE(const Value: TPolyLineAreaElement);
begin
  FLastARE := Value;
end;

procedure TCreateParcelModelFromDKM.SetLastHole(const Value: TPolyLineAreaElement);
begin
  FLastHole := Value;
end;

procedure TCreateParcelModelFromDKM.SetLastLevel(const Value: integer);
begin
  FLastLevel := Value;
end;

procedure TCreateParcelModelFromDKM.SetLastLineElement(const Value: TPolyLineElement);
begin
   ExChangeFieldElement(TElement(FLastLineElement), Value);
end;

procedure TCreateParcelModelFromDKM.SetLastObject(const Value: string);
begin
  FLastObject := Value;
end;

procedure TCreateParcelModelFromDKM.SetLastTmpText(const Value: TtmpText);
begin
  FLastTmpText := Value;
end;

procedure TCreateParcelModelFromDKM.SetLineReading(const Value: boolean);
begin
  FLineReading := Value;
end;

procedure TCreateParcelModelFromDKM.SetLostPoint(const Value: boolean);
begin
  FLostPoint := Value;
end;

procedure TCreateParcelModelFromDKM.SetL_K(const Value: integer);
begin
   FL_K := Value;
end;

procedure TCreateParcelModelFromDKM.SetL_T(const Value: integer);
begin
   FL_T := Value;
end;

procedure TCreateParcelModelFromDKM.SetPARcelaReading( const Value: boolean);
begin
   FPARcelaReading := Value;
end;

procedure TCreateParcelModelFromDKM.SetRCoord(const Value: boolean);
begin
  FRCoord := Value;
end;

procedure TCreateParcelModelFromDKM.SetRealLostPoint(const Value: boolean);
begin
  FRealLostPoint := Value;
end;

procedure TCreateParcelModelFromDKM.SetTestID(const Value: integer);
begin
  FTestID := Value;
end;

procedure TCreateParcelModelFromDKM.SetVGI(const Value: boolean);
begin
  FVGI := Value;
end;

procedure TCreateParcelModelFromDKM.SetX0(const Value: double);
begin
  FX0 := Value;
end;

procedure TCreateParcelModelFromDKM.SetY0(const Value: double);
begin
  FY0 := Value;
end;

procedure TCreateParcelModelFromDKM.StartLineElement;
begin
   LastLineElement := TPolyLineElement.Create;
   LineReading := true;
   L_T := 0;
   L_K := 219;
end;

{ TCreateParcelModelFromISKN }

procedure TCreateParcelModelFromISKN.FinishData;
var
   i,j: integer;
   Vla,Vla1: Tgis_Vlastnictvi;
   Tel: tgis_Tel;
   Opsub,Opsub1: Tgis_Person;
   T,T1: TTmpText;
   e: TELement;
   PC: Tgis_ParcelaCast;
   S: string;
   IE: TIntegerELement;
   M: Tgis_Majitel;
   Own:TEntity;
   TP: TTopolPointElement;
   prp: Tgis_ParcelaCast_Props;
begin
   if Test then exit;
   // vlas  ... vlozeni TEL a OPSUB  a pupfl
   NoPar := FPARs.NoElements;
   if NoPar then exit;
   for i := 0 to FVLAs.LastIndex do
   begin
      Vla := Tgis_Vlastnictvi(FVLAs.Elements[i]);
      Tel := Tgis_Tel(FTels.FindElementName(VLA.TEL_ID));
      VLA.AddElement(Tel);
      Opsub := Tgis_Person(FOPSUBs.FindElementName(Vla.OPSUB_ID));
      if Opsub <> nil then
      begin
         Opsub.AddElement(VLA);
         if Opsub.OPSUB_TYPE = 'BSM' then  // manzele
         begin
            Opsub1 := Tgis_Person(FOPSUBs.FindElementName(Opsub.ID_JE_1_PARTNER_BSM));
            if Opsub1 <> nil then
               Opsub1.AddElement(Opsub);
            Opsub1 := Tgis_Person(FOPSUBs.FindElementName(Opsub.ID_JE_2_PARTNER_BSM));
            if Opsub1 <> nil then
               Opsub1.AddElement(Opsub);
         end;
      end;
   end;
   for i := 0 to Texts.LastIndex do
   begin
      T := TTmpText(Texts.Elements[i]);
      e := FPARs.FindElementName(T.FontName);
      if e = nil then Continue; // Parcela neni... ?
      e := TEntity(e).FindElementClass(Tgis_ParcelaCast);
      PC := Tgis_ParcelaCast(e);
      T.AddElement(PC);
   end;
   for i := 0 to FRZOs.LastIndex do
   begin
      IE := TIntegerElement(FRZOs.Elements[i]);
      e := FPARs.FindElementName(IE.Name);
      if e = nil then Continue; // Parcela neni... ?
      e := TEntity(e).FindElementClass(Tgis_ParcelaCast);
      PC := Tgis_ParcelaCast(e);
      PC.PUPFL := true;
      PC.PUPFLc := true;
   end;
   for i := 0 to FPars.LastIndex do
   begin
      e := TEntity(FPars.Elements[i]);
      e := TEntity(e).FindElementClass(Tgis_ParcelaCast);
      if e = nil then continue;
      PC := Tgis_ParcelaCast(e);
      //S := IntToStr(PC.LVc);
      S := PC.TEL_ID;
      e := FTels.FindElementName(S);
      if e = nil then continue;
      Tel := tgis_Tel(e);
      PC.LVc := Tel.CISLO_TEL;
      PC.LV := Tel.CISLO_TEL;
      Vla := nil;
      for j := 0 to Tel.OwnersCount - 1 do
      begin
         Own := Tel.Owners[j];
         if not (Own is Tgis_Vlastnictvi) then continue;
         Vla1 := Tgis_Vlastnictvi(Own);
         if Vla = nil then
            Vla := Vla1
         else
         begin
            if (Vla.TYPRAV_KOD = 30) and (Vla1.TYPRAV_KOD = 92) then
            begin
               Vla := Vla1;
               break;
            end;
         end;
      end;
      if Vla = nil then Continue;
      PC.SuperID := Vla.PODIL_JMENOVATEL;
      M := Tgis_Majitel(Tel.FindElementClass(Tgis_Majitel));
      if M = nil then
      begin
         M := Tgis_Majitel.Create;
         Tel.AddElement(M);
         //Tel.AutoName := true;
         if (Majitele <> nil) and not M.IsMyOwner(Majitele) then
            Majitele.AddElement(M);
      end;
      M.SetBy := Vla;
      M.AddElement(PC);
   end;
   for i := 0 to FOPSUBs.LastIndex do
      Tgis_Person(FOPSUBs.Elements[i]).AutoName := true;
   for i := 0 to FOPSUBs.LastIndex do
      Tgis_Person(FOPSUBs.Elements[i]).AutoName := true;
   for i := 0 to FVLAs.LastIndex do
      Tgis_Vlastnictvi(FVLAs.Elements[i]).AutoName := true;
   for i := 0 to FTels.LastIndex do
      Tgis_Tel(FTELs.Elements[i]).AutoName := true;

   if (LIN_PARSLU <> nil) and (LIN_PARSLU is TRectEntity) then
      TRectEntity(LIN_PARSLU).Update;
   // Body par
   if PNT <> nil then
   for i := 0 to PNT.LastIndex do
   begin
      TP := TTopolPointElement(PNT.Elements[i]);
      e := TP.Properties;
      if not (e is Tgis_ParcelaCast_Props) then exit;
      prp := Tgis_ParcelaCast_Props(e);
      e := FPARs.FindElementName(prp.aID);
      if e = nil then Continue; // Parcela neni... ?
      e := TEntity(e).FindElementClass(Tgis_ParcelaCast);
      PC := Tgis_ParcelaCast(e);
      prp.AssignBy := PC;
   end;
end;

procedure TCreateParcelModelFromISKN.FinishLineTest;
begin
   if LastLineElement.Length > 1000 then
      FErrID.AddNameString(IntToStr(TestID),IntToStr(LastLineElement.Count));
end;

procedure TCreateParcelModelFromISKN.GetDPM(DPMID: string);
begin
   if (FActualDPM <> nil) and (FActualDPM.Name = DPMID) then
      exit;
   FActualDPM := THPEntity(FDPMs.FindElementName(DPMID));
   if FActualDPM = nil then
   begin
      FActualDPM := THPEntity.Create;
      FActualDPM.Name := DPMID;
      FDPMs.AddElement(FActualDPM);
   end;
end;

procedure TCreateParcelModelFromISKN.GetHP(HPID: string);
begin
   if (FActualHP <> nil) and (FActualHP.Name = HPID) then
      exit;
   FActualHP := THPEntity(FHPs.FindElementName(HPID));
   if FActualHP = nil then
   begin
      FActualHP := THPEntity.Create;
      FActualHP.Name := HPID;
      FHPs.AddElement(FActualHP);
   end;
end;

procedure TCreateParcelModelFromISKN.GetOB(OBID: string);
begin
   if (FActualOB <> nil) and (FActualOB.Name = OBID) then
      exit;
   FActualOB := THPEntity(FOBs.FindElementName(OBID));
   if FActualOB = nil then
   begin
      FActualOB := THPEntity.Create;
      FActualOB.Name := OBID;
      FOBs.AddElement(FActualOB);
   end;
end;

procedure TCreateParcelModelFromISKN.PrepareData;
   procedure PrepareParcelyFromModel;
   var
      Sel: TFirstSelector;
      PRS,oen: TOwnerEntity;
      i: integer;
      PC: Tgis_ParcelaCast;
   begin
      PRS := TOwnerEntity.Create;
      Sel := TFirstSelector.Create;
      Sel.Input := ParcelModel;
      Sel.Output := PRS;
      Sel.Condition := 'CLASS(TGis_ParcelaCast)';
      Sel.DoIt;
      Sel.Free;
      for i  := 0 to PRS.LastIndex do
      begin
         PC := Tgis_ParcelaCast(PRS.Elements[i]);
         oen := TOwnerEntity.Create;
         oen.Name := PC.aID;
         oen.AddElement(PC);
         FPARs.AddElement(oen);
      end;
      PRS.Free;
   end;
begin
   if PNT <> nil then  // point Layer checking
   begin
      if not (TElement(FPNT) is TEntity) then
         PNT := nil;
   end;
   TXNoPar := 0;
   ExchangeFieldElement(TElement(FPARs),TSortedEntity.Create);
   FPARS.Name := 'PARs';
   if ParcelyFromModel then
      PrepareParcelyFromModel;
   ExchangeFieldElement(TElement(FIDs),TSortedEntity.Create);
   FIDS.Name := 'IDs';
   ExchangeFieldElement(TElement(FHPs),TSortedEntity.Create);
   FHPs.Name := 'HPs';
   ExchangeFieldElement(TElement(FOBs),TSortedEntity.Create);
   FOBs.Name := 'OBs';
   ExchangeFieldElement(TElement(FDPMs),TSortedEntity.Create);
   FDPMs.Name := 'DPMs';
   ExchangeFieldElement(TElement(FVLAs),TSortedEntity.Create);
   FVLAS.Name := 'VLAs';
   ExchangeFieldElement(TElement(FOPSUBs),TSortedEntity.Create);
   FOPSUBS.Name := 'OPSUBs';
   ExchangeFieldElement(TElement(FTels),TSortedEntity.Create);
   FTELS.Name := 'TELs';
   ExchangeFieldElement(TElement(FRZOs),TOwnerEntity.Create);
   FRZOS.Name := 'RZOs';

   ExchangeFieldElement(TElement(FDSOBR),TStringListElement.Create);
   FDSOBR.Name := 'DSOBR';
   ExchangeFieldElement(TElement(FDSBP),TStringListElement.Create);
   FDSBP.Name := 'DSBP';
   ExchangeFieldElement(TElement(FDPAR),TStringListElement.Create);
   FDPAR.Name := 'DPAR';
   ExchangeFieldElement(TElement(FDOBDEBO),TStringListElement.Create);
   FDOBDEBO.Name := 'DOBDEBO';
   ExchangeFieldElement(TElement(FDVLA),TStringListElement.Create);
   FDVLA.Name := 'DVLA';
   ExchangeFieldElement(TElement(FDTEL),TStringListElement.Create);
   FDTEL.Name := 'DTEL';
   ExchangeFieldElement(TElement(FDRZO),TStringListElement.Create);
   FDRZO.Name := 'DRZO';
   ExchangeFieldElement(TElement(FDOPSUB),TStringListElement.Create);
   FDOPSUB.Name := 'DOPSUB';
   ExchangeFieldElement(TElement(FDKATUZE),TStringListElement.Create);
   FDKATUZE.Name := 'DKATUZE';
   ExchangeFieldElement(TElement(FDOP),TStringListElement.Create);
   FDOP.Name := 'DOP';
   ExchangeFieldElement(TElement(FErrID),TStringListElement.Create);
   FErrID.Name := 'ErrID';
end;

procedure TCreateParcelModelFromISKN.ProcessAfterRead;
var
   e: TElement;
   HP: THPEntity;
   PE: TPointElement;
   Sort: TSortElementsByInteger;
   EPoint: TEntity;
   PresnostK: double;

   procedure DoArc16;
   var
      PA,PB,PC: TDoubleCoord;        // body oblouku
      So: TDoubleCoord;              // stred oblouku
      CAB,CBC,PAB,PBC: TDoubleCoord; // stredy stran a posunute body
      U,L,U1,U2,U12,Alfa: double;        // uhel, delka, poc a konc uhel aktualni uhel
      aX,aY,X1,Y1: double;           // stred kruznice, souradnice
      B1,B2,B3: boolean;
      R,Ro,dU: double;               // polomer , oprava presnost a krokovy uhel
   begin
      if HP.Count < 3 then
         exit;
      // Definice bodu
      // A
      EPoint := TEntity(HP.Elements[0]);
      PE := TPointElement(EPoint.Elements[0]);
      PA.X := PE.X;
      PA.Y := PE.Y;
      // B
      EPoint := TEntity(HP.Elements[1]);
      PE := TPointElement(EPoint.Elements[0]);
      PB.X := PE.X;
      PB.Y := PE.Y;
      // A
      EPoint := TEntity(HP.Elements[2]);
      PE := TPointElement(EPoint.Elements[0]);
      PC.X := PE.X;
      PC.Y := PE.Y;
      // AB
      XYToPolar(PA,PB,L,U);       // uhel a delka AB
      CAB.X := (PA.X + PB.X) / 2; // stred AB
      CAB.Y := (PA.Y + PB.Y) / 2;
      VratPosunutyBod(CAB,U+PiPul,10,PAB);
      // BC
      XYToPolar(PB,PC,L,U);       // uhel a delka BC
      CBC.X := (PB.X + PC.X) / 2; // stred AB
      CBC.Y := (PB.Y + PC.Y) / 2;
      VratPosunutyBod(CBC,U+PiPul,10,PBC);
      // Mame dve primky, dane body CAB a PAB a CBC a PBC
      // prusecik ... to je stred kruznice...  aX,aY
      PrusecikUsecek(CBC.X,CBC.Y,PBC.X,PBC.Y,CAB.X,CAB.Y,PAB.X,PAB.Y,aX,aY,B1,B2,B3);

      // pocatecni, koncovy uhel a polomer
      So.X := aX;
      So.Y := aY;
      XYToPolar(So,PA,R,U1);
      XYToPolar(So,PB,R,U12);
      XYToPolar(So,PC,R,U2);
      Angle22PI(U1);
      Angle22PI(U12);
      Angle22PI(U2);
      if U1 > U12 then
      begin
         if ((U12 > U2) and (U1 > U2)) or ((U12 < U2) and (U1 < U2)) then
            Swap(U1,U2)
      end
      else
      if (U12 > U2) and (U1 < U2) then
         Swap(U1,U2);

      // Vypocet KrokovehoUhlu
      PresnostK := 0.1;
      Ro := R - PresnostK;
      dU := 2*ACos(Ro/R);

      // tvorba linie ...
      x1 := aX+R*(cos(U1));
      y1 := aY+R*(sin(U1));
      LastLineElement.AddXY(X1, Y1);
       Alfa := U1+dU;
      if U2 < U1 then
         U2 := U2 + DvaPI;
      while Alfa < U2 do
      begin
         x1 := aX+R*(cos(Alfa));
         y1 := aY+R*(sin(Alfa));
         LastLineElement.AddXY(X1, Y1);
         Alfa := Alfa+dU;
      end;
      x1 := aX+R*(cos(U2));
      y1 := aY+R*(sin(U2));
      LastLineElement.AddXY(X1, Y1);
   end;

   procedure ProcLay(tx: string; Lay,RLay: TEntity; Druh,Barva,Znacka: integer);
   var
      i,j: integer;
   begin
      Progress := 0;
      MaxProgress := Lay.LastIndex;
      ProgressText := tx + ' -> LIN';
      Application.ProcessMessages;
      Sort := TSortElementsByInteger.Create;
      Sort.PropertyName := 'Name';
      for i := 0 to Lay.LastIndex do
      begin
         if i mod 100 = 0 then
         begin
            Progress := i;
            Application.ProcessMessages;
         end;
         HP := THPEntity(Lay.Elements[i]);
         if HP.Count < 2 then continue;
         Sort.Input := HP;
         Sort.DoIt;
         if HP.ParSpoj = 16 then  // oblouk 3 body
         begin
            StartLineElement;
            DoArc16;
            FinishLineElement(RLay,Druh,Barva,Znacka);
         end
         else
         begin                    // usecka nebo linie
            StartLineElement;
            for j := 0 to HP.LastIndex do
            begin
               EPoint := TEntity(HP.Elements[j]);
               PE := TPointElement(EPoint.Elements[0]);
               LastLineElement.AddXY(PE.X, PE.Y);
               L_T := Round(PE.Angle);
            end;
            FinishLineElement(RLay,Druh,Barva,Znacka);
         end;
      end;
      Sort.Free;
   end;
begin
   ProcLay('HP', FHPs, nil, 1, 13, 0);
   ProcLay('DPM', FDPMs, LIN_PARSLU, Lin_DPMGroup, Lin_DPMColor, Lin_DPMSymbol);
   ProcLay('OB', FOBs, LIN_PARSLU, Lin_BudovaGroup, Lin_BudovaColor, Lin_BudovaSymbol);
   {
   Progress := 0;
   MaxProgress := FHps.LastIndex;
   ProgressText := 'HP -> LIN';
   Application.ProcessMessages;
   Sort := TSortElementsByInteger.Create;
   Sort.PropertyName := 'Name';
   for i := 0 to FHPs.LastIndex do
   begin
      if i mod 100 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      HP := TEntity(FHPs.Elements[i]);
      if HP.Count < 2 then continue;
      Sort.Input := HP;
      Sort.DoIt;
      StartLineElement;
      for j := 0 to HP.LastIndex do
      begin
         EPoint := TEntity(HP.Elements[j]);
         PE := TPointElement(EPoint.Elements[0]);
         LastLineElement.AddXY(PE.X, PE.Y);
         L_T := Round(PE.Angle);
      end;
      FinishLineElement;
   end;
   Sort.Free;
   }
   {
   MaxProgress := FHps.LastIndex;
   ProgressText := 'odstraovn HP';
   Application.ProcessMessages;
   for i := FHPs.LastIndex downto 0 do
   begin
      if i mod 100 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      e := FHPs.Elements[i];
      e.Free;
   end;
   MaxProgress := FIDs.LastIndex;
   ProgressText := 'odstraovn IDs';
   Application.ProcessMessages;
   for i := FIDs.LastIndex downto 0 do
   begin
      if i mod 100 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      e := FIDs.Elements[i];
      e.Free;
   end;
   }
end;

procedure TCreateParcelModelFromISKN.ProcessLine(const aLine: string);
var
   Li: integer;  // last line index
   W: string;    // nactene slovo z radku
   VCh: char;    // oznaceni vety
   Del: char;    // delimiter

   function Uvoz(const aStr: string): string;
   begin
      result := aStr;
      if aStr = '' then exit;
      if aStr[1] <> '"' then exit;
      if aStr[length(aStr)] <> '"' then exit;
      result:= copy(aStr, 2, length(aStr)-2);
   end;

   procedure ReadRecordHeader(aSLE: TStringListElement);
   var
      aCH: char;
      i: integer;
   begin
      aSLE.FreeAll;
      repeat
         W := ReadToDelimiter( aLine, [';'], Li, Del, Li);  // prvni slovo
         W := ReadToDelimiter(W,[' '],1,aCH,i);
         aSLE.AddNameString(W, '');
      until  Del = #0;
   end;

   procedure ReadRecordValues(aSLE: TStringListElement);
   var
      i: integer;
   begin
      i := 0;
      repeat
         W := ReadToDelimiter( aLine, [';'], Li, Del, Li);  // prvni slovo
         if i < aSLE.Count then
            aSLE.StringElements[i].Value := W;
         Inc(i);
      until  Del = #0;
   end;

   procedure ReadHeaders;
   var
      SLE: TStringListElement;
   begin
      //FinishLineELement;  // u hlavicky urcite ukoncime linii
      //W[2] := 'H';
      if Length(W) < 3 then exit;
      Vch := W[3];
      SLE := nil;
      if Test then
      begin
         if Vch = 'S' then
         begin
            if W = '&BSOBR' then
               SLE := FDSOBR
            else
            if W = '&BSBP' then
               SLE := FDSBP;
         end;
         if SLE <> nil then
            ReadRecordHeader(SLE);
         exit;
      end;
      case Vch of
      'O':
         begin
            if W = '&BOP' then
               SLE := FDOP
            else
            if W = '&BOPSUB' then
               SLE := FDOPSUB
            else
            if W = '&BOBDEBO' then
               SLE := FDOBDEBO;
         end;
      'P':
         begin
            if W = '&BPAR' then
               SLE := FDPAR;
         end;
      'D':
         begin
            if W = '&BPAR' then
               SLE := FDPAR;
         end;
      'V':
         begin
            if W = '&BVLA' then
               SLE := FDVLA;
         end;
      'T':
         begin
            if W = '&BTEL' then
               SLE := FDTEL;
         end;
      'R':
         begin
            if W = '&BRZO' then
               SLE := FDRZO;
         end;
      'K':
         begin
            if W = '&HKATUZE' then
               SLE := FDKATUZE;
         end;
      'S':
         begin
            if W = '&BSOBR' then
               SLE := FDSOBR
            else
            if W = '&BSBP' then
               SLE := FDSBP;
         end;
      end;
      if SLE <> nil then
      begin
         ProgressText := W;
         Application.ProcessMessages;
         ReadRecordHeader(SLE);
      end;
   end;

   procedure ReadDOP;  // Obraz parcely ... text
   var
      aX,aY: double;
      TmpT: TtmpText;
      S: string;
      Parcela: string;
      //SE: TStringELement;
   begin
      ReadRecordValues(FDOP);
      S := FDOP.GetStringByName('OPAR_TYPE');
      if S <> '"PC"' then exit;    // nic nez parcela nas nezajima
      aX := -StrToExtended(FDOP.GetStringByName('SOURADNICE_Y'));
      aY := -StrToExtended(FDOP.GetStringByName('SOURADNICE_X'));
      Parcela := FDOP.GetStringByName('TEXT');
      TmpT := TtmpText.Create;
      TmpT.X := aX;
      TmpT.Y := aY;
      TmpT.Text := Uvoz(Parcela);
      Texts.AddElement(TmpT);
      TmpT.FontName := FDOP.GetStringByName('PAR_ID');
      {
      SE := TStringElement.Create;
      SE.Name := 'PID';
      SE.Value := FDOP.GetStringByName('PAR_ID');
      TmpT.AddElement(SE);
      }
   end;

   procedure ReadDSOBR;
   var
      aX,aY: double;
      PE: TPointElement;
   begin
      ReadRecordValues(FDSOBR);
      aX := -StrToExtended(FDSOBR.GetStringByName('SOURADNICE_Y'));
      aY := -StrToExtended(FDSOBR.GetStringByName('SOURADNICE_X'));
      PE := TPointElement.Create;
      PE.Name := FDSOBR.GetStringByName('ID');
      PE.X := aX;
      PE.Y := aY;
      PE.Angle := FDSOBR.GetIntegerByName('KODCHB_KOD');
      FIDs.AddElement(PE);
   end;

   procedure ReadDSBP;
   var
      ParSpoj: string;
      iParSpoj: integer;
      PoradC: integer;
      SID: string;
      e: TElement;
      PE: TPointELement;
      H_ID: string;
      ActualH: THPEntity;
      EPoint: TEntity;
   begin
      ReadRecordValues(FDSBP);
      ParSpoj := Uvoz(FDSBP.GetStringByName('PARAMETRY_SPOJENI'));
      iParSpoj := StrToIntDef(ParSpoj,5);
      ActualH := nil;
      H_ID := FDSBP.GetStringByName('HP_ID');
      if H_ID <> '' then
      begin
         GetHP(H_ID);
         if FActualHP = nil then exit;
         ActualH := FActualHP;
      end
      else
      begin
         if LIN_PARSLU = nil then exit;
         H_ID := FDSBP.GetStringByName('OB_ID');
         if H_ID <> '' then
         begin
            GetOB(H_ID);
            if FActualOB = nil then exit;
            ActualH := FActualOB;
         end
         else
         begin
            H_ID := FDSBP.GetStringByName('DPM_ID');
            if H_ID <> '' then
            begin
               GetDPM(H_ID);
               if FActualDPM = nil then exit;
               ActualH := FActualDPM;
            end;
         end;
      end;
      if ActualH = nil then exit;
      if (iParSpoj > 4) and (iParSpoj <> 16) then
      begin
         LostPoint := true;
         exit;
      end;
      PoradC := FDSBP.GetIntegerByName('PORADOVE_CISLO_BODU');
      {
      if PoradC = 1 then
      begin
         //FinishLineElement;
         TestID := FDSBP.GetIntegerByName('ID');
         //StartLineELement;
      end;
      }
      SID := FDSBP.GetStringByName('BP_ID');
      e := FIDs.FindElementName(SID);
      if e = nil then
      begin
         LostPoint := true;
         exit;
      end;
      PE := TPointElement(e);
      EPoint := TOwnerEntity.Create;
      EPoint.Name := IntToStr(PoradC);
      EPoint.AddElement(PE);
      ActualH.AddElement(EPoint);
      ActualH.ParSpoj := iParSpoj;
      //LastLineElement.AddXY(PE.X, PE.Y);
      //if Test then
      //   L_T := iParSpoj
      //else
      //   L_T := Round(PE.Angle);
   end;

   procedure ReadDPAR;
   var
      KU,Parcis,Parpod, SKuparcis,ZDPAZE,aKATUZE_KOD_PUV: integer;
      Vym: double;
      S: string;
      PKN: boolean;
      LV: integer;
      EN: TEntity;
      aKultura: integer;
   begin
      ReadRecordValues(FDPAR);
      S := FDPAR.GetStringByName('PAR_TYPE');
      S := Uvoz(S);
      PKN := S = 'PKN';
      KU := FDPAR.GetIntegerByName('KATUZE_KOD');
      Parcis := FDPAR.GetIntegerByName('KMENOVE_CISLO_PAR');
      Parpod := FDPAR.GetIntegerByName('PODDELENI_CISLA_PAR');
      SkuparCis := FDPAR.GetIntegerByName('DRUH_CISLOVANI_PAR');
      aKATUZE_KOD_PUV := FDPAR.GetIntegerByName('KATUZE_KOD_PUV');
      if Skuparcis = 1 then
         Parcis := -Parcis;
      ZDPAZE := FDPAR.GetIntegerByName('ZDPAZE_KOD');
      ParcelModel.CreateKatastrCislo(KU);
      ParcelModel.CreateSkupinaParcelCislo(1);
      ParcelModel.CreateParcelaCislo(Parcis, Parpod, aKATUZE_KOD_PUV);
      //ParcelModel.ActualParcela.SKUPAR_CIS := SkuparCis;
      aKultura := FDPAR.GetIntegerByName('DRUPOZ_KOD');
      if aKultura > 0 then
         ParcelModel.ActualParcela.Kultura := aKultura;
      ParcelModel.CreateParCast;
      if ZDPAZE = 4 then
      begin
         ParcelModel.ActualParcela.PK := true;
         ParcelModel.ActualParCast.PKCIS := Abs(Parcis);
         ParcelModel.ActualParCast.PKPOD := Parpod;
      end;
      if ZDPAZE = 6 then
         ParcelModel.ActualParCast.GP := true;
      Vym := StrToExtended(FDPAR.GetStringByName('VYMERA_PARCELY'));
      Vym := Vym / 10000;
      ParcelModel.ActualParcela.Vymera := Vym;
      ParcelModel.ActualParCast.Vymera := Vym;
      ParcelModel.ActualParCast.PK_Dil := FDPAR.GetIntegerByName('DIL_PARCELY');
      ParcelModel.ActualParCast.TEL_ID := FDPAR.GetStringByName('TEL_ID');
      //LV := FDPAR.GetIntegerByName('TEL_ID');
      //ParcelModel.ActualParCast.LVc := LV;
      S := FDPAR.GetStringByName('ID');
      ParcelModel.ActualParCast.aID := S;
      EN := TOwnerEntity.Create;
      EN.Name := S;
      FPARs.AddElement(EN);
      EN.AddElement(ParcelModel.ActualParCast);
   end;

   procedure ReadOBDEBO;
   var
      aX,aY: double;
      TP: TTopolPointElement;
      GP: TPointElement;
      prop: Tgis_ParcelaCast_Props;
      PARID: string;
   begin
      if PNT = nil then exit;    // nejsou body

      ReadRecordValues(FDOBDEBO);
      PARID := FDOBDEBO.GetStringByName('PAR_ID');
      if PARID = '' then exit;
      aX := -StrToExtended(FDOBDEBO.GetStringByName('SOURADNICE_Y'));
      aY := -StrToExtended(FDOBDEBO.GetStringByName('SOURADNICE_X'));

      TP   := TTopolPointElement.Create;
      GP   := TPointElement.Create;
      GP.X := aX;
      GP.Y := aY;

      GP.AbsRefX  := aX;
      GP.AbsRefY  := aY;
      TP.Geometry := GP;
      TP.Druh     := 8210;
      TP.Barva    := 13;
      TP.Znacka   := 1;
      prop := Tgis_ParcelaCast_Props.Create;
      prop.aID := PARID;
      TP.Properties   := prop;
//      prop.AssignBy   := PC;
      PNT.NextElement := TP;
   end;

   procedure ReadDOPSUB;
   var
      P: Tgis_Person;
      S: string;
      procedure SetP(aName: string; aPropName: string);
      var
         S1: string;
      begin
         S1 := Uvoz(FDOPSUB.GetStringByName(aName));
         if S1 <> '' then
            S1 := _8859_2ToWin(S1);
         if aPropName <> '' then
            aName := aPropName;
         P.SetPropertyStringByName(aName,S1);
      end;
   begin
      if (Majitele = nil) or (Lide = nil) then exit;
      ReadRecordValues(FDOPSUB);
      P := Tgis_Person.Create;
      SetP('ID','aID');
      FOPSUBs.AddElement(P);
      Lide.AddElement(P);
      SetP('ID_JE_1_PARTNER_BSM','');
      SetP('ID_JE_2_PARTNER_BSM','');
      SetP('OPSUB_TYPE','');
      SetP('CHAROS_KOD','');
      SetP('ICO','');
      SetP('DOPLNEK_ICO','');
      SetP('NAZEV','');
      SetP('NAZEV_U','');
      SetP('RODNE_CISLO','');
      SetP('TITUL_PRED_JMENEM','');
      SetP('JMENO','');
      SetP('JMENO_U','');
      SetP('PRIJMENI','');
      SetP('PRIJMENI_U','');
      SetP('TITUL_ZA_JMENEM','');
      SetP('CISLO_DOMOVNI','');
      SetP('CISLO_ORIENTACNI','');
      SetP('NAZEV_ULICE','');
      SetP('CAST_OBCE','');
      SetP('OBEC','');
      SetP('OKRES','');
      SetP('STAT','');
      SetP('PSC','');
      SetP('MESTSKA_CAST','');
      SetP('CP_CE','');
   end;
   {
   procedure ReadDOPSUB;
   var
      M: Tgis_Majitel;
      S,S1,S2: string;
   begin
      if Majitele = nil then exit;
      ReadRecordValues(FDOPSUB);
      M := Tgis_Majitel.Create;
      M.Cislo := FDOPSUB.GetStringByName('ID');
      FOPSUBs.AddElement(M);
      S := Uvoz(FDOPSUB.GetStringByName('JMENO'));
      M.Jmeno := _8859_2ToWin(S);
      S := Uvoz(FDOPSUB.GetStringByName('PRIJMENI'));
      M.Prijmeni := _8859_2ToWin(S);
      S := Uvoz(FDOPSUB.GetStringByName('NAZEV'));
      if S <> '' then
         M.Jmeno := _8859_2ToWin(S);
      S := Uvoz(FDOPSUB.GetStringByName('NAZEV_ULICE'));
      S1 := FDOPSUB.GetStringByName('CISLO_DOMOVNI');
      S2 := Uvoz(FDOPSUB.GetStringByName('CISLO_ORIENTACNI'));
      if (S1 <> '') and (S2 <> '') then
         S1 := S1 + '/';
      S1 := S1 + S2;
      if S1 <> '' then
         S := S +' '+S1;
      S1 := Uvoz(FDOPSUB.GetStringByName('CAST_OBCE'));
      if S1 <> '' then
         S := S +' '+S1;
      S1 := Uvoz(FDOPSUB.GetStringByName('OBEC'));
      if S1 <> '' then
         S := S +' '+S1;
      S1 := Uvoz(FDOPSUB.GetStringByName('MESTSKA_CAST'));
      if S1 <> '' then
         S := S +' '+S1;
      M.Adresa := _8859_2ToWin(S);
   end;
   }
   procedure ReadDVLA;
   var
      //T: TTmpText;
      VL: Tgis_Vlastnictvi;
      S: string;
   begin
      ReadRecordValues(FDVLA);
      VL := Tgis_Vlastnictvi.Create;
      VL.Name := FDVLA.GetStringByName('ID');
      VL.OPSUB_ID := Uvoz(FDVLA.GetStringByName('OPSUB_ID'));
      VL.TEL_ID := FDVLA.GetStringByName('TEL_ID');
      VL.PODIL_CITATEL := FDVLA.GetIntegerByName('PODIL_CITATEL');
      VL.PODIL_JMENOVATEL := FDVLA.GetIntegerByName('PODIL_JMENOVATEL');
      S := Uvoz(FDVLA.GetStringByName('TYPRAV_KOD'));
      VL.TYPRAV_KOD := StrToIntDef(S,0);
      FVLAs.AddElement(VL);
      {
      T := TTmpText.Create;
      T.Name := FDVLA.GetStringByName('ID');
      T.Text := FDVLA.GetStringByName('OPSUB_ID');
      T.FontName := FDVLA.GetStringByName('TEL_ID');
      T.FontCode := FDVLA.GetIntegerByName('PODIL_JMENOVATEL');
      S := Uvoz(FDVLA.GetStringByName('TYPRAV_KOD'));
      T.TextColor := StrToIntDef(S,0);
      FVLAs.AddElement(T);
      }
   end;

   procedure ReadDTEL;
   var
      Tel: tgis_Tel;
   begin
      ReadRecordValues(FDTEL);
      Tel := Tgis_Tel.Create;
      Tel.Name := FDTEL.GetStringByName('ID');
      Tel.KATUZE_KOD := FDTEL.GetIntegerByName('KATUZE_KOD');
      Tel.CISLO_TEL := FDTEL.GetIntegerByName('CISLO_TEL');
      FTels.AddElement(Tel);
   end;

   procedure ReadDRZO;
   var
      IE: TIntegerElement;
      zochr: integer;
   begin
      ReadRecordValues(FDRZO);
      zochr := FDRZO.GetIntegerByName('ZPOCHR_KOD');
      if zochr = 26 then       // PUPFL
      begin
         IE := TIntegerElement.Create;
         IE.Name := FDRZO.GetStringByName('PAR_ID');
         IE.Value := Zochr;
         FRZOs.AddElement(IE);
      end;
   end;

   procedure ReadDKATUZE;
   var
      Kod: integer;
      Nazev: string;
   begin
      ReadRecordValues(FDKATUZE);
      Kod := FDKATUZE.GetIntegerByName('KOD');
      Nazev := FDKATUZE.GetStringByName('NAZEV');
      ParcelModel.CreateKatastrCislo(Kod);
      ParcelModel.ActualKatastr.Nazev := _8859_2ToWin(Uvoz(Nazev));
      KU_KOD := Kod;
   end;

   procedure ReadRecord;
   begin
      if Length(W) < 3 then exit;
      Vch := W[3];
      if Test then
      begin
         if Vch = 'S' then
         begin
            if W = '&DSOBR' then
               ReadDSOBR
            else
            if W = '&DSBP' then
               ReadDSBP;
         end;
         exit;
      end;
      case Vch of
      'O':
         begin
            if W = '&DOP' then
               ReadDOP
            else
            if W = '&DOPSUB' then
               ReadDOPSUB
            else
            if W = '&DOBDEBO' then
               ReadOBDEBO;

         end;
      'P':
         begin
            if W = '&DPAR' then
               ReadDPAR;
         end;
      'V':
         begin
            if W = '&DVLA' then
               ReadDVLA;
         end;
      'T':
         begin
            if W = '&DTEL' then
               ReadDTEL;
         end;
      'R':
         begin
            if W = '&DRZO' then
               ReadDRZO;
         end;
      'K':
         begin
            if W = '&DKATUZE' then
               ReadDKATUZE;
         end;
      'S':
         begin
            if W = '&DSOBR' then
               ReadDSOBR
            else
            if W = '&DSBP' then
               ReadDSBP;
            //else
            //if W = '&DSBM' then
            //   ReadDSBM;
         end;
      end;
   end;
begin
   if aLine = '' then exit;
   Li := 1;                  // zacatek radku
   W := ReadToDelimiter( aLine, [';'], Li, Del, Li);  // prvni slovo
   if W = '' then exit;        // nic tam nebylo...
   if W[1]<>'&' then exit;     // pozor - oznaceni vety
   if Length(W) < 2 then exit; // ale, ale?
   VCh := W[2];                // ve Vch je H,B  nebo D
   case Vch of
      'B','H': ReadHeaders;    // Hlavicka
      'D': ReadRecord;         // Cteni zaznamu
   end;
end;

procedure TCreateParcelModelFromISKN.ProcessTmpText(TmpText: TtmpText;
  Parcis, Parpod: integer; ARE: TAreaElement);
var
   PC: TGis_ParcelaCast;
   e: TElement;
begin
   e := TmpText.FindElementClass(Tgis_ParcelaCast);
   if e = nil then
   begin
      TXNoPar := TXNoPar + 1;
      inherited;
      exit;
   end;
   PC := Tgis_ParcelaCast(e);
   PC.Geometry := ARE;
   PC.Barva := Are_ParcelaColor;
   PC.Znacka := 1;
   PC.ParZar := true;
   if not PC.IsMyOwner(ARE_PAR) then
      ARE_PAR.AddElement(PC);
end;

procedure TCreateParcelModelFromISKN.ProcessTmpTextAsPoint(TmpText: TtmpText);
var
   PC: TGis_ParcelaCast;
   e: TElement;
   TP: TTopolPointElement;
   GP: TPointElement;
   prop: Tgis_ParcelaCast_Props;
begin
   // DEPRECATED .............................
   e := TmpText.FindElementClass(Tgis_ParcelaCast);
   if e = nil then
      exit;
   PC := Tgis_ParcelaCast(e);
   // Tvorba bodu .... pokud je nastavena entita pro ne ofsem zejo
   if PNT <> nil then
   begin
      TP   := TTopolPointElement.Create;
      GP   := TPointElement.Create;
      GP.X := TmpText.X;
      GP.Y := TmpText.Y;

      GP.AbsRefX  := TmpText.X;
      GP.AbsRefY  := TmpText.Y;
      TP.Geometry := GP;
      TP.Druh     := 8210;
      TP.Barva    := 13;
      TP.Znacka   := 1;
      prop := Tgis_ParcelaCast_Props.Create;
      TP.Properties   := prop;
      prop.AssignBy   := PC;
      PNT.NextElement := TP;
   end;
end;

procedure TCreateParcelModelFromISKN.ReadData;
begin
   PrepareData;
   inherited;
   FinishData;
end;


procedure TCreateParcelModelFromISKN.SetLide(const Value: Tgis_People);
begin
  FLide := Value;
end;

procedure TCreateParcelModelFromISKN.SetMajitele(const Value: Tgis_Majitele);
begin
  FMajitele := Value;
end;

procedure TCreateParcelModelFromISKN.SetNoMaj(const Value: boolean);
begin
  FNoMaj := Value;
end;

procedure TCreateParcelModelFromISKN.SetNoPar(const Value: boolean);
begin
  FNoPar := Value;
end;


procedure TCreateParcelModelFromISKN.SetParcelyFromModel(const Value: boolean);
begin
  FParcelyFromModel := Value;
end;

procedure TCreateParcelModelFromISKN.SetPNT(const Value: TEntity);
begin
   FPNT := Value;
end;

procedure TCreateParcelModelFromISKN.SetTestFile(const Value: boolean);
begin

end;

procedure TCreateParcelModelFromISKN.SetTestFile1(const Value: boolean);
begin

end;

procedure TCreateParcelModelFromISKN.SetTXNopar(const Value: integer);
begin
  FTXNopar := Value;
end;

{ THPEntity }

procedure THPEntity.SetParSpoj(const Value: integer);
begin
  FParSpoj := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TCreateParcelModelFromDGN);
   RegisterOrbisClass(TCreateParcelModelFromDKM);
   RegisterOrbisClass(TCreateParcelModelFromISKN);
END.
