unit T_HelSel;

interface
uses
// PROJEKTY
{$IFDEF TaxView}
   TaxView_TLB,
{$ENDIF}
// KERNEL
   Elements,
   Tools,
// GLIB
   G_Elems;

type

  THelePlocha = class(TTool)
  public
    constructor Create; override;
    procedure DoIt; override;
  end;


  THeleBasic = class(TTool)
  private
    function  GetDataModel: TEntity;
    function GetHierarchy: TRectEntity;
    procedure SetProtocolText(const Value: string);
  protected
    function  DejDATAEntitu(aJm: string): TEntity;
    function  CreateDATARectEntitu(aJm: string): TRectEntity;
    function FindLayer(aName, aType: string): TRectEntity;
  published
    property Protocol: string write SetProtocolText;
    property Hierarchy: TRectEntity read GetHierarchy;
    property DataModel: TEntity read GetDataModel;
  end;


  THeleNacti = class(THeleBasic)
  private
    FChyba: boolean;
    FDirectory: string;
    FModelScript: TEntity;
    FTemp: TRectEntity;

    procedure PosliText(aText: string);

    procedure VytvorModelScript;
    procedure NactiData;
    procedure PrehodDoDataLayers;
    procedure VytvorHierarchii;

  public
    FDetTemp: TEntity;
    procedure NajdiVrstvu(var aEntity: TEntity; aName, aType: string);
    procedure DoIt; override;

  published
    property Directory: string read FDirectory write FDirectory;
  end;



implementation
uses
   SysUtils, Forms,
// KERNEL
   e_class,
   worlds,
   M_Orbis,
// OIL
   T_AdvRcz,
// GLIB
   T_Grp,
// SPACE
   E_Space,
// GISLAYER
   T_LMCre,
   T_LayScr,
   T_BLKLay,
// MAIN
   T_Main,

   //F_Gauge,
// .
   U_HelStr;


constructor THelePlocha.Create;
begin
//  FAutoTax:= CoAutoTaxView.Create;
end;


procedure THelePlocha.DoIt;
var
  LHC, Odd, Dil, Por, PSk: string;
  aMT: TMainTool;
begin
  if not (input is TAreaElement) then exit;

  LHC:= input.GetPropertyStringByName('LHC');
  Odd:= input.GetPropertyStringByName('ODDELENI');
  DIL:= input.GetPropertyStringByName('DILEC');
  POR:= input.GetPropertyStringByName('POROST');
  PSK:= input.GetPropertyStringByName('SKUPINA');

  aMT:= TMainTool(World.MainTool);
  if aMT = nil then exit;

{$IFDEF TaxView}
  if aMT.AutoTaxView = nil then exit;
  aMT.AutoTaxView.LHC:= strToInt(LHC);
  aMT.AutoTaxView.Odd:= strToInt(Odd);
  aMT.AutoTaxView.Dil:= Dil;
  aMT.AutoTaxView.Por:= Por;
  aMT.AutoTaxView.PSkBzlJP:= DoplnMezeryDoPSk(PSk);
  aMT.AutoTaxView.TypPUPFL:= aMT.GetTypPUPFL(PSK);
  aMT.AutoTaxView.Show
{$ENDIF}
end;



               { THeleBasic }


procedure THeleBasic.SetProtocolText(const Value: string);
begin
  PostTextMsg(tm_AddToProtocol, Value, nil);
end;


function  THeleBasic.DejDATAEntitu(aJm: string): TEntity;
var
  aDATA: TElement;
begin
  result:= nil;
  aDATA:= World.ObjectModel.findElementName('DATA');
  if not (aDATA is TEntity) then exit;
  aData:= TEntity(aDATA).FindElementName(aJm);
  if not (aDATA is TEntity) then exit;
  result:= TEntity(aData)
end;


function  THeleBasic.CreateDATARectEntitu(aJm: string): TRectEntity;
var
  aDATA: TElement;
begin
  Result:= TRectEntity(DejDataEntitu(aJm));
  if TObject(Result) is TRectEntity then Exit;
  Result:= nil;
  aDATA:= World.ObjectModel.findElementName('DATA');
  if not (aDATA is TEntity) then exit;
  Result:= TRectEntity.Create;
  Result.Name:= aJm;
  TEntity(aData).AddElement(Result);
end;



function  THeleBasic.GetDataModel: TEntity;
begin
  result:= TEntity(World.ObjectModel.findElementName('DATAMODEL'))
end;


function THeleBasic.GetHierarchy: TRectEntity;
begin
  result:= TRectEntity(DejDataEntitu('HIERARCHY'));
  if not (TObject(Result) is TRectEntity) then
  begin
    Result:= nil
  end;
end;



function THeleBasic.FindLayer(aName, aType: string): TRectEntity;
var
  aLayers: TEntity;
  aLayer: TRectEntity;
begin
  Result:= nil;
  aLayers:= DejDataEntitu('LAYERS');
  if aLayers = nil then Exit;
  aLayer:= TRectEntity(aLayers.FindElementName(aType + '_'+aName));
  if not (TObject(aLayer) is TRectEntity) then
     Exit;
  Result:= TRectEntity(aLayer.findElementClass(TSpaceEntityString));
end;




             { THeleNacti }


procedure THeleNacti.VytvorModelScript;
var
  aDataModel: TEntity;
  aMSC: TModelScriptCreator;
begin
  FChyba:= true;
  aDataModel:= TEntity(World.ObjectModel.FindElementName('DATAMODEL'));
  if aDataModel = nil then exit;

  aMSC:= TModelScriptCreator.Create;
  aMSC.input:= aDataModel;
  aMSC.DataDirectory:= Directory;
  aMSC.DoIt;
  FModelScript:= TEntity(aMSC.Output);
  AddElement(FModelScript);
  aMSC.Free;
  FChyba:= false;
end;


procedure THeleNacti.NactiData;
var
  aMBSC: TModelByScriptCreator;
begin
  FChyba:= true;

  if FModelScript = nil then exit;
  if FTemp <> nil then
     FTemp.FreeAll
  else
  begin
     FTemp:= TRectEntity.Create;
     AddElement(FTemp);
  end;
  if FTemp = nil then exit;

  aMBSC:= TModelByScriptCreator.Create;
  aMBSC.Input:= FModelScript;
  aMBSC.Output:= FTemp;
  aMBSC.DoIt;

  aMBSC.Free;

  FChyba:= false;
end;

procedure THeleNacti.PrehodDoDataLayers;
var
  aLayers: TEntity;
  aBLT: TBlockLayersTool;
begin
  FChyba:= true;
  if FTemp = nil then exit;
  if FTemp.Count = 0 then exit;
  aLayers:= DejDataEntitu('LAYERS');
  if aLayers = nil then exit;
  aBLT:= TBlockLayersTool.Create;
  aBLT.Input:= FTemp;
  aBLT.Output:= aLayers;
  aBLT.DoIt;
  aBLT.Free;
  FChyba:= false;
end;




procedure THeleNacti.NajdiVrstvu(var aEntity: TEntity; aName, aType: string);
var
  aPomEnt, aLay: TEntity;
  aFBL: TFindBlockLayer;
  I: integer;
begin
  FChyba:= true;
  if FTemp = nil then exit;
  if FTemp.Count = 0 then exit;
  if aEntity = nil then
  begin
    aEntity:= TAreaString.Create;
    AddElement(aEntity);
  end
  else
    aEntity.FreeAll;

  aPomEnt:= TEntity.Create;

  aFBL:= TFindBlockLayer.Create;
  aFBL.Input:= FTemp;
  aFBL.Output:= aPomEnt;
  aFBL.LayerName:= aName;
  aFBL.LayerType:= aType;
  aFBL.DoIt;
  aFBL.Free;

  if aPomEnt.Count = 0 then exit;

  if aPomEnt.Count = 1 then
  begin
    aEntity:= TEntity(aPomEnt.FindElementClass(TAreaString));
  end
  else
  for I:= 0 to aPomEnt.Count-1 do
  begin
    aLay:= TEntity(aPomEnt.Elements[i]);
    if not (TObject(aLay) is TAreaString) then continue;
    aEntity.AddAllFrom:= aLay
  end;

  FChyba:= (aEntity = nil) or (aEntity.Count = 0)
end;



procedure THeleNacti.VytvorHierarchii;
var
   EE: TEntity;
   GR: TGroupper;
   Krit: TPropsAndClass;
   I: longInt;
   aHier: TEntity;
   aMax, Delta, aCount: longInt;
   //FGauge: TF_gaugeForm;
begin
  FChyba:= true;
  if not(FDETTEMP is TAreaString) then exit;
  if FDetTemp.Count = 0 then exit;

  aHier:= Hierarchy;
  if aHier = nil then Exit;

  EE := TEntity.Create;
  //vytvoen kritria pro tvorbu skupin dle katastru
  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'LHC';
  KRIT.OwnerClassName:= 'TLHC';
  //KRIT.SocketName:= 'ODDELENI';
  //KRIT.SocketClassName:= 'TRECTENTITY';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'ODDELENI';
  KRIT.OwnerClassName:= 'TOddeleni';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'DILEC';
  KRIT.OwnerClassName:= 'TDilec';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'POROST';
  KRIT.OwnerClassName:= 'TPorost';
  EE.NextElement := Krit;

  KRIT := TPropsAndClass.Create;
  KRIT.NextName := 'SKUPINA';
  KRIT.OwnerClassName:= 'TPorostniSkupina';
  KRIT.SocketName:= 'GEOMETRY';
  KRIT.SocketClassName:= 'TAREASTRING';
  EE.NextElement := Krit;

  //Vytvoen grupovacho nstroje
  GR := TGroupper.Create;
  GR.Criterion := EE;
  GR.OwnerClass := 'TRectEntity';
  //GR.NextAssigment='BlockDir=BlockDir'
  GR.DoItEmpty := false;
  GR.Output:= aHier;

  aMax:= FDetTemp.Count-1;
{
  TMainTool(World.MainTool).MinProgress:= 0;
  TMainTool(World.MainTool).MaxProgress:= aMax;
  TMainTool(World.MainTool).Progress:= 0;
}
  Delta:= aMax div 20;
  aCount:= 0;
  StartProgress('Vytven lesnick hierarchie ...', 0, aMax);
  {
  FGauge:= TF_gaugeForm.Create(Application);
  FGauge.MaxValue:= aMax;
  FGauge.Caption:= 'Vytven lesnick hierarchie ...';
  FGauge.Show;
  }
  for I:= 0 to aMax do
  begin
    GR.Input:= FDetTemp.Elements[I];
    GR.DoIt;
    if I > aCount then
    begin
       Progress := I;
      //FGauge.Progress:= I;
      inc(aCount, Delta)
    end;
  end;

  //FGauge.Free;

  GR.Free;
  FChyba:= false;
end;


procedure THeleNacti.PosliText(aText: string);
begin
  TMainTool(World.MainTool).Text:= aText;
end;



procedure THeleNacti.DoIt;
begin
  Busy:= true;
{  PosliText('Vytven popisu modelu ...');
  TMainTool(World.MainTool).ProgressVisible:= true;
  TMainTool(World.MainTool).MinProgress:= 0;
  TMainTool(World.MainTool).MaxProgress:= 10;
}
  VytvorModelScript;
  if FChyba then
  begin
    PosliText('Chyba vytven popisu modelu ...');
    Busy:= false;
    TMainTool(World.MainTool).ProgressVisible:= false;
    exit;
  end;
 { TMainTool(World.MainTool).Progress:= 1;

  PosliText('Natn dat ...');
}
  NactiData;

  if FChyba then
  begin
{    PosliText('Chyba natn dat ...');
    TMainTool(World.MainTool).ProgressVisible:= false;
}
    Busy:= false;
    exit;
  end;
{
  TMainTool(World.MainTool).Progress:= 2;

  PosliText('Pemisovn vrstev ...');
}
  PrehodDoDataLayers;
  if FChyba then
  begin
{    PosliText('Chyba pemisovn vrstev ...');
    TMainTool(World.MainTool).ProgressVisible:= false;
}
    Busy:= false;
    exit;
  end;
{
  TMainTool(World.MainTool).Progress:= 3;

  PosliText('Vyjmut vrstvy ploch z DET ...');
}
  NajdiVrstvu(FDetTemp, 'DET', 'ARE');

  FDetTemp.Name:= 'DETTEMP';
//  World.ObjectModel.AddElement(FDetTemp);

  if FChyba then
  begin
{    PosliText('Chyba vyjmn vrstvy ploch z DET ...');
    TMainTool(World.MainTool).ProgressVisible:= false;
}
    Busy:= false;
    exit;
  end;
{  TMainTool(World.MainTool).Progress:= 4;

  PosliText('Vytven hierarchie z natench dat ...');
}
  VytvorHierarchii;

  if FChyba then
  begin
{    PosliText('Chyba vytven hierarchie ...');
    TMainTool(World.MainTool).ProgressVisible:= false;
}
    Busy:= false;
    exit;
  end;
{
  PosliText('Naten dat do hierarchie v podku');
  TMainTool(World.MainTool).ProgressVisible:= false;
}
  Busy:= false;

end;





BEGIN
   RegisterOrbisClass(THeleNacti);
end.
