unit e_LHCProject;

interface
uses
   e_Project;

type

TORBISLHCProject = class(TOrbisProject)
private
    FSymbolsDirectory: string;
    FExternalDataDirectory: string;
    FDataDirectory: string;
    FLastModifyExported: boolean;
    FModified: boolean;
    FExternalParcelDirectory: string;
    FExportDataDirectory: string;
    FExportParcelDirectory: string;
    FYear: integer;
    procedure SetDataDirectory(const Value: string);
    procedure SetExternalDataDirectory(const Value: string);
    procedure SetSymbolsDirectory(const Value: string);
    function GetDataFileExists: boolean;
    function GetDataFileName: string;
    procedure SetLastModifyExported(const Value: boolean);
    procedure SetModified(const Value: boolean);
    function GetExternalDataExists: boolean;
    procedure SetExternalParcelDirectory(const Value: string);
    procedure SetExportDataDirectory(const Value: string);
    procedure SetExportParcelDirectory(const Value: string);
    procedure SetYear(const Value: integer);
published
    property Year: integer read FYear write SetYear;
    property ExternalParcelDirectory: string read FExternalParcelDirectory write SetExternalParcelDirectory;
    property ExternalDataDirectory: string read FExternalDataDirectory write SetExternalDataDirectory;
    property ExportParcelDirectory: string read FExportParcelDirectory write SetExportParcelDirectory;
    property ExportDataDirectory: string read FExportDataDirectory write SetExportDataDirectory;
    property ExternalDataExists: boolean read GetExternalDataExists stored false;
    property DataDirectory: string read FDataDirectory write SetDataDirectory;
    property SymbolsDirectory: string read FSymbolsDirectory write SetSymbolsDirectory;
    property DataFileName: string read GetDataFileName stored false;
    property DataFileExists: boolean read GetDataFileExists stored false;
    property Modified: boolean read FModified write SetModified stored false;
    property LastChangesExported: boolean read FLastModifyExported write SetLastModifyExported;
end;


implementation
uses
   Forms,
   FileCtrl,
   SysUtils,
   m_Orbis,
   e_Class,
   u_String, Elements;

{ TORBISLHCProject }

function TORBISLHCProject.GetDataFileExists: boolean;
begin
{$IFDEF FILEEVENT}
   PostTextMsg(tm_FileExists,DataFileName,nil);
   Application.ProcessMessages;
{$ENDIF}
   result := FileExists(DataFileName);
end;

function TORBISLHCProject.GetDataFileName: string;
begin
   result := DataDirectory;
   CheckBackSlash(result);
   result := GetAbsolutePath(result+Name+'.orb');
end;

function TORBISLHCProject.GetExternalDataExists: boolean;
var
   S: string;
begin
   S := ExternalDataDirectory;
   CheckBackSlash(S);
   S := S + 'DET.BLK';
   result := DirectoryExists(S);
end;

procedure TORBISLHCProject.SetDataDirectory(const Value: string);
begin
  FDataDirectory := Value;
end;

procedure TORBISLHCProject.SetExportDataDirectory(const Value: string);
begin
  FExportDataDirectory := Value;
end;

procedure TORBISLHCProject.SetExportParcelDirectory(const Value: string);
begin
  FExportParcelDirectory := Value;
end;

procedure TORBISLHCProject.SetExternalDataDirectory(const Value: string);
begin
  FExternalDataDirectory := Value;
end;

procedure TORBISLHCProject.SetExternalParcelDirectory(const Value: string);
begin
  FExternalParcelDirectory := Value;
end;

procedure TORBISLHCProject.SetLastModifyExported(const Value: boolean);
begin
  FLastModifyExported := Value;
end;

procedure TORBISLHCProject.SetModified(const Value: boolean);
begin
   FModified := Value;
   LastChangesExported := false;
end;

procedure TORBISLHCProject.SetSymbolsDirectory(const Value: string);
begin
  FSymbolsDirectory := Value;
end;

procedure TORBISLHCProject.SetYear(const Value: integer);
begin
  FYear := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TORBISLHCProject);
END.
