unit t_ExpLHC_XML;
(*
   ----------------------------------------------------------
   Export Struktury LHC s grafikou nebo bez) do standardu XML
   PPK 3.6.2003 -2010
   ----------------------------------------------------------
*)

interface
{$I ..\_conditions.inc}
uses
   Elements,
   e_Geometry,
   e_GeometryElement,
{$IFDEF TAX}
   e_LesCel,
   e_LesOdd,
{$ENDIF}
   e_LHCModel,
   e_XML,
   t_XML;

type

TExportLHCtoXML = class(TXMLSaver)
  private
   FSourceXML: System.Text;
   FSourceFileName: string;
   FSiz: integer;
   FPos,FPosN: integer;
    FLHCID: integer;
    FISLH_version: string;
    FForestModel: Tgis_ForestModel;
{$IFDEF TAX}
    FLesniCelek: TLesniCelek;
    F_Dilec: TDilec;
    F_Oddeleni: TOddeleni;
    F_Porost: TPorost;
    F_PorostniSkupina: TPorostniSkupina;
    F_Kategorie: TKategorie1;
{$ENDIF}
    FTAX: boolean;
    FLED: boolean;
    FLayers: TEntity;
    F_LastEntity: TEntity;
    FLastEntityName: string;
    FKBONames: string;
    FKPONames: string;
    FKLONames: string;
    FKTONames: string;
    FOPValue: integer;
    FBZLValue: integer;
    FJPValue: integer;
    FLCR: boolean;
    FLHC_KOD: integer;
    FLCR_ETAPA: integer;
    FImportREVScript: string;
    FImportKATScript: string;
    FImportLSScript: string;
    FImportHOPScript: string;
    FImportLHCScript: string;
    FImportSKPScript: string;
    FImportPARScript: string;
    FLHP_DO: string;
    FImportZROScript: string;
    FImportKOMScript: string;
    FImportVRSScript: string;
    FImportVODScript: string;
    FLHP_OD: string;
    FLHC_NAZ: string;
    FWorkEntity: TEntity;
    FORGDir: string;
    FGISDir: string;
{$IFDEF TAX}
    F_Bezlesi: TBezlesi;
    F_Drevina: TDrevina;
    F_Etaz: TEtaz;
    F_JinyPozemek: TJinyPozemek;
    F_Ostatni: TOstatni;
    F_Zalesneni: TZalesneni;
    F_Poskozeni: TPoskozeni;
{$ENDIF}
    FImportPRUScript: string;
    FKLO_ChangeGroup: string;
    FKLO_DefaultZnacka: string;
    FKLO_DefaultBarva: string;
    FKLO_DefaultDruh: string;
    FInsertKLO: boolean;
    FLHO: boolean;
    FErrorText: string;
    FProtocolScript: string;
    FPRLString: string;
    FPSKString: string;
    FDILString: string;
    FPORString: string;
    FLHCString: string;
    FODDString: string;
    FImportPLTScript: string;
    FImportLVSScript: string;
    FxmlVersion: string;
    FWGS84: boolean;
    FPARC: boolean;
    procedure SetISLH_version(const Value: string);
    procedure SetLHCID(const Value: integer);
    procedure SetForestModel(const Value: Tgis_ForestModel);
{$IFDEF TAX}
    procedure SetLesniCelek(const Value: TLesniCelek);
    procedure Set_Dilec(const Value: TDilec);
    procedure Set_Oddeleni(const Value: TOddeleni);
    procedure Set_Porost(const Value: TPorost);
    procedure Set_PorostniSkupina(const Value: TPorostniSkupina);
    procedure Set_Kategorie(const Value: TKategorie1);
{$ENDIF}
    procedure SetLED(const Value: boolean);
    procedure SetTAX(const Value: boolean);
    procedure SetLayers(const Value: TEntity);
    procedure Set_LastEntity(const Value: TEntity);
    procedure SetLastEntityName(const Value: string);
    procedure SetKBONames(const Value: string);
    procedure SetKLONames(const Value: string);
    procedure SetKPONames(const Value: string);
    procedure SetKTONames(const Value: string);
    procedure SetBZLValue(const Value: integer);
    procedure SetJPValue(const Value: integer);
    procedure SetOPValue(const Value: integer);
    procedure SetImportHOPScript(const Value: string);
    procedure SetImportKATScript(const Value: string);
    procedure SetImportKOMScript(const Value: string);
    procedure SetImportLHCScript(const Value: string);
    procedure SetImportLSScript(const Value: string);
    procedure SetImportPARScript(const Value: string);
    procedure SetImportREVScript(const Value: string);
    procedure SetImportSKPScript(const Value: string);
    procedure SetImportVODScript(const Value: string);
    procedure SetImportVRSScript(const Value: string);
    procedure SetImportZROScript(const Value: string);
    procedure SetLCR(const Value: boolean);
    procedure SetLCR_ETAPA(const Value: integer);
    procedure SetLHC_KOD(const Value: integer);
    procedure SetLHC_NAZ(const Value: string);
    procedure SetLHP_DO(const Value: string);
    procedure SetLHP_OD(const Value: string);
    procedure SetWorkEntity(const Value: TEntity);
    procedure SetGISDir(const Value: string);
    procedure SetORGDir(const Value: string);
{$IFDEF TAX}
    procedure Set_Bezlesi(const Value: TBezlesi);
    procedure Set_Drevina(const Value: TDrevina);
    procedure Set_Etaz(const Value: TEtaz);
    procedure Set_JinyPozemek(const Value: TJinyPozemek);
    procedure Set_Ostatni(const Value: TOstatni);
    procedure Set_Zalesneni(const Value: TZalesneni);
    procedure Set_Poskozeni(const Value: TPoskozeni);
{$ENDIF}
    procedure SetImportPRUScript(const Value: string);
    procedure SetKLO_ChangeGroup(const Value: string);
    procedure SetKLO_DefaultBarva(const Value: string);
    procedure SetKLO_DefaultDruh(const Value: string);
    procedure SetKLO_DefaultZnacka(const Value: string);
    procedure SetInsertKLO(const Value: boolean);
    procedure SetSourceFileName(const Value: string);
    procedure SetLHO(const Value: boolean);
    procedure SetErrorText(const Value: string);
    procedure SetProtocolScript(const Value: string);
    procedure SetPRLString(const Value: string);
    procedure SetDILString(const Value: string);
    procedure SetLHCString(const Value: string);
    procedure SetODDString(const Value: string);
    procedure SetPORString(const Value: string);
    procedure SetPSKString(const Value: string);
    procedure SetImportLVSScript(const Value: string);
    procedure SetImportPLTScript(const Value: string);
    procedure SetxmlVersion(const Value: string);
    procedure SetWGS84(const Value: boolean);
    procedure SetPARC(const Value: boolean);
public
   procedure   DoIt; override;
   procedure   Start; override;
   procedure   Finish; override;
   procedure   CheckDTDElement(const Value: TDTDModelElement);
   procedure   SaveDTDElementSTART(const Value: TDTDModelElement); override;
   procedure   DoInsertKLO;
   function    GetElementAndID(const S: string; var IDS: string; var IDI: integer): integer;
   procedure   SaveRootElement; override;
   procedure   SaveHeader; override;
   procedure   SaveLHC;
   procedure    SaveLHC_OBRAZ;
   procedure    SaveODD;
   procedure     SaveODD_OBRAZ;
   procedure     SaveDIL;
   procedure      SaveDIL_OBRAZ;
   procedure      SavePOR;
   procedure       SavePOR_OBRAZ;
   procedure       SaveKAT;
   procedure       SavePSK;
   procedure        SavePSK_OBRAZ;
   procedure        Save_OBRAZ(aEl: string);
   procedure        SaveETZ;
   procedure          SaveETAZ_OBRAZ;
   procedure          SaveZAL;
   procedure          SaveDRV;
   procedure           SavePOS;
   procedure          SaveCPP(aEl: string);
   procedure       SaveBZL;
   procedure        SaveBZL_OBRAZ;
   procedure       SaveJP;
   procedure        SaveJP_OBRAZ;
   procedure       SaveOP;
   procedure        SaveOP_OBRAZ;
   procedure   SaveKBO;
   procedure    SaveBOD_OBRAZ;
   procedure   SaveKLO;
   procedure    SaveLIN_OBRAZ;
   procedure   SaveKPO;
   procedure    SavePLO_OBRAZ;
   procedure   SaveKTO;
   procedure    SaveTXT_OBRAZ;
   procedure   SaveHS;
   procedure   SaveOU1;
   procedure   SaveOU2;
   procedure   SaveSCHU;
   procedure   SaveMZD;

   procedure   SaveKOM;
   procedure   SaveVOD;
   procedure   SaveVRS;
   procedure   SaveLCR;
   procedure   SaveLCR_Pre;
   procedure   SaveLS;
   procedure   SaveREV;
   procedure   Save_KAT;
   procedure   SavePAR;
   procedure   SaveSKP;
   procedure   SaveZRO;
   procedure   SaveLVS;
   procedure   SavePLT;
   procedure   SaveHOP;


{$IFDEF TAX}
   function    Calculate_PSK_ZNACKA(_PSK: TPorostniSkupina): integer;
{$ENDIF}
   function    CheckPSKValue(aPSK: string; i1, i2: integer): boolean;
   procedure   SaveLineEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SaveAreaEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SavePointEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SaveTextEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SaveMP(const Value: TGeometry; MP: boolean);
   procedure   WritePoint(_X,_Y: double; MB: boolean);
   procedure   WriteLine(aLine: TPolyLineElement);
   procedure   WriteArea(aArea: TAreaElement);
   procedure   WriteSimpleArea(aArea: TAreaElement);
   function    ZDoubleStr(aDouble:Double):String;
   function    AngleXml(aVal: string): string;
   procedure   FillElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
   procedure   FillGElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
   procedure   FillLHCtoSelf;
   function    Tecka(const Value: string): string;
   function    JTSK_WGS84(var aX,aY: double): boolean;
   {$IFDEF TAX}
   property    _Oddeleni: TOddeleni read F_Oddeleni write Set_Oddeleni;
   property    _Dilec: TDilec read F_Dilec write Set_Dilec;
   property    _Porost: TPorost read F_Porost write Set_Porost;
   property    _PorostniSkupina: TPorostniSkupina read F_PorostniSkupina write Set_PorostniSkupina;
   property    _Etaz: TEtaz read F_Etaz write Set_Etaz;
   property    _Zalesneni: TZalesneni read F_Zalesneni write Set_Zalesneni;
   property    _Poskozeni: TPoskozeni read F_Poskozeni write Set_Poskozeni;
   property    _Drevina: TDrevina read F_Drevina write Set_Drevina;
   property    _Bezlesi: TBezlesi read F_Bezlesi write Set_Bezlesi;
   property    _JinyPozemek: TJinyPozemek read F_JinyPozemek write Set_JinyPozemek;
   property    _Ostatni: TOstatni read F_Ostatni write Set_Ostatni;
   property    _Kategorie: TKategorie1 read F_Kategorie write Set_Kategorie;
   {$ENDIF}
   property    _LastEntity: TEntity read F_LastEntity write Set_LastEntity;
   property    LastEntityName: string read FLastEntityName write SetLastEntityName;
   procedure   RunScript(const Value: string);
   property    LHCString: string read FLHCString write SetLHCString;
   property    ODDString: string read FODDString write SetODDString;
   property    DILString: string read FDILString write SetDILString;
   property    PORString: string read FPORString write SetPORString;
   property    PSKString: string read FPSKString write SetPSKString;
published
   property    SourceFileName: string read FSourceFileName write SetSourceFileName; // zdrojovy xml
   property    ISLH_version: string read FISLH_version write SetISLH_version;
   property    LHCID: integer read FLHCID write SetLHCID;
   {$IFDEF TAX}
   property    LesniCelek: TLesniCelek read FLesniCelek write SetLesniCelek;
   {$ENDIF}
   property    ForestModel: Tgis_ForestModel read FForestModel write SetForestModel;
   property    Layers: TEntity read FLayers write SetLayers;
   property    TAX: boolean read FTAX write SetTAX;
   property    LED: boolean read FLED write SetLED;
   property    PARC: boolean read FPARC write SetPARC;
   property    KBONames: string read FKBONames write SetKBONames;
   property    KPONames: string read FKPONames write SetKPONames;
   property    KLONames: string read FKLONames write SetKLONames;
   property    KTONames: string read FKTONames write SetKTONames;
   property    BZLValue: integer read FBZLValue write SetBZLValue;
   property    OPValue: integer read FOPValue write SetOPValue;
   property    JPValue: integer read FJPValue write SetJPValue;
   property    ImportLHCScript: string read FImportLHCScript write SetImportLHCScript;
   property    ImportKOMScript: string read FImportKOMScript write SetImportKOMScript;
   property    ImportPRUScript: string read FImportPRUScript write SetImportPRUScript;
   property    ImportVODScript: string read FImportVODScript write SetImportVODScript;
   property    ImportVRSScript: string read FImportVRSScript write SetImportVRSScript;
   property    ImportLSScript: string read FImportLSScript write SetImportLSScript;
   property    ImportREVScript: string read FImportREVScript write SetImportREVScript;
   property    ImportKATScript: string read FImportKATScript write SetImportKATScript;
   property    ImportPARScript: string read FImportPARScript write SetImportPARScript;
   property    ImportSKPScript: string read FImportSKPScript write SetImportSKPScript;
   property    ImportZROScript: string read FImportZROScript write SetImportZROScript;
   property    ImportHOPScript: string read FImportHOPScript write SetImportHOPScript;
   property    ImportPLTScript: string read FImportPLTScript write SetImportPLTScript;
   property    ImportLVSScript: string read FImportLVSScript write SetImportLVSScript;
   property    WorkEntity: TEntity read FWorkEntity write SetWorkEntity;
   property  GISDir: string read FGISDir write SetGISDir;
   property  ORGDir: string read FORGDir write SetORGDir;
   property    LCR: boolean read FLCR write SetLCR;
   property    LCR_ETAPA: integer read FLCR_ETAPA write SetLCR_ETAPA;
   property    LHC_KOD: integer read FLHC_KOD write SetLHC_KOD;
   property    LHC_NAZ: string read FLHC_NAZ write SetLHC_NAZ;
   property    LHP_OD: string read FLHP_OD write SetLHP_OD;
   property    LHP_DO: string read FLHP_DO write SetLHP_DO;
   property    KLO_ChangeGroup: string read FKLO_ChangeGroup write SetKLO_ChangeGroup;
   property    KLO_DefaultDruh: string read FKLO_DefaultDruh write SetKLO_DefaultDruh;
   property    KLO_DefaultBarva: string read FKLO_DefaultBarva write SetKLO_DefaultBarva;
   property    KLO_DefaultZnacka: string read FKLO_DefaultZnacka write SetKLO_DefaultZnacka;
   property    InsertKLO: boolean read FInsertKLO write SetInsertKLO;
   property    LHO: boolean read FLHO write SetLHO;
   property    ErrorText: string read FErrorText write SetErrorText;
   property    ProtocolScript: string read FProtocolScript write SetProtocolScript;
   property    PRLString: string read FPRLString write SetPRLString;
   property    xmlVersion: string read FxmlVersion write SetxmlVersion;
   property    WGS84: boolean read FWGS84 write SetWGS84;
end;

TInsertLCRToXML = class(TXMLSaver)
private
   FSourceXML: System.Text;
   FSourceFileName: string;
   FSiz: integer;
   FPos,FPosN: integer;
    FForestModel: Tgis_ForestModel;
    FImportLSScript: string;
    FImportZROScript: string;
    FImportKATScript: string;
    FImportREVScript: string;
    FImportSKPScript: string;
    FImportLHCScript: string;
    FImportPARScript: string;
    FImportVODScript: string;
    FImportVRSScript: string;
    FImportKOMScript: string;
    FWorkEntity: TEntity;
    FGISDir: string;
    FORGDir: string;
    FImportHOPScript: string;
    FRepairVODKOM: boolean;
    FPre_PAR: boolean;
    FPreparing: boolean;
    FPre_SKP: boolean;
    FPre_ZRO: boolean;
    FLHC_KOD: integer;
    FISLH_version: string;
    FLHP_OD: string;
    FLHP_DO: string;
    FLHC_NAZ: string;
    FPre_HOP: boolean;
    FPre_KAT: boolean;
    FPre_REV: boolean;
    FPre_LS: boolean;
   procedure SetSourceFileName(const Value: string);
    procedure SetForestModel(const Value: Tgis_ForestModel);
    procedure SetImportKATScript(const Value: string);
    procedure SetImportKOMScript(const Value: string);
    procedure SetImportLHCScript(const Value: string);
    procedure SetImportLSScript(const Value: string);
    procedure SetImportPARScript(const Value: string);
    procedure SetImportREVScript(const Value: string);
    procedure SetImportSKPScript(const Value: string);
    procedure SetImportVODScript(const Value: string);
    procedure SetImportVRSScript(const Value: string);
    procedure SetImportZROScript(const Value: string);
    procedure SetWorkEntity(const Value: TEntity);
    procedure SetGISDir(const Value: string);
    procedure SetORGDir(const Value: string);
    procedure SetImportHOPScript(const Value: string);
    procedure SetRepairVODKOM(const Value: boolean);
    procedure SetPre_PAR(const Value: boolean);
    procedure SetPre_SKP(const Value: boolean);
    procedure SetPre_ZRO(const Value: boolean);
    procedure SetPreparing(const Value: boolean);
    procedure SetISLH_version(const Value: string);
    procedure SetLHP_DO(const Value: string);
    procedure SetLHC_KOD(const Value: integer);
    procedure SetLHC_NAZ(const Value: string);
    procedure SetLHP_OD(const Value: string);
    procedure SetPre_HOP(const Value: boolean);
    procedure SetPre_KAT(const Value: boolean);
    procedure SetPre_LS(const Value: boolean);
    procedure SetPre_REV(const Value: boolean);
public
   procedure   SaveHeader; override;
   procedure   DoIt; override;
   procedure   Start; override;
   procedure   DoInsertLCR; virtual;
   procedure   DoRepairVODKOM; virtual;
   procedure   DoPreparing; virtual;
   procedure   DoPreparingFinally; virtual;
   procedure   Finish; override;
   function    GetElementAndID(const S: string; var IDS: string; var IDI: integer): integer;
   procedure   SaveLHC_OBRAZ;
   procedure   SaveODD_OBRAZ;
   procedure   SaveDIL_OBRAZ;
   procedure   SaveKOM;
   procedure   SaveVOD;
   procedure   SaveVRS;
   procedure   SaveLCR;
   procedure   SaveLCR_Pre;
   procedure   SaveLS;
   procedure   SaveREV;
   procedure   SaveKAT;
   procedure   SavePAR;
   procedure   SaveSKP;
   procedure   SaveZRO;
   procedure   SaveHOP;
   procedure   SaveLineEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SaveAreaEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SavePointEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
   procedure   SaveMP(const Value: TGeometry);
   procedure   WritePoint(aPoint: TPointElement; MB: boolean);
   procedure   WriteLine(aLine: TPolyLineElement);
   procedure   WriteArea(aArea: TAreaElement);
   procedure   WriteSimpleArea(aArea: TAreaElement);
   procedure   FillElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
   function    Tecka(const Value: string): string;
   function    ZDoubleStr(aDouble:Double):String;
   procedure   RunScript(const Value: string);
published
   property  SourceFileName: string read FSourceFileName write SetSourceFileName; // zdrojovy xml
   property  ForestModel: Tgis_ForestModel read FForestModel write SetForestModel;
   property  ImportLHCScript: string read FImportLHCScript write SetImportLHCScript;
   property  ImportKOMScript: string read FImportKOMScript write SetImportKOMScript;
   property  ImportVODScript: string read FImportVODScript write SetImportVODScript;
   property  ImportVRSScript: string read FImportVRSScript write SetImportVRSScript;
   property  ImportLSScript: string read FImportLSScript write SetImportLSScript;
   property  ImportREVScript: string read FImportREVScript write SetImportREVScript;
   property  ImportKATScript: string read FImportKATScript write SetImportKATScript;
   property  ImportPARScript: string read FImportPARScript write SetImportPARScript;
   property  ImportSKPScript: string read FImportSKPScript write SetImportSKPScript;
   property  ImportZROScript: string read FImportZROScript write SetImportZROScript;
   property  ImportHOPScript: string read FImportHOPScript write SetImportHOPScript;
   property  WorkEntity: TEntity read FWorkEntity write SetWorkEntity;
   property  GISDir: string read FGISDir write SetGISDir;
   property  ORGDir: string read FORGDir write SetORGDir;
   property  RepairVODKOM: boolean read FRepairVODKOM write SetRepairVODKOM;
   property  Preparing: boolean read FPreparing write SetPreparing;
   property  Pre_LS: boolean read FPre_LS write SetPre_LS;
   property  Pre_REV: boolean read FPre_REV write SetPre_REV;
   property  Pre_KAT: boolean read FPre_KAT write SetPre_KAT;
   property  Pre_PAR: boolean read FPre_PAR write SetPre_PAR;
   property  Pre_SKP: boolean read FPre_SKP write SetPre_SKP;
   property  Pre_ZRO: boolean read FPre_ZRO write SetPre_ZRO;
   property  Pre_HOP: boolean read FPre_HOP write SetPre_HOP;
   property  ISLH_version: string read FISLH_version write SetISLH_version;
   property  LHC_KOD: integer read FLHC_KOD write SetLHC_KOD;
   property  LHC_NAZ: string read FLHC_NAZ write SetLHC_NAZ;
   property  LHP_OD: string read FLHP_OD write SetLHP_OD;
   property  LHP_DO: string read FLHP_DO write SetLHP_DO;
end;

const
   Test: boolean = true;

implementation
uses
   System.RegularExpressions,
{$IFDEF TAX}
   LesCisOr,
{$ENDIF}
   Dialogs,
   Forms,
   SysUtils,
   TypInfo,
   e_Class,
   e_TopolElements,
   e_Type,
   t_Coord,
   r_WGS84,
   m_Orbis,
   m_Proj,
   u_Props,
   u_String;

{ TExportLHCtoXML }

function TExportLHCtoXML.AngleXml(aVal: string): string;
var
   VAngle:double;
   Zap: boolean;
begin
 //VAngle:=abs(strToFloat(AVal));

 VAngle:=strToFloat(AVal);
 Zap := VAngle < 0;
 VAngle := abs(VAngle);
 VAngle:=VAngle-Int(VAngle/(2*PI))*2*PI;
 // VAngle:=VAngle/(2*pi);
 // VAngle:=(VAngle-trunc(VAngle))*(2*pi);
 if Zap then
    VAngle := 2*PI - Vangle;
 result:=floatTOStrf(VAngle,ffFixed,10,2);
end;

{$IFDEF TAX}
function TExportLHCtoXML.Calculate_PSK_ZNACKA(_PSK: TPorostniSkupina): integer;
var
   ECount: integer;
   ETZ,ETZA,ETZB,ETZC: TEtaz;
   Zakm,ZakmA,ZakmB,Vek,VekA,VekB: integer;
   Zn: integer;
   i: integer;

   procedure PrehodAB;
   begin
      ETZ   := ETZB;
      ETZB  := ETZA;
      ETZA  := ETZ;
      Vek   := VekB;
      VekB  := VekA;
      VekA  := Vek;
      Zakm  := ZakmB;
      ZakmB := ZakmA;
      ZakmA := Zakm;
   end;
   procedure SetEtz(Et: TEtaz; var aEtz: TEtaz; var aZakm, aVek: integer);
   begin
      aEtz  := Et;
      aVek  := Et.VEK;
      aZakm := Et.ZAKM;
      if aZakm > 6 then
         aZakm := 7
      else
      if aZakm > 3 then
         aZakm := 4
      else
      if aZakm > 0 then
         aZakm := 1
      else
         aZakm := 0;
   end;
   function Calc1Etz(aZakm: integer): integer;
   begin
      if aZakm > 6 then
         Zn := 10100
      else
      if aZakm > 3 then
         Zn := 10000
      else
      if aZakm > 0 then
         Zn := 20000
      else
         Zn := 10100;
      VekA := ETZA.VEK + 19;
      if VekA > 179 then VekA := 179;
      Result := Zn + (VekA div 20);
   end;
begin
   result := 10100;
   if _PSK = nil then exit;
   if _PSK.EtazMN = nil then exit;
   ECount := _PSK.EtazMN.Count;
   if ECount = 0 then exit;
   // jedna etaz
   if ECount = 1 then
   begin
      SetEtz(_PSK.IEtaz[0],ETZA,ZakmA,VekA);
      result := Calc1ETZ(ETZA.ZAKM);
      exit;
   end
   else
   // vic etazi
   begin
      ETZA := nil;
      ETZB := nil;
      // Hledani dvou nejstarsich etazi
      for i := 0 to ECount - 1 do
      begin
         if ETZA = nil then
            SetEtz(_PSK.IEtaz[i],ETZA,ZakmA,VekA)
         else
         if ETZB = nil then
         begin
            SetEtz(_PSK.IEtaz[i],ETZB,ZakmB,VekB);
            if ETZB.VEK > ETZA.VEK then PrehodAB;
         end
         else
         begin
            ETZ := _PSK.IEtaz[i];
            if ETZ.VEK > ETZB.VEK then
            SetEtz(ETZ,ETZB,ZakmB,VekB);
            if ETZB.VEK > ETZA.VEK then PrehodAB;
         end;
      end;
      // pokud je vic etazi a nestarsi2 maji zakm < 4, pouzije se nejstarsi se zakm >= 4
      if (ECount > 2) and (ZakmA < 4) and (ZakmB < 4) then
      begin
         ETZC := nil;
         for i := 0 to ECount - 1 do
         begin
            ETZ := _PSK.IEtaz[i];
            if (ETZ.ZAKM > 3) and ((ETZC = nil) or (ETZ.VEK > ETZC.VEK)) then
               ETZC := ETZ;
         end;
         if ETZC <> nil then   // asi sme neco nasli ....
         begin
            SetEtz(ETZC,ETZB,ZakmB,VekB);
         end;
      end
   end;
   // Etaze A a B serazeny podle veku....
   // Seradime je podle zakmeneni pokud je stejne bude A mladsi
   if ZakmB >= ZakmA then PrehodAB;
   VekA := VekA + 19;
   if VekA > 179 then VekA := 179;
   VekA := (VekA div 20);
   VekB := VekB + 19;
   if VekB > 179 then VekB := 179;
   VekB := VekB div 20;
   // Shodny Vek ... pocita se jako jedna etaz a soucet zakm
   if (VekA = VekB) or (ETZB.ZAKM = 0) then
   begin
      result := Calc1Etz(ETZA.ZAKM + ETZB.ZAKM);
      exit;
   end;
   // Shodne Zakm
   if ZakmA = ZakmB then
   begin
      if ZakmA >= 4 then
         Zn := 10000
      else
         Zn := 26000;
   end
   else
   // ruzne Zakm
   begin
      if ZakmA = 7 then
      begin
         if ZakmB = 1 then
            Zn := 20000
         else
            Zn := 10000;
      end
      else
         Zn := 25000;
   end;
   if (Zn = 10000) and (VekA > VekB) then
      PrehodAB;
   Result := Zn + 10*VekA + VekB;
end;
{$ENDIF}
procedure TExportLHCtoXML.CheckDTDElement(const Value: TDTDModelElement);
var
   S: string;
   At: Txs_Attribute;
   i: integer;
begin
   if Value = nil then exit;
   if not Value.NoAttributes then
   for i := 0 to Value.Attributes.LastIndex do
   begin
      At := Value.Attributes.Attribute[i];
//      if test then
//      begin
//          if At.Name = 'PSK_V' then
//          begin
//             At.Value := '0';
//             test := false;
//          end;
//      end;
      if not At.CheckRestriction(At.Value, S) then
         ErrorText := 'Atrib Err ' +PRLString + ' element '+ Value.Name + ' ' + At.Name +  '="' + At.Value + '" ' + S;
   end;
end;

function TExportLHCtoXML.CheckPSKValue(aPSK: string; i1,i2: integer): boolean;
var
   S: string;
   i: integer;
begin
   S := '';
   Result := false;
   i := 1;
   if aPSK <> '' then
   begin
      while not (i > Length(aPSK)) and not (aPSK[i] in ['0'..'9']) do Inc(i);
      while not (i > Length(aPSK)) and (aPSK[i] in ['0'..'9']) do
      begin
         S := S + aPSK[i];
         Inc(i);
      end;
   end;
   if S = '' then exit;
   i := StrToIntDef(S,0);
   result :=  (i >= i1) and (i < i2);
end;

procedure TExportLHCtoXML.DoInsertKLO;
var
   S: string;
   PRS: string;
   IDS: string;
   IDI: integer;
   aLHC: integer;
   aOdd: integer;
   aOdds: string;
   aDil: string;
   res: integer;
   WaitFor: boolean;
begin
   WaitFor := true;
   Fsiz := FileSize(FSourceXML);
   Fpos := 0;
   StartProgress('KLO do XML',0,FSiz);
   ProgressText := 'hledn KLO';
   Application.ProcessMessages;
   while not Eof(FSourceXML) do
   begin
      ReadLn(FSourceXML,S);
      //Gauge1.Progress := Gauge1.Progress + Length(S);
      FPosN := FilePos(FSourceXML);
      if fposn > fpos then
      begin
         fpos := fposn;
         Progress := fpos;
         Application.ProcessMessages;
      end;
      if WaitFor then
      begin
         res := GetElementAndID(S,IDS,IDI);
         case res of
            4: begin
                  ProgressText := 'Ukldn KLO';
                  Application.ProcessMessages;
                  WaitFor := false;
                  Level := 2;
                  SaveKLO;
                  //Writeln(FText,'***LCR a jine pindy');
                  ProgressText := 'Kartografie...';
                  Application.ProcessMessages;
                  Writeln(FText,S);
               end;
         else
            Writeln(FText,S);
         end;
         if Error > 0 then
         begin
            ShowMessage('Osudn chyba! Element DTD nebo co!');
            exit;
         end;
      end
      else
         Writeln(FText,S);
   end;
end;

procedure TExportLHCtoXML.DoIt;
var
   sDTD: string;
begin
   if InsertKLO then
   begin
      if not FileExists(FSourceFileName) then
      begin
         ShowMessage('Zdroj '+FSourceFileName + 'neexistuje!');
         exit;
      end;
      sDTD := ChangeFileExt(FSourceFileName,'.dtd');
      if not FileExists(sDTD) then
      begin
         ShowMessage('DTD '+sDTD + 'neexistuje!');
         exit;
      end;
      Start;
      DoInsertKLO;
      Finish
   end
   else
      inherited;
end;

procedure TExportLHCtoXML.FillElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
var
   i: integer;
   At: Txs_Attribute;
   S: string;
   aParName_xml: string;
   aPropIndex: integer;
   aTypeKind: TTypeKind;
   SZnacka,SUhel: string;
   IsFloat: boolean;
begin
   if (DTDModel = nil) or (aElement = nil) then exit;
   if DTDModel.NoAttributes then exit;
   for i := 0 to DTDModel.Attributes.LastIndex do
   begin
      AT := DTDModel.Attributes.Attribute[i];
      aParName_xml := At.Name + '_xml';
      if not aElement.HasPropertyByName(aParName_xml) then
      begin
         aParName_xml := At.Name;
         if not aElement.HasPropertyByName(aParName_xml) then
         begin
            continue;
            //writeln(FError, FAktObject + '->' + aParName + ' ... missing property');
         end;
      end
      else
      begin
      end;
      S := aElement.GetPropertyStringByName(aParName_XML);
      if At.Name = 'PSK' then
         S := RemoveAllSpaces(S);
      aPropIndex:= GetPropIndex(aElement, aParName_xml);
      if aPropIndex > -1 then
      begin
         aTypeKind:= GetPropType(aElement, aPropIndex);
         if aTypeKind = tkFloat then
            S := Tecka(S)
         else
         if  (aTypeKind = tkString) or (aTypeKind = tkLString){$IFDEF UNICODE} or (aTypeKind = tkUString){$ENDIF}then
            S := StrToXML(S);
      end;
      At.Value := S;
   end;
end;

procedure TExportLHCtoXML.FillGElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
var
   i: integer;
   At: Txs_Attribute;
   S: string;
   aParName_xml: string;
   aPropIndex: integer;
   aTypeKind: TTypeKind;
   pos: integer;
   SZnacka,SUhel,txUhel: string;
   IsFloat: boolean;
   IsAngle: boolean;
begin
   if (DTDModel = nil) or (aElement = nil) then exit;
   if DTDModel.NoAttributes then exit;
   DTDModel.ClearAttributes;
   SZnacka := DTDModel.Name + '_ZNACKA';
   SUhel   := DTDModel.Name + '_UHELZN';
   txUhel  := 'TXT_UHEL';
   for i := 0 to DTDModel.Attributes.LastIndex do
   begin
      IsFloat := false;
      IsAngle := false;
      At := DTDModel.Attributes.Attribute[i];
      //*****
      if At.Name = SZnacka then
         aParName_xml := 'Znacka'
      else
      if At.Name = SUhel then
      begin
         aParName_xml := 'Angle';
         IsFloat := true;
         IsAngle := true;
      end
      else
      if At.Name= 'PARVYM' then
      begin
         aParName_xml := At.Name;
         IsFloat := At.Name = 'PARVYM';
      end
      else
      //*****
      if At.Name= txUhel then
      begin
         aParName_xml := 'Direction';
         IsFloat := true;
         IsAngle := true;
      end
      else
      if AT.Name = 'L_' then
      begin
         At.Value := LastEntityName;
         continue;
      end
      else
      if aElement.HasPropertyByName(At.Name) then
         aParName_xml := At.Name
      else
      begin
         aParName_xml := copy(At.Name,5,Length(At.Name));
         S := copy(aParName_xml,1,4);
         if S = 'UHEL' then
         begin
            aParName_xml := 'Angle';
            IsFloat := true;
            IsAngle := true;
         end
         else
         if (S = 'STYL') or (S='DRUH') then
            aParName_xml := 'Group';
      end;
      if not aElement.HasPropertyByName(aParName_xml) then continue;
      S := aElement.GetPropertyStringByName(aParName_XML);
      S := StrToXML(S);    // vyhozeni nepovolenych znaku
      if IsAngle then
         S := AngleXml(S);
      if IsFloat then
         S := Tecka(S);
      At.Value := S;
   end;
end;

procedure TExportLHCtoXML.FillLHCtoSelf;
begin
{$IFDEF TAX}
   LHC_KOD := LesniCelek.LHC.LHC_KOD;
   LHC_NAZ := LesniCelek.LHC.LHC_NAZ;
   LHP_OD  := LesniCelek.LHC.LHP_OD;
{$ENDIF}
end;

procedure TExportLHCtoXML.Finish;
begin
   if InsertKLO then
         system.close(FSourceXML);
   inherited;
end;

function TExportLHCtoXML.GetElementAndID(const S: string; var IDS: string; var IDI: integer): integer;
var
   i: integer;
   Ch: char;
   SS: string;

   function FindIDS(const Key: string): boolean;
   var
      apos: integer;
      SSS: string;
   begin
      result := false;
      SSS := '';
      while S[i] in [#9,#32] do Inc(i);
      while S[i] in ['A'..'Z','_'] do
      begin
         SSS := SSS + S[i];
         Inc(i);
      end;
      if not (SSS = Key) then exit;
      while not (S[i]='"') do Inc(i);
      Inc(i);
      while not (S[i]='"') do
      begin
         IDS := IDS + S[i];
         Inc(i);
      end;
      result := true;
   end;
begin
   //zajima nas jenom KLO(4) jinak nic - ostatni se jen presypava
   result := 0;
   IDS := '';
   IDI := 0;
   i := pos('<',S);
   if i <= 0 then exit;
   if not (S[i+1] in ['K']) then exit;
   SS := Copy(S,i+1,3);
   i := i + 4;
   if SS = 'KLO' then
   begin
      result := 4;
   end;
   //while i <= S[i] in [#9,#32] do Inc(i)
end;

function TExportLHCtoXML.JTSK_WGS84(var aX, aY: double): boolean;
var
   A: TMapCoord;
begin
   A.X := -aY;
   A.Y := -aX;
   result := JTSKtoWGS84(A,aX,aY);
end;

procedure TExportLHCtoXML.RunScript(const Value: string);
begin
   PostTextMsg(tm_Run,Value,nil);
   Application.ProcessMessages;
end;

procedure TExportLHCtoXML.SaveAreaEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   A: TAreaElement;
   S : string;
   aMP: boolean;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   //DObr :=  D.FindDTDElement('PLO_OBRAZ');
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then
      DObr :=  D.FindDTDElement('PLO_OBRAZ');
   if DObr = nil then
      exit;
   if anEntity = nil then exit;
   aMP := DObr.FindDTDElement('MP') <> nil;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   if anEntity.NoElements then
      ErrorText := 'A Layer ' + anEntity.Name + ' is Empty' ;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TAreaElement) then continue;
      A := TAreaElement(G);
      FillGElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      SaveMP(A,aMP);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SaveBOD_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SaveBZL;
var
   _BZL: TDTDModelElement;
   i: integer;
   GBZL: Tgis_PorostniSkupina;
begin
   _BZL := DTD.FindDTDElement('BZL');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Porost.BezlesiMN.LastIndex do
      begin
         _Bezlesi := _Porost.IBezlesi[i];
         PSKString := ' ' + IntToStr(_Bezlesi.BZL);
         PRLString := ODDString + DILString + PORString + PSKString;
         FillElementAttributes(_BZL,_Bezlesi);
         SaveDTDElementSTART(_BZL);
         if LED then
         begin
            ForestModel.Skupina_Name := IntToStr(_Bezlesi.BZL);
            if ForestModel.ActualPorost <> nil then
            if ForestModel.ActualSkupina = nil then
            begin
               ErrorText :=  'G BZL Error: ' + PRLString;
            end
            else
            begin
               SaveBZL_OBRAZ;
               if PARC then SaveCPP('CPB');
            end;
         end;
         SaveDTDElementEND(_BZL);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualPorost.NoItems then
      for i := 0 to ForestModel.ActualPorost.Items.LastIndex do
      begin
         GBZL := Tgis_PorostniSkupina(ForestModel.ActualPorost.Items.Elements[i]);
         PSKString := GBZL.Name;
         PRLString := ODDString + DILString + PORString +PSKString;
         if not CheckPSKValue(GBZL.Name, BZLValue, JPValue) then continue;
         ForestModel.ActualSkupina := GBZL;
         FillGElementAttributes(_BZL,GBZL);
         SaveDTDElementSTART(_BZL);
         SaveBZL_OBRAZ;
         SaveDTDElementEND(_BZL);
      end;
   end;
end;

procedure TExportLHCtoXML.SaveBZL_OBRAZ;
begin
   Save_OBRAZ('BZL_OBRAZ');
end;

procedure TExportLHCtoXML.SaveCPP(aEl: string);
var
   _CPP: TDTDModelElement;
   At: Txs_Attribute;
   EN: TEntity;
   E: TElement;
   i,j: integer;
begin
   if not LED then exit;
   _CPP := DTD.FindDTDElement(aEL);
   if _CPP = nil then exit;
   if ForestModel.ActualSkupina = nil then exit;
   EN := TEntity(ForestModel.ActualSkupina.FindElementName('CPP'));
   if EN = nil then
   begin
      ErrorText := aEl + ' Error: '+ PRLString;
      exit;
   end;
   for i := 0 to En.LastIndex do
   begin
      E := EN.Elements[i];
      _CPP.ClearAttributes;
      for j := 0 to _CPP.Attributes.LastIndex do
      begin
         AT := _CPP.Attributes.Attribute[j];
         AT.Value := E.GetPropertyStringByName(AT.Name);
      end;
      SaveDTDElementSTART(_CPP);
      SaveDTDElementEND(_CPP);
   end;
end;

procedure TExportLHCtoXML.SaveDIL;
var
   _DIL: TDTDModelElement;
   i: integer;
   GDIL: Tgis_Dilec;
begin
   _DIL := DTD.FindDTDElement('DIL');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Oddeleni.DilecMN.LastIndex do
      begin
         _Dilec := TDilec(_Oddeleni.DilecMN.Elements[i]);
         _DIL.ClearAttributes;
         FillElementAttributes(_DIL,_Dilec);
         SaveDTDElementSTART(_DIL);
         DILString := _Dilec.DIL;
         PRLString := ODDString + DILString;
         if LED then
         begin
            ForestModel.Dilec_Name := _Dilec.DIL;
            if ForestModel.ActualOddeleni <> nil then
            if Forestmodel.ActualDilec = nil then
            begin
               ErrorText := 'G DIL Error: '+ PRLString;
               exit;
            end;
            if LCR then
               if _DIL.DTDElementExists('DIL_OBRAZ') then SaveDIL_OBRAZ;
         end;
         SavePOR;
         SaveDTDElementEND(_DIL);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualOddeleni.NoItems then
      for i := 0 to ForestModel.ActualOddeleni.Items.LastIndex do
      begin
         GDIL := TGis_Dilec(ForestModel.ActualOddeleni.Items.Elements[i]);
         DILString := GDIL.Name;
         PRLString := PRLString + DILString;
         ForestModel.ActualDilec := GDIL;
         _DIL.ClearAttributes;
         FillGElementAttributes(_DIL,GDIL);
         SaveDTDElementSTART(_DIL);
         if LCR then
            if _DIL.DTDElementExists('DIL_OBRAZ') then SaveDIL_OBRAZ;
         if _DIL.DTDElementExists('POR') then SavePOR;
         SaveDTDElementEND(_DIL);
      end;
   end;
end;

procedure TExportLHCtoXML.SaveDIL_OBRAZ;
var
   D: TDTDModelElement;
   aMP: boolean;
begin
   if not LED then exit;
   D := DTD.FindDTDElement('DIL_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   if ForestModel.ActualDilec.NoGeometry then
   begin
      ErrorText := 'DIL: '+ PRLString+' No geometry';
   end
   else
   begin
      SaveDTDElementSTART(D);
      aMP := D.FindDTDElement('MP') <> nil;
      SaveMP(ForestModel.ActualDIlec.Geometry,aMP);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SaveDRV;
var
   _DRV: TDTDModelElement;
   i: integer;
begin
   _DRV := DTD.FindDTDElement('DRV');
   {$IFDEF TAX}
   for i := 0 to _Etaz.DrevinaMN.LastIndex do
   begin
      _Drevina := _Etaz.IDrevina[i];
      FillElementAttributes(_DRV,_Drevina);
      SaveDTDElementSTART(_DRV);
      SavePOS;
      SaveDTDElementEND(_DRV);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveDTDElementSTART(const Value: TDTDModelElement);
var
   aSCHU: Txs_Attribute;
   SCHUKick: boolean;
begin
   aSCHU := Value.Attributes.GetAttributeByName('SCHU_KOD');
   SCHUKick := false;
   if (aSCHU <> nil) and (aSCHU.Value = '') then
   begin
      Value.Attributes.RemoveElement(aSCHU);
      SCHUKick := true;
   end;
   CHeckDTDElement(Value);
   inherited;
   if SCHUKick then
      Value.Attributes.AddElement(aSCHU);
end;

procedure TExportLHCtoXML.SaveETAZ_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SaveETZ;
var
   _ETZ: TDTDModelElement;
   i: integer;
begin
   _ETZ := DTD.FindDTDElement('ETZ');
   {$IFDEF TAX}
   for i := 0 to _PorostniSkupina.EtazMN.LastIndex do
   begin
      _Etaz := _PorostniSkupina.iEtaz[i];
      FillElementAttributes(_ETZ,_Etaz);
      SaveDTDElementSTART(_ETZ);
      SaveZAL;
      SaveDRV;
      SaveDTDElementEND(_ETZ);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveHeader;
var
   S_L: string;
   SS: string;
begin
   inherited;
{$IFDEF UHUL}
   ShowMessage('Doufm, e si jste vdomi, e tahle verze LEDu rozhodn nen urena pro njak exporty do standardu a trochu to zavn ernotou! Asi Vm zkysne mlko ....');
   SS := '<!-- LED pro UHUL xml ver.';
{$ELSE}
   SS := '<!-- LED xml ver.';
{$ENDIF}
   if xmlVersion = '' then
      xmlVersion := 'x';
   if not XSD then
      DTD.DTDFileName := ChangeFileExt(FileName,'.dtd');
   if LCR then
   begin
      writeLnToXML('<?ISLH '+ISLH_version+' LHP $ ?>');
      if not XSD then
         writeLnToXML('<!DOCTYPE LCR SYSTEM "'+ExtractFileName(DTD.DTDFileName)+'">')
      else
         writeLnToXML('<!DOCTYPE LCR>');
      writeLnToXML(SS+xmlVersion+' -->');
   end
   else
   begin
      S_L := 'LHP';
      if LHO then
         S_L := 'LHO';
      writeLnToXML('<?ISLH '+ISLH_version+' '+S_L+' $ ?>');
      if not XSD then
         writeLnToXML('<!DOCTYPE DATAISLH SYSTEM "'+ExtractFileName(DTD.DTDFileName)+'">');
      writeLnToXML(SS+xmlVersion+' -->');
   end;
end;

procedure TExportLHCtoXML.SaveHOP;
begin

end;

procedure TExportLHCtoXML.SaveHS;
var
   _HS: TDTDModelElement;
   i: integer;
begin
   _HS := DTD.FindDTDElement('HS');
   {$IFDEF TAX}
   for i := 0 to LesniCelek.CiselOrbis.cisHsMN.LastIndex do
   begin
      FillElementAttributes(_HS,LesniCelek.CiselOrbis.cisHsMN.Elements[i]);
      SaveDTDElementSTART(_HS);
      SaveDTDElementEND(_HS);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveJP;
var
   _JP: TDTDModelElement;
   i: integer;
   GJP: Tgis_PorostniSkupina;
begin
   _JP := DTD.FindDTDElement('JP');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Porost.JinyPozemekMN.LastIndex do
      begin
         _JinyPozemek := _Porost.IJinyPozemek[i];
         PSKString :=' ' + IntToStr(_JinyPozemek.JP);
         PRLString := ODDString + DILString + PORString + PSKString;
         FillElementAttributes(_JP,_JinyPozemek);
         SaveDTDElementSTART(_JP);
         if LED then
         begin
            ForestModel.Skupina_Name := IntToStr(_JinyPozemek.JP);
            if ForestModel.ActualPorost <> nil then
            if ForestModel.ActualSkupina = nil then
            begin
               ErrorText := 'G JP Error: ' + PRLString;
            end
            else
            begin
               SaveJP_OBRAZ;
               if PARC then SaveCPP('CPJ');
            end;
         end;
         SaveDTDElementEND(_JP);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualPorost.NoItems then
      for i := 0 to ForestModel.ActualPorost.Items.LastIndex do
      begin
         GJP := Tgis_PorostniSkupina(ForestModel.ActualPorost.Items.Elements[i]);
         PSKString :=' ' + GJP.Name;
         PRLString := ODDString + DILString + PORString + PSKString;
         if not CheckPSKValue(GJP.Name, JPValue, OPValue) then continue;
         ForestModel.ActualSkupina := GJP;
         FillGElementAttributes(_JP,GJP);
         SaveDTDElementSTART(_JP);
         SaveJP_OBRAZ;
         SaveDTDElementEND(_JP);
      end;
   end;
end;

procedure TExportLHCtoXML.SaveJP_OBRAZ;
begin
   Save_OBRAZ('JP_OBRAZ');
end;

procedure TExportLHCtoXML.SaveKAT;
var
   _KAT: TDTDModelElement;
   i: integer;
begin
   _KAT := DTD.FindDTDElement('KAT');
   {$IFDEF TAX}
   for i := 0 to _Porost.Kategorie1Mn.LastIndex do
   begin
      _Kategorie := TKategorie1(_Porost.Kategorie1Mn.Elements[i]);
      _KAT.ClearAttributes;
      FillElementAttributes(_KAT,_Kategorie);
      SaveDTDElementSTART(_KAT);
      SaveDTDElementEND(_KAT);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveKBO;
var
   S: string;
   SLE: TStringListElement;
   En: TEntity;
   i: integer;
begin
   if Layers = nil then exit;
   PRLString := '';
   S := 'KBO';
   SLE := TStringListElement.Create;
   SLE.Name := S;
   AddElement(SLE);
   SLE.NamesString := KBONames;
   Progress := 0;
   MaxProgress := SLE.LastIndex;
   for i := 0 to SLE.LastIndex do
   begin
      Progress := i;
      Application.ProcessMessages;
      En := TEntity(Layers.FindElementName(SLE.Names[i]));
      _LastEntity := En;
      if En = nil then
      begin
         ErrorText := 'KBO ' + SLE.Names[i] + ' not exists';
         continue;
      end;
      SavePointEntity(En,0,S);
   end;
   SLE.Free;
end;

procedure TExportLHCtoXML.SaveKLO;
var
   S: string;
   SLE: TStringListElement;
   En: TEntity;
   i: integer;
begin
   if Layers = nil then exit;
   PRLString := '';
   S := 'KLO';
   SLE := TStringListElement.Create;
   SLE.Name := S;
   AddElement(SLE);
   SLE.NamesString := KLONames;
   Progress := 0;
   MaxProgress := SLE.LastIndex;
   for i := 0 to SLE.LastIndex do
   begin
      Progress := i;
      Application.ProcessMessages;
      En := TEntity(Layers.FindElementName(SLE.Names[i]));
      _LastEntity := En;
      if En = nil then
      begin
         ErrorText := 'KLO '+ SLE.Names[i] + ' not exists';
         continue;
      end;
      SaveLineEntity(En,0,S);
   end;
   SLE.Free;
end;

procedure TExportLHCtoXML.SaveKOM;
var
   i: integer;
   e: TElement;
   GE: TTopolLineElement;
begin
   // CES
   WorkEntity := nil;
   ProgressText := 'Import KOM ...';
   Application.ProcessMessages;
   RunScript(ImportKOMScript);
   if WorkEntity = nil then exit;
   SaveLineEntity(WorkEntity, 2100, 'CES');
   // PRU
   WorkEntity := nil;
   ProgressText := 'Import PRU ...';
   Application.ProcessMessages;
   RunScript(ImportPRUScript);
   if WorkEntity = nil then exit;
   SaveLineEntity(WorkEntity, 2200, 'PRU');
end;

procedure TExportLHCtoXML.SaveKPO;
var
   S: string;
   SLE: TStringListElement;
   En: TEntity;
   i: integer;
begin
   if Layers = nil then exit;
   PRLString := '';
   S := 'KPO';
   SLE := TStringListElement.Create;
   SLE.Name := S;
   AddElement(SLE);
   SLE.NamesString := KPONames;
   Progress := 0;
   MaxProgress := SLE.LastIndex;
   for i := 0 to SLE.LastIndex do
   begin
      Progress := i;
      Application.ProcessMessages;
      En := TEntity(Layers.FindElementName(SLE.Names[i]));
      _LastEntity := En;
      if En = nil then
      begin
         ErrorText := 'KPO ' + SLE.Names[i] + ' not exists';
         continue;
      end;
      SaveAreaEntity(En,0,S);
   end;
   SLE.Free;
end;

procedure TExportLHCtoXML.SaveKTO;
var
   S: string;
   SLE: TStringListElement;
   En: TEntity;
   i: integer;
begin
   if Layers = nil then exit;
   PRLString := '';
   S := 'KTO';
   SLE := TStringListElement.Create;
   SLE.Name := S;
   AddElement(SLE);
   SLE.NamesString := KTONames;
   Progress := 0;
   MaxProgress := SLE.LastIndex;
   for i := 0 to SLE.LastIndex do
   begin
      Progress := i;
      Application.ProcessMessages;
      En := TEntity(Layers.FindElementName(SLE.Names[i]));
      _LastEntity := En;
      if En = nil then
      begin
         ErrorText := 'KTO ' + SLE.Names[i] + ' not exists';
         continue;
      end;
      SaveTextEntity(En,0,S);
   end;
   SLE.Free;
end;

procedure TExportLHCtoXML.SaveLCR;
var
   D,D1: TDTDModelElement;
begin
   D := DTD.FindDTDElement('LCR');
   if D = nil then exit;
   SaveDTDElementSTART(D);
   SaveLS;
   SaveREV;
   Save_KAT;
   SavePAR;
   SaveSKP;
   SaveZRO;
   SaveLVS;
   SavePLT;
   SaveHOP;
   SaveDTDElementEND(D);
end;

procedure TExportLHCtoXML.SaveLCR_Pre;
begin

end;

procedure TExportLHCtoXML.SaveLHC;
var
   _LHC: TDTDModelElement;
begin
   _LHC := DTD.FindDTDElement('LHC');
   if _LHC = nil then  exit; // ale, ale
   _LHC.ClearAttributes;
   {$IFDEF TAX}
   Odkornovat := true;
   snizovatEtatInduktTezbou := true;
   {$ENDIF}
   if LCR and (LCR_ETAPA > 1) then
   begin
      RunScript(ImportLHCScript);   // nacteni lhc asi ze ZRO nebo tak nejak
      {$IFDEF TAX}
      if TAX then
         LesniCelek.LHC.ExportProLCR := true;
      {$ENDIF}
   end;
   // naplnn vlastnost
   {$IFDEF TAX}
   if TAX then
   begin
      { vyhozeno 02 2012 na natlak zbyska :-)
      if LCR then
         LesniCelek.LHC.ZpusobVyplneniPovinnehoMZD := dleSesulky2011
      else
         LesniCelek.LHC.ZpusobVyplneniPovinnehoMZD := dleZezuly;
      }
      FillElementAttributes(_LHC,LesniCelek.LHC);
      FillLHCtoSelf;
   end
   else
   {$ENDIF}
   begin
      if LCR and (LCR_ETAPA < 3) then
         FillElementAttributes(_LHC,Self)
      else
         FillGElementAttributes(_LHC,FOrestModel.ActualLHC);
   end;
   //  ...
   SaveDTDElementSTART(_LHC);
   if LCR then
      if _LHC.DTDElementExists('LHC_OBRAZ') then SaveLHC_OBRAZ;
   if _LHC.DTDElementExists('ODD') then SaveODD;
   PRLString := '';
   if LCR and (LCR_ETAPA > 3) then
   begin
      SaveKOM;
      SaveVOD;
   end;
   if _LHC.DTDElementExists('LCR') then SaveLCR;
   if _LHC.DTDElementExists('KBO') then SaveKBO;
   if _LHC.DTDElementExists('KLO') then SaveKLO;
   if _LHC.DTDElementExists('KPO') then SaveKPO;
   if _LHC.DTDElementExists('KTO') then SaveKTO;
   if _LHC.DTDElementExists('HS')  then SaveHS;
   if _LHC.DTDElementExists('OU1') then SaveOU1;
   if _LHC.DTDElementExists('OU2') then SaveOU2;
   if _LHC.DTDElementExists('SCHU') then SaveSCHU;
   if _LHC.DTDElementExists('MZD') then SaveMZD;
   SaveDTDElementEND(_LHC);
   {$IFDEF TAX}
   Odkornovat := false;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveLHC_OBRAZ;
var
   D: TDTDModelElement;
   aMP: boolean;
begin
   if not LED then exit;
   D := DTD.FindDTDElement('LHC_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   if ForestModel.ActualLHC.NoGeometry then
   begin
      ErrorText := 'No LHC geometry';
   end
   else
   begin
      SaveDTDElementSTART(D);
      aMP := D.FindDTDElement('MP') <> nil;
      SaveMP(ForestModel.ActualLHC.Geometry,aMP);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SaveLineEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   L: TPolyLineElement;
   S : string;
   ILE: TIntegerListElement;
   //SL: TStringList;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then
     DObr :=  D.FindDTDElement('LIN_OBRAZ');
   if DObr = nil then exit;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   ILE := TIntegerListElement.Create;
   ILE.ValuesString := KLO_ChangeGroup;
   if anEntity.NoElements then
      ErrorText := 'L Layer ' + anEntity.Name + ' is Empty' ;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if (aGroup > 0) and (GE.Group <> aGroup) then continue;
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TPolyLineElement) then continue;
      L := TPolyLineElement(G);
      FillGElementAttributes(D,GE);
      if DTDName = 'KLO' then
      begin
         if ILE.ValueExists(GE.Group) then
         if not D.NoAttributes then
         begin
            D.Attributes.SetAttributeByName('LIN_DRUH',KLO_Defaultdruh );
            D.Attributes.SetAttributeByName('LIN_BARVA',KLO_DefaultBarva );
            D.Attributes.SetAttributeByName('LIN_ZNACKA',KLO_DefaultZnacka );
         end;
      end;
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      WriteLine(L);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
   ILE.Free;
end;

procedure TExportLHCtoXML.SaveLIN_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SaveLS;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import LS ...';
   Application.ProcessMessages;
   RunScript(ImportLSScript);
   if WorkEntity = nil then exit;
   if LCR_ETAPA > 3 then
   begin
      S := 'B_LS';
      e := WorkEntity.FindElementName(S);
      if (e <> nil) and (e is TEntity) then
      begin
         // LS bod
         En := TEntity(e);
         SavePointEntity(En, 7500, S);
      end;
   end;
   S := 'P_LS';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // LS plocha
      En := TEntity(e);
      SaveAreaEntity(En, 7500, S);
   end;
end;

procedure TExportLHCtoXML.SaveLVS;
begin
   if LCR_ETAPA < 5 then exit;
   WorkEntity := nil;
   ProgressText := 'Import LVS ...';
   Application.ProcessMessages;
   RunScript(ImportLVSScript);
   if WorkEntity = nil then exit;
   SaveAreaEntity(WorkEntity, 0, 'LVS');
end;

procedure TExportLHCtoXML.SaveMP(const Value: TGeometry; MP: boolean);
var
   D: TDTDModelElement;
   A: TAreaElement;
   MA: TMultiAreaELement;
   i: integer;
begin
   if MP then
   begin
      D := DTD.FindDTDElement('MP');
      if D = nil then
      begin
         Error := 1;
         exit;
      end;
      SaveDTDElementSTART(D);
   end;
   if not (Value is TAreaElement) then
      Error := 1
   else
   begin
      A := TAreaElement(Value);
      if A is TMultiAreaElement then
      begin
         MA := TMultiAreaElement(A);
         for i := 0 to MA.LastIndex do
         begin
            A := MA.AreaElement[i];
            WriteArea(A);
         end;
      end
      else
         WriteArea(A);
   end;
   if MP then
      SaveDTDElementEND(D);
end;

procedure TExportLHCtoXML.SaveMZD;
var
   _MZD: TDTDModelElement;
   i: integer;
begin
   _MZD := DTD.FindDTDElement('MZD');
   {$IFDEF TAX}
   if vytvaretMZDHospSOUB then
      LesniCelek.LHC.ciselOrbis.RozvinMZDHospSoub1;
   for i := 0 to LesniCelek.CiselOrbis.MZDHospSoubMN.LastIndex do
   begin
      FillElementAttributes(_MZD,LesniCelek.CiselOrbis.MZDHospSoubMN.Elements[i]);
      SaveDTDElementSTART(_MZD);
      SaveDTDElementEND(_MZD);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveODD;
var
   _ODD: TDTDModelElement;
   ODD: integer;
   j: integer;
   ODDS: TEntity;
   GODD: Tgis_Oddeleni;
begin
   _ODD := DTD.FindDTDElement('ODD');
   {$IFDEF TAX}
   if TAX then
   begin
      for j := 0 to LesniCelek.SeznamOddeleni.Count - 1 do
      begin
         progress := j;
         ODD := LesniCelek.LHC.Oddeleni.ODD;
         ODDString := IntToStr(LesniCelek.LHC.Oddeleni.ODD);
         PRLString := ODDString;
         if LED then
         begin
            ForestModel.ActualLS := nil;
            ForestModel.Oddeleni_Cislo := ODD;
            ProgressText := 'ODD: '+PRLString;
            Application.ProcessMessages;
            if ForestModel.ActualOddeleni = nil then
            begin
               ErrorText := 'G ODD Error: '+ PRLString;
               exit;
            end;
         end;
         // kontrola existence.....
         _Oddeleni := LesniCelek.LHC.Oddeleni;
         _Oddeleni.SmazZruseneStatutyOchPrir;
         _Oddeleni.Dopln10kdeNeniKategorie;
         _Oddeleni.smazprazdneZalesneni;
         if vytvaretMZDHospSOUB then
            _Oddeleni.VyberMzdHsLTADoplndoMZDHospSoubMN;
         _ODD.ClearAttributes;
         FillElementAttributes(_ODD,_Oddeleni);
         SaveDTDElementSTART(_ODD);
         if LCR then
            if _ODD.DTDElementExists('ODD_OBRAZ') then SaveODD_OBRAZ;
         SaveDIL;
         SaveDTDElementEND(_ODD);
         //if LesniCelek.PosledniOddeleni then break;
         LesniCelek.nactiOddeleni(true);
         //inc(j);
      end;
   end
   else
   {$ENDIF}
   begin
      ODDS := ForestModel.FindOdds;
      AddElement(ODDS);
      for j := 0 to ODDS.LastIndex do
      begin
         progress := j;
         GODD := Tgis_Oddeleni(ODDS.Elements[j]);
         ODDString := IntToStr(GODD.ODD);
         PRLString := ODDString;
         ProgressText := 'ODD: '+PRLString;
         Application.ProcessMessages;
         ForestModel.ActualLS := GODD._LS;
         ForestModel.ActualOddeleni := GODD;
         _ODD.ClearAttributes;
         FillGElementAttributes(_ODD,GODD);
         SaveDTDElementSTART(_ODD);
         SaveDIL;
         SaveDTDElementEND(_ODD);
      end;
      ODDS.Free;
   end;
end;

procedure TExportLHCtoXML.SaveODD_OBRAZ;
var
   D: TDTDModelElement;
   aMP: boolean;
begin
   if not LED then exit;
   D := DTD.FindDTDElement('ODD_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   if ForestModel.ActualOddeleni = nil then exit;
   if ForestModel.ActualOddeleni.NoGeometry then
   begin
      ErrorText := 'ODD '+PRLString+' No geometry';
   end
   else
   begin
      SaveDTDElementSTART(D);
      aMP := D.FindDTDElement('MP') <> nil;
      SaveMP(ForestModel.ActualOddeleni.Geometry,aMP);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SaveOP;
var
   _OP: TDTDModelElement;
   i: integer;
   GOP: Tgis_PorostniSkupina;
begin
   _OP := DTD.FindDTDElement('OP');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Porost.OstatniMN.LastIndex do
      begin
         _Ostatni := _Porost.IOstatni[i];
         PSKString :=' ' + IntToStr(_Ostatni.OP);
         PRLString := ODDString + DILString + PORString + PSKString;
         FillElementAttributes(_OP,_Ostatni);
         SaveDTDElementSTART(_OP);
         if LED then
         begin
            ForestModel.Skupina_Name := IntToStr(_Ostatni.OP);
            if ForestModel.ActualPorost <> nil then
            if ForestModel.ActualSkupina = nil then
               ErrorText := 'G OP Error: ' + PRLString
            else
               SaveOP_OBRAZ;
         end;
         //SaveETZ;
         SaveDTDElementEND(_OP);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualPorost.NoItems then
      for i := 0 to ForestModel.ActualPorost.Items.LastIndex do
      begin
         GOP := Tgis_PorostniSkupina(ForestModel.ActualPorost.Items.Elements[i]);
         PSKString :=GOP.Name;
         PRLString := ODDString + DILString + PORString + PSKString;
         if not CheckPSKValue(GOP.Name, OPValue, 100000) then continue;
         ForestModel.ActualSkupina := GOP;
         FillGElementAttributes(_OP,GOP);
         SaveDTDElementSTART(_OP);
         SaveOP_OBRAZ;
         SaveDTDElementEND(_OP);
      end;
   end;
end;

procedure TExportLHCtoXML.SaveOP_OBRAZ;
begin
   Save_OBRAZ('OP_OBRAZ');
end;

procedure TExportLHCtoXML.SaveOU1;
var
   _OU1: TDTDModelElement;
   i: integer;
begin
   _OU1 := DTD.FindDTDElement('OU1');
   {$IFDEF TAX}
   for i := 0 to LesniCelek.CiselOrbis.OrgUr1MN.LastIndex do
   begin
      FillElementAttributes(_OU1,LesniCelek.CiselOrbis.OrgUr1MN.Elements[i]);
      SaveDTDElementSTART(_OU1);
      SaveDTDElementEND(_OU1);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveOU2;
var
   _OU2: TDTDModelElement;
   i: integer;
begin
   _OU2 := DTD.FindDTDElement('OU2');
   {$IFDEF TAX}
   for i := 0 to LesniCelek.CiselOrbis.OrgUr2MN.LastIndex do
   begin
      FillElementAttributes(_OU2,LesniCelek.CiselOrbis.OrgUr2MN.Elements[i]);
      SaveDTDElementSTART(_OU2);
      SaveDTDElementEND(_OU2);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SavePAR;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import PAR ...';
   Application.ProcessMessages;
   RunScript(ImportPARScript);
   if WorkEntity = nil then exit;
   S := 'L_PAR';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveLineEntity(En, 8210, S);
   end;
   S := 'P_PAR';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveAreaEntity(En, 8210, S);
   end;
end;

procedure TExportLHCtoXML.SavePLO_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SavePLT;
begin
   if LCR_ETAPA < 5 then exit;
   WorkEntity := nil;
   ProgressText := 'Import PLT ...';
   Application.ProcessMessages;
   RunScript(ImportPLTScript);
   if WorkEntity = nil then exit;
   SaveAreaEntity(WorkEntity, 0, 'PLT');
end;

procedure TExportLHCtoXML.SavePointEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   P: TPointElement;
   S : string;
   aMB: boolean;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then
      DObr :=  D.FindDTDElement('BOD_OBRAZ');
   if DObr = nil then exit;
   aMB := DObr.FindDTDElement('MB') <> nil;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   if anEntity.NoElements then
      ErrorText := 'P Layer ' + anEntity.Name + ' is Empty' ;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TPointElement) then continue;
      P := TPointElement(G);
      FillGElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      WritePoint(P.X, P.Y,aMB);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SavePOR;
var
   _POR: TDTDModelElement;
   i: integer;
   GPOR: Tgis_Porost;
begin
   _POR := DTD.FindDTDElement('POR');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Dilec.PorostMN.LastIndex do
      begin
         _Porost := TPorost(_Dilec.PorostMN.Elements[i]);
         PORString := _Porost.POR;
         PRLString := ODDString + DILString + PORString;
         _POR.ClearAttributes;
         FillElementAttributes(_POR,_Porost);
         SaveDTDElementSTART(_POR);
         if LED then
         begin
            ForestModel.Porost_Name := _Porost.POR;
            if ForestModel.ActualDilec <> nil then
            if ForestModel.ActualPorost = nil then
            begin
               ErrorText := 'G POR Error: ' + PRLString;
               exit;
            end;
            if LCR then
               if _POR.DTDElementExists('POR_OBRAZ') then SavePOR_OBRAZ;
         end;
         SaveKAT;
         SavePSK;
         SaveBZL;
         SaveJP;
         SaveOP;
         SaveDTDElementEND(_POR);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualDilec.NoItems then
      for i := 0 to ForestModel.ActualDilec.Items.LastIndex do
      begin
         GPOR := Tgis_Porost(ForestModel.ActualDilec.Items.Elements[i]);
         PORString := GPOR.Name;
         PRLString := ODDString + DILString + PORString;
         ForestModel.ActualPorost := GPOR;
         _POR.ClearAttributes;
         FillGElementAttributes(_POR,GPOR);
         SaveDTDElementSTART(_POR);
         SavePSK;
         SaveBZL;
         SaveJP;
         SaveOP;
         SaveDTDElementEND(_POR);
      end;
   end;
end;

procedure TExportLHCtoXML.SavePOR_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SavePOS;
var
   _POS: TDTDModelElement;
   i: integer;
begin
   _POS := DTD.FindDTDElement('POS');
   {$IFDEF TAX}
   for i := 0 to _Drevina.PoskozeniMn.LastIndex do
   begin
      _Poskozeni := _Drevina.IPoskozeni[i];
      FillElementAttributes(_POS,_Poskozeni);
      SaveDTDElementSTART(_POS);
      SaveDTDElementEND(_POS);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SavePSK;
var
   _PSK: TDTDModelElement;
   i: integer;
   GPSK: Tgis_PorostniSkupina;
   Zn: string;
begin
   _PSK := DTD.FindDTDElement('PSK');
   {$IFDEF TAX}
   if TAX then
   begin
      for i := 0 to _Porost.PorostniSkupinaMN.LastIndex do
      begin
         _PorostniSKupina := _Porost.IPorostniSkupina[i];
         PSKString := ' ' + _PorostniSkupina.PSK;
         PRLString := ODDString + DILString + PORString + PSKString;
         if LED then
         begin
            ForestModel.Skupina_Name := RemoveAllSpaces(_PorostniSkupina.PSK);
            if ForestModel.ActualPorost <> nil then
            if ForestModel.ActualSkupina = nil then
            begin
               ErrorText := 'G PSK Error: '+ PRLString;
            end;
         end;
         FillElementAttributes(_PSK,_PorostniSkupina);
         if _PSK.Attributes.GetAttributeByName('PSK_ZNACKA') <> nil then
         if not LCR then
         begin
            _PSK.Attributes.SetAttributeByName('PSK_ZNACKA',IntToStr(Calculate_PSK_Znacka(_PorostniSkupina)));
         end
         else
         begin
         if ForestModel.ActualSkupina <> nil then
         begin
            if ForestModel.ActualSkupina.Znacka < 1000 then
            begin
               case ForestModel.ActualSkupina.Barva of
                  14: Zn := '10101';
                  11: Zn := '10102';
                   9: Zn := '10103';
                  10: Zn := '10104';
                   6: Zn := '10105';
                   7: Zn := '10106';
                   5: Zn := '10107';
                   2: Zn := '10108';
                else
                   Zn := '10100';
               end;
            end
            else
               Zn := IntToStr(ForestModel.ActualSkupina.Znacka);
               _PSK.Attributes.SetAttributeByName('PSK_ZNACKA',Zn);
         end
         else
               _PSK.Attributes.SetAttributeByName('PSK_ZNACKA','10100');
         end;
         SaveDTDElementSTART(_PSK);
         SavePSK_OBRAZ;
         SaveETZ;
         if PARC then SaveCPP('CPP');
         SaveDTDElementEND(_PSK);
      end;
   end
   else
   {$ENDIF}
   begin
      if not ForestModel.ActualPorost.NoItems then
      for i := 0 to ForestModel.ActualPorost.Items.LastIndex do
      begin
         GPSK := Tgis_PorostniSkupina(ForestModel.ActualPorost.Items.Elements[i]);
         if not CheckPSKValue(GPSK.Name, 0, BZLValue) then continue;
         ForestModel.ActualSkupina := GPSK;
         FillGElementAttributes(_PSK,GPSK);
         SaveDTDElementSTART(_PSK);
         SavePSK_OBRAZ;
         SaveDTDElementEND(_PSK);
      end;
   end;
end;

procedure TExportLHCtoXML.SavePSK_OBRAZ;
begin
   Save_OBRAZ('PSK_OBRAZ');
end;

procedure TExportLHCtoXML.SaveREV;
begin
   if LCR_ETAPA < 4 then exit;
   WorkEntity := nil;
   ProgressText := 'Import REV ...';
   Application.ProcessMessages;
   RunScript(ImportREVScript);
   if WorkEntity = nil then exit;
   SaveAreaEntity(WorkEntity, 7600, 'REV');
end;

procedure TExportLHCtoXML.SaveRootElement;
begin
   if DTD = nil then exit;
   {$IFDEF TAX}
   if LesniCelek = nil then
      TAX := false;
   {$ENDIF}
   LED := ForestModel <> nil;
   if not (LED or TAX) then
   begin
      ErrorText := 'No TAX or LED source';
      exit;
   end;
   if LED then
      ForestModel.ActualLHC := Tgis_LHC(ForestModel.FindElementClass(Tgis_LHC))
   else
      ErrorText := '- LED';

   if not TAX then
   begin
      ErrorText := '- TAX';
      if BZLValue = 0 then BZLValue := 100;
      if JPValue  = 0 then JPValue  := 500;
      if OPValue  = 0 then OPValue  := 900;
      if (BZLValue > JPValue) or (JPValue > OPValue) then
      begin
         ShowMessage('chybn definovan mez BZL '+IntTostr(BZLValue)+' JP '+IntToStr(JPValue)+' OP '+IntToStr(OPValue));
         exit;
      end;
   end;
   // kontrola ROOT elementu
   DTD.ActualElement := DTD.RootElement;
   if DTD.ActualElement = nil then exit; // nen ROOT
   if not (DTD.ActualElement.Name = 'DATAISLH') then
   begin
      ErrorText := ' X Root Element is not DATAISLH!';
      exit; // chybny root
   end;
   {$IFDEF TAX}
   if TAX then
      StartProgress('Export LHC do XML',0,LesniCelek.SeznamOddeleni.Count - 1)
   else
   {$ENDIF}
      StartProgress('Export LHC do XML bez TAXu',0,ForestModel.GetOddCount - 1);
   if not LCR then
   if XSD then
   begin
      //DTD.RootElement.Attributes.AddAttribute('xmlns','http://www.tpro.cz');
      //DTD.RootElement.Attributes.AddAttribute('xmlns:xsi','http://www.w3.org/2001/XMLSchema-instance');
      //DTD.RootElement.Attributes.AddAttribute('xsi:schemaLocation','http://www.tpro.cz/ishul2013.xsd');
   end;
   SaveDTDElementSTART(DTD.RootElement);
   SaveLHC;
   SaveDTDElementEND(DTD.RootElement);
   EndProgress;
end;

procedure TExportLHCtoXML.SaveSCHU;
var
   _SCHU: TDTDModelElement;
   i: integer;
   at: Txs_Attribute;
begin
   _SCHU := DTD.FindDTDElement('SCHU');
   {$IFDEF TAX}
   for i := 0 to LesniCelek.CiselOrbis.CisSCHUMN.LastIndex do
   begin
      FillElementAttributes(_SCHU,LesniCelek.CiselOrbis.CisSCHUMN.Elements[i]);
      at := _SCHU.Attributes.GetAttributeByName('SCHU_KOD');
      if at.Value.ToInteger  > 0 then
      begin
         SaveDTDElementSTART(_SCHU);
         SaveDTDElementEND(_SCHU);
      end;
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveSKP;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   if LCR_ETAPA < 2 then exit;
   WorkEntity := nil;
   ProgressText := 'Import SKP ...';
   Application.ProcessMessages;
   RunScript(ImportSKPScript);
   if WorkEntity = nil then exit;
   S := 'L_SKP';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveLineEntity(En, 8320, S);
   end;
   S := 'P_SKP';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveAreaEntity(En, 8320, S);
   end;
end;

procedure TExportLHCtoXML.SaveTextEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   T: TTextElement;
   S : string;
   aMB: boolean;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement('TXT_OBRAZ');
   if DObr = nil then exit;
   aMB := DObr.FindDTDElement('MB') <> nil;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   if anEntity.NoElements then
      ErrorText := 'T Layer ' + anEntity.Name + ' is Empty' ;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TTextElement) then continue;
      T := TTextElement(G);
      FillGElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      WritePoint(T.X,T.Y, aMB);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TExportLHCtoXML.SaveTXT_OBRAZ;
begin

end;

procedure TExportLHCtoXML.SaveVOD;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import VOD ...';
   Application.ProcessMessages;
   RunScript(ImportVODScript);
   if WorkEntity = nil then exit;
   S := 'PTK';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveLineEntity(En, 3100, S);
   end;
   S := 'RN';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveAreaEntity(En, 3200, S);
   end;
end;

procedure TExportLHCtoXML.SaveVRS;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import VRS ...';
   Application.ProcessMessages;
   RunScript(ImportVRSScript);
   if WorkEntity = nil then exit;
   S := 'VRS';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveLineEntity(En, 5100, S);
   end;
   S := 'KOT';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SavePointEntity(En, 5100, S);
   end;
end;

procedure TExportLHCtoXML.SaveZAL;
var
   _ZAL: TDTDModelElement;
   i: integer;
begin
   _ZAL := DTD.FindDTDElement('ZAL');
   {$IFDEF TAX}
   for i := 0 to _Etaz.ZalesneniMN.LastIndex do
   begin
      _Zalesneni := _Etaz.IZalesneni[i];
      FillElementAttributes(_ZAL,_Zalesneni);
      SaveDTDElementSTART(_ZAL);
      SaveDTDElementEND(_ZAL);
   end;
   {$ENDIF}
end;

procedure TExportLHCtoXML.SaveZRO;
begin
   if LCR_ETAPA < 2 then exit;
   WorkEntity := nil;
   ProgressText := 'Import ZRO ...';
   Application.ProcessMessages;
   RunScript(ImportZROScript);
   if WorkEntity = nil then exit;
   SaveLineEntity(WorkEntity, 0, 'ZRO');
end;

procedure TExportLHCtoXML.Save_KAT;
begin

end;

procedure TExportLHCtoXML.Save_OBRAZ(aEl: string);
var
   D: TDTDModelElement;
   aMP: boolean;
begin
   if not LED then exit;
   D := DTD.FindDTDElement(aEl);
   if D = nil then
   begin
      exit;
   end;
   aMP:= D.FindDTDElement('MP') <> nil;
   SaveDTDElementSTART(D);
   // kontrola ...
   if (ForestModel.ActualSkupina = nil) or  ForestModel.ActualSkupina.NoGeometry then
   begin
      ErrorText := ' PSK: ' + PRLString + ' No geometry';
      WriteToXML('GERROR');
   end
   else
      SaveMP(ForestModel.ActualSkupina.Geometry,aMP);
   SaveDTDElementEND(D);
end;


procedure TExportLHCtoXML.SetBZLValue(const Value: integer);
begin
  FBZLValue := Value;
end;

procedure TExportLHCtoXML.SetDILString(const Value: string);
begin
  FDILString := Value;
end;

procedure TExportLHCtoXML.SetErrorText(const Value: string);
begin
   FErrorText := ' ! '+Value+' !';
   if ProtocolScript <> '' then
   begin
      PostTextMsg(tm_run,ProtocolScript,nil);
      Application.ProcessMessages;
   end;
end;

procedure TExportLHCtoXML.SetForestModel(const Value: Tgis_ForestModel);
begin
  FForestModel := Value;
end;

procedure TExportLHCtoXML.SetGISDir(const Value: string);
begin
  FGISDir := Value;
end;

procedure TExportLHCtoXML.SetImportHOPScript(const Value: string);
begin
  FImportHOPScript := Value;
end;

procedure TExportLHCtoXML.SetImportKATScript(const Value: string);
begin
  FImportKATScript := Value;
end;

procedure TExportLHCtoXML.SetImportKOMScript(const Value: string);
begin
  FImportKOMScript := Value;
end;

procedure TExportLHCtoXML.SetImportLHCScript(const Value: string);
begin
  FImportLHCScript := Value;
end;

procedure TExportLHCtoXML.SetImportLSScript(const Value: string);
begin
  FImportLSScript := Value;
end;

procedure TExportLHCtoXML.SetImportLVSScript(const Value: string);
begin
  FImportLVSScript := Value;
end;

procedure TExportLHCtoXML.SetImportPARScript(const Value: string);
begin
  FImportPARScript := Value;
end;

procedure TExportLHCtoXML.SetImportPLTScript(const Value: string);
begin
  FImportPLTScript := Value;
end;

procedure TExportLHCtoXML.SetImportPRUScript(const Value: string);
begin
  FImportPRUScript := Value;
end;

procedure TExportLHCtoXML.SetImportREVScript(const Value: string);
begin
  FImportREVScript := Value;
end;

procedure TExportLHCtoXML.SetImportSKPScript(const Value: string);
begin
  FImportSKPScript := Value;
end;

procedure TExportLHCtoXML.SetImportVODScript(const Value: string);
begin
  FImportVODScript := Value;
end;

procedure TExportLHCtoXML.SetImportVRSScript(const Value: string);
begin
  FImportVRSScript := Value;
end;

procedure TExportLHCtoXML.SetImportZROScript(const Value: string);
begin
  FImportZROScript := Value;
end;

procedure TExportLHCtoXML.SetInsertKLO(const Value: boolean);
begin
  FInsertKLO := Value;
end;

procedure TExportLHCtoXML.SetISLH_version(const Value: string);
begin
  FISLH_version := Value;
end;

procedure TExportLHCtoXML.SetJPValue(const Value: integer);
begin
  FJPValue := Value;
end;

procedure TExportLHCtoXML.SetKBONames(const Value: string);
begin
  FKBONames := Value;
end;

procedure TExportLHCtoXML.SetKLONames(const Value: string);
begin
  FKLONames := Value;
end;

procedure TExportLHCtoXML.SetKLO_ChangeGroup(const Value: string);
begin
  FKLO_ChangeGroup := Value;
end;

procedure TExportLHCtoXML.SetKLO_DefaultBarva(const Value: string);
begin
  FKLO_DefaultBarva := Value;
end;

procedure TExportLHCtoXML.SetKLO_DefaultDruh(const Value: string);
begin
  FKLO_DefaultDruh := Value;
end;

procedure TExportLHCtoXML.SetKLO_DefaultZnacka(const Value: string);
begin
  FKLO_DefaultZnacka := Value;
end;

procedure TExportLHCtoXML.SetKPONames(const Value: string);
begin
  FKPONames := Value;
end;

procedure TExportLHCtoXML.SetKTONames(const Value: string);
begin
  FKTONames := Value;
end;

procedure TExportLHCtoXML.SetLastEntityName(const Value: string);
begin
  FLastEntityName := Value;
end;

procedure TExportLHCtoXML.SetLayers(const Value: TEntity);
begin
  FLayers := Value;
end;

procedure TExportLHCtoXML.SetLCR(const Value: boolean);
begin
  FLCR := Value;
end;

procedure TExportLHCtoXML.SetLCR_ETAPA(const Value: integer);
begin
  FLCR_ETAPA := Value;
end;

procedure TExportLHCtoXML.SetLED(const Value: boolean);
begin
  FLED := Value;
end;

{$IFDEF TAX}
procedure TExportLHCtoXML.SetLesniCelek(const Value: TLesniCelek);
begin
  FLesniCelek := Value;
end;
{$ENDIF}

procedure TExportLHCtoXML.SetLHCID(const Value: integer);
begin
  FLHCID := Value;
end;

procedure TExportLHCtoXML.SetLHCString(const Value: string);
begin
  FLHCString := Value;
end;

procedure TExportLHCtoXML.SetLHC_KOD(const Value: integer);
begin
  FLHC_KOD := Value;
end;

procedure TExportLHCtoXML.SetLHC_NAZ(const Value: string);
begin
  FLHC_NAZ := Value;
end;

procedure TExportLHCtoXML.SetLHO(const Value: boolean);
begin
  FLHO := Value;
end;

procedure TExportLHCtoXML.SetLHP_DO(const Value: string);
begin
  FLHP_DO := Value;
end;

procedure TExportLHCtoXML.SetLHP_OD(const Value: string);
begin
  FLHP_OD := Value;
end;

procedure TExportLHCtoXML.SetODDString(const Value: string);
begin
  FODDString := Value;
end;

procedure TExportLHCtoXML.SetOPValue(const Value: integer);
begin
  FOPValue := Value;
end;

procedure TExportLHCtoXML.SetORGDir(const Value: string);
begin
  FORGDir := Value;
end;

procedure TExportLHCtoXML.SetPARC(const Value: boolean);
begin
  FPARC := Value;
end;

procedure TExportLHCtoXML.SetPORString(const Value: string);
begin
  FPORString := Value;
end;

procedure TExportLHCtoXML.SetPRLString(const Value: string);
begin
  FPRLString := Value;
end;

procedure TExportLHCtoXML.SetProtocolScript(const Value: string);
begin
  FProtocolScript := Value;
end;

procedure TExportLHCtoXML.SetPSKString(const Value: string);
begin
  FPSKString := Value;
end;

procedure TExportLHCtoXML.SetSourceFileName(const Value: string);
begin
  FSourceFileName := Value;
end;

procedure TExportLHCtoXML.SetTAX(const Value: boolean);
begin
  FTAX := Value;
end;

procedure TExportLHCtoXML.SetWGS84(const Value: boolean);
begin
  FWGS84 := Value;
end;

procedure TExportLHCtoXML.SetWorkEntity(const Value: TEntity);
begin
  FWorkEntity := Value;
end;

procedure TExportLHCtoXML.SetxmlVersion(const Value: string);
begin
  FxmlVersion := Value;
end;

{$IFDEF TAX}
procedure TExportLHCtoXML.Set_Bezlesi(const Value: TBezlesi);
begin
  F_Bezlesi := Value;
end;

procedure TExportLHCtoXML.Set_Dilec(const Value: TDilec);
begin
  F_Dilec := Value;
end;

procedure TExportLHCtoXML.Set_Drevina(const Value: TDrevina);
begin
  F_Drevina := Value;
end;

procedure TExportLHCtoXML.Set_Etaz(const Value: TEtaz);
begin
  F_Etaz := Value;
end;

procedure TExportLHCtoXML.Set_JinyPozemek(const Value: TJinyPozemek);
begin
  F_JinyPozemek := Value;
end;

procedure TExportLHCtoXML.Set_Kategorie(const Value: TKategorie1);
begin
  F_Kategorie := Value;
end;

{$ENDIF}

procedure TExportLHCtoXML.Set_LastEntity(const Value: TEntity);
begin
  F_LastEntity := Value;
  if Value.Name[1]='@' then
     LastEntityName := copy(Value.Name,2,Length(Value.Name))
  else
     LastEntityName := Value.Name;
end;

{$IFDEF TAX}
procedure TExportLHCtoXML.Set_Oddeleni(const Value: TOddeleni);
begin
  F_Oddeleni := Value;
end;

procedure TExportLHCtoXML.Set_Ostatni(const Value: TOstatni);
begin
  F_Ostatni := Value;
end;

procedure TExportLHCtoXML.Set_Porost(const Value: TPorost);
begin
  F_Porost := Value;
end;

procedure TExportLHCtoXML.Set_PorostniSkupina(
  const Value: TPorostniSkupina);
begin
  F_PorostniSkupina := Value;
end;

procedure TExportLHCtoXML.Set_Poskozeni(const Value: TPoskozeni);
begin
  F_Poskozeni := Value;
end;

procedure TExportLHCtoXML.Set_Zalesneni(const Value: TZalesneni);
begin
  F_Zalesneni := Value;
end;
{$ENDIF}

procedure TExportLHCtoXML.Start;
begin
   if InsertKLO then
   begin
      system.assign(FSourceXML, SourceFileName);
      system.reset(FSourceXML);
      DTD.TemplateDTDFileName := ChangeFileExt(SourceFileName,'.dtd');
      DTD.DTDFileName := ChangeFileExt(FileName,'.dtd');
   end;
   inherited;
end;

function TExportLHCtoXML.Tecka(const Value: string): string;
var
   i: integer;
begin
   result := Value;
   for I:= 1 to length(result) do
   begin
      if result[i] in [','] then
         result[i]:= '.';
   end;
end;

procedure TExportLHCtoXML.WriteArea(aArea: TAreaElement);
var
   i: integer;
   Hole: TAreaElement;
begin
   WriteLnToXML(GetLevelSpace+'<P>');
   WriteSimpleArea(aArea);
   if aArea.Holes <> nil then
   begin
      if not aArea.Holes.NoElements then
      for i := 0 to aArea.Holes.LastIndex do
      begin
         Hole := TAreaElement(aArea.Holes.Elements[i]);
         WriteSimpleArea(Hole);
      end;
   end;
   WriteLnToXML(GetLevelSpace+'</P>');
end;

procedure TExportLHCtoXML.WriteLine(aLine: TPolyLineElement);
var
  i: integer;
  aX, aY: string;
  S: string;
  aDouble: double;
  dX, dY: double;
begin
  //WriteLnToXML(GetLevelSpace  + '<ML> <L>');
  WriteLnToXML(GetLevelSpace  + '<L>');
  IncLevel;
  for i := 0 to aLine.CoordsCount - 1 do
  begin
    dX := aLine.Xi[i];
    dY := aLine.Yi[i];
    if WGS84 then
       JTSK_WGS84(dX, dY);
    aDouble := dX;
    aDouble:= Abs(aDouble);
    aX:= Format('%.6f', [aDouble]);
    aX := Tecka(aX);
    aDouble := dY;
    aDouble:= Abs(aDouble);
    aY:= Format('%.6f', [aDouble]);
    aY := Tecka(aY);
    WriteLnToXML(GetLevelSpace+'<B S="'+aY+'$'+aX+'"/>');
  end;
  DecLevel;
  //WriteLnToXML(GetLevelSpace+'</L> </ML>');
  WriteLnToXML(GetLevelSpace+'</L>');
end;

procedure TExportLHCtoXML.WritePoint(_X,_Y: double; MB: boolean);
var
  aDouble: double;
  aX,aY: string;
  dX,dY: double;
begin
  dX := _X;
  dY := _Y;
  if WGS84 then
     JTSK_WGS84(dX, dY);
  aX:= ZDoubleStr(dX);
  aY:= ZDoubleStr(dY);
  if MB then
     WriteLnToXML(GetLevelSpace  + '<MB> <B S="'+aY+'$'+aX+'"/> </MB>')
  else
     WriteLnToXML(GetLevelSpace  + '<B S="'+aY+'$'+aX+'"/>');
end;

procedure TExportLHCtoXML.WriteSimpleArea(aArea: TAreaElement);
var
   i: integer;
   aX,aY,x0,Y0: string;
   S: string;
   aDouble: double;
   dX,dY: double;
begin
   IncLevel;
   WriteLnToXML(GetLevelSpace+'<L>');
   IncLevel;
   for i := 0 to aArea.CoordsCount - 1 do
   begin
      dX := aArea.Xi[i];
      dY := aArea.Yi[i];
      if WGS84 then
         JTSK_WGS84(dX, dY);
      aDouble := dX;
      aDouble:= Abs(aDouble);
      aX:= Format('%.6f', [aDouble]);
      aX := Tecka(aX);
      aDouble := dY;
      aDouble:= Abs(aDouble);
      aY:= Format('%.6f', [aDouble]);
      aY := Tecka(aY);
      if i = 0 then
      begin
         x0 := aX;
         y0 := aY;
      end;
      WriteLnToXML(GetLevelSpace+'<B S="'+aY+'$'+aX+'"/>');
   end;
   WriteLnToXML(GetLevelSpace+'<B S="'+Y0+'$'+X0+'"/>');
   DecLevel;
   WriteLnToXML(GetLevelSpace+'</L>');
   DecLevel;
end;

function TExportLHCtoXML.ZDoubleStr(aDouble: Double): String;
begin
   aDouble:= Abs(aDouble);
   result:= Format('%.6f', [aDouble]);
   result := Tecka(result);
end;

{ TInsertLCRToXML }

procedure TInsertLCRToXML.DoInsertLCR;
var
   S: string;
   PRS: string;
   IDS: string;
   IDI: integer;
   aLHC: integer;
   aOdd: integer;
   aOdds: string;
   aDil: string;
   res: integer;
   WaitFor: boolean;
begin
   WaitFor := true;
   Fsiz := FileSize(FSourceXML);
   Fpos := 0;
   StartProgress('LCR do XML',0,FSiz);
   ProgressText := 'Import LHC ODD DIL...';
   Application.ProcessMessages;
   RunScript(ImportLHCScript);
   PRS := 'Zasunut JPRL_OBRAZ ';
   while not Eof(FSourceXML) do
   begin
      ReadLn(FSourceXML,S);
      //Gauge1.Progress := Gauge1.Progress + Length(S);
      FPosN := FilePos(FSourceXML);
      if fposn > fpos then
      begin
         fpos := fposn;
         Progress := fpos;
         Application.ProcessMessages;
      end;
      if WaitFor then
      begin
         res := GetElementAndID(S,IDS,IDI);
         case res of
            1: begin
                  Writeln(FText,S);
                  //Writeln(FText,'***Obrzek LHC');
                  aLHC := IDI;
                  ProgressText := PRS+'LHC '+IDS;
                  Application.ProcessMessages;
                  Level := 1;
                  ForestModel.LHC_Cislo := IDI;
                  if ForestModel.ActualLHC = nil then
                  begin
                     ShowMessage('Osudn chyba! LHC '+IDS+' v modelu nen!');
                     exit;
                  end;
                  SaveLHC_OBRAZ;
               end;
            2: begin
                  Writeln(FText,S);
                  //Writeln(FText,'***Obrzek ODD');
                  aOdd := IDI;
                  aOdds := IDS;
                  ProgressText := PRS+'ODD '+IDS;
                  Application.ProcessMessages;
                  Level := 2;
                  ForestModel.Oddeleni_Cislo := IDI;
                  if ForestModel.ActualOddeleni = nil then
                  begin
                     ShowMessage('Osudn chyba! Oddelen '+IDS+' v modelu nen!');
                     exit;
                  end;
                  SaveODD_OBRAZ;
               end;
            3: begin
                  Writeln(FText,S);
                  //Writeln(FText,'***Obrzek DIL');
                  aDil := IDS;
                  ProgressText := PRS+'ODD '+aOdds+' DIL '+IDS;
                  Application.ProcessMessages;
                  Level := 3;
                  ForestModel.Dilec_Name := IDS;
                  if ForestModel.ActualLHC = nil then
                  begin
                     ShowMessage('Osudn chyba! Dlec '+aOdds+' '+IDS+' v modelu nen!');
                     exit;
                  end;
                  SaveDIL_OBRAZ;
               end;
            4: begin
                  ProgressText := 'LCR...';
                  Application.ProcessMessages;
                  WaitFor := false;
                  Level := 2;
                  SaveKOM;
                  SaveVOD;
                  SaveVRS;
                  SaveLCR;
                  //Writeln(FText,'***LCR a jine pindy');
                  ProgressText := 'Kartografie...';
                  Application.ProcessMessages;
                  Writeln(FText,S);
               end;
         else
            Writeln(FText,S);
         end;
         if Error > 0 then
         begin
            ShowMessage('Osudn chyba! Element DTD nebo co!');
            exit;
         end;
      end
      else
         Writeln(FText,S);
   end;
end;

procedure TInsertLCRToXML.DoRepairVODKOM;
var
   S: string;
   PRS: string;
   IDS: string;
   IDI: integer;
   res: integer;
   WaitFor: boolean;
   SkipIt: boolean;
   CESFound: boolean;
   VRSFound: boolean;
begin
   WaitFor := true;
   SkipIt := false;
   CESFound := false;
   VRSFound := false;
   Fsiz := FileSize(FSourceXML);
   Fpos := 0;
   StartProgress('LCR do XML Oprava',0,FSiz);
   ProgressText := 'Hledn VOD KOM...';
   Application.ProcessMessages;
   PRS := '...';
   while not Eof(FSourceXML) do
   begin
      ReadLn(FSourceXML,S);
      //Gauge1.Progress := Gauge1.Progress + Length(S);
      FPosN := FilePos(FSourceXML);
      if fposn > fpos then
      begin
         fpos := fposn;
         Progress := fpos;
         Application.ProcessMessages;
      end;
      if WaitFor then
      begin
         res := GetElementAndID(S,IDS,IDI);
         case res of
            4: begin
                  ProgressText := 'ALE ALE...';
                  Application.ProcessMessages;
                  WaitFor := false;
                  SkipIt := false;
                  //Writeln(FText,'***LCR a jine pindy');
                  ProgressText := 'Kartografie...VOD KOM nebo VRS chyb...';
                  Application.ProcessMessages;
                  Writeln(FText,S);
               end;
            5: begin
                  if not CESFound then
                  begin
                     CESFound := true;
                     SkipIt := true;
                     ProgressText := 'VOD KOM nalezeno - hledn VRS';
                     Application.ProcessMessages;
                  end;
               end;
            6: begin
                  ProgressText := 'Oprava ...';
                  Application.ProcessMessages;
                  VRSFound := true;
                  WaitFor := false;
                  SkipIt := false;
                  Level := 2;
                  SaveKOM;
                  SaveVOD;
                  //Writeln(FText,'***LCR a jine pindy');
                  ProgressText := 'koprovn zbytku...';
                  Application.ProcessMessages;
                  Writeln(FText,S);
               end;
         else
            if not SkipIt then
               Writeln(FText,S);
         end;
         if Error > 0 then
         begin
            ShowMessage('Osudn chyba! Element DTD nebo co!');
            exit;
         end;
      end
      else
         Writeln(FText,S);
   end;
   if not CESFound or not VRSFound then
      ShowMessage('Nebyly nalezeny vrstvy VOD KOM nebo VRS - Tohle asi nebude XML pro LR, e?!');
end;

procedure TInsertLCRToXML.DoIt;
begin
   Error := 0;
   if Preparing then       // pripravna faze ... odevzdani pracovnich vrstev....
   begin
      DoPreparing;
      exit;
   end;
   if ForestModel = nil then
   begin
      ShowMessage('ForestModel missing!');
      exit;
   end;
   if (DTD = nil) or (DTD.FindDTDElement('LHC_OBRAZ')= nil) then
   begin
      ShowMessage('DTD Error!');
      exit;
   end;
   if not FileExists(SourceFileName) then
   begin
      ShowMessage('Source XML missing!');
      exit;
   end;
   if ImportLHCScript = '' then
   begin
      ShowMessage('ImportLHCScript nen definovn!');
      exit;
   end;
   if ImportKOMScript = '' then
   begin
      ShowMessage('ImportKOMScript nen definovn!');
      exit;
   end;
   if ImportVODScript = '' then
   begin
      ShowMessage('ImportVODScript nen definovn!');
      exit;
   end;
   if ImportVRSScript = '' then
   begin
      ShowMessage('ImportVRSScript nen definovn!');
      exit;
   end;
   if ImportLSScript = '' then
   begin
      ShowMessage('ImportLSScript nen definovn!');
      exit;
   end;
   if ImportREVScript = '' then
   begin
      ShowMessage('ImportREVScript nen definovn!');
      exit;
   end;
   if ImportKATScript = '' then
   begin
      ShowMessage('ImportKATScript nen definovn!');
      exit;
   end;
   if ImportPARScript = '' then
   begin
      ShowMessage('ImportPARScript nen definovn!');
      exit;
   end;
   if ImportSKPScript = '' then
   begin
      ShowMessage('ImportSKPScript nen definovn!');
      exit;
   end;
   if ImportZROScript = '' then
   begin
      ShowMessage('ImportZROScript nen definovn!');
      exit;
   end;
   if ImportHOPScript = '' then
   begin
      ShowMessage('ImportHOPScript nen definovn!');
      exit;
   end;
   Start;
   if RepairVODKOM then
      DoRepairVODKOM
   else
      DoInsertLCR;
   Finish;
end;

procedure TInsertLCRToXML.FillElementAttributes(DTDModel: TDTDModelElement; aElement: TElement);
var
   i: integer;
   At: Txs_Attribute;
   S: string;
   aParName_xml: string;
   aPropIndex: integer;
   aTypeKind: TTypeKind;
   pos: integer;
   SZnacka,SUhel: string;
   IsFloat: boolean;
begin
   if (DTDModel = nil) or (aElement = nil) then exit;
   if DTDModel.NoAttributes then exit;
   DTDModel.ClearAttributes;
   SZnacka := DTDModel.Name + '_ZNACKA';
   SUhel   := DTDModel.Name + '_UHELZN';
   IsFloat := false;
   for i := 0 to DTDModel.Attributes.LastIndex do
   begin
      At := DTDModel.Attributes.Attribute[i];
      if At.Name = SZnacka then
         aParName_xml := 'Znacka'
      else
      if At.Name = SUhel then
      begin
         aParName_xml := 'Angle';
         IsFloat := true;
      end
      else
      begin
         aParName_xml := At.Name;
         IsFloat := At.Name = 'PARVYM';
      end;
      if not aElement.HasPropertyByName(aParName_xml) then continue;
      S := aElement.GetPropertyStringByName(aParName_XML);
      if IsFloat then
         S := Tecka(S);
      At.Value := S;
   end;
end;

procedure TInsertLCRToXML.Finish;
begin
   if not Preparing then        // pokud nejde o vrstvy priprav uzavirame zdroj...
      system.close(FSourceXML);
   inherited;
end;

function TInsertLCRToXML.GetElementAndID(const S: string; var IDS: string; var IDI: integer): integer;
var
   i: integer;
   Ch: char;
   SS: string;

   function FindIDS(const Key: string): boolean;
   var
      apos: integer;
      SSS: string;
   begin
      result := false;
      SSS := '';
      while S[i] in [#9,#32] do Inc(i);
      while S[i] in ['A'..'Z','_'] do
      begin
         SSS := SSS + S[i];
         Inc(i);
      end;
      if not (SSS = Key) then exit;
      while not (S[i]='"') do Inc(i);
      Inc(i);
      while not (S[i]='"') do
      begin
         IDS := IDS + S[i];
         Inc(i);
      end;
      result := true;
   end;
begin
   //zajima nas jenom LHC(1), ODD(2), DIL(3) a KBO(4) jinak nic - ostatni se jen presypava
   result := 0;
   IDS := '';
   IDI := 0;
   i := pos('<',S);
   if i <= 0 then exit;
   if not (S[i+1] in ['L','O','D','K','C','V']) then exit;
   SS := Copy(S,i+1,3);
   i := i + 4;
   if SS = 'LHC' then
   begin
      if FindIDS('LHC_KOD') then
      begin
         result := 1;
         IDI := StrToIntDef(IDS,0);
      end;
   end
   else
   if SS = 'ODD' then
   begin
      if FindIDS('ODD') then
      begin
         result := 2;
         IDI := StrToIntDef(IDS,0);
      end;
   end
   else
   if SS = 'DIL' then
   begin
      if FindIDS('DIL') then
      begin
         result := 3;
      end;
   end
   else
   if SS = 'KBO' then
   begin
      result := 4;
   end
   else
   if SS = 'CES' then
   begin
       result := 5;
   end
   else
   if SS = 'VRS' then
   begin
      result := 6;
   end;
   //while i <= S[i] in [#9,#32] do Inc(i)
end;

procedure TInsertLCRToXML.RunScript(const Value: string);
begin
   PostTextMsg(tm_Run,Value,nil);
   Application.ProcessMessages;
end;

procedure TInsertLCRToXML.SaveAreaEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   A: TAreaElement;
   S : string;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then exit;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if GE.Group <> aGroup then continue;
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TAreaElement) then continue;
      A := TAreaElement(G);
      FillElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      SaveMP(A);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TInsertLCRToXML.SaveDIL_OBRAZ;
var
   D: TDTDModelElement;
begin
   D := DTD.FindDTDElement('DIL_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   SaveDTDElementSTART(D);
   SaveMP(ForestModel.ActualDIlec.Geometry);
   SaveDTDElementEND(D);
end;

procedure TInsertLCRToXML.SaveHOP;
begin
   WorkEntity := nil;
   ProgressText := 'Import HOP ...';
   Application.ProcessMessages;
   RunScript(ImportHOPScript);
   if WorkEntity = nil then exit;
   SaveAreaEntity(WorkEntity, 9200, 'HOP');
end;

procedure TInsertLCRToXML.SaveKAT;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import KAT ...';
   Application.ProcessMessages;
   RunScript(ImportKATScript);
   if WorkEntity = nil then exit;
   S := 'L_KAT';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveLineEntity(En, 8110, S);
   end;
   S := 'P_KAT';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveAreaEntity(En, 8110, S);
   end;
end;

procedure TInsertLCRToXML.SaveKOM;
var
   i: integer;
   e: TElement;
   GE: TTopolLineElement;
begin
   WorkEntity := nil;
   ProgressText := 'Import KOM ...';
   Application.ProcessMessages;
   RunScript(ImportKOMScript);
   if WorkEntity = nil then exit;
   // CES
   SaveLineEntity(WorkEntity, 2100, 'CES');
   // PRU
   SaveLineEntity(WorkEntity, 2200, 'PRU');
end;

procedure TInsertLCRToXML.SaveLCR;
var
   D: TDTDModelElement;
begin
   D := DTD.FindDTDElement('LCR');
   if D = nil then exit;
   SaveDTDElementSTART(D);
   SaveLS;
   SaveREV;
   SaveKAT;
   SavePAR;
   SaveSKP;
   SaveZRO;
   SaveHOP;
   SaveDTDElementEND(D);
end;

procedure TInsertLCRToXML.SaveLHC_OBRAZ;
var
   D: TDTDModelElement;
begin
   D := DTD.FindDTDElement('LHC_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   SaveDTDElementSTART(D);
   SaveMP(ForestModel.ActualLHC.Geometry);
   SaveDTDElementEND(D);
end;

procedure TInsertLCRToXML.SaveLineEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   L: TPolyLineElement;
   S : string;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then exit;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if (aGroup > 0) and (GE.Group <> aGroup) then continue;
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TPolyLineElement) then continue;
      L := TPolyLineElement(G);
      FillElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      WriteLine(L);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TInsertLCRToXML.SaveLS;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import LS ...';
   Application.ProcessMessages;
   RunScript(ImportLSScript);
   if WorkEntity = nil then exit;
   S := 'B_LS';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // LS bod
      En := TEntity(e);
      SavePointEntity(En, 7500, S);
   end;
   S := 'P_LS';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // LS plocha
      En := TEntity(e);
      SaveAreaEntity(En, 7500, S);
   end;
end;

procedure TInsertLCRToXML.SaveMP(const Value: TGeometry);
var
   D: TDTDModelElement;
   A: TAreaElement;
   MA: TMultiAreaELement;
   i: integer;
begin
   D := DTD.FindDTDElement('MP');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   SaveDTDElementSTART(D);
   if not (Value is TAreaElement) then
      Error := 1
   else
   begin
      A := TAreaElement(Value);
      if A is TMultiAreaElement then
      begin
         MA := TMultiAreaElement(A);
         for i := 0 to MA.LastIndex do
         begin
            A := MA.AreaElement[i];
            WriteArea(A);
         end;
      end
      else
         WriteArea(A);
   end;
   SaveDTDElementEND(D);
end;

procedure TInsertLCRToXML.SaveODD_OBRAZ;
var
   D: TDTDModelElement;
begin
   D := DTD.FindDTDElement('ODD_OBRAZ');
   if D = nil then
   begin
      Error := 1;
      exit;
   end;
   SaveDTDElementSTART(D);
   SaveMP(ForestModel.ActualOddeleni.Geometry);
   SaveDTDElementEND(D);
end;

procedure TInsertLCRToXML.SavePAR;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import PAR ...';
   Application.ProcessMessages;
   RunScript(ImportPARScript);
   if WorkEntity = nil then exit;
   S := 'L_PAR';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveLineEntity(En, 8210, S);
   end;
   S := 'P_PAR';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveAreaEntity(En, 8210, S);
   end;
end;

procedure TInsertLCRToXML.SavePointEntity(const anEntity: TEntity; aGroup: integer; const DTDName: string);
var
   i,ni: integer;
   D,DObr: TDTDModelElement;
   e: TElement;
   GE: TGeometryELement;
   G: TGeometry;
   P: TPointElement;
   S : string;
   aMB: boolean;
begin
   S := DTDName+ ' ';
   D := DTD.FindDTDElement(DTDName);
   if D = nil then exit;
   DObr :=  D.FindDTDElement(DTDName+'_OBRAZ');
   if DObr = nil then exit;
   aMB := DObr.FindDTDElement('MB') <> nil;
   if anEntity = nil then exit;
   ni :=anEntity.LastIndex;
   ProgressText := S;
   Application.ProcessMessages;
   for i := 0 to anEntity.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         ProgressText := S + IntToStr(i)+'/'+IntToStr(ni);
         Application.ProcessMessages;
      end;
      e := anEntity.Elements[i];
      if not (e is TGeometryElement) then continue;
      GE := TGeometryElement(e);
      if (aGroup > 0) and (GE.Group <> aGroup) then continue;
      if GE.NoGeometry then continue;
      G := GE.Geometry;
      if not (G is TPointElement) then continue;
      P := TPointElement(G);
      FillElementAttributes(D,GE);
      SaveDTDElementSTART(D);
      SaveDTDElementSTART(DObr);
      WritePoint(P,aMB);
      SaveDTDElementEND(DObr);
      SaveDTDElementEND(D);
   end;
end;

procedure TInsertLCRToXML.SaveREV;
begin
   WorkEntity := nil;
   ProgressText := 'Import REV ...';
   Application.ProcessMessages;
   RunScript(ImportREVScript);
   if WorkEntity = nil then exit;
   SaveAreaEntity(WorkEntity, 7600, 'REV');
end;

procedure TInsertLCRToXML.SaveSKP;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import SKP ...';
   Application.ProcessMessages;
   RunScript(ImportSKPScript);
   if WorkEntity = nil then exit;
   S := 'L_SKP';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveLineEntity(En, 8320, S);
   end;
   S := 'P_SKP';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      En := TEntity(e);
      SaveAreaEntity(En, 8320, S);
   end;
end;

procedure TInsertLCRToXML.SaveVOD;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import VOD ...';
   Application.ProcessMessages;
   RunScript(ImportVODScript);
   if WorkEntity = nil then exit;
   S := 'PTK';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveLineEntity(En, 3100, S);
   end;
   S := 'RN';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveAreaEntity(En, 3200, S);
   end;
end;

procedure TInsertLCRToXML.SaveVRS;
var
   i: integer;
   e: TElement;
   En: TEntity;
   S: string;
begin
   WorkEntity := nil;
   ProgressText := 'Import VRS ...';
   Application.ProcessMessages;
   RunScript(ImportVRSScript);
   if WorkEntity = nil then exit;
   S := 'VRS';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SaveLineEntity(En, 5100, S);
   end;
   S := 'KOT';
   e := WorkEntity.FindElementName(S);
   if (e <> nil) and (e is TEntity) then
   begin
      // PTK
      En := TEntity(e);
      SavePointEntity(En, 5100, S);
   end;
end;

procedure TInsertLCRToXML.SaveZRO;
begin
   WorkEntity := nil;
   ProgressText := 'Import ZRO ...';
   Application.ProcessMessages;
   RunScript(ImportZROScript);
   if WorkEntity = nil then exit;
   SaveLineEntity(WorkEntity, 0, 'ZRO');
end;

procedure TInsertLCRToXML.SetForestModel(const Value: Tgis_ForestModel);
begin
  FForestModel := Value;
end;

procedure TInsertLCRToXML.SetGISDir(const Value: string);
begin
  FGISDir := Value;
end;

procedure TInsertLCRToXML.SetImportHOPScript(const Value: string);
begin
  FImportHOPScript := Value;
end;

procedure TInsertLCRToXML.SetImportKATScript(const Value: string);
begin
  FImportKATScript := Value;
end;

procedure TInsertLCRToXML.SetImportKOMScript(const Value: string);
begin
  FImportKOMScript := Value;
end;

procedure TInsertLCRToXML.SetImportLHCScript(const Value: string);
begin
  FImportLHCScript := Value;
end;

procedure TInsertLCRToXML.SetImportLSScript(const Value: string);
begin
  FImportLSScript := Value;
end;

procedure TInsertLCRToXML.SetImportPARScript(const Value: string);
begin
  FImportPARScript := Value;
end;

procedure TInsertLCRToXML.SetImportREVScript(const Value: string);
begin
  FImportREVScript := Value;
end;

procedure TInsertLCRToXML.SetImportSKPScript(const Value: string);
begin
  FImportSKPScript := Value;
end;

procedure TInsertLCRToXML.SetImportVODScript(const Value: string);
begin
  FImportVODScript := Value;
end;

procedure TInsertLCRToXML.SetImportVRSScript(const Value: string);
begin
  FImportVRSScript := Value;
end;

procedure TInsertLCRToXML.SetImportZROScript(const Value: string);
begin
  FImportZROScript := Value;
end;

procedure TInsertLCRToXML.SetORGDir(const Value: string);
begin
  FORGDir := Value;
end;

procedure TInsertLCRToXML.SetRepairVODKOM(const Value: boolean);
begin
  FRepairVODKOM := Value;
end;

procedure TInsertLCRToXML.SetSourceFileName(const Value: string);
begin
  FSourceFileName := Value;
end;

procedure TInsertLCRToXML.SetWorkEntity(const Value: TEntity);
begin
  FWorkEntity := Value;
end;

procedure TInsertLCRToXML.Start;
begin
   if not Preparing then   // pokud nejde o pripravu otevirame zdroj...
   begin
      system.assign(FSourceXML, SourceFileName);
      system.reset(FSourceXML);
      if not RepairVODKOM then
         DTD.DTDFileName := ChangeFileExt(FileName,'.dtd');
   end
   else
      DTD.DTDFileName := ChangeFileExt(FileName,'.dtd');
   inherited; // puvodni soubor pro zapis
end;

function TInsertLCRToXML.Tecka(const Value: string): string;
var
   i: integer;
begin
   result := Value;
   for I:= 1 to length(result) do
   begin
      if result[i] in [','] then
         result[i]:= '.';
   end;
end;

procedure TInsertLCRToXML.WriteArea(aArea: TAreaElement);
var
   i: integer;
   Hole: TAreaElement;
begin
   WriteLnToXML(GetLevelSpace+'<P>');
   WriteSimpleArea(aArea);
   if aArea.Holes <> nil then
   begin
      if not aArea.Holes.NoElements then
      for i := 0 to aArea.Holes.LastIndex do
      begin
         Hole := TAreaElement(aArea.Holes.Elements[i]);
         WriteSimpleArea(Hole);
      end;
   end;
   WriteLnToXML(GetLevelSpace+'</P>');
end;

procedure TInsertLCRToXML.WriteLine(aLine: TPolyLineElement);
var
  i: integer;
  aX, aY: string;
  S: string;
  aDouble: double;
begin
  WriteLnToXML(GetLevelSpace  + '<ML> <L>');
  IncLevel;
  for i := 0 to aLine.CoordsCount - 1 do
  begin
    aDouble := aLine.Xi[i];
    aDouble:= Abs(aDouble);
    aX:= Format('%.6f', [aDouble]);
    aX := Tecka(aX);
    aDouble := aLine.Yi[i];
    aDouble:= Abs(aDouble);
    aY:= Format('%.6f', [aDouble]);
    aY := Tecka(aY);
    WriteLnToXML(GetLevelSpace+'<B S="'+aY+'$'+aX+'"/>');
  end;
  DecLevel;
  WriteLnToXML(GetLevelSpace+'</L> </ML>');
end;

procedure TInsertLCRToXML.WritePoint(aPoint: TPointElement; MB: boolean);
var
  aDouble: double;
  aX,aY: string;
begin
  aX:= ZDoubleStr(aPoint.X);
  aY:= ZDoubleStr(aPoint.Y);
  if MB then
     WriteLnToXML(GetLevelSpace  + '<MB> <B S="'+aY+'$'+aX+'"/> </MB>')
  else
     WriteLnToXML(GetLevelSpace  + '<B S="'+aY+'$'+aX+'"/>');
end;

procedure TInsertLCRToXML.WriteSimpleArea(aArea: TAreaElement);
var
   i: integer;
   aX,aY,x0,Y0: string;
   S: string;
   aDouble: double;
begin
   IncLevel;
   WriteLnToXML(GetLevelSpace+'<L>');
   IncLevel;
   for i := 0 to aArea.CoordsCount - 1 do
   begin
      aDouble := aArea.Xi[i];
      aDouble:= Abs(aDouble);
      aX:= Format('%.6f', [aDouble]);
      aX := Tecka(aX);
      aDouble := aArea.Yi[i];
      aDouble:= Abs(aDouble);
      aY:= Format('%.6f', [aDouble]);
      aY := Tecka(aY);
      if i = 0 then
      begin
         x0 := aX;
         y0 := aY;
      end;
      WriteLnToXML(GetLevelSpace+'<B S="'+aY+'$'+aX+'"/>');
   end;
   WriteLnToXML(GetLevelSpace+'<B S="'+Y0+'$'+X0+'"/>');
   DecLevel;
   WriteLnToXML(GetLevelSpace+'</L>');
   DecLevel;
end;

function TInsertLCRToXML.ZDoubleStr(aDouble: Double): String;
begin
   aDouble:= Abs(aDouble);
   result:= Format('%.6f', [aDouble]);
   result := Tecka(result);
end;

procedure TInsertLCRToXML.SetPre_PAR(const Value: boolean);
begin
  FPre_PAR := Value;
end;

procedure TInsertLCRToXML.SetPre_SKP(const Value: boolean);
begin
  FPre_SKP := Value;
end;

procedure TInsertLCRToXML.SetPre_ZRO(const Value: boolean);
begin
  FPre_ZRO := Value;
end;

procedure TInsertLCRToXML.SetPreparing(const Value: boolean);
begin
  FPreparing := Value;
end;

procedure TInsertLCRToXML.DoPreparing;
begin
   Error := 0;
   if (DTD = nil) or (DTD.FindDTDElement('LCR')= nil) then
   begin
      ShowMessage('DTD Error!');
      exit;
   end;
   if Pre_ZRO then
   begin
      if ForestModel = nil then
      begin
         ShowMessage('ForestModel missing!');
         exit;
      end;
      if ImportZROScript = '' then
      begin
         ShowMessage('ImportZROScript nen definovn!');
         exit;
      end;
   end;
   if Pre_PAR then
   if ImportPARScript = '' then
   begin
      ShowMessage('ImportPARScript nen definovn!');
      exit;
   end;
   if Pre_SKP then
   if ImportSKPScript = '' then
   begin
      ShowMessage('ImportSKPScript nen definovn!');
      exit;
   end;
   Start;
   DoPreparingFinally;
   Finish;
end;

procedure TInsertLCRToXML.DoPreparingFinally;
var
   S: string;
begin
   S := 'LCR do XML -';
   if Pre_PAR then
      S := S + ' PAR';
   if Pre_SKP then
      S := S+ ' SKP';
   if Pre_ZRO then
      S := S+ ' ZRO';
   StartProgress(S,0,0);
   Application.ProcessMessages;
   //Level := 1;
   SaveHeader;
   SaveLCR_Pre;
   //Writeln(FText,'***LCR a jine pindy');
end;

procedure TInsertLCRToXML.SaveLCR_Pre;
var
   D0,D1,D: TDTDModelElement;
begin
   D0 := DTD.FindDTDElement('DATAISLH');
   if D0 = nil then exit;
   SaveDTDElementSTART(D0);
   D1 := DTD.FindDTDElement('LHC');
   if D1 = nil then exit;
   FillElementAttributes(D1,Self);
   SaveDTDElementSTART(D1);
   D  := DTD.FindDTDElement('LCR');
   if D = nil then exit;
   SaveDTDElementSTART(D);
   if Pre_LS then
      SaveLS;
   if Pre_REV then
      SaveREV;
   if Pre_KAT then
      SaveKAT;
   if Pre_PAR then
      SavePAR;
   if Pre_SKP then
      SaveSKP;
   if Pre_ZRO then
      SaveZRO;
   if Pre_HOP then
      SaveHOP;
   SaveDTDElementEND(D);
   SaveDTDElementEND(D1);
   SaveDTDElementEND(D0);
end;


procedure TInsertLCRToXML.SaveHeader;
begin
  inherited;
  writeLnToXML('<?ISLH '+ISLH_version+' LHP $ ?>');
  writeLnToXML('<!DOCTYPE LCR SYSTEM "'+ExtractFileName(DTD.DTDFileName)+'">');
end;

procedure TInsertLCRToXML.SetISLH_version(const Value: string);
begin
  FISLH_version := Value;
end;

procedure TInsertLCRToXML.SetLHP_DO(const Value: string);
begin
  FLHP_DO := Value;
end;

procedure TInsertLCRToXML.SetLHC_KOD(const Value: integer);
begin
  FLHC_KOD := Value;
end;

procedure TInsertLCRToXML.SetLHC_NAZ(const Value: string);
begin
  FLHC_NAZ := Value;
end;

procedure TInsertLCRToXML.SetLHP_OD(const Value: string);
begin
  FLHP_OD := Value;
end;

procedure TInsertLCRToXML.SetPre_HOP(const Value: boolean);
begin
  FPre_HOP := Value;
end;

procedure TInsertLCRToXML.SetPre_KAT(const Value: boolean);
begin
  FPre_KAT := Value;
end;

procedure TInsertLCRToXML.SetPre_LS(const Value: boolean);
begin
  FPre_LS := Value;
end;

procedure TInsertLCRToXML.SetPre_REV(const Value: boolean);
begin
  FPre_REV := Value;
end;


INITIALIZATION
   RegisterOrbisClass(TExportLHCtoXML);
   RegisterOrbisClass(TInsertLCRToXML);
END.

