unit t_ExportLHCDialog;

interface
uses
   f_ExportLHCDialog,
   t_OrbisDialog;

type

TExportLHCDialog = class(TOrbisDialog)
private
    FDirectory: string;
    FBlockName: string;
   function GetForm: TExportLHCDialog_Form;
   procedure SetBackup(const Value: boolean);
   procedure SetBackupName(const Value: string);
   function GetBackup: boolean;
   function GetBackupName: string;
    function GetControlDirectory: string;
    procedure SetControlDirectory(const Value: string);
    procedure SetDirectory(const Value: string);
    procedure SetBlockName(const Value: string);
public
   procedure DoIt; override;
   procedure CreateForm; override;
   property  Form: TExportLHCDialog_Form read GetForm;
published   
   property  Backup: boolean read GetBackup write SetBackup;
   property  BackupName: string read GetBackupName write SetBackupName;
   property  ControlDirectory: string read GetControlDirectory write SetControlDirectory;
   property  Directory: string read FDirectory write SetDirectory;
   property  BlockName: string read FBlockName write SetBlockName;
end;

implementation
uses
   Forms,
   e_Class,
   u_String;

{ TExportLHCDialog }

procedure TExportLHCDialog.CreateForm;
begin
   aForm := TExportLHCDialog_Form.Create(Application);
   aForm.Tool := Self;
   aForm.IsPossibleToClose := false;
end;

procedure TExportLHCDialog.DoIt;
var
   S: string;
begin
   S := Directory;
   if S <> '' then
   begin
      CheckBackSlash(S);
      BlockName := S + BlockName;
      Form.ed_BlockName.Text := BlockName;
   end;
   inherited;
   if Result = 1 then
      BlockName := Form.ed_BlockName.Text
   else
      BlockName := '';
end;

function TExportLHCDialog.GetBackup: boolean;
begin
   result := Form.c_Backup.Checked;
end;

function TExportLHCDialog.GetBackupName: string;
begin
   result := Form.ed_Backup.Text
end;

function TExportLHCDialog.GetControlDirectory: string;
begin
   result := Form.ed_ControlDirectory.Text
end;


function TExportLHCDialog.GetForm: TExportLHCDialog_Form;
begin
   result := TExportLHCDialog_Form(aForm);
end;

procedure TExportLHCDialog.SetBackup(const Value: boolean);
begin
  Form.c_Backup.Checked := Value;
end;

procedure TExportLHCDialog.SetBackupName(const Value: string);
begin
  Form.ed_Backup.Text := Value;
end;

procedure TExportLHCDialog.SetBlockName(const Value: string);
begin
   FBlockName := Value;
end;

procedure TExportLHCDialog.SetControlDirectory(const Value: string);
begin
  Form.ed_ControlDirectory.Text := Value;
end;

procedure TExportLHCDialog.SetDirectory(const Value: string);
begin
  FDirectory := Value;
end;




INITIALIZATION
   RegisterOrbisClass(TExportLHCDialog);
END.
