unit F_rected;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  Elements, Tools, G_Elems, Buttons, ExtCtrls,
  t_Editor;

type
  TF_rectedForm = class(TForm)
    GroupBox1: TGroupBox;
    edYmin: TEdit;
    edXmin: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edWidth: TEdit;
    Label4: TLabel;
    edHeight: TEdit;
    Label5: TLabel;
    edXmax: TEdit;
    Label6: TLabel;
    edYmax: TEdit;
    Label7: TLabel;
    edX: TEdit;
    Label8: TLabel;
    edY: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    edDX: TEdit;
    edDY: TEdit;
    b_OK: TBitBtn;
    B_Close: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Label11: TLabel;
    ed_Name: TEdit;
    Image3: TImage;
    Timer1: TTimer;
    b_Undo: TBitBtn;
    Panel1: TPanel;
    rbM: TRadioButton;
    rbCM: TRadioButton;
    rbMM: TRadioButton;
    procedure edXExit(Sender: TObject);
    procedure edYExit(Sender: TObject);
    procedure edWidthExit(Sender: TObject);
    procedure edHeightExit(Sender: TObject);
    procedure edDXExit(Sender: TObject);
    procedure edDYExit(Sender: TObject);
    procedure edXminExit(Sender: TObject);
    procedure edYminExit(Sender: TObject);
    procedure edXmaxExit(Sender: TObject);
    procedure edYmaxExit(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
    procedure b_OKClick(Sender: TObject);
    procedure b_UndoClick(Sender: TObject);
    procedure B_CloseClick(Sender: TObject);
    procedure rbMClick(Sender: TObject);
    procedure rbCMClick(Sender: TObject);
    procedure rbMMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FDontInformTool: boolean;
    aLeft: integer;
    aTop: integer;
    OMinx,OMinY,OMaxX,OMaxY: double;
    OName : string;
    Koef: double;
    DesMist: integer;
    function StrToFloatM(aValue: string): double;
    function FloatToStrM(aValue: double): string;
    procedure SaveRect;
    procedure LoadRect;

  public
    Tool: TTool;
    Editor: TRectEntityEditor;
    ShiftRect: Wintypes.TRect;
    UndoToGo: integer;
    function GetX: double;
    function GetY: double;
    function GetWidth: double;
    function GetHeight: double;
    function GetXmin: double;
    function GetXmax: double;
    function GetYmin: double;
    function GetYmax: double;
    procedure SetX(aValue: double);
    procedure SetY(aValue: double);
    procedure SetWidth(aValue: double);
    procedure SetHeight(aValue: double);
    procedure SetdX(aValue: double);
    procedure SetdY(aValue: double);
    procedure SetXmin(aValue: double);
    procedure SetXmax(aValue: double);
    procedure SetYmin(aValue: double);
    procedure SetYmax(aValue: double);
    property  DontInformTool: boolean read FDontInformTool write FDontInformTool;

  published
    property X: double read GetX write SetX;
    property Y: double read GetY write SetY;
    property RectWidth: double read GetWidth write SetWidth;
    property RectHeight: double read GetHeight write SetHeight;
    property dX: double write SetdX;
    property dY: double write SetdY;
    property Xmin: double read GetXmin write SetXmin;
    property Xmax: double read GetXmax write SetXmax;
    property Ymin: double read GetYmin write SetYmin;
    property Ymax: double read GetYmax write SetYmax;
  end;





type

TEdRectangle = class(TTool)
private
  Form: TF_rectedForm;
  FRE: TRectEntity;
public
  Tool: TTool;
  procedure DoIt; override;
published
end;





implementation

{$R *.DFM}
uses
  m_Orbis,
  m_Proj,
  U_String;


function TF_rectedForm.StrToFloatM(aValue: string): double;
begin
  result:= 0;
  if aValue = '' then exit;
  try
    result:= strToFloat(aValue)/Koef;
  except
  end
end;


function TF_rectedForm.FloatToStrM(aValue: double): string;
begin
  result:= DoubleToStr(aValue*Koef, 15, DesMist)
end;


procedure TEdRectangle.DoIt;
begin
  if not (input is TRectEntity) then exit;
  FRE:= TRectEntity(input);
  Application.CreateForm(TF_rectedForm, Form);
  TF_rectedForm(Form).Tool := Tool;
  with Form do
  try
    SetXmin(FRE.MinX);
    SetXmax(FRE.MaxX);
    SetYmin(FRe.MinY);
    SetYmax(FRe.MaxY);
    SetDX(0);
    SetDY(0);
  except
  end;

  if Form.ShowModal = mrOK then
  with Form do
  begin
    FRE.MinX:= GetXmin;
    FRE.MaxX:= GetXmax;
    FRE.MinY:= GetYmin;
    FRE.MaxY:= GetYmax;
  end
end;




function TF_rectedForm.GetX: double;
begin
  result:= GetXmin;
end;

function TF_rectedForm.GetY: double;
begin
  result:= GetYmin;
end;

function TF_rectedForm.GetWidth: double;
begin
  result:= abs(GetXmax - GetXmin)
end;

function TF_rectedForm.GetHeight: double;
begin
  result:= abs(GetYmax - GetYmin)
end;

function TF_rectedForm.GetXmin: double;
begin
  result:= StrToFloatM(edXmin.Text);
end;

function TF_rectedForm.GetXmax: double;
begin
  result:= StrToFloatM(edXmax.Text);
end;

function TF_rectedForm.GetYmin: double;
begin
  result:= StrToFloatM(edYmin.Text);
end;

function TF_rectedForm.GetYmax: double;
begin
  result:= StrToFloatM(edYmax.Text);
end;

procedure TF_rectedForm.SetX(aValue: double);
begin
  edX.Text:= FloatToStrM(aValue);
  edXmin.Text:= edX.Text;
  edXmax.Text:= FloatToStrM(aValue + StrToFloatM(edWidth.Text))
end;

procedure TF_rectedForm.SetY(aValue: double);
begin
  edY.Text:= FloatToStrM(aValue);
  edYmin.Text:= edY.Text;
  edYmax.Text:= floatToStrM(aValue + StrToFloatM(edHeight.Text))
end;

procedure TF_rectedForm.SetWidth(aValue: double);
begin
  edWidth.Text:= FloattoStrM(aValue);
  edXmax.Text:= FloatToStrM(GetXmin + aValue);
end;

procedure TF_rectedForm.SetHeight(aValue: double);
begin
  edHeight.Text:= FloatToStrM(aValue);
  edYmax.Text:= FloatToStrM(GetYmin + aValue);
end;

procedure TF_rectedForm.SetdX(aValue: double);
begin
  edDX.Text:= FloatToStrM(aValue);
  SetX(GetX+aValue);
end;


procedure TF_rectedForm.SetdY(aValue: double);
begin
  edDY.Text:= FloatToStrM(aValue);
  SetY(GetY+aValue);
end;

procedure TF_rectedForm.SetXmin(aValue: double);
begin
  edXmin.Text:= FloatToStrM(aValue);
  edX.Text:= edXmin.Text;
  edWidth.Text:= FloatToStrM(abs(GetXmax-GetXmin));
  if UndoToGo = 0 then b_Undo.Visible := false;
  Dec(UndoToGo);
end;


procedure TF_rectedForm.SetXmax(aValue: double);
begin
  edXmax.Text:= FloatToStrM(aValue);
  edWidth.Text:= FloatToStrM(abs(GetXmax-GetXmin));
  if UndoToGo = 0 then b_Undo.Visible := false;
  Dec(UndoToGo);
end;

procedure TF_rectedForm.SetYmin(aValue: double);
begin
  edYmin.Text:= FloatToStrM(aValue);
  edY.Text:= edYmin.Text;
  edHeight.Text:= FloatToStrM(abs(GetYmax-GetYmin));
  if UndoToGo = 0 then b_Undo.Visible := false;
  Dec(UndoToGo);
end;

procedure TF_rectedForm.SetYmax(aValue: double);
begin
  edYmax.Text:= FloatToStrM(aValue);
  edHeight.Text:= FloatToStrM(abs(GetYmax-GetYmin));
  if UndoToGo = 0 then b_Undo.Visible := false;
  Dec(UndoToGo);
end;


procedure TF_rectedForm.edXExit(Sender: TObject);
begin
  SetX(StrToFloatM(edX.Text))
end;

procedure TF_rectedForm.edYExit(Sender: TObject);
begin
  SetY(StrToFloatM(edY.Text))
end;

procedure TF_rectedForm.edWidthExit(Sender: TObject);
begin
  SetWidth(StrToFloatM(edWidth.Text))
end;

procedure TF_rectedForm.edHeightExit(Sender: TObject);
begin
  SetHeight(StrToFloatM(edHeight.Text))
end;

procedure TF_rectedForm.edDXExit(Sender: TObject);
begin
  SetDX(StrToFloatM(edDX.Text))
end;

procedure TF_rectedForm.edDYExit(Sender: TObject);
begin
  SetDY(StrToFloatM(edDY.Text))
end;

procedure TF_rectedForm.edXminExit(Sender: TObject);
begin
  SetXmin(StrToFloatM(edXmin.Text))
end;

procedure TF_rectedForm.edYminExit(Sender: TObject);
begin
  SetYmin(StrToFloatM(edYmin.Text))
end;

procedure TF_rectedForm.edXmaxExit(Sender: TObject);
begin
  SetXmax(StrToFloatM(edXmax.Text))
end;

procedure TF_rectedForm.edYmaxExit(Sender: TObject);
begin
  SetYmax(StrToFloatM(edYmax.Text))
end;

procedure TF_rectedForm.FormResize(Sender: TObject);
begin
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.FormDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.Timer1Timer(Sender: TObject);
begin
   if (aLeft <> Left) or (aTop <> Top) then
   begin
      aLeft := Left;
      aTop  := Top;
      Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
   end;
end;

procedure TF_rectedForm.FormActivate(Sender: TObject);
begin
   Timer1.Enabled := true;
end;

procedure TF_rectedForm.FormDeactivate(Sender: TObject);
begin
   Timer1.Enabled := false;
end;

procedure TF_rectedForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   if not DontInformTool then
      Tool.PostMsg(tm_SizePanelOff, Tool, nil, DontKill);
end;

procedure TF_rectedForm.FormHide(Sender: TObject);
begin
   if not DontInformTool then
      Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.b_OKClick(Sender: TObject);
var
   E: TRectEntity;
begin
   E := Editor.SelectedElement;
   if E = nil then exit;
   OMinx := E.MinX;
   OMinY := E.MinY;
   OMaxX := E.MaxX;
   OMaxY := E.MaxY;
   OName := E.Name;
   E.Name := ed_Name.Text;
   E.Minx := GetXMin;
   E.MinY := GetYMin;
   E.MaxX := GetXMax;
   E.MaxY := GetYMax;
   b_Undo.Visible := true;
   UndoToGo := 4;
   Editor.SelectedElement := E;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.b_UndoClick(Sender: TObject);
var
   E: TRectEntity;
begin
   E := Editor.SelectedElement;
   if E = nil then exit;
   E.Name := OName;
   E.Minx := OMinx;
   E.MinY := OMinY;
   E.MaxX := OMaxX;
   E.MaxY := OMaxY;
   b_Undo.Visible := false;
   Editor.SelectedElement := E;
   Tool.PostMsg(tm_ReView, Tool, nil, DontKill);
end;

procedure TF_rectedForm.B_CloseClick(Sender: TObject);
begin
   Close;
end;

procedure TF_rectedForm.SaveRect;
begin
  OMinX:= GetXmin;
  OMinY:= GetYmin;
  OMaxX:= GetXmax;
  OMaxY:= GetYmax
end;

procedure TF_rectedForm.LoadRect;
begin
  SetXmin(OMinX);
  SetYmin(OMinY);
  SetXmax(OMaxX);
  SetYmax(OMaxY);
end;

procedure TF_rectedForm.rbMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 1;
  DesMist:= 3;
  LoadRect
end;

procedure TF_rectedForm.rbCMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 100;
  DesMist:= 2;
  LoadRect
end;

procedure TF_rectedForm.rbMMClick(Sender: TObject);
begin
  SaveRect;
  Koef:= 1000;
  DesMist:= 2;
  LoadRect
end;

procedure TF_rectedForm.FormCreate(Sender: TObject);
begin
  rbMM.Enabled:= true;
  Koef:= 1000;
  DesMist:= 2;
end;

end.
