unit T_mapcre;

interface
uses
   Elements,
   e_MSpace,
   Tools;

type
TMapCreator = class(TTool)
private
   FDataDirectory: string;
   FTemplateName: string;
    FFillGraphics: boolean;
    FNoMIND: boolean;
   function  GetMapSpace: TMapSpace;
   procedure SetMapSpace(aValue: TMapSpace);
    procedure SetFillGraphics(const Value: boolean);
    procedure SetNoMIND(const Value: boolean);
public
   constructor Create; override;
   procedure DoIt; override;
published
   property  MapSpace: TMapSpace read GetMapSpace write SetMapSpace;
   property  DataDirectory: string read FDataDirectory write FDataDirectory;
   property  TemplateName : string read FTemplateName  write FTemplateName;
   property  FillGraphics: boolean read FFillGraphics write SetFillGraphics;
   property  NoMIND: boolean read FNoMIND write SetNoMIND;
end;

implementation
uses
   e_Class,
   e_Type,
   t_LHPMap;

{ TMapCreator }

function  TMapCreator.GetMapSpace: TMapSpace;
begin
   result := TMapSpace(Input);
end;

procedure TMapCreator.SetMapSpace(aValue: TMapSpace);
begin
   Input := aValue;
end;

procedure TMapCreator.SetNoMIND(const Value: boolean);
begin
  FNoMIND := Value;
end;

procedure TMapCreator.DoIt;
var
   MSF: TMapsheetFiller;
begin
   MSF := TMapSheetFiller.Create;
   MSF.Input:= MapSpace;
   MSF.Input:= TStringElement.CreateAll('TEMPLATE', TemplateName);
   MSF.Input:= TStringElement.CreateAll('DATADIR',  DataDirectory);
   MSF.FillGraphics:= FillGraphics;
   MSF.NoMIND := NoMIND;
   MSF.DoIt;
   Output:= MSF.Output;
   MSF.Free;
end;

(*
procedure TLayerImportDialog.DoIt;
var
  LF: TF_layimpForm;
  MS: TModelScript;
  LS: TLayerScript;
  aType, aDir: string;
  I: integer;
  aXmin, aYmin, aXmax, aYmax: double;
begin
  Application.CreateForm(TF_LayImpForm, LF);
  if (LF.ShowModal = mrOK) and (LF.OutLayers.Items.Count > 0) then
  begin
    MS:= TModelScript.Create;
    for I:= 0 to LF.OutLayers.Items.Count-1 do
    begin
      if StringAsParameter(LF.OutLayers.Items[I], aType, aDir) and
         OKLayerType(aType) and DirectoryExists(aDir) then
      begin
        LS:= TLayerScript.Create;
        LS.Name:= aType;
        GetBlokRect(aDir, aXmin, aYmin, aXmax, aYmax);
        with LS do
        begin
          MinX:= aXmin;
          MinY:= aYmin;
          MaxX:= aXmax;
          MaxY:= aYmax
        end;

        LS.Description:= aDir;
        MS.AddAndUpdateRect(LS);

      end
    end
  end;
  LF.Free;
  Output:= MS
end;

*)




procedure TMapCreator.SetFillGraphics(const Value: boolean);
begin
   FFillGraphics := Value;
end;

constructor TMapCreator.Create;
begin
   inherited;
   FillGraphics := true;
end;

INITIALIZATION
   RegisterOrbisClass(TMapCreator);
END.
