unit e_MapperProject;

interface
uses
   e_Project;

type

TORBISMapperProject = class(TOrbisProject)
private
    FSymbolsDirectory: string;
    FDataDirectory: string;
    FModified: boolean;
    FCompatibility30: boolean;
    FDirectory30: string;
    procedure SetDataDirectory(const Value: string);
    procedure SetSymbolsDirectory(const Value: string);
    procedure SetModified(const Value: boolean);
    procedure SetCompatibility30(const Value: boolean);
    procedure SetDirectory30(const Value: string);
published
    property DataDirectory: string read FDataDirectory write SetDataDirectory;
    property Compatibility30: boolean read FCompatibility30 write SetCompatibility30;
    property Directory30: string read FDirectory30 write SetDirectory30;
    property SymbolsDirectory: string read FSymbolsDirectory write SetSymbolsDirectory;
    property Modified: boolean read FModified write SetModified stored false;
end;


implementation
uses
   FileCtrl,
   SysUtils,
   e_Class,
   u_String;

{ TORBISMapperProject }

procedure TORBISMapperProject.SetCompatibility30(const Value: boolean);
begin
  FCompatibility30 := Value;
end;

procedure TORBISMapperProject.SetDataDirectory(const Value: string);
begin
  FDataDirectory := Value;
end;

procedure TORBISMapperProject.SetDirectory30(const Value: string);
begin
  FDirectory30 := Value;
end;

procedure TORBISMapperProject.SetModified(const Value: boolean);
begin
   FModified := Value;
end;

procedure TORBISMapperProject.SetSymbolsDirectory(const Value: string);
begin
  FSymbolsDirectory := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TORBISMapperProject);
END.
