unit F_penw;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin;

type
  TPenWidthDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Edit: TEdit;
    SpinButton1: TSpinButton;
    Label1: TLabel;
    procedure EditChange(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
  private
    FResultValue: double;
  public
    procedure SetResultValue(aValue: Double);
    property  ResultValue: double read FResultValue write FResultValue;
  end;


implementation

uses
   SysUtils;
{$R *.DFM}


procedure TPenWidthDialog.SetResultValue(aValue: Double);
begin
   if aValue < 0.1 then aValue := 0;
   FResultValue := aValue;
   Edit.Text := FloatToStrF(FResultValue, ffFixed, 7, 1);
end;


procedure TPenWidthDialog.EditChange(Sender: TObject);
begin
   try
      ResultValue := StrToFloat(Edit.Text);
   except
      SetResultValue(FResultValue);
   end;
end;

procedure TPenWidthDialog.SpinButton1DownClick(Sender: TObject);
begin
   SetResultValue(FResultValue - 0.1);
end;

procedure TPenWidthDialog.SpinButton1UpClick(Sender: TObject);
begin
   SetResultValue(FResultValue + 0.1);
end;

end.


