unit I_Rect;
{****************************************************************************}
{                                                                            }
{          ORBIS ... Interpret Obdelniku                                     }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}

interface
uses
   Wintypes,
   Elements,
   e_View,
   g_Elems,
   i_Basic;

type

  TDrawRectInterpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
  public
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;


implementation
uses
   Graphics,
   M_Orbis,
   //i_TopoL,
   e_Class,
   e_Device,
   Tools;


function  TDrawRectInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
end;


function  TDrawRectInterpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TDrawRectangle);
end;





function TDrawRectInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TDrawRectangle;
end;




procedure TDrawRectInterpret.Process(Element: TElement);
var
   R: TDrawRectangle;
begin
   if (Element is TDrawRectangle) then
   begin

      R:= TDrawRectangle(Element);
{
      Device.Pen.Color:= 0;
      Device.Pen.Style:= psSolid;
}

      Device.Pen.Color:= R.PenColor;
      Device.Pen.Style:= R.PenStyle;
      Device.PenWidth := R.PenWidth;
{
      Device.Brush.Color:= $00FF00;
      Device.Brush.Style:= bsSolid;
}
      Device.Brush.Color:= R.BrushColor;
      Device.Brush.Style:= R.BrushStyle;
      Device.Rectangle(R.MinX, R.MinY, R.MaxX, R.MaxY)

   end;
end;




BEGIN
   RegisterOrbisClass(TDrawRectInterpret);
END.