unit language;

interface
uses {!t_main,}
     Elements,
     E_Type,
     T_Oper,
     Tools;

const MaxVariables=25;
      MaxVarLength=30;

      WorldIndex=0{poradi Worldu ve stacku};
      MToolIndex=1{poradi MainToolu ve stacku};
      ActiveElIndex=2{poradi Activeelemetu ve stacku};
type
 NameString=string[MaxVarLength];
 TToolClass=class of TTool;

 TPrgLine=class(TOwnerEntity) {predelat na entitu a pridelat Program caller}
 private
  FStack:TOwnerEntity;
  procedure SetStack(aStack:TOwnerEntity);virtual;{asi neni nutne}
  function GetStack:TOwnerEntity;virtual;
  procedure SetVariable(index:integer;aVar:TTypeElement);virtual;{asi neni nutne}
  function GetVariable(index:integer):TTypeElement;virtual;
  property Variable[index:integer]:TTypeElement read GetVariable write SetVariable;
 public
  procedure DoIt;virtual;abstract;
  property Stack:TOwnerEntity read GetStack write SetStack;
 end;

{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}

TPrgBlock=class(TPrgLine)
private
 FPrgLineList:TEntity;
 FStackIndex:integer;{prvni volne misto v staku}
 procedure SetPrgLineList(aList:TEntity);virtual;
 function GetPrgLineList:TEntity;virtual;
 function GetPrgLine(index:longint):TPrgLine;virtual;
 procedure SetPrgline(index:longint;aLine:TPrgLine);virtual;
public
 property PrgLinelist:TEntity read GetPrgLineList write SetPrgLineList;
 property PrgLine[index:longint]:TPrgLine read GetPrgLine write SetPrgline;
 property StackIndex:integer read FStackIndex write FStackIndex;
 procedure AddPrgLine(aLine:TPrgLine);
 procedure DoIt;override;
end;


TVariable=class(TNoPtrOperator){POTREBA UPRAVIT TOPERATOR}
  private
   function GetConst:TTypeElement;virtual;abstract;
   function GetConstTyp:TType;virtual;abstract;
   procedure SetConst(aConst:TTypeElement);virtual;abstract;
  public
   procedure GetTypeInfo;override;
   property Constant:TTypeElement read GetConst write SetConst;
   property Typ:TType read GetConstTyp;
  end;


TNormalVariable=class(TVariable)
  private
   FVarIndex:integer;
   FBlock:TPrgBlock;
   function GetConst:TTypeElement;override;
   function GetConstTyp:TType;override;
   procedure SetConst(aConst:TTypeElement);override;
  public
   procedure DoIt;override;
   property Block:TPrgBlock read FBlock write FBlock;
  published
   property VarIndex:integer read FVarIndex write FVarIndex;
  end;

TPropVariable=class(TVariable)
 private
  FInitialExp:TOperator;
  FPropName:string;
  function GetConst:TTypeElement;override;
  function GetConstTyp:TType;override;
  procedure SetConst(aConst:TTypeElement);override;
  function GetInitialExp:TOperator;
  procedure SetInitialExp(aOp:TOperator);
 public
  procedure DoIt;override;
  property InitialExp:TOperator read GetInitialExp write SetInitialExp;
 published
  property PropertyName:string read FPropName write FPropName;
 end;

TCalledVariable=class(TNormalVariable)
 private
   function GetConst:TTypeElement;override;
   procedure SetConst(aConst:TTypeElement);override;
 end;

TToolInputInfo=class(TEntity)
 private
  FPropIndex:longint;
  FInputExpr:TOperator;
  function GetInputExpr:TOperator;
  procedure SetInputExpr(aExp:TOperator);
 public
  property InputExpr:TOperator read GetInputExpr write SetInputExpr;
 published
  property PropIndex:longint read FPropIndex write FPropIndex;
end;

TToolOperator=class(TNOPtrOperator)
 private
  FToolClass:TToolClass;
  FMainInput:TOperator;
  FPropInputList:TEntity;
  function GetPropInputList:TEntity;
  procedure SetPropInputList(aList:TEntity);
  function GetInputItem(index:longint):TToolInputinfo;virtual;
  function GetMainInput:TOperator;virtual;
  procedure SetMainInput(aInput:TOperator);virtual;
 public
  property PropInputList:TEntity read GetPropInputList write SetPropInputList;
  property PropInputItem[index:longint]:TToolInputInfo read GetInputItem;
  property MainInput:TOperator read getMainInput write SetMainInput;
  property ToolClass:TToolClass read FToolClass write FToolClass;
  procedure DoIt;override;
  procedure GetTypeInfo;override;
 end;


TAssignLine=class(TPrgLine)
private
 FLeftVar:TVariable;
 FExpression:TOperator;
 function GetExpr:TOperator;
 procedure SetExpr(aExpr:TOperator);
 function GetLeftVar:TVariable;
 procedure SetLeftVar(aExpr:TVariable);
public
 procedure DoIt;override;
 property LeftVar:TVariable read GetLeftVar write SetLeftVar;
 property Expression:TOperator read GetExpr write Setexpr;
end;

TExpressionLine=class(TPrgLine)
private
 FExpression:TOperator;
 function GetExpr:TOperator;
 procedure SetExpr(aExpr:TOperator);
public
 property Expression:TOperator read GetExpr write SetExpr;
 procedure DoIt;override;
end;

TIfLine=class(TPrgLine)
private
 FExpression:{TBooleanOperator}TOperator;
 FThenBlock,FElseBlock:TPrgLine;
 function GetExpr:TOperator;
 procedure SetExpr(aExpr:TOperator);
 function GetThenBlock:TPrgLine;
 procedure SetThenBlock(ablock:TPrgLine);
 function GetElseBlock:TPrgLine;
 procedure SetElseBlock(aBlock:TPrgLine);
 public
 procedure DoIt;override;
 property Expression:TOperator read GetExpr write SetExpr;
 property ThenBlock:TPrgLine read GetThenBlock write SetThenBlock;
 property ElseBlock:TPrgLine read GetElseBlock write SetElseBlock;
end;

TForLine=class(TPrgLine)
private
 FVariable:TNormalVariable;
 FBlock:TPrgLine;
 FStart,FEnd:TOperator;
 FIncrease:Boolean;
 function GetVar:TNormalVariable;
 procedure SetVar(aVar:TNormalVariable);
 function GetStart:TOperator;
 procedure SetStart(aVar:TOperator);
 function GetEnd:TOperator;
 procedure SetEnd(aVar:TOperator);
 function GetBlock:TPrgLine;
 procedure SetBlock(ablock:TPrgLine);
 public
 procedure DoIt;override;
 property Variable:TNormalVariable read GetVar write SetVar;
 property Block:TPrgLine read GetBlock write SetBlock;
 property Increase:boolean read FIncrease write FIncrease;
 {predelat na operatory}
 property StartValue:TOperator read GetStart write SetStart;
 property EndValue:TOperator read GetEnd write SetEnd;
end;

TWhileLine=class(TprgLine)
  FBlock:TPrgLine;
  FExpression:{TBooleanOperator}TOperator;
 private
  function GetBlock:TPrgLine;
  procedure SetBlock(ablock:TPrgLine);
  function GetExpr:TOperator;
  procedure SetExpr(aExpr:TOperator);
 public
  procedure DoIt;override;
  property Block:TPrgLine read GetBlock write SetBlock;
  property Expression:TOperator read GetExpr write SetExpr;
 end;

TRepeatline=class(TWhileLine)
public
 procedure DoIt;override;
end;

TCaseLine=class(TPrgline)
  FExpression:TOperator;
  FCaseList,FBlockList:TEntity;
  {FBlock:TPrgLine;}
  FElseBlock:TPrgLine;
private
  function GetExp:TOperator;
  procedure SetExp(aExp:TOperator);
  {function GetBlock:TPrgLine;
  procedure SetBlock(ablock:TPrgLine);}
  function GetCaseList:TEntity;
  procedure SetCaseList(aList:TEntity);
  function GetCaseItem(index:integer):TTypeElement;
  procedure SetCaseItem(index:integer;Item:TTypeElement);
  function GetBlockList:TEntity;
  procedure SetBlockList(aList:TEntity);
  function GetBlockItem(index:integer):TPrgLine;
  procedure SetBlockItem(index:integer;Item:TPrgLine);
  function GetElseBlock:TPrgLine;
  procedure SetElseBlock(aBlock:TPrgLine);
public
  procedure DoIt;override;
  property Expression:TOperator read GetExp write SetExp;
  {property Block:TPrgLine read GetBlock write SetBlock;}
  property CaseList:TEntity read GetCaseList write SetCaseList;
  property CaseItem[index:integer]:TTypeElement read GetCaseItem write SetCaseItem;
  property BlockList:TEntity read GetBlockList write SetBlockList;
  property BlockItem[index:integer]:TPrgLine read GetBlockItem write SetBlockItem;
  property ElseBlock:TPrgLine read GetElseBlock write SetElseBlock;
end;

TVarInfo=class(TOwnerElement)
private
   FType:TType;
   FVarName:NameString;
published
   property VarType:TType read FType write FType;
   property VarName:NameString read FVarName write FVarName;
end;

TOilProc=class(TPrgBlock)
private
 FVarInfoList:TEntity;
 FVarNumber:byte;
 FCalls:integer;
 procedure Create_Vars_In_Stack;virtual;
 procedure Destroy_Vars_In_Stack;virtual;
 function GetVarType(index:byte):TType;
 procedure SetVarType(index:byte;aType:TType);
 function GetVarName(index:byte):string;
 procedure SetVarName(index:byte;aname:string);
 procedure SetVarInfoList(aList:TEntity);
 function GetVarInfoList:TEntity;
public
 property VarInfoList:TEntity read GetVarInfoList write SetVarInfoList;
 property VarType[index:byte]:TType read GetVarType write SetVarType;
 property VarName[index:byte]:string read GetVarName write SetVarName;
 procedure DoIt;override;
published
 property VarNumber:byte read FVarNumber write FVarNumber;
 property Calls:integer read FCalls write FCalls;
end;

TOilFunc=class(TOilProc)
private
 FFuncType:TType;
 procedure Create_Vars_In_Stack;override;
 procedure Destroy_Vars_In_Stack;override;
 property FuncType:TType read FFuncType write FFuncType;
end;

TCaller=class(TPrgLine)
private
 FCalls:TEntity;
 FReferences:byte;
 function GetCalls:TEntity;
 procedure SetCalls(aList:TEntity);
 procedure SetCalledVar(index:integer;aVar:TOperator);virtual;
 function GetCalledVar(index:integer):TOperator;virtual;
 property Calls:TEntity read GetCalls write SetCalls;
public
 property References:byte read FReferences write FReferences;
 property CalledVar[index:integer]:TOperator read GetCalledVar write SetCalledVar;
end;

TProcCaller=class(TCaller)
private
 FProc:TOilProc;
 function GetProc:TOilProc;
 procedure SetProc(aProc:TOilProc);
public
 property Proc:TOilProc read GetProc write SetProc;
 procedure DoIt;override;
end;


TFunctionCaller=class(TCaller)
private
 FFunc:TOilFunc;
 function GetFunc:TOilFunc;
 procedure SetFunc(aFunc:TOilFunc);
public
 property Func:TOilFunc read GetFunc write SetFunc;
 procedure ReleaseResult;virtual;
 function GetResult:TTypeElement;virtual;
 procedure DoIt;override;
end;

TFunctionOperator=class(TNoPtrOperator)
private
 FCaller:TFunctionCaller;
 function GetCaller:TFunctionCaller;
 procedure SetCaller(aCaller:TFunctionCaller);
public
 property Caller:TFunctionCaller read GetCaller write SetCaller;
 {procedure CleanData; override;}{asi neni duvod ho menit}
 procedure GetTypeInfo;override;
 procedure DoIt;override;
end;

TProgram=class(TOilProc)
private
 FProcedureList:TEntity;
 function GetProcList:TEntity;
 procedure SetProcList(aList:TEntity);
public
 property ProcList:TEntity read GetProcList write SetProcList;
 procedure DoIt;override;
end;







implementation
uses
     {!}Dialogs,
     Classes,
     U_Props,
     SysUtils,
     E_Class,
     TypInfo,
     worlds;



procedure TPrgLine.SetStack(aStack:TOwnerEntity);
 begin
  if assigned(FStack) then FreeElement(FStack);
  AddElement(aStack);
  FStack:=aStack;
 end;

function TPrgLine.GetStack:TOwnerEntity;
 begin
 if not assigned(FStack) then
   begin
   FStack:=TOwnerEntity.create;
   AddElement(FStack);
   end;
  result:=FStack;
 end;

procedure TPrgLine.SetVariable(index:integer;aVar:TTypeElement);
var El:TTypeElement;
 begin
  if Stack.Count>index then
  begin
  El:=TTypeElement(Stack.Elements[index]);
   case El.Typ of
    _Boolean:El.AsBoolean:=aVar.AsBoolean;
    _Char:El.AsChar:=aVar.AsChar;
    _Float:El.AsFloat:=aVar.AsFloat;
    _String:El.AsString:=aVar.AsString;
    _Integer:El.AsInteger:=aVar.AsInteger;
    _Pointer:El.AsPointer:=aVar.AsPointer
    else El.AsString:=aVar.AsString;
    end;{case}
  if aVar.OwnersCount=0 then
     aVar.Free;
  end else
  Stack.AddElement(aVar);
 end;

function TPrgLine.GetVariable(index:integer):TTypeElement;
 begin
  result:=TTypeElement(Stack.Elements[index]);
 end;

{TPrgBlock}
procedure TPrgBlock.SetPrgLineList(aList:TEntity);
   begin
   if assigned(FPrgLineList) then FreeElement(FPrgLineList);
   AddElement(aList);
   FPrgLineList:=aList;
   end;

function TPrgBlock.GetPrgLineList:TEntity;
   begin
   if not assigned(FPrgLineList) then
      begin
      FPrgLineList:=TEntity.create;
      AddELement(FPrgLineList);
      end;
   result:=FPrgLineList;
   end;

function TPrgBlock.GetPrgLine(index:longint):TPrgLine;
   begin
   result:=TPrgLine(PrgLineList.Elements[index]);
   end;

procedure TPrgBlock.SetPrgline(index:longint;aLine:TPrgLine);
   begin
   if PrgLineList.Count>index then
   begin
   PrgLineList.InsertElement(index,aLine);
   PrgLineList.FreeElement(PrgLineList.Elements[index+1]);
   end
   else PrgLineList.AddElement(aLine);
   end;

procedure TPrgBlock.AddPrgLine(aLine:TPrgLine);
var max:integer;
   begin
   max:=PrgLineList.Count;
   PrgLineList.AddElement(aLine);
   PrgLine[max].Stack:=Stack;
   end;


procedure TPrgBlock.DoIt;
var i:longint;
   begin
   if PrgLineList.Count>0 then
     for i:=0 to PrgLinelist.Count-1 do if PrgLine[i]<>nil then PrgLine[i].Doit;
   end;

{SetLine}
function TAssignLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TAssignLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

function TAssignLine.GetLeftVar:TVariable;
 begin
  result:=FLeftVar;
 end;

procedure TAssignLine.SetLeftVar(aExpr:TVariable);
 begin
  if assigned(FLeftVar) then FreeElement(FLeftVar);
  FLeftVar:=aExpr;
  AddElement(FLeftVar);
 end;

procedure TAssignLine.DoIt;
var TmpRes:TTypeElement;
begin
 {try}
 Expression.DoIt;
 TmpRes:=TTypeElement(Expression.Output);
 if (TmpRes=nil) or (Leftvar=nil) then {raise};
 if LeftVar.typ=TmpRes.typ then LeftVar.Constant:=TmpRes
  else
   case LeftVar.Typ of
    _Other:LeftVar.Constant:=TmpRes;{site horkou jehlou}
    _Float:if TmpRes.Typ in [_Integer,_Byte] then TFloatElement(LeftVar).Value:=TmpRes.AsFloat;
    _Integer:if TmpRes.Typ=_Byte then TIntegerElement(LeftVar).Value:=TmpRes.AsInteger;
    _Byte:if TmpRes.Typ=_Integer then TByteElement(LeftVar).Value:=TmpRes.AsByte;
    end;
 {except}
 Expression.Output:=nil;
end;

{TVariable}
procedure TVariable.GetTypeInfo;
{prekontrolovat}
var i:TType;
    tmp:TType;
   begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   tmp:=Typ;
   if tmp=_other then For i:=_boolean to pred(_other) do TypeItem[i]:=true else
      TypeItem[tmp]:=true;
   end;

{ConstVAR}
function TNormalVariable.GetConst:TTypeElement;
 begin
  result:=TTypeElement(Block.Variable[Block.StackIndex+VarIndex]);
 end;

procedure TNormalVariable.SetConst(aConst:TTypeElement);
function Agrees:boolean;
         var p:TElement;
             CL:TClass;
             PEl:TPointerElement;
         begin
         p:=TPointerElement(aConst).Value;
         if p=nil then result:=true
         else
         begin
         PEl:=TPointerElement(Block.Variable[Block.StackIndex+VarIndex]);
         CL:=GetOrbisClass(PEl.ClassName);
         result:=p.InheritsFrom(CL);
         end
         end;

  begin
  if (aConst.Typ=_pointer) and (Block.Variable[Block.StackIndex+VarIndex].typ=_Pointer) then
  begin
  if Agrees then Block.Variable[Block.StackIndex+VarIndex]:=aConst
     else {raise typova neshoda objektu};
  end
  else
  Block.Variable[Block.StackIndex+VarIndex]:=aConst;
  end;

function TNormalVariable.GetConstTyp:TType;
 begin
  //result:=_other;
  if (Block is TOilProc)  then result:=TOilProc(Block).VarType[VarIndex+TOilProc(Block).Calls]
   else result:=_other;
 end;

procedure TNormalVariable.DoIt;
 begin
  Output:=Constant;
 end;

{PropVAR}
function TPropVariable.GetConst:TTypeElement;
  var InitialValue:TTypeElement;
      FObjPtr:pointer;
      FStrRes:string;
      num:real48;
      err,PIndex:integer;
   begin
    result:=nil;
    InitialValue := nil;
    try
    InitialExp.Doit;
    InitialValue:=TTypeElement(InitialExp.Output);
    if not (InitialValue.Typ=_pointer) then {raise};
    if InitialValue.AsPointer=nil then {raise};
    if not (TObject(InitialValue.AsPointer) is TPersistent) then {raise};
    {  starsi verze
    FObjPtr:=GetObjectPropByName(InitialValue.AsPointer,PropertyName);
    if assigned(FObjPtr) then
     result:=TPointerElement.CreateValue(FObjPtr)
     }
     FObjPtr:=nil;
     PIndex:=GetPropIndex(TPersistent(InitialValue.AsPointer),PropertyName);
     if PIndex<0 then
        begin {pouze u entity}
        if (TObject(InitialValue.AsPointer) is TEntity) then
           FObjPtr:=TEntity(InitialValue.AsPointer).FindElementName(PropertyName)
           else {raise spatne jmeno property, nebo predchozi prvek neni entita};
        if assigned(FObjPtr) then  result:=TPointerElement.CreateValue(FObjPtr)
           else {raise takovy prvek tu neni};
        end
     else
        begin {existuje properta}
        if GetPropType(TPersistent(InitialValue.AsPointer),PIndex)= tkClass
           then result:=TPointerElement.CreateValue(GetObjectPropByName(InitialValue.AsPointer,PropertyName))
          else
          begin{hodnotova properta}
          if (TObject(Initialvalue.AsPointer) is TElement )
              then FStrRes:=TElement(Initialvalue.AsPointer).GetPropertyStringByName(PropertyName)
              else FStrRes:=GetPropStringByName(Initialvalue.AsPointer,PropertyName);
          if (Uppercase(FStrRes)='TRUE') then result:=TBooleanElement.createvalue(true)
          else
          if (Uppercase(FStrRes)='FALSE') then result:=TBooleanElement.createvalue(false)
         else
          begin
          val(FStrRes,num,err);
          if err=0 then
              begin {je cislo}
              if (abs(num)<maxlongint) and (trunc(num)=num) then
                 result:=TIntegerElement.Createvalue(trunc(num))
              else result:=TFloatElement.createValue(num);
             end
           else
             begin {neni cislo}
              if length(FStrRes)=1 then result:=TCharElement.CreateValue(FStrRes[1])
              else result:=TStringElement.Createvalue(FStrRes);
             end;
          end;
          end{hod.properta}
        end;

    (* Stara verze -pouze pro kontrolu
    if GetPropIndex(TPersistent(InitialValue.AsPointer),PropertyName)>-1 then
    begin
    FObjPtr:=GetObjectPropByName(InitialValue.AsPointer,PropertyName);
    result:=TPointerElement.CreateValue(FObjPtr)
    end
     else
    begin
    if (TObject(InitialValue.AsPointer) is TElement) then
       FObjPtr:=TEntity(InitialValue.AsPointer).FindElementName(PropertyName);
    if assigned(FObjPtr) then  result:=TPointerElement.CreateValue(FObjPtr)
    else
        begin
        if (TObject(Initialvalue.AsPointer) is TElement )
            then FStrRes:=TElement(Initialvalue.AsPointer).GetPropertyStringByName(PropertyName)
            else FStrRes:=GetPropStringByName(Initialvalue.AsPointer,PropertyName);
       if (Uppercase(FStrRes)='TRUE') then result:=TBooleanElement.createvalue(true)
       else
       if (Uppercase(FStrRes)='FALSE') then result:=TBooleanElement.createvalue(false)
       else
         begin
         val(FStrRes,num,err);
         if err=0 then
         begin {je cislo}
            if (abs(num)<maxlongint) and (trunc(num)=num) then
              result:=TIntegerElement.Createvalue(trunc(num))
            else result:=TFloatElement.createValue(num);
         end
         else
         begin {neni cislo}
            if length(FStrRes)=1 then result:=TCharElement.CreateValue(FStrRes[1])
            else result:=TStringElement.Createvalue(FStrRes);
         end;
        end;
      end;
    end;*)
    finally
    if InitialValue.OwnersCount=0 then  InitialValue.free;
    end;
  end;


function TPropVariable.GetConstTyp:TType;
 begin
   result:=_Other;
 end;

procedure TPropVariable.SetConst(aConst:TTypeElement);
var Initialvalue:TTypeElement;
begin
  InitialValue := nil;
  try
    InitialExp.DoIt;
    InitialValue:=TTypeElement(InitialExp.Output);
    if not (InitialValue.Typ=_pointer) then {raise};
    if InitialValue.AsPointer=nil then {raise};
    if not (TObject(InitialValue.AsPointer) is TPersistent) then {raise};
    if not SetPropStringByName(TPersistent(Initialvalue.AsPointer),PropertyName,aConst.AsString)  then {raise};
 finally
 if InitialValue.OwnersCount=0 then InitialValue.free;
 end;
end;

function TPropVariable.GetInitialExp:TOperator;
 begin
  result:=FInitialExp;
 end;

procedure TPropVariable.SetInitialExp(aOp:TOperator);
 begin
  if assigned(FInitialExp) then FreeElement(FInitialExp);
  AddElement(aOp);
  FInitialExp:=aOp;
 end;

procedure TPropVariable.DoIt;
 begin
  Output:=Constant;
 end;

{called VAR}
function TCalledVariable.GetConst:TTypeElement;
var El:TTypeElement;
 begin
  El:=Block.Variable[Block.StackIndex+VarIndex];
  result:=TVariable(TPointerElement(El).Value).Constant;
 end;

procedure TCalledVariable.SetConst(aConst:TTypeElement);
 begin
  TVariable(TPointerElement(Block.Variable[Block.StackIndex+VarIndex]).Value).Constant:=aConst;
 end;

{TToolInputInfo}
function TToolInputInfo.GetInputExpr:TOperator;
   begin
   result:=FInputExpr;
   end;

procedure TToolInputInfo.SetInputExpr(aExp:TOperator);
   begin
   if assigned(FInputExpr) then FreeElement(FInputExpr);
   AddElement(aExp);
   FInputExpr:=aExp;
   end;

{TToolOperator}
function TToolOperator.GetPropInputList:TEntity;
    begin
    if not assigned(FPropInputList) then
       begin
       FPropInputList:=TEntity.Create;
       AddElement(FPropInputList);
       end;
    result:=FPropInputList;
    end;

procedure TToolOperator.SetPropInputList(aList:TEntity);
    begin
    if assigned(FPropInputList) then FreeElement(FPropInputList);
    FPropInputList:=aList;
    AddElement(FPropInputList);
    end;

function TToolOperator.GetInputItem(index:longint):TToolInputInfo;
   begin
   result:=TToolInputInfo(PropInputList.Elements[index]);
   end;


procedure TToolOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   TypeItem[_pointer]:=true;
  end;

function TToolOperator.GetMainInput:TOperator;
  begin
  result:=FMainInput;
  end;

procedure TToolOperator.SetMainInput(aInput:TOperator);
  begin
  if assigned(FMainInput) then FreeElement(FMainInput);
  FMainInput:=aInput;
  Addelement(FMainInput);
  end;

procedure TToolOperator.DoIt;
var
aRes:TTypeElement;
aInp:TElement;
theTool:TTool;
aInstance:TOrbisInstance;
PIndex,i,int:longint;
bool:boolean;
st:string;
ptr:pointer;
chr:char;
fl:extended;

  function CompatibleTypes(a:TTypeKind;b:TType):boolean;
      {hruzna cunarna}
      begin
      result := false;
      case a of
      tkInteger:result:=b in [_integer,_byte];
      tkChar:result:=b in [_char];
      tkEnumeration:result:=b in [_boolean];
      tkFloat:result:=b in [_integer,_byte,_float];
      tkString:result:=b in [_char,_string];
      tkClass, tkMethod:result:=b in [_pointer,_other];
      end
      end;


  begin
  aInstance := nil;
  TheTool := nil;
  try
  aInp:=nil;
  if MainInput<>nil then
   begin
   MainInput.DoIt;
   aRes:=TTypeElement(MainInput.Output);
   if aRes.typ=_pointer then aInp:=aRes.AsPointer
    else {raise input musi byt prvek nikoli hodnota};
   end;
   if Toolclass=nil then {raise nen zadan dn nstroj};
   theTool:=ToolClass.Create;
   theTool.Input:=aInp;
   aInstance:=TOrbisInstance.Create;
   aInstance.ElementClass:=ToolClass;
   aInstance.Instance:=theTool;
   if PropInputList.Count>0 then
      begin
      for i:=0 to PropInputList.Count-1 do
      begin {naplneni propert}
      pindex:=PropInputItem[i].PropIndex-1;
      PropInputItem[i].InputExpr.DoIt;
      aRes:=TTypeElement(PropInputItem[i].InputExpr.Output);
      if CompatibleTypes(aInstance.PropertyTypeKind[PIndex],aRes.Typ) or (aRes.typ=_string) then
         begin
          case  aInstance.PropertyTypeKind[PIndex] of
             tkInteger:
                 begin
                 int:=aRes.AsInteger;
                 aInstance.SetPropertyValue(PIndex,int);
                 end;
             tkChar:
                 begin
                 chr:=aRes.AsChar;
                 aInstance.SetPropertyValue(PIndex,chr);
                 end;
             tkEnumeration:
                 begin
                 bool:=aRes.AsBoolean;
                 aInstance.SetPropertyValue(PIndex,bool);
                 end;
             tkFloat:
                 begin
                 fl:=aRes.AsFloat;
                 aInstance.SetPropertyValue(PIndex,fl);
                 end;
             tkString:
                 begin
                 st:=aRes.AsString;
                 aInstance.SetPropertyValue(PIndex,st);
                 end;
             tkClass, tkMethod:
                 begin
                 ptr:=aRes.AsPointer;
                 aInstance.SetPropertyValue(PIndex,ptr);
                 end;
             end{case}
         end
        else
         {raise typova nekompatibilita s propertou aInstance.PropertyTypename[PIndex]};
      end;
      end;
   theTool.DoIt;
   Output:=TPointerElement.CreateValue(theTool.Output);
   finally
    if aInstance<>nil then aInstance.Free;
    if theTool<>nil then theTool.Free;
   end;
   end;

{TExpressionline}
function TExpressionline.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TExpressionline.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

procedure TExpressionline.DoIt;
begin
  Expression.DoIt;
  {Ulozit vysledek do...StringListu}
  {Expression.CleanData;}
end;

{IF}
function TIfLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TIfLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

function TIfLine.GetThenBlock:TPrgLine;
 begin
  result:=FThenBlock;
 end;

procedure TIfLine.SetThenBlock(aBlock:TPrgLine);
 begin
  if assigned(FThenBlock) then FreeElement(FThenBlock);
  AddElement(aBlock);
  FThenBlock:=aBlock;
 end;

function TIfLine.GetElseBlock:TPrgLine;
 begin
  result:=FElseBlock;
 end;

procedure TIfLine.SetElseBlock(aBlock:TPrgLine);
 begin
  if assigned(FElseBlock) then FreeElement(FElseBlock);
  AddElement(aBlock);
  FElseBlock:=aBlock;
 end;

procedure TIfLine.DoIt;
var TmpRes:TTypeElement;
 begin
  {try}
  Expression.DoIt;
  TmpRes:=TTypeElement(Expression.Output);
  if (TmpRes=nil)or(TmpRes.Typ<>_boolean) then {raise};
  if TBooleanElement(TmpRes).Value then ThenBlock.DoIt
     else ElseBlock.DoIt;
  {except}
  Expression.CleanData;
 end;

{FOR}
function TForLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TForLine.SetBlock(aBlock:TPrgLine);
 begin
  if assigned(FBlock) then FreeElement(FBlock);
  AddElement(aBlock);
  FBlock:=aBlock;
 end;

function TForLine.GetVar:TNormalVariable;
 begin
  result:=FVariable;
 end;

procedure TForLine.SetVar(aVar:TNormalVariable);
 begin
 if assigned(FVariable) then FreeElement(FVariable);
  AddElement(aVar);
  FVariable:=aVar;
 end;

function TForLine.GetStart:TOperator;
 begin
  result:=FStart;
 end;

procedure TForLine.SetStart(aVar:TOperator);
 begin
 if assigned(FStart) then FreeElement(FStart);
  AddElement(aVar);
  FStart:=aVar;
 end;

function TForLine.GetEnd:TOperator;
 begin
  result:=FEnd;
 end;

procedure TForLine.SetEnd(aVar:TOperator);
 begin
 if assigned(FEnd) then FreeElement(FEnd);
  AddElement(aVar);
  FEnd:=aVar;
 end;

procedure TForLine.DoIt;
var TmpRes:TTypeElement;
    First:boolean;

 function GetOut:boolean;
    var tmp:TTypeElement;
    begin
    //result:=false;
    EndValue.DoIt;
    Tmp:=TTypeElement(EndValue.Output);
    if (Variable.Typ=_char) then
      begin
      if not (Tmp.Typ=_char) then
         {raise-nekompatibilni};
      end
      else if not((Tmp.Typ=_byte) or (Tmp.Typ=_integer)) then {raise nekmpatibilni};
    result:=Variable.Constant.AsInteger=Tmp.AsInteger;
    EndValue.CleanData;
    end;

 begin
  {try}
  if not(Variable.Typ in [_integer,_char,_byte]) then {raise};
  (*if (StartVar.Typ<>EndVar.Typ) and not((StartVar.Typ in[_integer,_byte])
       and(EndVar.Typ in [_integer,_byte])) then {raise-nekompatibilita};*)
  {nedokonale}
  (*patri do kompilatoru
  StartValue.GetTypeInfo;
  EndValue.GetTypeInfo;
  if (Variable.Typ=_char) then if not(StartValue.TypeItem[_char] and EndValue.TypeItem[_char]) then
         {raise-nekompatibilni};
  if not((StartValue.TypeItem[_byte]or StartValue.TypeItem[_integer])
          and (EndValue.TypeItem[_byte]or EndValue.TypeItem[_integer])) then
         {raise-nekompatibilni};*)
  StartValue.Doit;
  TmpRes:=TTypeElement(StartValue.Output);
  if (Variable.Typ=_char) then
      begin
      if not (Tmpres.Typ=_char) then
         {raise-nekompatibilni};
      end
  else if not((TmpRes.Typ=_byte) or (Tmpres.Typ=_integer)) then {raise nekmpatibilni};

  Variable.Constant:=TmpRes;
  First:=true;
  repeat
  if not First then
      if Increase then Variable.Constant.AsInteger:=Variable.Constant.AsInteger+1
      else Variable.Constant.AsInteger:=Variable.Constant.AsInteger-1;
  Block.DoIt;
  First:=false;
  until GetOut;
  {except}
  (*StartValue.ClearTypeInfo;
  EndValue.ClearTypeInfo;*)
 end;

{WHILE}
function TWhileLine.GetExpr:TOperator;
 begin
  result:=FExpression;
 end;

procedure TWhileLine.SetExpr(aExpr:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
  AddElement(aExpr);
  FExpression:=aExpr;
 end;

 function TWhileLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TWhileLine.SetBlock(aBlock:TPrgLine);
 begin
  if assigned(FBlock) then FreeElement(FBlock);
  AddElement(aBlock);
  FBlock:=aBlock;
 end;

procedure TWhileLine.DoIt;
var TmpRes:TTypeElement;
 begin
  {try}
  Expression.DoIt;
  TmpRes:=TTypeElement(Expression.Output);
  if (TmpRes=nil)or(TmpRes.Typ<>_boolean) then {raise};
  while (TmpRes as TBooleanElement).value do
    begin
    Expression.CleanData;
    Block.Doit;
    Expression.DoIt;
    TmpRes:=TTypeElement(Expression.Output);
    if (TmpRes=nil)or(TmpRes.Typ<>_boolean) then {raise};
    end;
  {except}
  Expression.CleanData;
 end;

{REPEAT}
procedure TRepeatLine.DoIt;
var TmpRes:TTypeElement;
    NotFirst:boolean;
 begin
  {try}
   NotFirst:=false;
   repeat
    if NotFirst then Expression.CleanData;
    NotFirst:=true;
    Block.Doit;
    Expression.DoIt;
    TmpRes:=TTypeElement(Expression.Output);
    if (TmpRes=nil)or(TmpRes.Typ<>_boolean) then {raise};
   until TBooleanElement(Tmpres).value;
  {except}
  Expression.CleanData;
 end;

{CASE}
 {function TCaseLine.GetBlock:TPrgLine;
 begin
  result:=FBlock;
 end;

procedure TCaseLine.SetBlock(aBlock:TPrgLine);
 begin
 if assigned(FBlock) then FreeElement(FBlock);
 AddElement(aBlock);
 FBlock:=aBlock;
 end;
  }
function TCaseLine.GetExp:TOperator;
 begin
 result:=FExpression;
 end;

procedure TCaseLine.SetExp(aExp:TOperator);
 begin
 if assigned(FExpression) then FreeElement(FExpression);
 AddElement(aExp);
 FExpression:=aExp;
 end;

procedure TCaseLine.SetCaseList(aList:TEntity);
 begin
 if assigned(FCaseList) then FreeElement(FCaseList);
 AddElement(aList);
 FCaseList:=aList;
 end;

function TCaseLine.GetCaseList:TEntity;
 begin
 if not assigned(FCaseList) then
   begin
   FCaseList:=TEntity.create;
   AddElement(FCaseList);
   end;
 result:=FCaseList;
 end;

procedure TCaseLine.SetCaseItem(index:integer;Item:TTypeElement);
 begin
 if CaseList.Count>index then
  begin
  CaseList.InsertElement(index,Item);
  CaseList.FreeElement(CaseList.Elements[index+1]);
  end
  else
  CaseList.AddElement(Item);
 end;

function TCaseLine.GetcaseItem(index:integer):TTypeElement;
 begin
 result:=TTypeElement(CaseList.Elements[index]);
 end;

procedure TCaseLine.SetBlockList(aList:TEntity);
 begin
 if assigned(FBlockList) then FreeElement(FBlockList);
 AddElement(aList);
 FBlockList:=aList;
 end;

function TCaseLine.GetBlockList:TEntity;
 begin
  if not assigned(FBlockList) then
   begin
   FBlockList:=TEntity.create;
   AddElement(FBlockList);
   end;
 result:=FBlockList;
 end;

procedure TCaseLine.SetBlockItem(index:integer;Item:TPrgLine);
 begin
 if BlockList.Count>index then
  begin
  BlockList.InsertElement(index,Item);
  BlockList.FreeElement(BlockList.Elements[index+1]);
  end
  else BlockList.AddElement(Item);
 end;

function TCaseLine.GetBlockItem(index:integer):TPrgLine;
 begin
 result:=TPrgLine(BlockList.Elements[index]);
 end;

function TCaseLine.GetElseBlock:TPrgLine;
 begin
  result:=FElseBlock;
 end;

procedure TCaseLine.SetElseBlock(aBlock:TPrgLine);
 begin
  if assigned(FElseBlock) then FreeElement(FElseBlock);
  AddElement(aBlock);
  FElseBlock:=aBlock;
 end;

procedure TCaseline.DoIt;
var i:longint;
    GoOn:boolean;
    TmpObj:TTypeElement;
    Res:TTypeElement;
    CanCompare,Equal:boolean;
 begin
 i:=0;
 GoOn:=true;
 CanCompare := false;
 Expression.Doit;
 Res:=TTypeElement(Expression.Output);
 if Res.Typ in [_byte,_char,_integer,_float,_string,_boolean] then
 begin
 while (i < CaseList.Count)and GoOn do
  begin
  TmpObj:=CaseItem[i];
  case TmpObj.typ of
       _boolean:CanCompare:=Res.Typ=_boolean;
       _char,_string:CanCompare:=Res.Typ in [_char,_string];
       _integer,_float:CanCompare:=Res.Typ in [_integer,_float];
       end;
  if CanCompare then
     begin
     Equal:=false;
     case TmpObj.typ of
       _boolean:Equal:=Res.Asboolean=TmpObj.AsBoolean;
       _char,_string:Equal:=Res.AsString=TmpObj.AsString;
       _integer,_float:Equal:=Res.AsFloat=TmpObj.AsFloat;
       end;
     if Equal then if BlockItem[i]<>nil then
          begin
          BlockItem[i].DoIt;
          GoOn:=false;
         end
         else {raise vnitrni chba} ;
     end;
  inc(i);
  end;
  if GoOn then if ElseBlock<>nil then ElseBlock.DoIt;
  end else {raise spatny typ pro case};
  if Res.OwnersCount=0 then Res.Free;
 end;

{TCaller}
function TCaller.GetCalls:TEntity;
   begin
   if not assigned(FCalls) then
      begin
      FCalls:=TEntity.create;
      AddElement(FCalls);
      end;
   result:=FCalls;
   end;

procedure TCaller.SetCalls(aList:TEntity);
   begin
   if assigned(FCalls) then FreeElement(FCalls);
   AddElement(aList);
   FCalls:=alist;
   end;

function TCaller.GetCalledVar(index:integer):TOperator;
   begin
   result:=TOperator(Calls.Elements[index]);
   end;

procedure TCaller.SetCalledVar(index:integer;aVar:TOperator);
   begin
   if Calls.Count>index then
      begin
      Calls.InsertElement(index,aVar);
      Calls.FreeElement(Calls.Elements[index+1]);
      end
      else Calls.AddElement(aVar);
   end;

{TProcCaller}
procedure TProcCaller.DoIt;
var i,k:longint;
    aOper:TOperator;
   begin
   Proc.Stack:=Stack;
   Proc.StackIndex:=Stack.Count;
   if References>0 then
      for i:=0 to References-1 do
       Variable[Stack.Count]:=TPointerElement.CreateValue(CalledVar[i]);
   if References<Calls.Count then
      for k:=i to Calls.Count-1 do
       begin
       aOper:=CalledVar[k];
       aOper.DoIt;
       Variable[Stack.Count]:=TTypeElement(aOper.Output);
       end;
   Proc.DoIt;
   for k:=0 to i do Stack.FreeElement(Variable[Stack.Count-1]);
   end;

function TProcCaller.GetProc:TOilProc;
   begin
   result:=FProc;
   end;

procedure TProcCaller.SetProc(aProc:TOilProc);
   begin
   if assigned(FProc) then FreeElement(FProc);
   AddElement(aProc);
   FProc:=aProc;
   end;

{TOilProc}
function TOilProc.GetVarInfoList:TEntity;
    begin
    if not assigned(FVarInfoList) then
       begin
       FVarInfoList:=TEntity.Create;
       AddElement(FVarInfoList);
       end;
    result:=FVarInfoList;
    end;

procedure TOilProc.SetVarInfoList(aList:TEntity);
    begin
    if assigned(FVarInfoList) then FreeElement(FVarInfoList);
    FVarInfoList:=aList;
    AddElement(FVarInfoList);
    end;


function TOilProc.GetVarType(index:byte):TType;
   begin
   result:=TVarinfo(VarInfoList.Elements[index]).VarType;
   end;

procedure TOilProc.SetVarType(index:byte;aType:TType);
   begin
   TVarinfo(VarInfoList.Elements[index]).VarType:=aType;
   end;

function TOilProc.GetVarName(index:byte):string;
   begin
   result:=TVarinfo(VarInfoList.Elements[index]).VarName;
   end;

procedure TOilProc.SetVarName(index:byte;aName:string);
   begin
   TVarinfo(VarInfoList.Elements[index]).VarName:=aName;
   end;


procedure TOilProc.Create_Vars_In_Stack;
var i:integer;
    aVar:TPointerElement;
   begin
   if VarNumber>0 then for i:=0 to VarNumber-1 do
      begin
      case VarType[i] of {mozna, ze je count+1}
            _Boolean:Stack.AddElement(TBooleanElement.CreateValue(false));
            _Char:Stack.AddElement(TCharElement.CreateValue(#0));
            _Byte:Stack.AddElement(TByteElement.CreateValue(0));
            _Float:Stack.AddElement(TFloatElement.CreateValue(0));
            _String:Stack.AddElement(TStringElement.CreateValue(''));
            _Integer:Stack.AddElement(TIntegerElement.CreateValue(0));
            _Pointer:begin
                     aVar:=TPointerElement.Create;
                     aVar.aClassName:=VarName[i];
                     Stack.AddElement(aVar);
                     {Variable[Stack.Count]:=aVar;}
                     end;
      end;{case}
      end;
   end;

procedure TOilProc.Destroy_Vars_In_Stack;
var i:integer;
   begin
   if VarNumber>0 then
    for i:=0 to VarNumber-1 do Stack.FreeElement(Variable[Stack.Count-1]);{mozna jen count}
   end;

procedure TOilProc.DoIt;
   begin
   {gotta finish it-preruseni chyb}
   Create_Vars_In_Stack;
   inherited DoIt;
   Destroy_Vars_In_Stack;
   end;

{TOilFunc}
procedure TOilFunc.Create_Vars_In_Stack;
   begin
   inherited Create_Vars_In_Stack;
      case FuncType of
            _Boolean:Variable[Stack.Count]:=TBooleanElement.CreateValue(false);
            _Char:Variable[Stack.Count]:=TCharElement.CreateValue(#0);
            _Byte:Variable[Stack.Count]:=TByteElement.CreateValue(0);
            _Float:Variable[Stack.Count]:=TFloatElement.CreateValue(0);
            _String:Variable[Stack.Count]:=TStringElement.CreateValue('');
            _Integer:Variable[Stack.Count]:=TIntegerElement.CreateValue(0);
            _Pointer:Variable[Stack.Count]:=TPointerElement.Create;
      end;{case}
   end;

procedure TOilFunc.Destroy_Vars_In_Stack;
var i:integer;
   begin
   if VarNumber>0 then
    for i:=0 to VarNumber-1 do Stack.FreeElement(Variable[Stack.Count-2]);{mozna jen count-1}
   end;

{TFunctionCaller}
function TFunctionCaller.GetFunc:TOilFunc;
   begin
   result:=FFunc;
   end;

procedure TFunctionCaller.SetFunc(aFunc:TOilFunc);
   begin
   if assigned(FFunc) then FreeElement(FFunc);
   AddElement(aFunc);
   FFunc:=aFunc;
   end;

procedure TFunctionCaller.DoIt;
var i,k:longint;
    aOper:TOperator;
   begin
   Func.Stack:=Stack;
   Func.StackIndex:=Func.Count;
   if References>0 then
      for i:=0 to References-1 do
       Variable[Stack.Count]:=TPointerElement.CreateValue(CalledVar[i]);
   if References<Calls.Count then
      for k:=i to Calls.Count-1 do
       begin
       aOper:=CalledVar[k];
       aOper.DoIt;
       Variable[Stack.Count]:=TTypeElement(aOper.Output);
       end;
   Func.DoIt;
   for k:=0 to i do Stack.FreeElement(Variable[Stack.Count-2]);
   end;

procedure TFunctionCaller.ReleaseResult;
   begin
   Stack.RemoveElement(Variable[Stack.Count-1]);
   end;

function TFunctionCaller.GetResult:TTypeElement;
   begin
   result:=Variable[Stack.Count-1];
   end;

{TFunctionOperator}
function TFunctionOperator.GetCaller:TFunctionCaller;
   begin
   result:=FCaller;
   end;

procedure TFunctionOperator.SetCaller(aCaller:TFunctionCaller);
   begin
   if assigned(FCaller) then FreeElement(FCaller);
   AddElement(aCaller);
   FCaller:=aCaller;
   end;

procedure TFunctionOperator.GetTypeInfo;
  var i:TType;
  begin
   new(FTypeList);
   For i:=_boolean to _other do TypeItem[i]:=false;
   if (Caller<>nil) and (Caller.Func<>nil) then TypeItem[Caller.Func.FuncType]:=true;
  end;

procedure TFunctionOperator.DoIt;
   begin
    inherited DoIt;
    Caller.DoIt;
    Output:=Caller.GetResult;
    Caller.ReleaseResult;
   end;


{TProgram}
procedure TProgram.DoIt;
var i:longint;
    PE:TPointerElement;
begin
StackIndex:=0;
Create_Vars_In_Stack;
PE:=TPointerElement.CreateValue(World);
PE.Name:='TELEMENT';
Variable[WorldIndex]:=PE;
PE:=TPointerElement.CreateValue(World.MainTool);
PE.Name:='TTOOL';
Variable[MToolIndex]:=PE;
PE:=TPointerElement.CreateValue(World);
PE.Name:='TELEMENT';
Variable[ActiveElIndex]:=PE;
{ulozit world,acctivelemment a maintool}
if PrgLineList.Count>0 then
   for i:=0 to PrgLinelist.Count-1 do if PrgLine[i]<>nil then
    PrgLine[i].DoIt;
Destroy_Vars_In_Stack;
end;

procedure TProgram.SetProcList(aList:TEntity);
 begin
  if assigned(FProcedureList) then FreeElement(FProcedureList);
  AddElement(aList);
  FProcedureList:=aList;
 end;

function TProgram.GetProcList:TEntity;
 begin
 if not assigned(FProcedureList) then
   begin
   FProcedureList:=TEntity.create;
   AddElement(FProcedureList);
   end;
  result:=FProcedureList;
 end;

end.

