unit T_ptt;

interface
uses
// KERNEL
   Classes,
   Elements,
// INTEREPRET
   i_Basic;

type

TPropertiesToListTool = class(TInterpret)
private
   FList: TStringList;
   function GetList: TStringList;
   procedure SetList(aValue: TStringList);
protected
   procedure Process(Element: TElement); override;
public
   destructor Destroy; override;
published
   property  List: TStringList read GetList write SetList;
end;

TPropertiesToTextTool = class(TPropertiesToListTool)
private
   FFileName: string;
protected
   procedure DoIt; override;
published
   property  FileName: string read FFileName write FFileName;
end;


implementation

uses
// KERNEL
   e_Class,
   u_Props;

{ TPropertiesToListTool }

function   TPropertiesToListTool.GetList: TStringList;
begin
   if FList = nil then FList := TStringList.Create;
   result := FList;
end;

procedure  TPropertiesToListTool.SetList(aValue: TStringList);
begin
   List.Clear;
   List.Assign(aValue);
end;

procedure  TPropertiesToListTool.Process(Element: TElement);
var
   S: string;
   i: longInt;
   E: TElement;
   IsClass: boolean;
begin
   S := '';
   S := Element.Name;
   List.Add(S);
   IsClass := Element is TOrbisClass;
   if IsClass and (TOrbisClass(Element).ElementClass = nil) then exit;
   if IsClass then E := TOrbisClass(Element).ElementClass.Create
              else E := Element;
   for i := 0 to GetPropCount(E) - 1 do
   begin
      S := #9 + GetPropName(E, i);
      List.Add(S);
   end;
   if IsClass then E.Free;
end;

destructor TPropertiesToListTool.Destroy;
begin
  List.Free;
  inherited destroy
end;


{ TPropertiesToTextTool }

procedure TPropertiesToTextTool.DoIt;
begin
   inherited DoIt;
   if FileName <> '' then List.SaveToFile(FileName);
end;

BEGIN
   RegisterOrbisClass(TPropertiesToListTool);
   RegisterOrbisClass(TPropertiesToTextTool);
END.
