unit t_KontrolyByTam;

interface
uses
   IniFiles,
   Elements,
   e_IModel,
   e_INode,
   e_Type,
   t_DirectoryHCHeck,
   Tools;

type

TKontrolyByTam = class(TTool)
  private
    FFileName: string;
    FTam: TOwnerEntity;
    FPaletaKontrol: TInterpretModelEntity;
    FDirs: TDirectoryHCheckNode;
    procedure SetFileName(const Value: string);
    function Getkontroly: TInterpretNodeEntity;
    procedure SetTAM(const Value: TOwnerEntity);
    procedure SetPaletaKontrol(const Value: TInterpretModelEntity);
    procedure SetDirs(const Value: TDirectoryHCheckNode);
public
   procedure DoIt; override;
   procedure Processlayer(aLayerID: string);
   function  FindTAMGroups(aID: string): TEntity;
   function  TAMSection(aID: string): TStringListElement;
   Property  TAM: TOwnerEntity read FTAM write SetTAM;
   property  Dirs: TDirectoryHCheckNode read FDirs write SetDirs;
published
   property Kontroly: TInterpretNodeEntity read Getkontroly;
   property PaletaKontrol: TInterpretModelEntity read FPaletaKontrol write SetPaletaKontrol;
   property FileName: string read FFileName write SetFileName;
end;

implementation
uses
   Classes,
   Dialogs,
   Forms,
   SysUtils,
   m_Orbis,
   e_ElementModel,
   e_HierTempl,
   t_Loader,
   u_String,
   Worlds;



{ TKontrolyByTam }

procedure TKontrolyByTam.DoIt;
var
   Layers: TStringList;
   LayersID: string;
   LayerID: string;
   i,j: integer;
   S,S1: string;
   SL: TStringListElement;
   INE,INE1: TInterpretNodeEntity;
   E: TElement;
   L: TLoad;
   N: TInterpretNode;
   HT: THierarchyTemplate;
begin
   if not FileExists(FileName) then
   begin
      ShowMessage('Soubor TAM: '+FileName+' neexistuje !');
      exit;
   end;
   if PaletaKontrol = nil then
   begin
      ShowMessage('Paleta kontrol chyb !');
      exit;
   end;
   {
   FTAM := TIniFile.Create(FileName);
   LayersID := TAM.ReadString('0','LyL','1');
   Layers := TStringList.Create;
   TAM.ReadSectionValues(LayersID,Layers);
   for i := 0 to Layers.Count - 1 do
   begin
      S := Layers.Strings[i];
      StringAsTwoParams(S,',',S,LayerID);
      ProcessLayer(LayerID);
   end;
   FTAM.Free;
   }
   Layers := TstringList.Create;
   Layers.LoadFromFile(FileName);
   StartProgress('Kontroly dle TAMu: '+FileName,0,Layers.Count-1);
   ProgressText := 'Analza...';
   TAM := TOwnerEntity.Create;
   TAM.Name := FileName;
   World.ObjectModel.NextElement := TAM;
   SL := nil;
   for i := 0 to Layers.Count - 1 do
   begin
      S := Layers.Strings[i];
      if S = '' then continue;
      if S[1]='[' then
      begin
                SL := TStringListElement.Create;
         SL.Name := S;
         TAM.AddElement(SL);
         Progress := i;
         ProgressText := 'Analza...'+S;
         Application.ProcessMessages;
      end
      else
      begin
         if SL <> nil then
            SL.AddNameIsValue(S);
      end;
   end;
   Progress := 0;
   Application.ProcessMessages;
   Layers.Free;
   // zkladn sekce
   SL := TAMSection('0');
   if SL = nil then exit;
   LayersID := SL.GetStringByName('LyL');
   // Sekce vrstev
   SL := TAMSection(LayersID);
   if SL = nil then exit;
   Output := TInterpretNodeEntity.Create;
   Kontroly.Name := 'Kontrola dle TAMu: '+ ExtractFileName(FileName);
   Kontroly.Version := PaletaKontrol.Version;
   // rozebrn jednotlivch vrstev a jejich zpracovn
   Dirs := TDirectoryHCheckNode.Create;
   Dirs.Name := 'Adresov struktura';
   MaxProgress := SL.LastIndex;
   for i := 0 to SL.LastIndex do
   begin
      S := SL.Strings[i];
      StringAsTwoParams(S,',',S,LayerID);
      Progress := i;
      ProcessLayer(LayerID);
   end;
   Kontroly.AddElement(Dirs);
   //PODFUK
   (*
   S := ExtractFilePath(ParamStr(0));
   CHeckBackSlash(S);
   S := S+'OPRL.ORB';
   ProgressText := 'Pprava ablony...';
   Application.ProcessMessages;
   L := TLoad.Create;
   L.FileName := S;
   L.DoIt;
   INE := Kontroly;
   INE1 := TInterpretNodeEntity(L.Output);
   Output := TInterpretNodeEntity.Create;
   Kontroly.Name := INE.Name;
   Kontroly.Version := PaletaKontrol.Version;
   Dirs := TDirectoryHCheckNode.Create;
   Dirs.Name := 'Adresov struktura OPRL';
   MaxProgress := 1000;
   Application.ProcessMessages;
   for i := 0 to INE.LastIndex do
   begin
      N := INE.InterpretNode[i];
      S := N.Name;
      HT := THierarchyTemplate.Create;
      HT.Name := S;
      Dirs.Template.AddElement(HT);
      StringAsTwoParams(S,'.',S,S1);
      S1 := 'Finalizace kontroly pro vrstvu ' + S;
      ProgressText := S1;
      Application.ProcessMessages;
      E := INE1.FindElementName(S);
      Kontroly.AddElement(E);
      E := INE1.FindElementName(S+' - zaplochovn');
      Kontroly.AddElement(E);
      for j := 0 to 1000 do
      begin
         Progress := j;
         Application.ProcessMessages;
      end;
   end;
   ProgressText := S1 + ' + adresov struktura .... a';
   Application.ProcessMessages;
   Kontroly.AddElement(Dirs);
   ProgressText := ' HOTOVO !';
   Application.ProcessMessages;
   INE.Free;
   INE1.Free;
   L.Free;
   *)
   //PODFUK END
end;

function TKontrolyByTam.FindTAMGroups(aID: string): TEntity;
var
   SL,SLG,DBSL,DFSL,FSL: TStringListElement;
   SE: TStringElement;
   GroupID: string;
   DBFID: string;
   S,S1: string;
   i,j: integer;
   Smi: SmallInt;
   GE,DBE: TOwnerEntity;
begin
   result := TOwnerEntity.Create;
   SL := TAMSection(aID);
   if SL = nil then exit;
   for i := 0 to SL.LastIndex do
   begin
      S := SL.Strings[i];
      StringAsTwoParams(S,',',S,GroupID);
      // GroupSet
      SLG := TAMSection(GroupID);
      S := SLG.GetStringByName('Grp');
      // Group definition
      SLG := TAMSection(S);
      GE := TOwnerEntity.Create;
      result.AddElement(GE);
      GE.Name := SLG.GetStringByName('Grc');
      // Barva
      SE := TStringElement.Create;
      SE.Name := 'COLOR';
      SE.Value := SLG.GetStringByName('RGB');
      SE.AsInteger := SmallInt(SE.AsInteger);
      GE.AddElement(SE);
      // Znacka
      SE := TStringElement.Create;
      SE.Name := 'SYMBOL';
      SE.Value := SLG.GetStringByName('Smb');
      GE.AddElement(SE);
      // DBF
      DBFID := SLG.GetStringByName('DbF');
      if DBFID = '' then continue;
      DBE := TOwnerEntity.Create;
      DBE.Name := 'DBF';
      GE.AddElement(DBE);
      DBSL := TAMSection(DBFID);
      for j := 0 to DBSL.LastIndex do
      begin
         S := DBSL.Strings[j];
         StringAsTwoParams(S,',',S,S1);
         DFSL := TAMSection(S1);
         FSL := TStringListElement.Create;
         DBE.AddElement(FSL);
         FSL.Name := DFSL.GetStringByName('Nam');
         if S = 'TStringDbField' then
         begin
            FSL.AddNameString('T','C');
            FSL.AddNameString('S',DFSL.GetStringByName('ChC'));
            FSL.AddNameString('D','0');
         end
         else
         if S = 'TIntegerDbField' then
         begin
            FSL.AddNameString('T','N');
            FSL.AddNameString('S',DFSL.GetStringByName('ChC'));
            FSL.AddNameString('D','0');
         end
         else
         if S = 'TDoubleDbField' then
         begin
            FSL.AddNameString('T','N');
            FSL.AddNameString('S',DFSL.GetStringByName('ChC'));
            FSL.AddNameString('D',DFSL.GetStringByName('DcP'));
         end
         else
         if S = 'TBooleanDbField' then
         begin
            FSL.AddNameString('T','L');
            FSL.AddNameString('S','1');
            FSL.AddNameString('D','0');
         end
         else
          { TODO -oppk -crevizor : Zrevidovat datov field }
         if S = 'TDateDbField' then
         begin
            FSL.AddNameString('T','D');
            FSL.AddNameString('S','1');
            FSL.AddNameString('D','0');
            {
            FSL.AddNameString('S',DFSL.GetStringByName('ChC'));
            FSL.AddNameString('D',DFSL.GetStringByName('DcP'));
            }
         end;
      end;
   end;
end;

function TKontrolyByTam.Getkontroly: TInterpretNodeEntity;
begin
   result := TInterpretNodeEntity(Output);
end;

procedure TKontrolyByTam.Processlayer(aLayerID: string);
var
   SL,SLG,DBSL: TStringListElement;
   N,NZap,NDB: TInterpretNode;
   Nam: string;
   LinID: string;
   AreID: string;
   PntID: string;
   TxtID: string;
   S,S1,DBFName,SDB,S1DB: string;
   IM,IM1,IMDB,IM1DB: TInterpretModel;
   i,j: integer;
   E,GE: TEntity;
   IsDB: boolean;
   HT: THierarchyTemplate;

function CreateDBFName(aTyp: Char; aDruh: string): string;
var
   i: integer;
   S0: string;
begin
   i := Length(aDruh);
   S0 := StringOfChar('0',4-i);
   result := aTyp + S0 + aDruh +'.DBF';
end;

begin
   SL := TAMSection(aLayerID);
   if SL = nil then exit;
   N := TInterpretNode.Create;
   Kontroly.NextElement := N;
   Nam := SL.GetStringByName('Nam');
   N.Name := Nam;
   HT := THierarchyTemplate.Create;
   HT.Name := Nam;
   Dirs.Template.AddElement(HT);
   ProgressText := 'Layer:'+Nam;
   //PostTextMsg(tm_AddToProtocol,aLayerID+' Layer: '+SL.GetStringByName('Nam'),nil);
   Application.ProcessMessages;
   // Vytvoen datovho modelu:
   N.DataModel := TStringListElement.Create;
   N.InterpretModel := TInterpretModelEntity.Create;
   LinID := SL.GetStringByName('Ln');
   AreID := SL.GetStringByName('Ar');
   PntID := SL.GetStringByName('Pn');
   TxtID := SL.GetStringByName('Tx');

   // Kontroly ploch
   S := 'Kontroly ploch';
   N.DataModel.NextNameIsValue := 'ARE=+'+Nam;
   IM := TInterpretModel(PaletaKontrol.Element[S]);
   N.InterpretModel.ModelToAdd := IM;
   IM := TInterpretModel(N.InterpretModel.FindElementName(S));
try
   if AreID <> '' then
   begin
      //zaplochovn BEGIN
      NZap := TInterpretNode.Create;
      Kontroly.NextElement := NZap;
      NZap.Name := Nam+ '-zaplochovn';
      NZap.DataModel := TStringListElement.Create;
      NZap.InterpretModel := TInterpretModelEntity.Create;
         // data model
      NZap.DataModel.NextNameIsValue := 'LIN=+'+Nam;
      NZap.DataModel.NextNameIsValue := 'ARE=+'+Nam;
         // interpret model
      IM1 := TInterpretModel(PaletaKontrol.Element['Kontrola zaplochovn']);
      NZap.InterpretModel.ModelToAdd := IM1;
      //zaplochovn END
      // Druhy
      //IM := TInterpretModel(TInterpretModel(PaletaKontrol.Element['Kontroly ploch']).Submodels.Element['Druhy ploch']);
      E := FindTamGroups(AreID);
      // Druhy
      IM1 := TInterpretModel(IM.Submodels.Element['Druhy ploch']);
      S := '';
      S1 := '';
      IsDB := false;
      for i := 0 to E.LastIndex do
      begin
         GE := TEntity(E.Elements[i]);
         if i > 0 then S := S + ',';
         S := S + GE.Name;
         if GE.FindElementName('DBF') = nil then
         begin
            if GE.Name <> '134' then
            begin
               S1 := S1+'(DRUH=' + GE.Name + ') OR ';
            end;
         end
         else
         begin
            IsDB := True;
            DBFName := CreateDBFName('P',GE.Name);
            NDB := TInterpretNode.Create;
            Kontroly.NextElement := NDB;
            NDB.Name := Nam+ '-'+DBFName;
            NDB.DataModel := TStringListElement.Create;
            NDB.InterpretModel := TInterpretModelEntity.Create;
            NDB.DataModel.NextNameIsValue := 'TAB=+'+DBFName;
            GE := TEntity(GE.FindElementName('DBF'));
            for j := 0 to GE.LastIndex do
            begin
               SDB := 'Kontrola tabulky - ';
               S1DB := 'Struktura poloky - ';
               DBSL := TStringListElement(GE.Elements[j]);
               IM1DB := TInterpretModel(TInterpretModel(PaletaKontrol.Element[SDB]).Submodels.Element[S1DB]);
               NDB.InterpretModel.ModelToAdd := IM1DB;
               IMDB := TInterpretModel(NDB.InterpretModel.FindElementName(SDB));
               IM1DB := TInterpretModel(IMDB.Submodels.Element[S1DB]);
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldName')).Value := DBSL.Name;
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldType')).Value := DBSL.GetStringByName('T');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldSize')).Value := DBSL.GetStringByName('S');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldDec')).Value := DBSL.GetStringByName('D');
            end;
            TPropertyModel(IMDB.PropertyModels.FindElementName('TableName')).Value := DBFName;
         end;
      end;
      TPropertyModel(IM1.PropertyModels.FindElementName('ValuesString')).Value := S;
      IM1 := TInterpretModel(IM.Submodels.Element['Grafick a DB plocha']);
      if not IsDB then
         IM1.Free
      else
      begin
         S := TPropertyModel(IM1.PropertyModels.FindElementName('TestCondition')).Value;
         TPropertyModel(IM1.PropertyModels.FindElementName('TestCondition')).Value := S1+S;
      end;
      // vyhzen blbost
      IM.Submodels.Element['G plocha a VYMERA'].Free;
      IM.Submodels.Element['Znacka - KOD_SRF'].Free;
      E.Free; // ruen pomocn entity
      //World.ObjectModel.NextElement := E;
   end
else
   IM.FreeAll;
except
   PostTextMsg(tm_AddToProtocol, aLayerID+' '+Nam+' ARE '+AREID,nil);
end;
   // Kontroly lini
   S := 'Kontroly lini';
   N.DataModel.NextNameIsValue := 'LIN=+'+Nam;
   IM := TInterpretModel(PaletaKontrol.Element[S]);
   N.InterpretModel.ModelToAdd := IM;
   IM := TInterpretModel(N.InterpretModel.FindElementName(S));
try
   if LinID <> '' then
   begin
      // Druhy
      //IM := TInterpretModel(TInterpretModel(PaletaKontrol.Element['Kontroly lini']).SubModels.Element['Druhy lini']);

      E := FindTamGroups(LinID);
      // Druhy
      IM1 := TInterpretModel(IM.Submodels.Element['Druhy lini']);
      S := '';
      S1 := '';
      IsDB := false;
      for i := 0 to E.LastIndex do
      begin
         GE := TEntity(E.Elements[i]);
         if i > 0 then S := S + ',';
         S := S + GE.Name;
         if GE.FindElementName('DBF') <> nil then
         begin
            IsDB := True;
            DBFName := CreateDBFName('L',GE.Name);
            NDB := TInterpretNode.Create;
            Kontroly.NextElement := NDB;
            NDB.Name := Nam+ '-'+DBFName;
            NDB.DataModel := TStringListElement.Create;
            NDB.InterpretModel := TInterpretModelEntity.Create;
            NDB.DataModel.NextNameIsValue := 'TAB=+'+DBFName;
            GE := TEntity(GE.FindElementName('DBF'));
            for j := 0 to GE.LastIndex do
            begin
               SDB := 'Kontrola tabulky - ';
               S1DB := 'Struktura poloky - ';
               DBSL := TStringListElement(GE.Elements[j]);
               IM1DB := TInterpretModel(TInterpretModel(PaletaKontrol.Element[SDB]).Submodels.Element[S1DB]);
               NDB.InterpretModel.ModelToAdd := IM1DB;
               IMDB := TInterpretModel(NDB.InterpretModel.FindElementName(SDB));
               IM1DB := TInterpretModel(IMDB.Submodels.Element[S1DB]);
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldName')).Value := DBSL.Name;
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldType')).Value := DBSL.GetStringByName('T');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldSize')).Value := DBSL.GetStringByName('S');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldDec')).Value := DBSL.GetStringByName('D');
            end;
            TPropertyModel(IMDB.PropertyModels.FindElementName('TableName')).Value := DBFName;
         end;
      end;
      TPropertyModel(IM1.PropertyModels.FindElementName('ValuesString')).Value := S;
      // vyhzen blbost
      if AreID = '' then
         IM.Submodels.Element['Voln konce'].Free;
      IM.Submodels.Element['Maximln dlka linie'].Free;
      E.Free; // ruen pomocn entity

   end
   else
      IM.FreeAll;
except
   PostTextMsg(tm_AddToProtocol, aLayerID+' '+Nam+' LIN '+LINID,nil);
end;
   // Kontroly Bod
   S := 'Kontroly bod';
   N.DataModel.NextNameIsValue := 'PNT=+'+Nam;
   IM := TInterpretModel(PaletaKontrol.Element[S]);
   N.InterpretModel.ModelToAdd := IM;
   IM := TInterpretModel(N.InterpretModel.FindElementName(S));
try
   if PntID <> '' then
   begin
      // Druhy
      //IM := TInterpretModel(TInterpretModel(PaletaKontrol.Element['Kontroly bod']).SubModels.Element['Druhy bod']);

      E := FindTamGroups(PntID);
      // Druhy
      IM1 := TInterpretModel(IM.Submodels.Element['Druhy bod']);
      S := '';
      S1 := '';
      IsDB := false;
      for i := 0 to E.LastIndex do
      begin
         GE := TEntity(E.Elements[i]);
         if i > 0 then S := S + ',';
         S := S + GE.Name;
         if GE.FindElementName('DBF') <> nil then
         begin
            IsDB := True;
            DBFName := CreateDBFName('B',GE.Name);
            NDB := TInterpretNode.Create;
            Kontroly.NextElement := NDB;
            NDB.Name := Nam+ '-'+DBFName;
            NDB.DataModel := TStringListElement.Create;
            NDB.InterpretModel := TInterpretModelEntity.Create;
            NDB.DataModel.NextNameIsValue := 'TAB=+'+DBFName;
            GE := TEntity(GE.FindElementName('DBF'));
            for j := 0 to GE.LastIndex do
            begin
               SDB := 'Kontrola tabulky - ';
               S1DB := 'Struktura poloky - ';
               DBSL := TStringListElement(GE.Elements[j]);
               IM1DB := TInterpretModel(TInterpretModel(PaletaKontrol.Element[SDB]).Submodels.Element[S1DB]);
               NDB.InterpretModel.ModelToAdd := IM1DB;
               IMDB := TInterpretModel(NDB.InterpretModel.FindElementName(SDB));
               IM1DB := TInterpretModel(IMDB.Submodels.Element[S1DB]);
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldName')).Value := DBSL.Name;
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldType')).Value := DBSL.GetStringByName('T');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldSize')).Value := DBSL.GetStringByName('S');
               TPropertyModel(IM1DB.PropertyModels.FindElementName('FieldDec')).Value := DBSL.GetStringByName('D');
            end;
            TPropertyModel(IMDB.PropertyModels.FindElementName('TableName')).Value := DBFName;
         end;
      end;
      TPropertyModel(IM1.PropertyModels.FindElementName('ValuesString')).Value := S;
      // vyhzen blbost
      IM.Submodels.Element['Vzdlenost plsluek od DET linie'].Free;
      IM.Submodels.Element['Vzdlenost sluek od SLU linie'].Free;
      E.Free; // ruen pomocn entity
   end
   else
      IM.FreeAll;
except
   PostTextMsg(tm_AddToProtocol, aLayerID+' '+Nam+' PNT '+PNTID,nil);
end;

   S := 'Kontroly text';
   N.DataModel.NextNameIsValue := 'TXT=+'+Nam;
   IM := TInterpretModel(PaletaKontrol.Element[S]);
   N.InterpretModel.ModelToAdd := IM;
   IM := TInterpretModel(N.InterpretModel.FindElementName(S));
try
   if TxtID <> '' then
   begin
      E := FindTamGroups(TxtID);
      // Druhy
      IM1 := TInterpretModel(IM.Submodels.Element['Druhy text']);
      S := '';
      for i := 0 to E.LastIndex do
      begin
         if i > 0 then S := S + ',';
         S := S + E.Elements[i].Name;
      end;
      TPropertyModel(IM1.PropertyModels.FindElementName('ValuesString')).Value := S;
      E.Free; // ruen pomocn entity
   end
   else
      IM.FreeAll;
except
   PostTextMsg(tm_AddToProtocol, aLayerID+' '+Nam+' TXT '+TXTID,nil);
end;
end;

procedure TKontrolyByTam.SetDirs(const Value: TDirectoryHCheckNode);
begin
  FDirs := Value;
end;

procedure TKontrolyByTam.SetFileName(const Value: string);
begin
  FFileName := Value;
end;

procedure TKontrolyByTam.SetPaletaKontrol(
  const Value: TInterpretModelEntity);
begin
   FPaletaKontrol := Value;
end;

procedure TKontrolyByTam.SetTAM(const Value: TOwnerEntity);
begin
  FTAM := Value;
end;

function TKontrolyByTam.TAMSection(aID: string): TStringListElement;
begin
   result := TStringListElement(TAM.FindElementName('['+aID+']'));
end;

end.
