unit E_ShpPrp;

interface
uses
  DBTables, DB,
// KERNEL
  Elements,
// GLIB
  G_Elems,
// SPACE  
  E_Space,
  E_SpaPrp,
  C_ShpDBF;



Type

  TCodePage = (cpIBM, cpLatin2, cpKamenickych);

  TShapeProps = class(TSpaceEntityProps)
  private
    FRecNo:    longInt;
    FShapeType: longInt;
    FDone:      boolean;
    FBarva, FZnacka: smallInt;
    function   GetObjectsOwner: TSpaceEntityString; virtual; abstract;
    function   GetDBFName: string; virtual;
{ TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
    function   GetDBFTable: TDataSet; virtual;
  protected
    function   GetSpaceID: longInt; override;
  public
    function  HasDBFItem(aItem: string): boolean; override;
    function   GetDBFFieldAsString(aItem: string): string; override;
    procedure  SetDBFFieldAsString(aItem, aValue: string); override;
    function  SetDBFRecord: boolean; override;
    procedure SetPropertyStringByName(AName: string; aValue: string); override;
    property   ObjectOwner: TSpaceEntityString read GetObjectsOwner;
  published
    property ShapeType: longInt read FShapeType write FShapeType;
    property RecNo:    longInt read FRecNo   write FRecNo stored true;
    property OrigNo:   longInt read GetOrigNo stored false;
    property IsDone: boolean   read FDone     write FDone stored false default false;
    property Barva: smallInt read FBarva write FBarva;
    property Znacka: smallInt read FZnacka write FZnacka;

    property DBFName:  string read GetDBFName stored false;
    property DBFTable: TDataSet read GetDBFTable stored false;
  end;




implementation
uses
  SysUtils,
  e_Class,
  U_Props, E_Reg
{$IFDEF Databaze}
{$ENDIF}
  ;



                 { TTopolProps }




function TShapeProps.GetDBFName: string;
var
  aName: string;
  aProps: TSpaceEntityProps;
begin
  result:= '';
  aProps:= GetOrigProps;
  if not (aProps is TShapeProps) then exit;
  aName:= GetBlockName;
  if aName = '' then exit;
  result:= ChangeFileExt(aName, '.DBF');
end;





function TShapeProps.HasDBFItem(aItem: string): boolean;
var
  aDBFName: string;
begin
  result:= false;
  aDBFName:= GetDBFName;

  if TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).SetForName(aDBFName) then
     result:= TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).FieldExists(aItem);
end;




function TShapeProps.SetDBFRecord: boolean;
var
  aDBFName: string;
begin
  aDBFName:= GetDBFName;
  result := TShapeDBFTable(ObjectRegister.DBF).SetForNameRecNo(aDBFName, RecNo);
end;



function TShapeProps.GetDBFFieldAsString(aItem: string): string;
begin
 result:= TShapeDBFTable(ObjectRegister.DBF).GetFieldAsString(aItem);
end;


procedure TShapeProps.SetDBFFieldAsString(aItem, aValue: string);
begin
  TShapeDBFTable(ObjectRegister.DBF).SetFieldAsString(aItem, aValue);
end;



procedure   TShapeProps.SetPropertyStringByName(AName: string; aValue: string);
var
  aDBFName: string;
begin
  if GetPropIndex(Self, aName) > -1 then
  begin
     inherited SetPropertyStringByName(aName, aValue);
     exit;
  end;
  try
    if ObjectRegister = nil then exit;
{$IFDEF Databaze}
    aDBFName:= GetDBFName;
    TShapeDBFTable(TObjectRegister(ObjectRegister).DBF).SetForNameRecNo(aDBFName, RecNo);
{$ENDIF}
  except
  end;
end;


function  TShapeProps.GetSpaceID: longInt;
begin
  result:= RecNo
end;





function  TShapeProps.GetDBFTable: TDataSet;
begin
  result:= nil;
  if not (TElement(ObjectRegister) is TObjectRegister) then exit;

  result:= TObjectRegister(ObjectRegister).DBF;
end;




initialization
   RegisterOrbisClass(TShapeProps);
end.

