unit T_SpOper;

interface

uses
  Elements, Tools, E_Space, E_QTree, G_Elems,
  T_ToTool;


type
  TSpaceStringToQTree = class(TTool)
  { Input: entita SpaceEntit,
    Output: TSpaceEntityQTree }

  public
    procedure DoIt; override;
  end;

  TSpOperInside = class(TTool)
  { Input: zkouman entita SpaceEntit
    Operand: entita SpaceEntit se kterou je porovnvno
    OperandQTree: ppadn ptomn QTree pro operand aby se nemuselo pokad vyrbt
    Output: entita vybranch SpaceEntit vyhovujcch prniku }
  private
    FOperand: TEntity;
    FQTree  : TSpaceEntityQTree;
    procedure AddToOutput(aRect: TRectEntity);
  public
    procedure DoIt; override;
  published
    property Operand: TEntity read FOperand write FOperand;
    property OperandQTree: TSpaceEntityQTree read FQtree write FQTree;
  end;


TAreasToQTree = class(TProchazecPlochGauge)
public
  procedure  Process(aElement: TElement); override;
  procedure  DoIt; override;
end;

TAreaToAreaAndLines = class(TTool)
public
   procedure  DoIt; override;
end;


implementation
uses
  e_Class,
  T_QTFind;


procedure TAreaToAreaAndLines.DoIt;
var
   E: TRectEntity;
   A: TAreaElement;
   i: longInt;
begin
   if not (Input is TAreaElement) then exit;
   A := TAreaElement(Input);
   E := TRectEntity.Create;
   Output := E;
   E.AddAndUpdateRect(A);
   for i := 0 to A.Count-1 do
   begin
      E.AddAndUpdateRect(A.Elements[i]);
   end;
end;


procedure TSpaceStringToQTree.DoIt;
var
  SE: TSpaceEntity;
  I: longInt;
begin
  if not (Input is TEntity) then exit;
  output:= TSpaceEntityQTree.Create;
  for I:= 0 to TEntity(Input).Count-1 do
  begin
    SE:= TSpaceEntity(TEntity(Input).Elements[I]);
    if not (SE is TSpaceEntity) then continue;
    TSpaceEntityQTree(Output).NextSpaceEntity:= SE
  end;
end;



procedure TSpOperInside.AddToOutput(aRect: TRectEntity);
begin
  if Output = nil then
     Output:= TSpaceEntityString.Create;
  if Output = nil then exit;
  TSpaceEntityString(Output).AddAndUpdateRect(aRect);
end;



procedure TSpOperInside.DoIt;
var
  SSTQ: TSpaceStringToQTree;
  FFSE: TFindFirstSpaceEntityForXY;
  WasQTree: boolean;
  RE: TRectEntity;
  I: longInt;
begin
  Output:= nil;
  if not (Input is TEntity) then
     exit;
  if (not (Operand is TEntity)) and
     (not (OperandQTree is TSpaceEntityQTree)) then
      exit;

  WasQTree:= false;

  if OperandQTree = nil then
  begin
    SSTQ:= TSpaceStringToQTree.Create;
    SSTQ.Input:= Operand;
    SSTQ.DoIt;
    OperandQTree:= TSpaceEntityQTree(SSTQ.Output);
    SSTQ.Free
  end
  else
    WasQTree:= true;

  for I:= 0 to TEntity(Input).Count-1 do
  begin
    RE:= TRectEntity(TEntity(Input).Elements[I]);
    if not (RE is TRectEntity) then continue;

    FFSE:= TFindFirstSpaceEntityForXY.Create;
    FFSE.X:= RE.X;
    FFSE.Y:= RE.Y;
    FFSE.Input:= OperandQTree;
    FFSE.DoIt;
    if FFSE.Output <> nil then
       AddToOutput(RE);
    FFSE.Free;
  end;

  if not WasQTree then
     OperandQTree.Free
end;


              { TAreasToQTree }

procedure  TAreasToQTree.Process(aElement: TElement);
begin
  if not (aElement is TAreaElement) then exit;
  if TAreaElement(aElement).IsHole then exit;
  TSpaceEntityQTree(Output).NextSpaceEntity:= TAreaElement(aElement)
end;


procedure  TAreasToQTree.DoIt;
begin
  if not (input is TEntity) then exit;
  output:= TSpaceEntityQTree.Create;

  inherited DoIt;
end;



initialization
   RegisterOrbisClass(TSpaceStringToQTree);
   RegisterOrbisClass(TSpOperInside);
   RegisterOrbisClass(TAreasToQTree);
   RegisterOrbisClass(TAreaToAreaAndLines);
end.
