unit T_ToTool;

interface
uses
// KERNEL
  Elements,
  E_Type,
  Tools,
  T_Recurs,
// SPACE
  e_Geometry,
  e_Qtree;
  //E_Space,
// DIALOG
  //F_Gauge;


{
TProchazecObjektu
    TProchazecLinii
          TOznacLinie
          TProchazecLiniiGauge
                 TProchazecLiniiDleTridy
    TProchazecPloch
          TOznacPlochy
          TProchazecPlochGauge
                 TProchazecPlochDleTridy


}
type

TProchazecObjektu = class(TRecursor)
private
  FModulo: longInt;
  //F_gaugeForm: TF_gaugeForm;
  procedure   SendProtocolMessage(aMessage: string);
  procedure   SetGaugeCaption(aCaption: string);
public
  procedure GaugeMaxValue(aValue: longInt);
  procedure GaugeShow;
  procedure GaugeHide;
  procedure GaugeSetModulo(aModulo: longInt);
  procedure GaugeSet(PocetObjektu: longInt);

  constructor Create; override;
  destructor Destroy; override;
  procedure  DoIt; override;
published
  property GaugeCaption: string write SetGaugeCaption;
  property Protocol: string write SendProtocolMessage;
end;



TProchazecLinii = class(TProchazecObjektu)
public
  FPocetLinii: longInt;

  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
end;



TOznacLinie = class(TProchazecLinii)
  procedure Process(Element: TElement); override;
end;





TProchazecLiniiGauge = class(TProchazecLinii)
public
  procedure DoIt; override;
end;


TProchazecLiniiDleTridy = class(TProchazecLiniiGauge)
private
  procedure SetContainerClassByString(aName: string);
  function GetContainerClassAsString: string;
protected
  FClass: TClass;

public
    procedure SetContainerClass(aClass: TClass);
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
published
  property ContainerClass: string read GetContainerClassAsString write SetContainerClassByString;
end;


TProchazecPloch = class(TProchazecObjektu)
public
  FPocetPloch: longInt;

  function  QGoInside(Element: TElement): boolean; override;
  function  QProcessBefore(Element: TElement): boolean; override;
  procedure Process(Element: TElement); override;
end;




TOznacPlochy = class(TProchazecPloch)
  procedure Process(Element: TElement); override;
end;



TProchazecPlochGauge = class(TProchazecPloch)
public
  procedure DoIt; override;
end;


TProchazecPlochDleTridy = class(TProchazecPlochGauge)
protected
  FClass: TClass;
private
  procedure SetContainerClassByString(aName: string);
  function GetContainerClassAsString: string;
public
    procedure SetContainerClass(aClass: TClass);
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
published
  property ContainerClass: string read GetContainerClassAsString write SetContainerClassByString;
end;



THledacPloch = class(TProchazecPlochGauge)
private
  FIncludeHoles: boolean;
  FMinX, FMinY, FMaxX, FMaxY: double;
  FAreaString: TGeometry;
public
  procedure  SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
  procedure  Process(aElement: TElement); override;
  procedure  DoIt; override;
published
  property IncludeHoles: boolean read FIncludeHoles write FIncludeHoles;
end;





THledacLinii = class(TProchazecLiniiGauge)
  public
    FMinX, FMinY, FMaxX, FMaxY: double;
    NalezeneLinie: TGeometry;

    procedure  SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
    procedure  Process(Element: TElement); override;
    procedure  DoIt; override;
end;



THledacLiniiDleTridy = class(TProchazecLiniiDleTridy)
  public
    FMinX, FMinY, FMaxX, FMaxY: double;
    NalezeneLinie: TGeometry;

    procedure  SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
    procedure  Process(Element: TElement); override;
    procedure  DoIt; override;
end;




TNacitacLinii = class(TProchazecLiniiGauge)
private
  ILE: TIntegerListElement;
  function  JeMeziDruhy(Lin: TPolyLineElement): boolean;
  procedure SetDruhy(aValue: string);
public
{
  FEntityDleDruhu: boolean;
  procedure NastavDruhy(aDruhy: array of integer); }
  procedure Process(Element: TElement); override;
published
  property Druhy: string write SetDruhy;
end;


TReadLinesIntoQTree = class(TProchazecLiniiGauge)
private
  FQTree: TSpaceLineBegEndCell;
public
  procedure DoIt; override;
  procedure Process(Element: TElement); override;
end;



TReadLinesIntoQTreeDleTridy = class(TProchazecLiniiDleTridy)
private
  FQTree: TSpaceLineBegEndCell;
public
  procedure DoIt; override;
  procedure Process(Element: TElement); override;
end;



implementation
uses
  SysUtils, Forms, Controls, Dialogs,
// KERNEL
  e_Class,
  M_Orbis,
  Worlds,
// GLIB
  G_Elems;
// SPACE
  //E_SpaPrp;


            { TProchazecObjektu }



constructor TProchazecObjektu.Create;
begin
  inherited Create;
  {
  F_GaugeForm:= TF_GaugeForm.Create(Application);
  F_GaugeForm.Caption:= self.Name;
  F_GaugeForm.MaxValue:= 0;
  }
  //StartProgress(Self.Name,0,0);
end;


procedure TProchazecObjektu.SetGaugeCaption(aCaption: string);
begin
  //F_GaugeForm.Caption:= aCaption;
  ProgressText := aCaption;
end;


procedure TProchazecObjektu.DoIt;
var
  AuxCursor: TCursor;
begin
  AuxCursor:= Screen.Cursor;
  Screen.Cursor:= crHourglass;

  //F_GaugeForm.Caption:= self.Name;

  try
    inherited DoIt;
  finally
    Screen.Cursor:= AuxCursor
  end
end;


destructor TProchazecObjektu.Destroy;
begin
  //F_GaugeForm.Free;
  Screen.Cursor := crDefault;
  inherited Destroy
end;



procedure   TProchazecObjektu.SendProtocolMessage(aMessage: string);
begin
  {PostMsgText(tm_AddToProtocol, aMessage, World.MainTool);}
end;




procedure TProchazecObjektu.GaugeMaxValue(aValue: longInt);
begin
  //F_GaugeForm.MaxValue:= aValue;
  MaxProgress := aValue;
  Application.ProcessMessages;
end;

procedure TProchazecObjektu.GaugeShow;
begin
  //F_GaugeForm.Show
end;


procedure TProchazecObjektu.GaugeHide;
begin
  //F_GaugeForm.Hide
end;

procedure TProchazecObjektu.GaugeSetModulo(aModulo: longInt);
begin
  FModulo:= aModulo
end;


procedure TProchazecObjektu.GaugeSet(PocetObjektu: longInt);
begin
{
try
  if (F_GaugeForm.MaxValue > 0) then
  begin
    if (FModulo = 0) or ((FModulo > 0) and (PocetObjektu mod FModulo = 0)) then
    begin
      F_GaugeForm.Progress:= PocetObjektu;
      Application.ProcessMessages
    end
  end
except
  ShowMessage('Chyba v GaugeSet');
end;
}
   Progress := PocetObjektu;
   //ProgressText := IntToStr(PocetObjektu);
   Application.ProcessMessages;
end;




                       {  TProchazecLinii }


function  TProchazecLinii.QGoInside(Element: TElement): boolean;
begin
{
  Result:= (Element is TTopolBlok) or (Element is TTopolPredmetZajmu)
           or (Element is TTopolPlochy) or (Element is TTopolLinie) or
              (Element is TForestSpaceUnit)
}
  Result:= (Element is TOwnerEntity) and not (Element is TPolyLineElement)
end;




function TProchazecLinii.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TPolyLineElement)
end;




procedure TProchazecLinii.Process(Element: TElement);
begin
  if Element is TPolyLineElement then
  begin
    inc(FPocetLinii)
  end;
end;




                         { TProchazecPloch }

function  TProchazecPloch.QGoInside(Element: TElement): boolean;
begin
  Result:= (Element is TOwnerEntity) and not (Element is TPolyLineElement)
end;



function TProchazecPloch.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is TAreaElement)
end;




procedure TProchazecPloch.Process(Element: TElement);
begin
  if Element is TAreaElement then
  begin
    inc(FPocetPloch)
  end;
end;





                     { TOznacLinie }


procedure TOznacLinie.Process(Element: TElement);
begin
  if Element is TPolyLineElement then
  begin
    inc(FPocetLinii);
    if TPolyLineElement(Element).IsDone then
       TPolyLineElement(Element).IsDone:= false
  end;
end;



                   { TOznacPlochy }

procedure TOznacPlochy.Process(Element: TElement);
begin
  if Element is TAreaElement then
  begin
    inc(FPocetPloch);
    if TAreaElement(Element).IsDone then
       TAreaElement(Element).IsDone:= false
  end;
end;



                    { TProchazecLiniiGauge }


procedure TProchazecLiniiGauge.DoIt;
var
  Prochazec: TOznacLinie;
begin
  FPocetLinii:= 0;
  Prochazec:= TOznacLinie.Create;
  Prochazec.Input:= Input;
  Prochazec.DoIt;
  if Prochazec.FPocetLinii > 100 then
  begin
    {
    GaugeMaxValue(Prochazec.FPocetLinii);
    GaugeShow;
    }
    StartProgress(Self.Name,0,Prochazec.FPocetLinii);
  end;
  Prochazec.Free;
  inherited DoIt;
  GaugeHide
end;
                      { TProchazecLiniiDleTridy }


procedure TProchazecLiniiDleTridy.SetContainerClassByString(aName: string);
begin
  FClass:= nil;
  FClass:= GetOrbisClass(aName)
end;

function TProchazecLiniiDleTridy.GetContainerClassAsString: string;
begin
  result:= '';
  result:= FClass.ClassName;
end;




procedure TProchazecLiniiDleTridy.SetContainerClass(aClass: TClass);
begin
  FClass:= aClass
end;




function  TProchazecLiniiDleTridy.QGoInside(Element: TElement): boolean;
begin
  Result:= ((Element is TRectEntity)
           and not (Element is FClass) and not (Element is TPolyLineElement))
end;



function  TProchazecLiniiDleTridy.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is FClass)
end;


                              { TProchazecPlochGauge }

procedure TProchazecPlochGauge.DoIt;
var
  Prochazec: TOznacPlochy;
begin
  Prochazec:= TOznacPlochy.Create;
  Prochazec.Input:= Input;
  Prochazec.DoIt;
  if Prochazec.FPocetPloch > 100 then
  begin
    {
    GaugeMaxValue(Prochazec.FPocetPloch);
    GaugeShow;
    }
    StartProgress(Self.Name,0,Prochazec.FPocetploch);
    GaugeSetModulo(10);
  end;
  Prochazec.Free;
  inherited DoIt;
  GaugeHide
end;


procedure TProchazecPlochDleTridy.SetContainerClassByString(aName: string);
begin
  FClass:= nil;
  FClass:= GetOrbisClass(aName)
end;

function TProchazecPlochDleTridy.GetContainerClassAsString: string;
begin
  result:= '';
  result:= FClass.ClassName;
end;



procedure TProchazecPlochDleTridy.SetContainerClass(aClass: TClass);
begin
  FClass:= aClass
end;




function  TProchazecPlochDleTridy.QGoInside(Element: TElement): boolean;
begin
  Result:= ((Element is TRectEntity)
           and not (Element is FClass) and not (Element is TAreaElement))
end;



function  TProchazecPlochDleTridy.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element is FClass)
end;




{ THledacPloch }



procedure  THledacPloch.SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
begin
  FMinX:= aMinX;
  FMinY:= aMinY;
  FMaxX:= aMaxX;
  FMaxY:= aMaxY
end;



procedure THledacPloch.Process(aElement: TElement);
var
  anAre: TAreaElement;
begin
  if not (aElement is TAreaElement) then exit;
  anAre:= TAreaElement(aElement);
  if anAre.IsHole and not IncludeHoles then exit;
  begin
    inc(FPocetPloch);
    if not TAreaElement(aElement).IsDone then
    begin
      if ((FMinX =0) and (FMinY=0) and (FMaxX=0) and (FMaxY=0)) or
          TAreaElement(aElement).IsOverRegion(FMinX, FMinY, FMaxX, FMaxY) then
      begin
        FAreaString.AddAndUpdateRect(aElement)
      end;
      TAreaElement(aElement).IsDone:= true
    end;
  end;
end;



procedure THledacPloch.DoIt;
begin
  if not (input is TEntity) then exit;
  if Output=nil then
  begin
    FAreaString:= TAreaString.Create;
    Output:= FAreaString;
    AddElement(FAreaString)
  end
  else
  FAreaString:= TGeometry(Output);

  inherited DoIt
end;



{ THledacLinii }




procedure  THledacLinii.SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
begin
  FMinX:= aMinX;
  FMinY:= aMinY;
  FMaxX:= aMaxX;
  FMaxY:= aMaxY
end;



procedure THledacLinii.Process(Element: TElement);
begin
  if Element is TPolyLineElement then
  begin
    inc(FPocetLinii);
    GaugeSet(FPocetLinii);
    if not TPolyLineElement(Element).IsDone then
    begin
      if ((FMinX =0) and (FMinY=0) and (FMaxX=0) and (FMaxY=0)) or
          TPolyLineElement(Element).IsOverRegion(FMinX, FMinY, FMaxX, FMaxY) then
      begin
        NalezeneLinie.AddAndUpdateRect(Element);
      end;
      TPolyLineElement(Element).IsDone:= true
    end;
  end;
end;



procedure THledacLinii.DoIt;
begin
  if Output=nil then
  begin
    NalezeneLinie:= TPolyLineString.Create;
    Output:= NalezeneLinie;
    AddElement(NalezeneLinie)
  end
  else
    NalezeneLinie:= TGeometry(Output);

  inherited DoIt
end;


               { THledacLiniiDleTridy }

procedure  THledacLiniiDleTridy.SetRect(aMinX, aMinY, aMaxX, aMaxY: double);
begin
  FMinX:= aMinX;
  FMinY:= aMinY;
  FMaxX:= aMaxX;
  FMaxY:= aMaxY
end;


procedure THledacLiniiDleTridy.Process(Element: TElement);
var
  Linie: TPolyLineString;
  Lin: TPolyLineElement;
  I: longInt;
begin
  if not (Element is FClass) then exit;

  Linie:= TPolyLineString(TEntity(Element).FindElementClass(TPolyLineString));
  if Linie = nil then exit;

  for I:= 0 to Linie.Count-1 do
  begin
    Lin:= TPolyLineElement(Linie.Elements[I]);
    if not Lin.IsDone then
    begin
      inc(FPocetLinii);
      GaugeSet(FPocetLinii);

      if ((FMinX =0) and (FMinY=0) and (FMaxX=0) and (FMaxY=0)) or
          Lin.IsOverRegion(FMinX, FMinY, FMaxX, FMaxY) then
      begin
        NalezeneLinie.AddAndUpdateRect(Lin);
      end;
      Lin.IsDone:= true
    end;
  end;
end;



procedure THledacLiniiDleTridy.DoIt;
begin
  if Output=nil then
  begin
    NalezeneLinie:= TPolyLineString.Create;
    Output:= NalezeneLinie;
    AddElement(NalezeneLinie)
  end
  else
    NalezeneLinie:= TGeometry(Output);

  inherited DoIt
end;



                 { TNacitacLinii }

function TNacitacLinii.JeMeziDruhy(Lin: TPolyLineElement): boolean;
var
  I: integer;
  Nasel: boolean;
  aDruh: integer;
begin
  result:= true;
  if ILE = nil then exit;

  I:= 0;
  Nasel:= false;
  //result:= false;

  aDruh:= Lin.GetPropertyLongIntByName('DRUH');

  while (I < ILE.Count) and not Nasel do
  begin
    Nasel:= ILE.Integers[I] = aDruh;
    if not Nasel then inc(I)
  end;

  result:= Nasel
end;



procedure TNacitacLinii.SetDruhy(aValue: string);
begin
  if ILE <> nil then
  begin
    ILE.Free;
    ILE:= nil;
  end;

  ILE:= CreateIntegerListElementFromString('DRUHY', aValue);
  AddElement(ILE)
end;



procedure TNacitacLinii.Process(Element: TElement);
//var
  //Linie: TPolyLineString;
{  PodLinie: TTopolLinieDruhu; }

begin
  if (Element is TPolyLineElement) and (Parameter[0] is TPolyLineString) then
  begin
    //Linie:= TPolyLineString(Parameter[0]);
    if not TPolyLineElement(Element).IsDone then
    begin

      if JeMeziDruhy(TPolyLineElement(Element)) then
      begin
{
        if FEntityDleDruhu then
        begin
          PodLinie:=
            TTopolLinieDruhu
            (Linie.CreateSubEntity
             (TTopolLinieDruhu, 'LINIE DRUHU: '+
                                 IntToStr(TPolyLineElement(Element).Druh)));
          if PodLinie <> nil then
          begin
            PodLinie.AddAndUpdateRect(Element);
            Linie.Rect.UpdateByRectangle(TRectEntity(Element).Rect);

            GaugeSet(FPocetLinii);
          end;
        end
        else

          TTopolLinie(Parameter[0]).AddAndUpdateRect(Element);
      end;
}
        TPolyLineString(Parameter[0]).AddAndUpdateRect(Element);
        TPolyLineElement(Element).IsDone:= true
      end;
      inc(FPocetLinii);
    end
  end;
end;



procedure TReadLinesIntoQTree.DoIt;
var
  RectEntity: TRectEntity;
begin
  if NoParameters then
     RectEntity:= TRectEntity(Input)
  else
     RectEntity:= TRectEntity(Parameter[0]);

  if not RectEntity.IsValid then
     Exit;

  if TElement(RectEntity) is TRectEntity then
  begin
    FQTree:= TSpaceLineBegEndCell.Create;
    if FQTree <> nil then
    begin
      FQTree.Name:= 'QTREE';
      FQTree.Rect.MinX:= RectEntity.MinX;
      FQTree.Rect.MaxX:= RectEntity.MaxX;
      FQTree.Rect.MinY:= RectEntity.MinY;
      FQTree.Rect.MaxY:= RectEntity.MaxY;
{      RectEntity.AddElement(FQTree); }

      GaugeSetModulo(10);

      try
      inherited DoIt;
      except
        ShowMessage('Error: Nata lini do QTree');
      end;

      Output:= FQTree
    end
  end
end;



procedure TReadLinesIntoQTree.Process(Element: TElement);
//var
  //Linie, PodLinie: TPolyLineString;
  //LC: longInt;
begin
  if (Element is TPolyLineElement) then
  begin
    if not TPolyLineElement(Element).IsDone then
    begin
      //LC:= TPolyLineElement(Element).SpaceId;

      FQTree.AddLine(TPolyLineElement(Element), true);
      FQTree.AddLine(TPolyLineElement(Element), false);
      TPolyLineElement(Element).IsDone:= true;

      GaugeSet(FPocetLinii);
    end;
    inc(FPocetLinii)
  end;
end;




procedure TReadLinesIntoQTreeDleTridy.Process(Element: TElement);
var
  Linie: TPolyLineString;
  Lin: TPolyLineElement;
  I: longInt;
begin
  if Element is FClass then
  begin
    Linie:= TPolyLineString(TEntity(Element).FindElementClass(TPolyLineString));
    if Linie <> nil then
    begin
      for I:= 0 to Linie.Count-1 do
      begin
        Lin:= TPolyLineElement(Linie.Elements[I]);
        if not Lin.IsDone then
        begin
          FQTree.AddLine(Lin, true);
          FQTree.AddLine(Lin, false);
          Lin.IsDone:= true;
          GaugeSet(FPocetLinii)
        end;
        inc(FPocetLinii)
      end;
    end
  end
end;





procedure TReadLinesIntoQTreeDleTridy.DoIt;
var
  RectEnt: TRectEntity;
begin
  if NoParameters then
     RectEnt:= TRectEntity(Input)
  else
     RectEnt:= TRectEntity(Parameter[0]);

  if TElement(RectEnt) is TRectEntity then
  begin
    FQTree:= TSpaceLineBegEndCell.Create;
    if FQTree <> nil then
    begin
      FQTree.Name:= 'QTREE ' + FClass.ClassName;
      FQTree.Rect.MinX:= RectEnt.MinX;
      FQTree.Rect.MaxX:= RectEnt.MaxX;
      FQTree.Rect.MinY:= RectEnt.MinY;
      FQTree.Rect.MaxY:= RectEnt.MaxY;
      RectEnt.AddElement(FQTree);

      inherited DoIt;

      Output:= FQTree
    end
  end
end;



INITIALIZATION
   RegisterOrbisClass(TOznacLinie);
   RegisterOrbisClass(THledacPloch);
   RegisterOrbisClass(THledacLinii);
   RegisterOrbisClass(TReadLinesIntoQTree);
END.
