unit T_areare;
{ Penosy Plocha  Plocha }

interface

uses
// KERNEL
  Elements,
  Tools,
// SPACE
  E_Space,
  E_Reg;

type

TCarryArToArThroughLines = class(TTool)
{
  input: TAreaString ploch do kterch se pen vlastnosti
  pro kadou plochu se vezmou obklopujc linie a zjiuj se odpovdajc
  plochy naten z registr. V ppad neshody se vybere jako zdroj ta plocha,
  kter:
        1. M property
        2. Je vt
  Vsledkem je piazen nov plochy ploe v registru
  }
private
  FQuality: string;
  FReg: TRegister;
  FSelectForProblem: boolean;
  FProtocolOnlyProblem: boolean;
protected
  FProtocolFile: string;
  FPFile: system.text;
  FOK: boolean;
  procedure Process(anAre: TPolyLineAreaElement); virtual;
  procedure AddQuality(aVal: string); virtual;
  procedure AddLineQuality(aLine: TPolyLineElement; aVal: string); virtual;

public
  procedure ChangeInformations(anAre: TPolyLineAreaElement;
                               BestNeibArea: TAreaElement); virtual;
  procedure DoIt; override;
published
  property ProtocolFile: string read FProtocolFile write FProtocolFile;
  property SelectForProblem: boolean read FSelectForProblem write FSelectForProblem;
  property ProtocolOnlyProblem: boolean read FProtocolOnlyProblem write FProtocolOnlyProblem;
end;


implementation

uses
  SysUtils, Dialogs, Forms,
// KERNEL
  e_Class,
  U_String,
  Worlds,
// DIALOG
  F_Gauge,
// TOPOL
  E_TplPrp;




procedure TCarryArToArThroughLines.AddQuality(aVal: string);
begin
  FQuality:= FQuality + '| ' + aVal
end;


procedure TCarryArToArThroughLines.AddLineQuality(aLine: TPolyLineElement; aVal: string);
var
  aProp: TTopolProps;
begin
  if aVal = 'Diff.Block' then
  begin
    aProp:= TTopolProps(aLine.Properties);
    if not (TElement(aProp) is TTopolProps) then exit;
    aProp.Symbol:= -23;
  end;

  aVal:= 'L:'+DoubleToStr(aLine.X,10,2)+','+DoubleToStr(aLine.Y,11,2) + ' ' + aVal;
  AddQuality(aVal);
end;





procedure TCarryArToArThroughLines.ChangeInformations(anAre: TPolyLineAreaElement;
                                                      BestNeibArea: TAreaElement);
var
  NProps: TTopolAreaProps;
begin
  anAre.Properties:= TTopolAreaProps(BestNeibArea.Properties).CreateDuplicate;
  NProps:= TTopolAreaProps(anAre.Properties);

  if SelectForProblem then
     NProps.Vyber:= FQuality <> ''
  else
     NProps.Vyber:= false;

  if FOK and (not ProtocolOnlyProblem or (FQuality <> '')) then
  begin
   {$I-}
    writeln(FPFile,
            ' New XY:', anAre.X:11:2, ',', anAre.Y:12:2,
            ' New area:', anAre.Area1:12:4,
            ' Old XY:', BestNeibArea.X:11:2, ',', BestNeibArea.Y:12:2,
            ' Old area:', BestNeibArea.Area1:12:4,
            ' Old No:', NProps.Cislo:6, ' Type:', NProps.Druh:4,
             FQuality);

    if ioResult <> 0 then
       FOK:= false
   {$I+}
  end;
end;




procedure TCarryArToArThroughLines.Process(anAre: TPolyLineAreaElement);
var
  AreaNo: longInt;
  NeibArea, BestNeibArea: TAreaElement;
  aLineProps: TTopolLineProps;
  aLine: TPolyLineElement;
  I: longInt;
  BlockReg, BestBlock: TBlockRegister;

begin
{ hledn ploch pes linie }
  if not (anAre is TPolyLineAreaElement) then exit;
  BestBlock:= nil;
  BestNeibArea:= nil;
  FQuality:= '';

  for I:= 0 to anAre.Count-1 do
  { cyklus pes vechny linie, nalezen nejvt plochy od kter je mon pevzt
    vlastnosti }
  begin
  try
  { naten sprvn linie }
    aLine:= TPolyLineElement(anAre.Elements[I]);
    if not (aLine is TPolyLineElement) then continue;
    if not (aLine.Properties is TTopolLineProps) then continue;
  { zjitn sla plochy ze sprvn strany a nalezen Registru objekt }
    aLineProps:= TTopolLineProps(aLine.Properties);
    AreaNo:= aLineProps.GetRightAreaNoForBegin(anAre.LinesOrigines[I]);
    BlockReg:= FReg.GetBlockRegister(aLineProps.BlockName);

    if BlockReg = nil then
    begin
      AddLineQuality(aLine, 'No BlockReg');
      continue;
    end;
  { nalezen v registru vlastn plochy, mus mt nastaveny vlastnosti }
    NeibArea:= TAreaElement(BlockReg.GetObject('P', AreaNo));
    if NeibArea = nil then
    begin
      AddLineQuality(aLine, 'No Reg.Area');
      continue
    end;

    if NeibArea.Properties = nil then
    begin
      AddLineQuality(aLine, 'No Area Props');
      continue
    end;

  { nalezen nejvt - nejreprezentativnj plochy }
    if BestNeibArea <> nil then
    begin
      if BestBlock <> BlockReg then
      begin
        AddLineQuality(aLine, 'Diff.Block')
      end;

      if NeibArea.WholeArea > BestNeibArea.WholeArea then
      begin
        BestNeibArea:= NeibArea;
        BestBlock:= BlockReg
      end
    end
    else
    begin
      BestNeibArea:= NeibArea;
      BestBlock:= BlockReg
    end;
  except
      on EX: Exception  do
      begin
         ShowMessage(IntToStr(I) + ' ' + EX.Message);
         AddQuality(Ex.Message + ' are:' + DoubleToStr(anAre.X,10,2) + ','
                    + DoubleToStr(anAre.Y,11,2) + ' line ord:' + IntToStr(I))
      end

  end
  end;

  if BestNeibArea <> nil then
  begin
    ChangeInformations(anAre, BestNeibArea);
    BestBlock.RegisterLogicObject(anAre);
  end
  else
  begin
    if FOK and (not ProtocolOnlyProblem or (FQuality <> '')) then
    begin
     {$I-}
      writeln(FPFile,
              ' New area XY:', anAre.X:11:2, ',', anAre.Y:12:2,
              ' New area area:', anAre.Area1:12:4,
               FQuality);
     {$I+}
      if ioResult <> 0 then
         FOK:= false
    end
  end
end;




procedure TCarryArToArThroughLines.DoIt;
var
  Areas: TAreaString;
  anAre: TPolyLineAreaElement;
  I: longInt;
  F_GaugeForm: TF_GaugeForm;
begin
  if FProtocolFile <> '' then
  begin
    system.assign(FPFile, FProtocolFile);
    {$I-}
    system.rewrite(FPFile);
    {$I+}
    FOK:= ioResult = 0
  end;

  if not (input is TAreaString) then exit;
  FReg:= TRegister(World.ObjectModel.FindElementClass(TRegister));
  if FReg = nil then exit;

  Areas:= TAreaString(input);

  Application.CreateForm(TF_GaugeForm, F_GaugeForm);
  F_GaugeForm.MaxValue:= Areas.Count;
  F_GaugeForm.Caption:= 'Carry props area-area';
  F_GaugeForm.Show;
  for I:= 0 to Areas.Count-1 do
  begin
    if F_gaugeForm.DoCloseQuery and
       F_gaugeForm.RealyClose('Peruit penos atribut ?') then
       break;
    F_GaugeForm.Progress:= I;
    Application.ProcessMessages;
    anAre:= TPolyLineAreaElement(Areas.Elements[I]);
    if not (anAre is TPolyLineAreaElement) then continue;
    Process(anAre)
  end;

  F_GaugeForm.Free;

  if FOK then
     system.close(FPFile)
end;

initialization
  RegisterOrbisClass(TCarryArToArThroughLines);
end.

