unit I_top_t;
{
********************************************************
**                                                    **
**                    ORBIS                           **
**     Skupina interpretr Topolovskch text         **
**                                                    **
********************************************************
}

interface
uses
// KERNEL
   Elements,
   T_Recurs,
   Tools,
// GLIB
   g_Elems,
// DEVICE
   e_Device,
// SYMBOL
   e_BGIF,
   u_Symbol,
// TOPOL
   I_Top;

type

TInterpretTopTextu = class(TInterpretTopObject)
 protected
   //Rect: TDoubleRect;
   BGIF: TBGIFont;
   TextInfo: TBGIText;
   procedure SetInput(aInput: TElement); override;
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
 public
   procedure  Reset(aDevice: TDevice); override;
   procedure  Close; override;
   procedure  On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean); override;
end;



implementation

uses
   WinProcs,
   Dialogs,
   Graphics,
   SysUtils,
// KERNEL
   cpConvrt,
   e_Class,
   m_Orbis,
   //u_TopolT,
// GLIB
   e_Color,
// SPACE
   e_Geometry,
   e_GeometryElement,
   //e_Space,
// TOPOL
   e_TopoLElements;
   //e_TplPrp;


{ TInterpretTopTextu }

procedure TInterpretTopTextu.SetInput(aInput: TElement);
//var
//   BGIF: TBGIFont;
begin
   inherited SetInput(aInput);
   {
   if aInput is TTopolText then
   begin
      BGIF := TBGIFont.Create;
      BGIF.SetDevice(Device);
      BGIF.FreeTextInfo := false;
      BGIF.TextInfo := TTopoLText(aInput);
      BGIF.CalculateOpsanyObdelnik;
      BGIF.Free;
      Device.Projection.ChangeProjectionByRect(TTopolText(aInput).GetRegion, Device.Page);
   end;
   }
end;



procedure TInterpretTopTextu.Process(Element: TElement);
var
  TE: TTopoLTextElement;
  TX: TTextElement;
begin
   if BGIF.CHybaFontu then
   begin
      PostTextMsg(tm_AddToProtocol,'TopoL Text interpret - FontError !',nil);
      exit;
   end;
   TE := TTopoLTextElement(Element);
   TX := TTextElement(TE.Geometry);
   try
    //SetInterpretTopProps(TTopoLText(Element).ObjectOwner);

      TextInfo.Druh       := TE.Druh;
      TextInfo.Barva      := TE.Barva;
      TextInfo.Znacka     := TE.Znacka;
      TextInfo.Font       := TE.TopolFont;
      TextInfo.Vyska      := TE.Height;
      TextInfo.KoefSirky  := TE.WidthCoef;
      TextInfo.Smer       := TE.Direction;
      TextInfo.Sklon      := TE.Slope;
      TextInfo.Rozestupy  := TE.Distance;
      TextInfo.Atributy   := u_Symbol.TTextAtrib(TE.TextAtrib);
      TextInfo.RezimTextu := TE.TextMode;
      TextInfo.VychoziBod.x := TE.StartPoint.x;
      TextInfo.VychoziBod.y := TE.StartPoint.y;
      if TE.CodePage = cpWindows then
      begin
         TextInfo.CodePage   := cpLatin2;
         TextInfo.Veta       := WinTo852(TX.Text);
      end
      else
      begin
         TextInfo.CodePage   := TE.CodePage;
         TextInfo.Veta       := TX.Text;
      end;
      BGIF.TextInfo := TextInfo;
      BGIF.CalculateOpsanyObdelnik;
      if StrictRects then
      begin
         BGIF.NastavInfoPodleDruhu(TextInfo.Druh);
         TE.TextMode  := TextInfo.RezimTextu;
         TE.TopolFont := TextInfo.Font;
         TE.Height    := TextInfo.Vyska;
         TE.WidthCoef := TextInfo.KoefSirky;
         TE.Slope     := TextInfo.Sklon;
         TE.Distance  := TextInfo.Rozestupy;
         //if ColorByDruh then
         //   TE.Barva := TextInfo.Barva;
      end;
      if NoRect or TextInfo.IsOverRegion(Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY)then
      begin
         if UseColor then
         begin
           Device.Pen.Color := Color;
           TE.TextAtrib := TE.TextAtrib - [txtZmena];
         end
         else
           Device.Pen.Color := DejBarvicku(TE.Barva);
         {
         if OwnerProps.GetPropertyBooleanByName('USESYMBOL') then
            BGIF.TextInfo.Druh:= OwnerProps.GetPropertyLongIntByName('SYMBOL');
         }
         //Device.Pen.Color := DejBarvicku(aProps.Barva);
         Device.Pen.Style := psSolid;
         BGIF.ZobrazText(False);
      end;
   except
   end;
end;

function  TInterpretTopTextu.IsItsClass(AObject: TObject): boolean;
begin
   result := (AObject is TTopoLTextElement);
end;

function  TInterpretTopTextu.QProcessBefore(Element: TElement): boolean;
begin
  //result:= false;
  if Element is TTextCollection then
  begin
     //OwnerProps:= TTextString(Element).Properties;
     UseColor := TTextCollection(Element).UseColor;
     Color := TTextCollection(Element).Color;
     UseSymbol:= TTextCollection(Element).UseSymbol;
     Symbol := TTextCollection(Element).Symbol;
  end;
  (*
  if (Element is TTopolTexty) then
  begin
{
     UseColor := TTopolTexty(Element).UseColor;
     Color := TTopolTexty(Element).Color;
     UseSymbol:= TTopolTexty(Element).UseSymbol;
     Symbol := TTopolTexty(Element).Symbol;
}
     exit;
  end;
  *)
  Result:= (Element.ClassType = TTopoLTextElement);
end;

procedure  TInterpretTopTextu.Reset(aDevice: TDevice);
begin
   inherited Reset(aDevice);
   //Rect := Device.Projection.ModelView;
   if BGIF = nil then
   begin
      BGIF := TBGIFont.Create;
      BGIF.SetDevice(Device);
      BGIF.FreeTextInfo := false;
   end;
   if TextInfo = nil then
      TextInfo := TBGIText.Create;
end;

procedure  TInterpretTopTextu.Close;
begin
   if BGIF <> nil then BGIF.Free;
   BGIF := nil;
   if TextInfo <> nil then TextInfo.Free;
   TextInfo := nil;
   inherited Close
end;

procedure   TInterpretTopTextu.On_tm_ReView(var aMessage: TOrbisMessage; var Handled: boolean);
begin
   Device.Page.Color := clWhite;
   Device.Reset;
   inherited On_tm_ReView(aMessage, Handled);
   Device.Close;
end;


BEGIN
   RegisterOrbisClass(TInterpretTopTextu);
END.
