{ D-}
{$N+,E+,R-}
unit TrVekPC;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses
     TranType,
     TrojSit;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

type
  PTransfVektPoCastech = ^TTransfVektPoCastech;
  TTransfVektPoCastech = object

    SeznamTrojuhelniku: PTrojuhelnikVektCollection;
    Dimense: byte;

    constructor Init(
                     IniTransfPtr: pointer);

    procedure   ZobrazTrojuhelniky;

    function    OKTransformuj(
                                  BodZdroj: Bod;
                              var BodCil  : Bod): boolean;

    destructor  Done;
  end;


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses WinTypes, WinProcs,
     MatProc, StrProc, FilProc, Nadgraph,
     RasOpDLL,
     ProsTypy, ProsGlob, Hlasky,
     Pokus, VektoOkn;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}





constructor TTransfVektPoCastech.Init(
                                      IniTransfPtr: pointer);

var
  GeneratorSite: PGeneratorTrSite;
  PomSeznamTrSite: PTrojuhelnikCollection;
  TransfPtr: pointer;
  ZdrojStred, CilStred, Sta, Nov: TranType.Bod;


  procedure VytvorVektTrojuhelnik(
                                  Trojuhelnik: PTrojuhelnik); far;

  type
    TIdenBod = record
      Z1, Z2, Z3,
      C1, C2, C3: extended;
    end;

  var
    CastecnaTransformace: pointer;
    BufferPtr: PExtVector;
    VelikostBuffru, VelikostPrenosu: longInt;
    IdenBody: array[1..3] of TIdenBod;
    VektTrojuhelnik: PVektTrojuhelnik;

    procedure DejBuffer;
    var
      i, j: integer;

    begin
      VelikostPrenosu := Dimense * 2 * SizeOf(extended)+SizeOf(extended);
      VelikostBuffru  := 3 * VelikostPrenosu;

      getMem(BufferPtr, VelikostBuffru);

      if BufferPtr <> nil then
      begin
        i := 0;
        for j := 1 to 3 do
          with IdenBody[j] do
          begin
            inc(i);
            BufferPtr^[i] := 1;
            inc(i);
            BufferPtr^[i] := Z1;
            inc(i);
            BufferPtr^[i] := Z2;
            if Dimense = 3 then
            begin
              inc(i);
              BufferPtr^[i] := Z3;
            end;
            inc(i);
            BufferPtr^[i] := C1;
            inc(i);
            BufferPtr^[i] := C2;
            if Dimense = 3 then
            begin
              inc(i);
              BufferPtr^[i] := C3;
            end;
          end;
      end;
    end;

    procedure DisposeBuffer;
    begin
      if BufferPtr <> nil then
        freeMem(BufferPtr, VelikostBuffru);
      BufferPtr:= nil;
    end;

  begin
    getMem(VektTrojuhelnik, sizeOf(TVektTrojuhelnik));

    IniOpObdelnik(VektTrojuhelnik^.OpsObdelnik);

    TransformaceDejZdrojStred(TransfPtr, ZdrojStred);
    TransformaceDejCilStred(TransfPtr, CilStred);

    TransformaceDejSta(TransfPtr, Trojuhelnik^.V1, Sta);

    VektTrojuhelnik^.V1.Y := ZdrojStred.X + Sta.X;
    VektTrojuhelnik^.V1.X := ZdrojStred.Y + Sta.Y;
    with VektTrojuhelnik^ do
      AktualizaceOpObdelnika(V1.Y, V1.X, OpsObdelnik);

    TransformaceDejSta(TransfPtr, Trojuhelnik^.V2, Sta);
    VektTrojuhelnik^.V2.Y := ZdrojStred.X + Sta.X;
    VektTrojuhelnik^.V2.X := ZdrojStred.Y + Sta.Y;
    with VektTrojuhelnik^ do
      AktualizaceOpObdelnika(V2.Y, V2.X, OpsObdelnik);

    TransformaceDejSta(TransfPtr, Trojuhelnik^.V3, Sta);
    VektTrojuhelnik^.V3.Y := ZdrojStred.X + Sta.X;
    VektTrojuhelnik^.V3.X := ZdrojStred.Y + Sta.Y;
    with VektTrojuhelnik^ do
      AktualizaceOpObdelnika(V3.Y, V3.X, OpsObdelnik);

    with IdenBody[1] do
    begin
      TransformaceDejSta(TransfPtr, Trojuhelnik^.V1, Sta);
      TransformaceDejNov(TransfPtr, Trojuhelnik^.V1, Nov);

      Z1 := ZdrojStred.X + Sta.X;
      Z2 := ZdrojStred.Y + Sta.Y;
      if Dimense = 3 then
        Z3 := ZdrojStred.Z + Sta.Z;
      C1 :=   CilStred.X + Nov.X;
      C2 :=   CilStred.Y + Nov.Y;
      if Dimense = 3 then
        C3 :=   CilStred.Z + Nov.Z;
    end;

    with IdenBody[2] do
    begin
      TransformaceDejSta(TransfPtr, Trojuhelnik^.V2, Sta);
      TransformaceDejNov(TransfPtr, Trojuhelnik^.V2, Nov);

      Z1 := ZdrojStred.X + Sta.X;
      Z2 := ZdrojStred.Y + Sta.Y;
      if Dimense = 3 then
        Z3 := ZdrojStred.Z + Sta.Z;
      C1 :=   CilStred.X + Nov.X;
      C2 :=   CilStred.Y + Nov.Y;
      if Dimense = 3 then
        C3 :=   CilStred.Z + Nov.Z;
    end;

    with IdenBody[3] do
    begin
      TransformaceDejSta(TransfPtr, Trojuhelnik^.V3, Sta);
      TransformaceDejNov(TransfPtr, Trojuhelnik^.V3, Nov);

      Z1 := ZdrojStred.X + Sta.X;
      Z2 := ZdrojStred.Y + Sta.Y;
      if Dimense = 3 then
        Z3 := ZdrojStred.Z + Sta.Z;
      C1 :=   CilStred.X + Nov.X;
      C2 :=   CilStred.Y + Nov.Y;
      if Dimense = 3 then
        C3 :=   CilStred.Z + Nov.Z;
    end;

    DejBuffer;
    if Dimense = 2 then
      CastecnaTransformace := TransformaceInit(BufferPtr, 3, 1)
    else
      CastecnaTransformace := TransformaceInit(BufferPtr, 3, 4);
    DisposeBuffer;

    VektTrojuhelnik^.Klic[1]    := TransformaceDejKlic(CastecnaTransformace, 1);
    VektTrojuhelnik^.Klic[2]    := TransformaceDejKlic(CastecnaTransformace, 2);
    VektTrojuhelnik^.Klic[3]    := TransformaceDejKlic(CastecnaTransformace, 3);
    VektTrojuhelnik^.Klic[4]    := TransformaceDejKlic(CastecnaTransformace, 4);
    VektTrojuhelnik^.Klic[5]    := TransformaceDejKlic(CastecnaTransformace, 5);
    VektTrojuhelnik^.Klic[6]    := TransformaceDejKlic(CastecnaTransformace, 6);
    if Dimense = 3 then
    begin
      VektTrojuhelnik^.Klic[7]    := TransformaceDejKlic(CastecnaTransformace, 7);
      VektTrojuhelnik^.Klic[8]    := TransformaceDejKlic(CastecnaTransformace, 8);
      VektTrojuhelnik^.Klic[9]    := TransformaceDejKlic(CastecnaTransformace, 9);
    end;
    TransformaceDejZdrojStred(CastecnaTransformace, VektTrojuhelnik^.ZdrojStred);
    TransformaceDejCilStred(CastecnaTransformace, VektTrojuhelnik^.CilStred);

    TransformaceDone(CastecnaTransformace);

    SeznamTrojuhelniku^.Insert(VektTrojuhelnik);
  end;

begin
  TransfPtr := IniTransfPtr;
  Dimense   := TransformaceDejDimenzi(TransfPtr);
  GeneratorSite := New(PGeneratorTrSite, Init(TransfPtr, true));
  GeneratorSite^.Generuj;
  PomSeznamTrSite := GeneratorSite^.SeznamTrojuhelniku;
  Dispose(GeneratorSite, Done);
  if PomSeznamTrSite <> nil then
  begin
    New(SeznamTrojuhelniku, Init(PomSeznamTrSite^.Count, 1));
    PomSeznamTrSite^.ForEach(@VytvorVektTrojuhelnik);
    Dispose(PomSeznamTrSite, Done);
    ZobrazTrojuhelniky;
  end else
  begin
    hlaska('Si nebyla vytvoena!');
    exit;
  end;
end;


procedure TTransfVektPoCastech.ZobrazTrojuhelniky;


  procedure KresliTrojuhelnik(
                              Trojuhelnik: PVektTrojuhelnik); far;

  var
    Bod1, Bod2, Bod3: TPoint;
    DC: HDC;
    OldPen, Pen: HPen;

  begin
    with PVektorOkno(State^.ZobrOkno)^, Trojuhelnik^ do
    begin
      SourNaObrBod(V1, Bod1);
      SourNaObrBod(V2, Bod2);
      SourNaObrBod(V3, Bod3);
    end;

    DC     := GetDC(State^.ZobrOkno^.HWindow);
    Pen    := CreatePen(ps_Solid, 1, DejSkutBarvu(JsCervena));
    OldPen := SelectObject(DC, Pen);

    moveTo(DC, Bod1.X, Bod1.Y);
    lineTo(DC, Bod2.X, Bod2.Y);
    lineTo(DC, Bod3.X, Bod3.Y);
    lineTo(DC, Bod1.X, Bod1.Y);

    SelectObject(DC, OldPen);
    DeleteObject(Pen);
    ReleaseDC(State^.ZobrOkno^.HWindow, DC);

    with PVektorOkno(State^.ZobrOkno)^, Trojuhelnik^ do
    begin
      SourNaObrBodPaint(V1, Bod1);
      SourNaObrBodPaint(V2, Bod2);
      SourNaObrBodPaint(V3, Bod3);

      MemoryDC := CreateMemoryDC;
      PomBmp   := SelectObject(MemoryDC, BitMap);

      Pen    := CreatePen(ps_Solid, 1, DejSkutBarvu(Zluta));
      OldPen := SelectObject(MemoryDC, Pen);

      moveTo(MemoryDC, Bod1.X, Bod1.Y);
      lineTo(MemoryDC, Bod2.X, Bod2.Y);
      lineTo(MemoryDC, Bod3.X, Bod3.Y);
      lineTo(MemoryDC, Bod1.X, Bod1.Y);

      SelectObject(DC, OldPen);
      DeleteObject(Pen);

      SelectObject(MemoryDC, PomBmp);
      DeleteDC(MemoryDC);
      MemoryDC := 0;
    end;
  end;

begin
  SeznamTrojuhelniku^.ForEach(@KresliTrojuhelnik)
end;


function TTransfVektPoCastech.OKTransformuj(
                                                BodZdroj: Bod;
                                            var BodCil  : Bod): boolean;
var
  i: integer;
  Hotovo: boolean;
  Sour: TSour;

  procedure Transformace2D(
                           VektTrojuhelnik: PVektTrojuhelnik);
  var
    H: Bod;

    function BodVTrojuhelniku: boolean;
    var
      Sm: array[1..3] of extended;
      Pom: extended;
      i, kont: byte;
      Identicke: boolean;

    begin
      BodVTrojuhelniku := true;
      with VektTrojuhelnik^ do
      begin
        Sm[1] := Smernik(Sour.Y, Sour.X, V1.Y, V1.X, Identicke);
        if Identicke then exit;
        Sm[2] := Smernik(Sour.Y, Sour.X, V2.Y, V2.X, Identicke);
        if Identicke then exit;
        Sm[3] := Smernik(Sour.Y, Sour.X, V3.Y, V3.X, Identicke);
        if Identicke then exit;
      end;
      repeat
        kont := 0;
        for i := 1 to 2 do
          if Sm[i] > Sm[succ(i)] then
          begin
            inc(kont);
            Pom         := Sm[i];
            Sm[i]       := Sm[succ(i)];
            Sm[succ(i)] := Pom;
          end;
      until kont = 0;
      if (Sm[3] - Sm[2] > 180) or (Sm[2] - Sm[1] > 180) or (Sm[3] - Sm[1] < 180) then
        BodVTrojuhelniku := false;
    end;

  begin
    Hotovo:= false;
    if BodVObdelniku(Sour, VektTrojuhelnik^.OpsObdelnik, 0) then
      if BodVTrojuhelniku then
        with VektTrojuhelnik^ do
        begin
          H.X      := BodZdroj.X - ZdrojStred.X;
          H.Y      := BodZdroj.Y - ZdrojStred.Y;
          BodCil.X := H.X * Klic[1] + H.Y * Klic[2] + Klic[3] + CilStred.X;
          BodCil.Y := H.X * Klic[4] + H.Y * Klic[5] + Klic[6] + CilStred.Y;
          Hotovo := true;
        end;
  end;

  procedure Transformace3D(
                           VektTrojuhelnik: PVektTrojuhelnik);
  var
    H: Bod;

    function BodVTrojuhelniku: boolean;
    var
      Sm: array[1..3] of extended;
      Pom: extended;
      i, kont: byte;
      Identicke: boolean;

    begin
      BodVTrojuhelniku := true;
      with VektTrojuhelnik^ do
      begin
        Sm[1] := Smernik(Sour.X, Sour.Y, V1.X, V1.Y, Identicke);
        if Identicke then exit;
        Sm[2] := Smernik(Sour.X, Sour.Y, V2.X, V2.Y, Identicke);
        if Identicke then exit;
        Sm[3] := Smernik(Sour.X, Sour.Y, V3.X, V3.Y, Identicke);
        if Identicke then exit;
      end;
      repeat
        kont := 0;
        for i := 1 to 2 do
          if Sm[i] > Sm[succ(i)] then
          begin
            inc(kont);
            Pom         := Sm[i];
            Sm[i]       := Sm[succ(i)];
            Sm[succ(i)] := Pom;
          end;
      until kont = 0;
      if (Sm[3] - Sm[2] > 180) or (Sm[2] - Sm[1] > 180) or (Sm[3] - Sm[1] < 180) then
        BodVTrojuhelniku := false;
    end;

  begin
    if BodVObdelniku(Sour, VektTrojuhelnik^.OpsObdelnik, 0) then
      if BodVTrojuhelniku then
        with VektTrojuhelnik^ do
        begin
          H.X      := BodZdroj.X - ZdrojStred.X;
          H.Y      := BodZdroj.Y - ZdrojStred.Y;
          H.Z      := BodZdroj.Z - ZdrojStred.Z;
          BodCil.X := H.X * Klic[1] + H.Y * Klic[2] + Klic[3] + CilStred.X;
          BodCil.Y := H.X * Klic[4] + H.Y * Klic[5] + Klic[6] + CilStred.Y;
          BodCil.Z := H.X * Klic[7] + H.Y * Klic[8] + Klic[9] + CilStred.Z;
          Hotovo := true;
        end;
  end;


begin
  Hotovo := false;
  Sour.Y := BodZdroj.X;
  Sour.X := BodZdroj.Y;

  i := 0;
  if Dimense = 2 then
    repeat
      Transformace2D(SeznamTrojuhelniku^.At(i));
      inc(i);
    until Hotovo or (i = SeznamTrojuhelniku^.Count)
  else
    repeat
      Transformace3D(SeznamTrojuhelniku^.At(i));
      inc(i);
    until Hotovo or (i = SeznamTrojuhelniku^.Count);

  OKTransformuj := Hotovo;
end;






destructor TTransfVektPoCastech.Done;
begin
  if SeznamTrojuhelniku <> nil then
    Dispose(SeznamTrojuhelniku, Done);
end;


end.
