{$R-}
Unit Tablet;
interface
uses BPobject;
type PTabletCommand = ^TTabletCommand;
     TTabletCommand = record
                       InitS,
                       MaskaS:string;          {maska viz nize}
                       TypC:char;              {A znaci ASCII, B je binarni}
                      end;


{masky -ASCII:
        X - X-ova souradnice
        Y - Y-ova souradnice
        F - byt, jehoz hodnota udava kombinaci stisknutych tlacitek tabletu
        prijaty retezec musi byt ukoncen posloupnosti znaku
        #$0D#$0A (do masky se tyto dva znaky nezapisuji)
        ostatni znaky v masce slouzi k dolpneni retezce
        a MUSI souhlasit s prijimanym retezcem.
        Vzajemna kombinace znaku "A" a "F" neni dovolena

        -BINARNI
        Maka je usporadana tak, jak jsou jednotlive bity
        prijimany tzn. bit0 prvniho byte, bit1 prvniho byte, bit2 ...
        ... bit7 posledniho byte. Jeden bit odpovida jednomu znaku
        v masce

        N - bit, ktery ma byt ignorovan
        F - bit tlacitka. Vysledna hodnota udava
            kombinaci stisknutych tlacitek na tabletu
        > - "Sign" bit pro X-ovou souradnici - nastaveny bit znaci "+"
        < -      - || -                      - nastaveny bit znaci "-"
        ^ - "Sign" bit pro Y-ovou souradnici - nastaveny bit znaci "+"
        _ -      - || -                      - nastaveny bit znaci "-"
        X - bit X-ove souradnice (byty jsou nacitany v poradi od nejnizsiho po nejvyssi)
        x -      - || -          (byty jsou nacitany v poradi od nejvyssiho po nejnizsi)
        Y - bit Y-ove souradnice (byty jsou nacitany v poradi od nejnizsiho po nejvyssi)
        y -      - || -          (byty jsou nacitany v poradi od nejvyssiho po nejnizsi)
        1 - bit, ktery vzdy MUSI byt jednickovy
        0 - bit, ktery vzdy MUSI byt nulovy

        Vzajemna kombinace znaku "><" , " ^_", "FA", "Xx" a "Yy" neni
        dovolena a vede k ziskavani nesmyslnych udaju.
        Pocet bitu pro jednu souradnici je max 32, pro cislo tlacitka 8.
}


type
      PCommandColl = ^TCommandColl;
      TCommandColl = object(TCollection)
                     Procedure AddPoz(_x,_y:double; _t:word);
                     Function GetPoz(var _x,_y:double; var _t:word):boolean;
                     Procedure FreeItem(Item:pointer); virtual;
                     end;



      PTablet = ^TTablet;
      TTablet = object
               Commands:TTabletCommand;
               IsOpen:boolean;
               Prubezne:string;
               Constructor Init;
               Destructor Done; virtual;
               Function PosledniXYT(var X,Y:double; var T:word):boolean;
               Function OpenPort:boolean;
               Procedure ClosePort;
               Procedure Polling;
               Function InitHS:boolean;
               Procedure StartScan;
               Procedure StopScan;

               Private
               LastX,LastY:double;
               LastT:word;
               x1,x2,y1,y2,t1:integer;
               Kolekce:PCommandColl;
               Prijimano:string;
               PocetT:word;
               TranslateTab:array[0..15] of record B:byte; H:word end;
               Procedure TestMask;
               Function TestPrijato:boolean;
               Function Translate(t:byte):word;
               Procedure NoveXYTA;
               Procedure NoveXYTB;
               Function DejKodZRetezce(s:string):word;
               end;

const
  TransformaceTablet: pointer = nil;
  TabletPtr: PTablet = nil;

implementation
uses WWLink,BPWinPro,BPString,BPWinTyp;
type
    PPozice = ^TPozice;
    TPozice = object
              x,y:double;
              t:word;
              Constructor Init(_x,_y:double; _t:word);
              Destructor Done;
              end;

Constructor TPozice.Init(_x,_y:double; _t:word);
begin
     x:=_x; y:=_y; t:=_t;
end;

Destructor TPozice.Done;
begin
end;

Procedure TCommandColl.AddPoz(_x,_y:double; _t:word);
var PPoz:PPozice;
begin
     If Count>0 then
     begin
          PPoz:=At(Count-1);
          If _t=PPoz^.t then
          begin
               PPoz^.x:=_x; PPoz^.y:=_y;
          end else
          If Count<40 then
          begin
               PPoz:=New(PPozice,Init(_x,_y,_t));
               If PPoz<>nil then Insert(PPoz);
          end;
     end else
     begin
          PPoz:=New(PPozice,Init(_x,_y,_t));
          If PPoz<>nil then Insert(PPoz);
     end;
end;

Function TCommandColl.GetPoz(var _x,_y:double; var _t:word):boolean;
var PPoz:PPozice;
begin
     If Count>0 then
     begin
          GetPoz:=True;
          PPoz:=At(0);
          _x:=PPoz^.x; _y:=PPoz^.y; _t:=PPoz^.t;
          Free(PPoz);
     end else GetPoz:=False;
end;

Procedure TCommandColl.FreeItem(Item:pointer);
begin
     Dispose(PPozice(Item),Done);
end;

Constructor TTablet.Init;
begin
     IsOpen:=False;
     Kolekce:=New(PCommandColl,Init(40,0));
     LastT:=0; LastX:=0; LastY:=0;
end;

Destructor TTablet.Done;
begin
     If IsOpen then ClosePort;
     If Kolekce<>nil then Dispose(Kolekce,Done);
end;

Function TTablet.OpenPort;

Procedure Zpracuj(s:string);
var i,j,c:word;
    s1:string[5];
begin
     s:=copy(s,1,length(s)-1);
     For i:=1 to Length(s) do s[i]:=UpCase(s[i]);
     i:=Pos(':',s);
     If (i=0) or (i>4) then Exit;
     If i<>2 then
     begin
          s1:=copy(s,1,i-1);
          val(s1,j,c);
          If c<>0 then Exit;
     end else j:=Byte(s[1]);
     s:=copy(s,i+1,length(s)-i);
     i:=DejKodZRetezce(s);
     If i=0 then Exit;
     TranslateTab[PocetT].B:=j;
     TranslateTab[PocetT].H:=i;
     Inc(PocetT);
end;

var _port,_bd,_ws,_stb,_MaxB,i:word;
    _tmp1:word;
    _Parity:char;
    _s:array[0..999] of char;
    s:string;
    b:boolean;
begin
     _port:=GetPrivateProfileInt('TabletParams','Com',$FF,'Tablet.Ini');

     _Bd:=GetPrivateProfileInt('TabletParams','BaudRate',$FF,'Tablet.Ini');

     _ws:=GetPrivateProfileInt('TabletParams','DataLength',$FF,'Tablet.Ini');

     _stb:=GetPrivateProfileInt('TabletParams','StopBit',$FF,'Tablet.Ini');

     GetPrivateProfileString('TabletParams','Parity','-',_s,2,'Tablet.Ini');
     _Parity:=UpCase(Char(_s[0]));

     GetPrivateProfileString('TabletParams','Type','-',_s,2,'Tablet.Ini');
     Commands.TypC:=UpCase(Char(_s[0]));

     GetPrivateProfileString('TabletParams','Mask','-',_s,99,'Tablet.Ini');
     Commands.MaskaS:=StrPas(_s);

     PocetT:=0;
     GetPrivateProfileString('TabletParams','Buttons','-',_s,999,'Tablet.Ini');
     If _s[1]=#0 then PocetT:=0
     else
     begin
          _MaxB:=StrLen(_s);
          _Tmp1:=0; For i:=0 to _MaxB do If _s[i]=';' then Inc(_Tmp1);
          If _Tmp1>0 then
          begin
               s:='';
               For i:=0 to _MaxB do
               begin
                    s:=s+_s[i];
                    If _s[i]=';' then
                    begin
                         Zpracuj(s);
                         s:='';
                    end;
               end;
          end else PocetT:=0;
     end;

     GetPrivateProfileString('TabletParams','SeqInit','-',_s,99,'Tablet.ini');
     Commands.InitS:=StrPas(_s);
     If Commands.InitS='-' then Commands.InitS:='';
     s:='';
     If (_bd<>9600) and (_bd<>4800) and (_bd<>2400) and (_bd<>1200)
        and (_bd<>600) then   s:='Chybne urceni prenosove rychlosti v souboru Tablet.Ini (BaudRate)';
     If (not _port in [1,2]) then  s:='Chybne urceni serioveho portu v souboru Tablet.Ini (Com)';
     If  not _ws in [7,8] then s:='Chybne urceni delky prenaseneho slova v souboru Tablet.Ini (DataLength)';
     If not _StB in [1,2] then s:='Chybne urceni stop bitu v souboru Tablet.Ini (StopBit)';
     If not PocetT in [1,12] then s:='Chybna definice vyznamu tlacitek tabletu v souboru Tablet.Ini (Buttons)';
     If not (_Parity in ['O','N','E']) then s:='Chybne urceni parity v souboru Tablet.Ini (Parity)';
     If not (Commands.TypC in ['A','B']) then s:='Chybne urceni typu tabletu v souboru Tablet.Ini (Type)';
     If (Commands.MaskaS[0]=#0) or (Commands.MaskaS[1]='-') then
        s:='Nedefinovana maska dat tabletu v souboru Tablet.Ini (Mask)';
     If s<>'' then
     begin
          OpenPort:=False;
          IsOpen:=False;
          s:=s+#0;
          {****}
          MessageBox(0,@s[1],'Chyba',mb_OK or mb_IconExclamation);
          Exit;
     end;
     TestMask;
     _Init;
     IsOpen:=_Open(_Port,_Bd,_Parity,_WS,_StB);
     If IsOpen then IsOpen:=InitHS;
     if not IsOpen then
     begin
          {****}
          MessageBox(0,'Tablet nelze pripojit na zvoleny port !','Chyba',mb_OK or mb_IconExclamation);
     end;
     OpenPort:=IsOpen;
     Prijimano:='';
end;

Function TTablet.DejKodZRetezce(s:string):word;
var kod:word;

Function Kolik_(_s:string; c:char):byte;
var i,j:byte;
begin
     j:=0;
     For i:=1 to length(_s) do If _s[i]=c then Inc(j);
     Kolik_:=j;
end;

Function Bez_(_s:string):word;
var i,j,w:word;
begin
     If length(_s)=1 then
     begin           {jednoznakova volba}
          If _s[1] in ['0'..'9','A'..'Z'] then
          j:=Ord(_s[1]) else j:=0;
     end else
     begin           {viceznakova volba}
          If _s[1]='F' then       {klavesa "F.."}
          begin
               _s:=copy(_s,2,length(_s)-1);
               val(_s,i,w);
               If (w<>0) or not(i in [1..12]) then j:=0
               else j:=$6F+i;
          end else
          begin   {ruzne klavesy}
               j:=0;
               If _s='ENTER' then j:=$0D;
               If _s='INS'   then j:=$2D;
               If _s='DEL'   then j:=$2E;
               If _s='HOME'  then j:=$24;
               If _s='END'   then j:=$23;
               If _s='PGUP'  then j:=$21;
               If _s='PGDN'  then j:=$22;
               If _s='ESC'   then j:=$1B;
               If _s='SPACE' then j:=$20;
               IF _s='TAB'   then j:=$09;
          end;
     end;
     Bez_:=j;
end;

Function Rozsir_(var _s:string):word;
var _s2:string;
    i:byte;
begin
     i:=Pos('_',_s);
     _s2:=copy(_s,1,i-1); _s:=copy(_s,i+1,length(_s)-i);
     Rozsir_:=0;
     If _s2='CTRL'  then Rozsir_:=$0200;
     If _s2='ALT'   then Rozsir_:=$0400;
     If _s2='SHIFT' then Rozsir_:=$0100;
end;

begin
     case Kolik_(s,'_') of
     0: DejKodZRetezce:=Bez_(s);
     1: begin
             kod:=Rozsir_(s);
             DejKodZRetezce:=Bez_(s) or kod;
        end;
     2: begin
             kod:=Rozsir_(s);
             kod:=Rozsir_(s) or kod;
             DejKodZRetezce:=Bez_(s) or kod;
        end;
     3: begin
             kod:=Rozsir_(s);
             kod:=Rozsir_(s) or kod;
             kod:=Rozsir_(s) or kod;
             DejKodZRetezce:=Bez_(s) or kod;
        end;
     else DejKodZRetezce:=0;
     end;
end;

Function TTablet.Translate(t:byte):word;
var i:word;
begin
     i:=0;
     While (i<=(pocetT-1)) and (TranslateTab[i].B<>t) do inc(i);
     If i>=PocetT then Translate:=0 else Translate:=TranslateTab[i].H;
end;

Procedure TTablet.StartScan;
begin
     _StartReceive;
end;

Procedure TTablet.StopScan;
begin
     _StopReceive;
end;

Procedure TTablet.ClosePort;
begin
     If IsOpen then
     begin
          _Close;
          IsOpen:=False;
     end;
end;

Procedure TTablet.TestMask;
var i:word;
begin
     If Commands.TypC='A' then
     begin
          x1:=Pos('X',Commands.MaskaS);
          y1:=Pos('Y',Commands.MaskaS);
          t1:=Pos('F',Commands.MaskaS);
          x2:=x1;
          While (x2<=length(Commands.MaskaS))
           and (Commands.MaskaS[x2]='X') do Inc(x2);
          Dec(x2);
          y2:=y1;
          While (y2<=length(Commands.MaskaS))
           and (Commands.MaskaS[y2]='Y') do Inc(y2);
          Dec(y2);
     end;
end;

Function TTablet.InitHS;
var b:boolean;
    i:word;
begin
     If (Commands.InitS<>'') and IsOpen then
     begin
          _FreeBuffer;
          i:=1; b:=True;
          While b and (i<=length(Commands.InitS)) do
          begin
               b:=_Send(Ord(Commands.InitS[i]));
               Inc(i);
          end;
          InitHS:=b;
     end else InitHS:=True;
end;

Function TTablet.TestPrijato;
var i:word;
    b:boolean;

Function TestByte(ii,byt:byte):boolean;
var j:byte;
begin
     TestByte:=False;
     For j:=1 to 8 do
     begin
          case Commands.MaskaS[(ii-1)*8+j] of
          '0': If (byt and $01)<>0 then Exit;
          '1': If (byt and $01)=0 then Exit;
          end;
          byt:= byt shr 1;
     end;
     TestByte:=True;
end;

begin
     b:=True; i:=1;
     If Commands.TypC='A' then
     begin
          While b and (i<=Length(Prijimano)) do
          begin
               case Commands.MaskaS[i] of
                'X','Y': If not (Prijimano[i] in ['0'..'9']) then b:=False;
                'F'    : b:=True;
               else If Prijimano[i]<>Commands.MaskaS[i] then b:=False;
               end;
               inc(i);
          end;
          TestPrijato:=b;
     end else
     begin
          While b and (i<=Length(Prijimano)) do
          begin
               b:=TestByte(i,Ord(Prijimano[i]));
               Inc(i);
          end;
          If not b then Prijimano:=copy(Prijimano,2,Length(Prijimano)-1);
          TestPrijato:=b;
     end;
end;

Procedure TTablet.Polling;
var c:byte;
begin
     If not IsOpen then Exit;
     If _IsOverFlow then
     begin
          InitHS;
          Exit;
     end;
     If _Buffer_Check(c) then
        If Commands.TypC='A' then {je ASCII typ}
        begin
             If (c<>$D) and (c<>$A) then Prijimano:=Prijimano+Chr(c);
             If c=$A then
             begin
                  If TestPrijato then NoveXYTA;
                  Prijimano:='';
             end;
        end else {je binarni typ}
        begin
             Prijimano:=Prijimano+Chr(c);
             If length(Prijimano)=Trunc(Length(Commands.MaskaS)/8) then
                      If TestPrijato then NoveXYTB;
        end;
end;

Procedure TTablet.NoveXYTA;
{zpracovani prijatych byte pro ASCII rezim}
var c,t:integer;
    x,y:double;
begin
     If Length(Prijimano)<>Length(Commands.MaskaS) then Exit;
     val(copy(Prijimano,x1,x2-x1+1),x,c);
     val(copy(Prijimano,y1,y2-y1+1),y,c);
     t:=Translate(byte(Prijimano[t1]));
     If (t=0) and ((LastX<>x) or (LastY<>y)) then
     begin
          Kolekce^.AddPoz(x,y,t);
          LastX:=x;
          LastY:=y;
          LastT:=0;
     end;
     If t<>LastT then
     begin
          LastT:=t;
          Kolekce^.AddPoz(x,y,t);
          LastX:=x;
          LastY:=y;
     end;
end;

Procedure TTablet.NoveXYTB;
{zpracovani prijatych byte pro binarni rezim}
var t,t2:integer;
    x,y:longint;
    dx,dy:integer;
    byt:byte;
    i,j:word;
    SwapX,SwapY:boolean;

Function OJedenVPravo(zdroj:byte; cil:longint):longint; assembler;
type
    LongRec = record Lo,Hi:word; end;
asm
            MOV AX,LongRec(cil).LO
            MOV DX,LongRec(cil).HI
            RCR zdroj,1
            RCR DX,1
            RCR AX,1
end;

Function OJedenVPravoW(zdroj:byte; cil:integer):integer; assembler;
asm
            MOV AX,Cil
            RCR zdroj,1
            RCR AX,1
end;

begin
     x1:=0; y1:=0; x:=0; y:=0; t:=0; t1:=0;
     x2:=0; y2:=0; t2:=0;
     For i:=1 to length(Prijimano) do
     begin
          byt:=Ord(Prijimano[i]);
          For j:=1 to 8 do
          begin
               case Commands.MaskaS[(i-1)*8+j] of
               'F': begin t:=OJedenVPravoW(byt,t); inc(t1); end;
               'X': begin x:=OJedenVPravo(byt,x); inc(x1); SwapX:=False; end;
               'Y': begin y:=OJedenVPravo(byt,y); inc(y1); SwapY:=False; end;
               'x': begin x:=OJedenVPravo(byt,x); inc(x1); SwapX:=True; end;
               'y': begin y:=OJedenVPravo(byt,y); inc(y1); SwapY:=True; end;
               '>': begin dx:=0; dx:=OJedenVPravoW(byt,dx);
                          If dx<>0 then dx:=1 else dx:=-1;
                    end;
               '<': begin dx:=0; dx:=OJedenVPravoW(byt,dx);
                          If dx<>0 then dx:=-1 else dx:=1;
                    end;
               '^': begin dy:=0; dy:=OJedenVPravoW(byt,dy);
                          If dy<>0 then dy:=1 else dy:=-1;
                    end;
               '_': begin dy:=0; dy:=OJedenVPravoW(byt,dy);
                          If dy<>0 then dy:=-1 else dy:=1;
                    end;
               end;
               byt:=byt shr 1;
          end;
     end;
     If x1<32 then x:=x shr (32-x1);
     If y1<32 then y:=y shr (32-y1);
     If t1<16 then t:=t shr (16-t1);
     If SwapX then
        case x1 of
         9..16: asm
                   mov   AX,LongRec(x).LO
                   Xchg  AH,AL
                   mov   LongRec(x).LO,AX
                   mov   LongRec(x).HI,0
                end;
        17..24: asm
                   mov   AX,LongRec(x).LO
                   mov   DX,LongRec(x).HI
                   Xchg  AL,DL
                   mov   DL,0
                   mov   LongRec(x).LO,AX
                   mov   LongRec(x).HI,DX
                end;
        25..32: asm
                   mov   AX,LongRec(x).LO
                   mov   DX,LongRec(x).HI
                   Xchg  AL,DH
                   Xchg  AH,DL
                   mov   LongRec(x).LO,AX
                   mov   LongRec(x).HI,DX
                end;
        end;
     If SwapY then
        case x1 of
         9..16: asm
                   mov   AX,LongRec(y).LO
                   Xchg  AH,AL
                   mov   LongRec(y).LO,AX
                   mov   LongRec(y).HI,0
                end;
        17..24: asm
                   mov   AX,LongRec(y).LO
                   mov   DX,LongRec(y).HI
                   Xchg  AL,DL
                   mov   DL,0
                   mov   LongRec(y).LO,AX
                   mov   LongRec(y).HI,DX
                end;
        25..32: asm
                   mov   AX,LongRec(y).LO
                   mov   DX,LongRec(y).HI
                   Xchg  AL,DH
                   Xchg  AH,DL
                   mov   LongRec(y).LO,AX
                   mov   LongRec(y).HI,DX
                end;
        end;
     x:=x*dx; y:=y*dy;
     Prijimano:='';
      t:=Translate(byte(Prijimano[t1]));
     If (t=0) and ((LastX<>x) or (LastY<>y)) then
     begin
          Kolekce^.AddPoz(x,y,t);
          LastX:=x;
          LastY:=y;
          LastT:=0;
     end;
     If t<>LastT then
     begin
          LastT:=t;
          Kolekce^.AddPoz(x,y,t);
          LastX:=x;
          LastY:=y;
     end;
end;

Function TTablet.PosledniXYT(var X,Y:double; var T:word):boolean;
{var _x,_y,_t:}
begin
     PosledniXYT:=Kolekce^.GetPoz(X,Y,T);
end;

end.